"""
Created on Wed Feb 22 17:03:49 2017

@author: kanishka
""" 

import numpy as np
import matplotlib.pyplot as plt
import scipy.stats as sta
from scipy.optimize import curve_fit

from mpl_toolkits.mplot3d import Axes3D

import itertools
import six

import pandas as pd

import random
 


dt=1./10**7 #.01 ms


c=244.49539061
N_shots=40
times =np.linspace(0,2,N_shots)
y=c*(np.exp(-2.3*times )-np.exp(-2.31*times ))

input_times=(times/dt).astype(int)


total_number=300
input_ion_numbers=np.round(y*total_number/np.sum(y)).astype(int)

input_freq=input_times[1]
 
#plt.stem(times ,input_ion_numbers)

tau_RyR_steps=int(0.010/dt)    #10ms





allCaH=[]
allcalens=[]
#first calculate the maximum length

numtrials=25

for jj in range(numtrials):
    
            
    file_name="DiracRyR_opn_time_step"+ str(jj )+".txt"
    RyR_opn_time=int(np.loadtxt(file_name, delimiter=",", unpack=False).tolist())
    
    if RyR_opn_time!=0:
        file_name="Dirac_Ca_head"+ str(jj)+".txt"
        allCaH.append(np.loadtxt(file_name, delimiter=",", unpack=False).tolist())
        allcalens.append(len(allCaH[-1]))

lenmin=min(allcalens)

Ca_Hrandom500=[]
Ca_baserandom500=[]
Ca_ERrandom500=[]
 
 
for jj in range(numtrials):
        
    file_name="DiracRyR_opn_time_step"+ str(jj )+".txt"
    RyR_opn_time=int(np.loadtxt(file_name, delimiter=",", unpack=False).tolist())
    if RyR_opn_time!=0:
        file_name="Dirac_Ca_head"+ str(jj)+".txt"
        Ca_H=np.loadtxt(file_name, delimiter=",", unpack=False).tolist()
        Ca_Hrandom500.append(np.array(Ca_H) )
    
        file_name="Dirac_Ca_base"+ str(jj )+".txt"
        Ca_base=np.loadtxt(file_name, delimiter=",", unpack=False).tolist()
        Ca_baserandom500.append(np.array(Ca_base) )
      
      
        file_name="Dirac_CainsideER"+ str(jj )+".txt"
        Ca_inER=np.loadtxt(file_name, delimiter=",", unpack=False).tolist()
        Ca_ERrandom500.append(np.array(Ca_inER) )


     
    
Ca_B2=[]
for jj in range(len(Ca_ERrandom500)-10):
    jj=jj+5
    Ca_B2.extend(Ca_baserandom500[jj])
    
        
Ca_H2=[]
for jj in range(len(Ca_Hrandom500)-10):
    jj=jj+5
    Ca_H2.extend(Ca_Hrandom500[jj])
    
    
    
Ca_ER2=[]
Ca_ER2.extend(Ca_ERrandom500[5])
inject_times=[0]
inject_numbers=[Ca_H2[0]]
for jj in range(len(Ca_ERrandom500)-11):
    jj=jj+6
    len_uptohere=len(Ca_ER2)
    inject_times.append(len(Ca_ER2))
    inject_numbers.append(Ca_H2[len(Ca_ER2)])
    ERcallevel=Ca_ERrandom500[jj][0]-Ca_ER2[-1]  
    Ca_ER2.extend(Ca_ERrandom500[jj]-ERcallevel)


plt.figure(1)
markerline, stemlines,baseline= plt.stem(np.array(inject_times)*100/1e7*1000,inject_numbers,basefmt=" " ) 
plt.setp(stemlines,'linewidth',3,color='black')

plt.ylabel('Calcium Input',fontsize=30)
plt.xlabel('Time (ms)', fontsize=30) 
plt.xlim([-.5,110])
plt.ylim([-2,320])
plt.tick_params(axis='both', which='major', labelsize=30)



plt.figure(2)
plt.plot(np.array(range(10984))*100/1e7*1000, Ca_H2[0:10984],color='g',label='Head', linewidth=2)
plt.plot(np.array(range(10984))*100/1e7*1000, Ca_B2[0:10984],color='black',label='Base', linewidth=2)
plt.ylabel('Calcium ions',fontsize=30)
plt.xlabel('Time (ms)', fontsize=30) 
plt.xlim([-.5,110])
plt.ylim([-2,320])
plt.tick_params(axis='both', which='major', labelsize=30)
plt.legend(fontsize=26).draggable() 



plt.figure(3)
plt.plot(np.array(range(10984))*100/1e7*1000, np.subtract(Ca_ER2,500)[0:10984],color='red', linewidth=2)
plt.xlim([-2,110])
plt.ylim([-2,620])
plt.ylabel('ER Calcium',fontsize=30)
plt.xlabel('Time (ms)', fontsize=30)  
plt.tick_params(axis='both', which='major', labelsize=30) 
