 
"""
Created on Wed Feb 22 17:03:49 2017

@author: kanishka
""" 

import numpy as np
import matplotlib.pyplot as plt
import scipy.stats as sta
import scipy.integrate
from scipy.optimize import curve_fit

from mpl_toolkits.mplot3d import Axes3D

import itertools
import six

import pandas as pd
import random
 
#y = lambda t : 
#total_number=300
#integral_value=scipy.integrate.quad(y, 0, 2)
#plt.plot(times,(np.exp(-2.3*times)-np.exp(-2.31*times))/integral_value[0]*total_number )

dt=1./10**7 #.01 ms


total_number=300
c=244.49539061
N_shots=25

times =np.linspace(0,2,N_shots) 
y=c*(np.exp(-2.3*times )-np.exp(-2.31*times ))

input_times1=(times/dt).astype(int)

input_times=[]

input_ion_numbers1=np.round(y*total_number/np.sum(y)).astype(int)

for uu in range(len(times)-1):
    eachtimes=np.array(np.random.uniform(input_times1[uu],input_times1[uu+1], input_ion_numbers1[uu]))
    if len(eachtimes)>0:
        input_times.append((eachtimes.astype(int)).tolist())

input_times=list(itertools.chain.from_iterable(input_times))
input_times.append(input_times[-1]+input_times[5])
input_times=np.sort(input_times)
#plt.stem(times ,input_ion_numbers)

tau_RyR_steps=int(0.010/dt)    #10ms

random500=np.sort(np.array(random.sample(range(int(2e7)), 500)))

Ca_Hrandom500=[]
Ca_baserandom500=[]
Ca_ERrandom500=[]


for jj in range(5): 
    file_name="D20nm_pois_RyR_opn_time_step"+ str(jj )+".txt"
    RyR_opn_time=int(np.loadtxt(file_name, delimiter=",", unpack=False).tolist())
    print RyR_opn_time
    
    if RyR_opn_time==0:
        
        file_name="D20nm_pois_last_time_step_simulated"+ str(jj )+".txt"
        tt=int(np.loadtxt(file_name, delimiter=",", unpack=False).tolist())
            
        file_name="D20nm_pois_double_expo_jumptimes"+ str(jj)+".txt"
        jumptimes=np.loadtxt(file_name, delimiter=",", unpack=False).tolist()
        jumptimes   = [int(i) for i in jumptimes]
        
        file_name="D20nm_pois_double_expo_jumpsteps"+ str(jj)+".txt"
        jumpsteps=np.loadtxt(file_name, delimiter=",", unpack=False).tolist()
        jumpsteps  = [int(i) for i in jumpsteps]
        
        file_name="D20nm_pois_double_expo_Ca_head"+ str(jj )+".txt"
        Ca_H=np.loadtxt(file_name, delimiter=",", unpack=False).tolist()
                
        #fill up jumptimes with ones
        for hh in range(len(jumptimes)):
            insertarray=Ca_H[jumptimes[hh]]*np.ones(jumpsteps[hh])
            insertlest=insertarray.tolist()
          #  print jumpsteps[hh]
            Ca_H[jumptimes[hh]:jumptimes[hh]]=insertlest

        Ca_H=Ca_H[0:int(2e7)]
        Ca_Hrandom500.append(np.array(Ca_H)[random500])
        
        file_name="D20nm_pois_double_expo_Ca_base"+ str(jj)+".txt"
        Ca_base=np.loadtxt(file_name, delimiter=",", unpack=False).tolist()
                
        for hh in range(len(jumptimes)):
            insertarray=Ca_base[jumptimes[hh]]*np.ones(jumpsteps[hh])
            insertlest=insertarray.tolist()
            Ca_base[jumptimes[hh]:jumptimes[hh]]=insertlest

        Ca_base=Ca_base[0:int(2e7)]
        Ca_baserandom500.append(np.array(Ca_base)[random500])

        file_name="D20nm_pois_double_expo_CainsideER"+ str(jj)+".txt"
        Ca_inER=np.loadtxt(file_name, delimiter=",", unpack=False).tolist()
                        
        for hh in range(len(jumptimes)):
            insertarray=Ca_inER[jumptimes[hh]]*np.ones(jumpsteps[hh])
            insertlest=insertarray.tolist()
            Ca_inER[jumptimes[hh]:jumptimes[hh]]=insertlest

        Ca_inER=Ca_inER[0:int(2e7)]
        Ca_ERrandom500.append(np.array(Ca_inER)[random500])
  


plt.figure(17) 
#plt.stem(times ,input_ion_numbers,color='b', label='Injected',linewidth=3) 

plt.plot(random500/1e7,np.mean(Ca_Hrandom500,0),color='g',label='Head', linewidth=2)
plt.plot(random500/1e7,np.mean(Ca_baserandom500,0),color='r',label='Base', linewidth=3)
plt.legend(fontsize=26).draggable() 
plt.ylim([-0.02,17])
plt.xlim([0,2])

plt.ylabel('Calcium ions',fontsize=30)
plt.xlabel('Time (s)', fontsize=30)
plt.tick_params(axis='both', which='major', labelsize=30)  
 
plt.figure(11) 
plt.plot(random500/1e7,np.mean(Ca_ERrandom500,0)-600 ,color='b',label='Inside ER', linewidth=2)
#plt.legend(fontsize=26).draggable() 
plt.ylim([0,1100])
plt.xlim([0,2])

plt.ylabel('Calcium in ER',fontsize=30)
plt.xlabel('Time (s)', fontsize=30)
plt.tick_params(axis='both', which='major', labelsize=30) 


plt.figure() 
plt.hist(input_times/1e7,50)
plt.xlim([0,2])
plt.ylabel('Calcium injection',fontsize=30)
plt.xlabel('Time (s)', fontsize=30)
plt.tick_params(axis='both', which='major', labelsize=30) 



times =np.linspace(0,2,N_shots+1) 

timnew=times[0:-1]

plt.plot()
plt.bar(timnew,input_ion_numbers1,width=.08)
plt.plot(timnew,(np.exp(-2.3*timnew)-np.exp(-2.31*timnew))*max(input_ion_numbers1)/max(np.exp(-2.3*timnew)-np.exp(-2.31*timnew)), color="black", linewidth=1.5)
plt.scatter(timnew,(np.exp(-2.3*timnew)-np.exp(-2.31*timnew))*max(input_ion_numbers1)/max(np.exp(-2.3*timnew)-np.exp(-2.31*timnew)), color="black" )
 
plt.xlim([0,2])

plt.ylim([0,26])


