
"""
Created on Wed Feb 22 17:03:49 2017

@author: kanishka
""" 

import numpy as np
import matplotlib.pyplot as plt
import scipy.stats as sta
from scipy.optimize import curve_fit

from mpl_toolkits.mplot3d import Axes3D
import itertools
import six
import pandas as pd
import random 
num_ions_one_injection=300
dist=-730

Ca_H=[]
Ca_base=[]
Ca_inER=[]
base_error_lines=[]
ER_error_lines=[]
for jj in range(2):
    print jj
    file_name="ltp_tsodysk_2000max_withslow_Cer"+str(dist)+"_N"+str(num_ions_one_injection)+"_last_time_step_simulated"+ str(jj)+".txt"
    tt=int(np.loadtxt(file_name, delimiter=",", unpack=False).tolist())
    
    file_name="ltp_tsodysk_2000max_withslow_Cer"+str(dist)+"_N"+str(num_ions_one_injection)+"_Ca_head"+ str(jj )+".txt"
    Ca_H.append(np.loadtxt(file_name, delimiter=",", unpack=False).tolist())
          
    file_name="ltp_tsodysk_2000max_withslow_Cer"+str(dist)+"_N"+str(num_ions_one_injection)+"_Ca_base"+ str(jj)+".txt"
    Ca_base.append(np.loadtxt(file_name, delimiter=",", unpack=False).tolist())
    base_error_lines.append(Ca_base[-1][::39999])

    file_name="ltp_tsodysk_2000max_withslow_Cer"+str(dist)+"_N"+str(num_ions_one_injection)+"_CainsideER"+ str(jj)+".txt"
    Ca_inER.append(np.loadtxt(file_name, delimiter=",", unpack=False).tolist())
    ER_error_lines.append(Ca_inER[-1][::39999])
 
Ca_Hmean=np.average(Ca_H,0) 
Ca_basemean=np.average(Ca_base,0) 
Ca_inERmean=np.average(Ca_inER,0) 


plt.figure(1) 
plt.plot(np.array(range(len(Ca_inERmean)))/1e7*1000 , np.array(Ca_inER[-1]),color='r',label='ER one trial', linewidth=2)
plt.errorbar(np.array(range(len(Ca_inER[-1])))[::39999][::2]/1e7*1000, np.mean( ER_error_lines,axis=0)[::2] , yerr=sta.sem(ER_error_lines,axis=0)[::2],linewidth=2,color='b',label='ER average')   
plt.ylabel('#of Calcium ions in ER',fontsize=30)
plt.xlabel('Time (ms)', fontsize=30) 
plt.tick_params(axis='both', which='major', labelsize=30)
plt.legend(fontsize=26).draggable() 


plt.figure(2) 
plt.plot(np.array(range(len(Ca_Hmean)))/1e7*1000 , np.array(Ca_H[-1]),color='magenta',label='Head one trial', linewidth=2)
plt.plot(np.array(range(len(Ca_H[-1])))/1e7*1000 , np.array(Ca_Hmean),color='g',label='Head average', linewidth=2)
plt.plot(np.array(range(len(Ca_basemean)))/1e7*1000 , np.array(Ca_base[-1]),color='orange',label='Base one trial', linewidth=2)
plt.plot(np.array(range(len(Ca_base[-1])))/1e7*1000 , np.array(Ca_basemean),color='black',label='Base average', linewidth=2)
plt.ylabel('Calcium ions',fontsize=30)
plt.xlabel('Time (ms)', fontsize=30) 
plt.tick_params(axis='both', which='major', labelsize=30)
plt.legend(fontsize=26).draggable() 


plt.figure(3) 
plt.plot(np.array(range(len(Ca_base[-1])))/1e7*1000 , np.array(Ca_basemean),color='black',label='Base average', linewidth=2)
plt.ylabel('# of Ca2+ ions in base',fontsize=30)
plt.xlabel('Time (ms)', fontsize=30) 
plt.tick_params(axis='both', which='major', labelsize=30)
plt.legend(fontsize=26).draggable() 


plt.figure(4)  
plt.errorbar(np.array(range(len(Ca_base[-1])))[::39999][::2]/1e7*1000, np.mean(base_error_lines,axis=0)[::2] , yerr=sta.sem(base_error_lines,axis=0)[::2],linewidth=5,color='red',label='N=300')   
plt.legend(fontsize=26).draggable() 
plt.ylim([0,25]) 