"""
Created on Wed Feb 22 17:03:49 2017

@author: kanishka
""" 

import numpy as np
import matplotlib.pyplot as plt
import scipy.stats as sta
from scipy.optimize import curve_fit

from mpl_toolkits.mplot3d import Axes3D

import itertools
import six

import pandas as pd

dt=1./10**7 #.01 ms

total_number=300 #SLOW INJECTIONS

injection_freq=100  #input freq in Hz 
timebetweeninputs=1./injection_freq #time in ms
timestepsbetweeninjections=int(timebetweeninputs/dt) #time in ms
num_injections=25  #10
num_ions_one_injection=300# 300
tau_RyR_steps=int(0.010/dt)    

C_er=-730
     #shift of the ER head

file_name="eE.txt"
inputs=np.loadtxt(file_name, delimiter=",", unpack=False).tolist()


for jj in range(3):
    jj=jj+18
    N_bins=25
    times =np.linspace(0,2,N_bins) 
    y=np.exp(-2.3*times )-np.exp(-2.31*times)
    input_times1=(times/dt).astype(int)
    
    input_times=[]
    input_ion_numbers1=np.round(y*total_number/np.sum(y)).astype(int)
    
    for uu in range(len(times)-1):
        eachtimes=np.array(np.random.uniform(input_times1[uu],input_times1[uu+1], input_ion_numbers1[uu]))
        if len(eachtimes)>0:
            input_times.append((eachtimes.astype(int)).tolist())
    
    input_times=list(itertools.chain.from_iterable(input_times))
    input_times=np.sort(input_times) 
    input_times=np.append(input_times,input_times[0]/3+input_times[-1])
    input_times=np.append(input_times,input_times+input_times[-1])

    #LTD INJECTIONS
    injection_ion_numbers= []     
    injection_ion_numbers=[num_ions_one_injection for y in num_ions_one_injection*np.ones(int(num_injections))] #starts at the top of the sphere
    injection_ion_numbers= np.multiply(injection_ion_numbers,inputs).astype(int).tolist()
    
    injection_times=[0]
    for yy in range(num_injections-1):
        injection_times.append(timestepsbetweeninjections+injection_times[-1])

    runfile('/media/basnayak/Data new/basnayak/Dropbox/STIM_ORAI/LTP_Tsodysk/main_funcs_ltp_withslowinput_tsodysk.py', wdir='/media/basnayak/Data new/basnayak/Dropbox/STIM_ORAI/LTP_Tsodysk')
    
    file_name="ltp_tsodysk_2000max_withslow_Cer"+str(C_er)+"_N"+str(num_ions_one_injection)+"_last_time_step_simulated"+ str(jj)+".txt"
    print file_name
    np.savetxt(file_name,np.array([tt]),fmt='%1.1f')
    
    file_name="ltp_tsodysk_2000max_withslow_Cer"+str(C_er)+"_N"+str(num_ions_one_injection)+"_Ca_head"+ str(jj )+".txt"
    print file_name
    np.savetxt(file_name,Ca_H , delimiter="\t",fmt='%1.1f')
    
    file_name="ltp_tsodysk_2000max_withslow_Cer"+str(C_er)+"_N"+str(num_ions_one_injection)+"_Ca_base"+ str(jj )+".txt"
    print file_name
    np.savetxt(file_name,Ca_base , delimiter="\t",fmt='%1.1f')   #this was caT
    
    file_name="ltp_tsodysk_2000max_withslow_Cer"+str(C_er)+"_N"+str(num_ions_one_injection)+"_CainsideER"+ str(jj)+".txt"
    print file_name
    np.savetxt(file_name,Ca_inER , delimiter="\t",fmt='%1.1f')
    
    file_name="ltp_tsodysk_2000max_withslow_Cer"+str(C_er)+"_N"+str(num_ions_one_injection)+"_Ca_SERCA"+ str(jj)+".txt"
    print file_name
    np.savetxt(file_name,Ca_SERCA_times, delimiter="\t",fmt='%1.1f')
    
    file_name="ltp_tsodysk_2000max_withslow_Cer"+str(C_er)+"_N"+str(num_ions_one_injection)+"_Ca_pumptake"+ str(jj)+".txt"
    print file_name
    np.savetxt(file_name,Ex_crosstimes, delimiter="\t",fmt='%1.1f')
    
    file_name="ltp_tsodysk_2000max_withslow_Cer"+str(C_er)+"_N"+str(num_ions_one_injection)+"_jumptimes"+ str(jj)+".txt"
    print file_name
    np.savetxt(file_name,jumptimes, delimiter="\t" )
    
    file_name="ltp_tsodysk_2000max_withslow_Cer"+str(C_er)+"_N"+str(num_ions_one_injection)+"_jumpsteps"+ str(jj)+".txt"
    print file_name
    np.savetxt(file_name,jumpsteps, delimiter="\t" )

 