"""
Created on Wed Feb 22 17:03:49 2017

@author: kanishka
""" 

import numpy as np
import matplotlib.pyplot as plt
import scipy.stats as sta
from scipy.optimize import curve_fit

from mpl_toolkits.mplot3d import Axes3D

import itertools
import six

import pandas as pd


dt=1./10**7 #.01 ms

total_number=300 #SLOW INJECTIONS


injection_freq=1  #injection freq in Hz 
timebetweeninjections=1./injection_freq #time in ms
timestepsbetweeninjections=int(timebetweeninjections/dt) #time in ms
num_ions_one_injection=1    # means 100 or 200


tau_RyR_steps=int(0.010/dt)    

C_er=-730     #shift of the ER head

num_2s_blocks=15
num_injections=num_2s_blocks*2  #every block 2 inj

N_shotsvector=range(25)

for jj in range(3):
    jj=jj+9
    #SLOW INPUTS
    N_bins=25
    times =np.linspace(0,2,N_bins+1) 
    y=np.exp(-2.3*times)-np.exp(-2.31*times)
    input_times1=(times/dt).astype(int)
    
    input_times=[]
    input_ion_numbers1=np.round(y*total_number/np.sum(y)).astype(int)
    
    for uu in range(N_bins):
        eachtimes=np.array(np.random.uniform(input_times1[uu],input_times1[uu+1], input_ion_numbers1[uu+1]))
        if len(eachtimes)>0:
            input_times.append((eachtimes.astype(int)).tolist())
    
    input_times=list(itertools.chain.from_iterable(input_times))

    input_times=np.sort(input_times) 

    input_times=np.array(input_times)
    one2sblocklength=len(input_times)
    
    for kk in range(num_2s_blocks-1):
        input_times=np.append(input_times,input_times[-one2sblocklength:len(input_times)]+2*timestepsbetweeninjections)

    input_times=np.append(input_times,input_times[0]/3+num_2s_blocks*2*timestepsbetweeninjections)
    print  input_times  

    #STIM ORAI INJECTIONS
    injection_ion_numbers= []     
    injection_ion_numbers=[num_ions_one_injection for y in num_ions_one_injection*np.ones(int(num_injections))] #starts at the top of the sphere
    
    injection_times=[0]
    for yy in range(num_injections-1):
        injection_times.append(timestepsbetweeninjections+injection_times[-1])

    runfile('/media/kanishkacb/Data new/basnayak/Dropbox/STIM_ORAI/noectopic_refilling/main_funcs_ectopic_withslow.py', wdir='/media/kanishkacb/Data new/basnayak/Dropbox/STIM_ORAI/noectopic_refilling')

    file_name="noectopic_maxER2000_long_withslow_Cer"+str(C_er+750)+"_N"+str(2550)+"_last_time_step_simulated"+ str(jj)+".txt"
    print file_name
    np.savetxt(file_name,np.array([tt]),fmt='%1.1f')
    
    file_name="noectopic_maxER2000_long_withslow_Cer"+str(C_er+750)+"_N"+str(2550)+"_Ca_head"+ str(jj)+".txt"
    print file_name
    np.savetxt(file_name,Ca_H , delimiter="\t",fmt='%1.1f')
    
    file_name="noectopic_maxER2000_long_withslow_Cer"+str(C_er+750)+"_N"+str(2550)+"_Ca_base"+ str(jj)+".txt"
    print file_name
    np.savetxt(file_name,Ca_base , delimiter="\t",fmt='%1.1f')   #this was caT
    
    file_name="noectopic_maxER2000_long_withslow_Cer"+str(C_er+750)+"_N"+str(2550)+"_CainsideER"+ str(jj)+".txt"
    print file_name
    np.savetxt(file_name,Ca_inER , delimiter="\t",fmt='%1.1f')
    
    file_name="noectopic_maxER2000_long_withslow_Cer"+str(C_er+750)+"_N"+str(2550)+"_Ca_SERCA"+ str(jj)+".txt"
    print file_name
    np.savetxt(file_name,Ca_SERCA_times, delimiter="\t",fmt='%1.1f')
    
    file_name="noectopic_maxER2000_long_withslow_Cer"+str(C_er+750)+"_N"+str(2550)+"_Ca_pumptake"+ str(jj)+".txt"
    print file_name
    np.savetxt(file_name,Ex_crosstimes, delimiter="\t",fmt='%1.1f')
    
    file_name="noectopic_maxER2000_long_withslow_Cer"+str(C_er+750)+"_N"+str(2550)+"_jumptimes"+ str(jj)+".txt"
    print file_name
    np.savetxt(file_name,jumptimes, delimiter="\t" )
    
    file_name="noectopic_maxER2000_long_withslow_Cer"+str(C_er+750)+"_N"+str(2550)+"_jumpsteps"+ str(jj)+".txt"
    print file_name
    np.savetxt(file_name,jumpsteps, delimiter="\t" )

 