"""
Created on Wed Feb 22 17:03:49 2017

@author: kanishka
""" 

import numpy as np
import matplotlib.pyplot as plt
import scipy.stats as sta
from scipy.optimize import curve_fit

from mpl_toolkits.mplot3d import Axes3D

import itertools
import six

import pandas as pd

import random


plt.figure() 
error_lines=[]

for hh in range(10):
    print hh
    if hh>5:
        hh=hh+1 
    file_name="ltd_maxER2000_long30s_withslow_Ca_ER_inj300_500downsampled"+ str(hh)+".txt"  #print file_name
    Ca_er500=np.loadtxt(file_name, delimiter=",", unpack=False).tolist()[0:600000]
    error_lines.append(Ca_er500[::39999])
    
    if hh==1:
        Ca_erfull=np.loadtxt(file_name, delimiter=",", unpack=False).tolist()[0:600000]
        times=np.array(range(len(Ca_erfull)))*500/1e7    #BECAUSE 500 TIMES DOWNSAMPLING
        plt.plot(times,Ca_erfull,linewidth=2,color='g',label='N=300 single trial')
    
error_bars=sta.sem(error_lines,axis=0) 
plt.errorbar(times[::39999], np.mean(error_lines,axis=0), yerr=error_bars,linewidth=2,color='b',label='N=300 mean') 
plt.legend(fontsize=26).draggable()  

plt.tick_params(axis='both', which='major', labelsize=30)
plt.ylabel('# of Calcium ions in ER',fontsize=30)
plt.xlabel('Time (s)', fontsize=30) 

plt.ylim([0,2300])  

error_lines=[]
for hh in range(10):
    print hh
    file_name="ltd_maxER2000_long30s_withslow_Ca_ER_inj500_500downsampled"+ str(hh)+".txt"  #print file_name
    Ca_er500=np.loadtxt(file_name, delimiter=",", unpack=False).tolist()[0:600000]
    error_lines.append(np.loadtxt(file_name, delimiter=",", unpack=False)[::39999])
    if hh==1:
        Ca_er500full=np.loadtxt(file_name, delimiter=",", unpack=False).tolist()[0:600000]
        times=np.array(range(len(Ca_er500full)))*500/1e7
        plt.plot(times,Ca_er500full ,linewidth=2,color='r',label='N=500 single trial')

error_bars=sta.sem(error_lines,axis=0) 
plt.errorbar(times[::39999], np.mean(error_lines,axis=0), yerr=error_bars,linewidth=2,color='black',label='N=500 mean') 
plt.legend(fontsize=26).draggable()    
plt.tick_params(axis='both', which='major', labelsize=30)
plt.ylabel('# of Calcium ions in ER',fontsize=30)
plt.xlabel('Time (s)', fontsize=30) 
plt.ylim([0,2300]) 