"""
Created on Wed Feb 22 17:03:49 2017

@author: kanishka
""" 

import numpy as np
import matplotlib.pyplot as plt
import scipy.stats as sta
from scipy.optimize import curve_fit
from mpl_toolkits.mplot3d import Axes3D
import itertools
import six
import pandas as pd
import random


plt.figure() 
error_lines=[]

for hh in range(10):
    print hh
    if hh>5:
        hh=hh+1 

    file_name="ltd_maxER2000_long30s_withslow_Ca_ER_inj300_500downsampled"+ str(hh)+".txt"  #print file_name
    Ca_er500=np.loadtxt(file_name, delimiter=",", unpack=False).tolist()[0:5000]
    error_lines.append(Ca_er500[::499])
    times=np.array(range(len(Ca_er500)))*500/1e7*1000  #BECAUSE 500 TIMES DOWNSAMPLING
 
error_bars=sta.sem(error_lines,axis=0) 
plt.errorbar(times[::499], np.mean(error_lines,axis=0), yerr=error_bars,linewidth=2,color='r',label='N=300') 
plt.legend(fontsize=26).draggable()  
plt.ylim([0,2300])  


error_lines=[]

for hh in range(10):
    print hh
    file_name="ltd_maxER2000_long30s_withslow_Ca_ER_inj500_500downsampled"+ str(hh)+".txt"  #print file_name
    Ca_er500=np.loadtxt(file_name, delimiter=",", unpack=False).tolist()[0:5000]
    error_lines.append(Ca_er500[::499])
    times=np.array(range(len(Ca_er500)))*500/1e7*1000 #BECAUSE 500 TIMES DOWNSAMPLING

error_bars=sta.sem(error_lines,axis=0) 
plt.errorbar(times[::499], np.mean(error_lines,axis=0), yerr=error_bars,linewidth=2,color='b',label='N=500') 
plt.legend(fontsize=26).draggable()  
plt.tick_params(axis='both', which='major', labelsize=30)
plt.ylabel('# of Calcium ions in ER',fontsize=30)
plt.xlabel('Time (ms)', fontsize=30) 
plt.ylim([0,2300])  
 