"""
Created on Wed Feb 22 17:03:49 2017

@author: kanishka
""" 

import numpy as np
import matplotlib.pyplot as plt
import scipy.stats as sta
from scipy.optimize import curve_fit

from mpl_toolkits.mplot3d import Axes3D

import itertools
import six

import pandas as pd

import random


error_lines300=[]
full_lines300=[]
first250ms300=[]
for hh in range(10):
    print hh
    if hh>5:
        hh=hh+1 

    file_name="ltd_maxER2000_long30s_withslow_Ca_base_inj300_500downsampled"+ str(hh)+".txt"  #print file_name
    full_lines300.append(np.loadtxt(file_name, delimiter=",", unpack=False).tolist()[0:600000])
    error_lines300.append(full_lines300[-1][::39999])
    for uu in range(30):
        first250ms300.append(full_lines300[-1][uu*20000:uu*20000+5000])

times=np.array(range(len(full_lines300[-1])))*500/1e7

fig1, ax1 = plt.subplots()  
plt.plot(times,full_lines300[-1],linewidth=2,color='g',label='single trial',alpha=0.8)
plt.tick_params(axis='both', which='major', labelsize=30)
plt.ylim([0,80])

plt.ylabel('# of Ca2+ ions in base: one trial',fontsize=30)
plt.xlabel('Time (s)', fontsize=30) 

ax2 = ax1.twinx()
plt.plot(times, np.mean(full_lines300,axis=0),linewidth=2,color='r',alpha=0.6) 
plt.ylabel('Mean # of Ca2+ ions in base',fontsize=30)
plt.tick_params(axis='both', which='major', labelsize=30)
plt.ylim([0,15])
ax2.yaxis.set_label_position("right")
ax2.yaxis.tick_right()
 


plt.figure(2)
plt.errorbar((np.array(range(len(first250ms300[-1])))*500/1e7*1000)[::99], np.mean(first250ms300,axis=0)[::99] , yerr=sta.sem(first250ms300,axis=0)[::99],linewidth=2,color='r',label='N=300') 
 
error_lines=[]
full_lines500=[]
first250ms500=[]
for hh in range(10):
    print hh 
    file_name="ltd_maxER2000_long30s_withslow_Ca_base_inj500_500downsampled"+ str(hh)+".txt"  #print file_name
    full_lines500.append(np.loadtxt(file_name, delimiter=",", unpack=False).tolist()[0:600000])
    error_lines.append(full_lines500[-1][::39999])
    for uu in range(30):
        first250ms500.append(full_lines500[-1][uu*20000:uu*20000+5000])

    if hh==0:  
        times=np.array(range(len(full_lines500[-1])))*500/1e7
        
fig3, ax1 = plt.subplots()  
plt.plot(times,full_lines500[-1],linewidth=2,color='g',label='single trial',alpha=0.8)
plt.tick_params(axis='both', which='major', labelsize=30)
plt.ylabel('# of Ca2+ ions in base: one trial',fontsize=30)
plt.xlabel('Time (s)', fontsize=30) 
plt.ylim([0,80])

ax2 = ax1.twinx()
plt.plot(times, np.mean(full_lines500,axis=0),linewidth=2,color='r',label='10 trials\' mean ',alpha=0.6) 
plt.ylabel('Mean # of Ca2+ ions in base',fontsize=30)
plt.tick_params(axis='both', which='major', labelsize=30)
plt.ylim([0,15])

ax2.yaxis.set_label_position("right")
ax2.yaxis.tick_right()


plt.figure(2)
plt.errorbar((np.array(range(len(first250ms500[-1])))*500/1e7*1000)[::99], np.mean(first250ms500,axis=0)[::99] , yerr=sta.sem(first250ms500,axis=0)[::99],linewidth=2,color='b',label='N=500') 
plt.tick_params(axis='both', which='major', labelsize=30)
plt.legend(fontsize=26).draggable()    
plt.ylabel('Pooled average # of Ca2+ in the base',fontsize=30)
plt.xlabel('Time (s)', fontsize=30) 


plt.ylim([0,2.5])
plt.xlim([0,100])
