# -*- coding: utf-8 -*-
"""
Created on Thu Nov 24 14:00:23 2016

@author: kanishka
"""

import numpy as np
import math
import matplotlib.pyplot as plt

from mpl_toolkits.mplot3d import Axes3D

import itertools
import six

R=1000    #sphere radius
r=150 #cylinder radiusR=10    

R_er=250      #er head radius
r_er=50   #ER cylinder radius
l_neck=-2000 # position of the lower end of the spine neck  #THIS IS WRONG

D=600*10**6 #nm^2 s-1   600um^2
dt=1./10**7 #.01 ms
pi=np.pi
SS_ul=-1*np.sqrt(R**2-r**2)  #Spine Stem upper limit
ER_ul= -1*(np.sqrt(R_er**2-r_er**2)+C_er) #upper limit of ER stem
r_ds=500  #radius dendritic shaft
r_ers=100  #radius ER shaft
c_ds=l_neck-r_ds    #center of the dend shaft also ER shaft
ER_ll=c_ds+r_ers  #lower limit of ER stem
SS_ll=c_ds+r_ds #lower limit of Spine stem

def newpositions(XYZ_last):
    x_n=XYZ_last[0]+np.sqrt(2*D*dt)*np.random.normal(0.,1.)
    y_n=XYZ_last[1]+np.sqrt(2*D*dt)*np.random.normal(0.,1.)
    z_n=XYZ_last[2]+np.sqrt(2*D*dt)*np.random.normal(0.,1.)
    return [x_n, y_n, z_n]
 

def sphere_reflex(x_n,y_n,z_n,xyz,R_or_RER):    #R = spine head radius; RER =ER head radius
    X=xyz[0]; Y=xyz[1];Z=xyz[2] #X, Y and Z becomes the x,y,z of the point where supposed to go             
    if R_or_RER==R_er:
        Z=Z+C_er
    x=X-x_n; y=Y-y_n; z=Z-z_n
    xi=X**2+Y**2+Z**2-R_or_RER**2        #these values are needed for calculating
    epsilon=x**2+y**2+z**2   #intersection points with the sphere
    kappa=(x*X+y*Y+z*Z)
    if R_or_RER==R_er:
        t2=(-kappa+np.sqrt(kappa**2-epsilon*xi))/epsilon
    else:
        t2=(-kappa-np.sqrt(kappa**2-epsilon*xi))/epsilon
    P=np.array([X+t2*x, Y+t2*y , Z+t2*z])   
    Q=np.array([x_n,y_n,z_n])
    t3=(R_or_RER**2-np.dot(P,Q))/ R_or_RER**2             #xyz[-1] isnt correct P not appended now
    N=Q+t3*P
    L=2*N-Q
    return P,L

def cylin_reflex(x_n,y_n,z_n, xyz,r_or_rER):    #r = spine stem radius; rER =ER stem radius
    X=xyz[0]; Y=xyz[1];Z=xyz[2] #X, Y and Z becomes the x,y,z of the point where supposed to go             
    x=X-x_n; y=Y-y_n; z=Z-z_n
    xi=X**2+Y**2-r_or_rER**2        #these values are needed for calculating
    epsilon=x**2+y**2   #intersection points with the sphere
    kappa=(x*X+y*Y)
    if r_or_rER==r_er:
        t2=(-kappa+np.sqrt(kappa**2-epsilon*xi))/epsilon
    else:
        t2=(-kappa-np.sqrt(kappa**2-epsilon*xi))/epsilon
    P=np.array([X+t2*x, Y+t2*y , Z+t2*z])
    Q=np.array([x_n,y_n,z_n])
    t3=(r_or_rER**2-np.dot(P[0:2],Q[0:2]))/r_or_rER**2
    N=Q+t3*P
    L=2*N-Q
    L[2]=z_n
    return P,L
    
def horiz_cylin_reflex(x_n,y_n,z_n, xyz,r_ers):    #r_ds = spine dend shaft radius; rERs =ER shaft radius
    X=xyz[0]; Y=xyz[1];Z=xyz[2]-c_ds #X, Y and Z becomes the x,y,z of the point where supposed to go             
    #Z=Z+c_ds already sent like thisdone
    x=X-x_n; y=Y-y_n; z=Z-z_n
    xi=X**2+Z**2-r_ers**2        #these values are needed for calculating
    epsilon=x**2+z**2   #intersection points with the sphere
    kappa=(x*X+z*Z)
    
    t2=(-kappa+np.sqrt(kappa**2-epsilon*xi))/epsilon
    P=np.array([X+t2*x, Y+t2*y , Z+t2*z])
    t3=(r_ers**2-(P[0]*x_n+P[2]*z_n))/r_ers**2
    Q=np.array([x_n,y_n,z_n])
    N=Q+t3*P
    L=2*N-Q
    L[1]=y_n
    return P,L
    
 

def plotspinehead(R,ax):
    u = np.linspace(0, 2 * pi, 100)
    v = np.linspace(0, pi, 100)
    xR = R * np.outer(np.cos(u), np.sin(v))
    yR = R * np.outer(np.sin(u), np.sin(v))
    zR = R * np.outer(np.ones(np.size(u)), np.cos(v))
    ax.plot_wireframe(xR, yR, zR, alpha=0.5, rstride=10, cstride=10,color='green')
    return 
    
def plotspineneck(r,ax):
    x=np.linspace(-1*r, r, 100)
    z=np.linspace(l_neck, SS_ul, 100)
    Xc, Zc=np.meshgrid(x, z)
    Yc = np.sqrt(r**2-Xc**2)
    ax.plot_wireframe(Xc, Yc, Zc, alpha=0.5, rstride=20, cstride=10,color='green')
    ax.plot_wireframe(Xc, -Yc, Zc, alpha=0.5, rstride=20, cstride=10,color='green')
    return 
    
def plotERhead(R_er,ax):
    u = np.linspace(0, 2 * pi, 100)
    v = np.linspace(0, pi, 100)
    xR = R_er * np.outer(np.cos(u), np.sin(v))
    yR = R_er * np.outer(np.sin(u), np.sin(v))
    zR = R_er * np.outer(np.ones(np.size(u)), np.cos(v))-C_er
    ax.plot_surface(xR, yR, zR, alpha=0.2, rstride=10, cstride=10,color='blue')
    return 

def plotERneck(r_er,ax):
    x=np.linspace(-1*r_er, r_er,50)
    z=np.linspace(ER_ll, ER_ul, 50)  #LOWER AND UPPER limits of the ER stem
    Xc, Zc=np.meshgrid(x, z)
    Yc = np.sqrt(r_er**2-Xc**2)
    ax.plot_surface(Xc, Yc, Zc, alpha=0.2, rstride=20, cstride=10,color='blue')
    ax.set_aspect('equal')
    ax.plot_surface(Xc, -Yc, Zc, alpha=0.2, rstride=20, cstride=10,color='blue')
    return 

    
def plot_dend_shaft(r_ds,ax):
    x=np.linspace(-1*r_ds, r_ds,50)
    y=np.linspace(-1*R, R, 50)  #LOWER AND UPPER limits of the ER stem
    Xc, Yc=np.meshgrid(x, y)
    Zc = np.sqrt(r_ds**2-Xc**2)
    ax.plot_wireframe(Xc, Yc, Zc+c_ds, alpha=0.2, rstride=5, cstride=10,color='green')
    ax.set_xlabel('X')
    ax.set_ylabel('Y')
    ax.set_zlabel('Z')
    ax.set_aspect('equal')
    ax.plot_wireframe(Xc, Yc, -Zc+c_ds, alpha=0.2, rstride=5, cstride=10,color='green')
    return 
          
def plot_ER_shaft(r_ers,ax):
    x=np.linspace(-1*r_ers, r_ers,50)
    y=np.linspace(-1*R, R, 50)  #LOWER AND UPPER limits of the ER stem
    Xc, Yc=np.meshgrid(x, y)
    Zc = np.sqrt(r_ers**2-Xc**2)
    ax.plot_surface(Xc, Yc, Zc+c_ds, alpha=0.2, rstride=10, cstride=5,color='blue')
    ax.set_xlabel('X')
    ax.set_ylabel('Y')
    ax.set_zlabel('Z')
    ax.set_aspect('equal')
    ax.plot_surface(Xc, Yc, -Zc+c_ds, alpha=0.2, rstride=10, cstride=5,color='blue')
    return 
            
    
def plot_result(XYZ,ax):
    for kk in range(len(XYZ)):
        xyz_kk=np.array(XYZ[kk])
        xyz_kk[:,0][xyz_kk[:,0]>20]= np.nan
        xyz_kk[:,0][xyz_kk[:,0]<-20]= np.nan
        ax.plot(xyz_kk[:,0],xyz_kk[:,1],xyz_kk[:,2],color=tuple(.85*np.random.rand(4)))
    return 

N_SER=36
uu=np.random.rand(N_SER)*pi-pi/2
vv=np.random.rand(N_SER)*pi
x_SER=R_er*np.sin(uu)*np.cos(vv)
y_SER=R_er*np.sin(uu)*np.sin(vv)
z_SER=R_er*np.cos(uu)-C_er

r_SER=10
tau_transloc_SER=int(0.0100/dt)  #translocation time: how much time it takes after the arrival of the second ion
                        #0.1s=100ms is the translocation time
tau_SER_steps=tau_transloc_SER*1 #how many time steps to wait as refractory for the first ion

initER=10 #how many Ca in SERCA initially?
def check_SERCA(simul_yn,SER_IDs,P,jjj):
    sercas=range(N_SER)
    np.random.shuffle(sercas)        
    inside_SER=0
    for yy in sercas:
        if (P[0]-x_SER[yy])**2 + (P[1]-y_SER[yy])**2 + (P[2]-z_SER[yy])**2 < r_SER**2:
            all_IDs=np.array([val for sublist in SER_IDs for val in sublist]) #all the particles in SERCA
    
            if len(SER_IDs[yy])<4:
                inside_SER=1  #at least one ion was in            
                if np.sum(all_IDs==jjj)==0:
                   # print SER_IDs
                    SER_IDs[yy].append(jjj)
                    simul_yn[jjj]=0
    return simul_yn, inside_SER,  SER_IDs 
    
    
N_RyR=36 #has to be divisible by 6
N_RyR_cyl=N_RyR/6*4 #RyR in the cylindrical stem
N_RyR_sh=N_RyR/6*2#RyR in the shaft

RyR_xy_angles=np.random.rand(N_RyR_cyl)*2*pi
neck_RyR_centers_x=r_er*np.cos(RyR_xy_angles)
RyR_centers_shaft_x=np.zeros(N_RyR_sh)
RyR_centers_x=np.concatenate((RyR_centers_shaft_x,neck_RyR_centers_x))

neck_RyR_centers_y=r_er*np.sin(RyR_xy_angles)
shaft_RyR_centers_y1=np.linspace(-1*r,-1*r_er,N_RyR/6)
shaft_RyR_centers_y2=np.linspace(r_er,r,N_RyR/6)
sh_RyR_centers_y=np.concatenate((shaft_RyR_centers_y1,shaft_RyR_centers_y2))
RyR_centers_y=np.concatenate((sh_RyR_centers_y,neck_RyR_centers_y))


tau_RyR_steps=int(0.01/dt)    #
N_levs=4 #how many levels of RyR in the stem
neck_RyR_centers_z4=np.linspace(ER_ll,ER_ll+(r_ds-r_ers),N_levs+1)[1:]  
N_RyR_perRing=N_RyR_cyl/len(neck_RyR_centers_z4)
neck_RyR_centers_z=neck_RyR_centers_z4
for ll in range(N_RyR_perRing-1):
    neck_RyR_centers_z=np.concatenate((neck_RyR_centers_z,neck_RyR_centers_z4))
shaft_RyR_centers_z=ER_ll*np.ones(N_RyR_sh)
RyR_centers_z=np.concatenate((shaft_RyR_centers_z,neck_RyR_centers_z))

RyR_centers=np.vstack((RyR_centers_x,RyR_centers_y,RyR_centers_z))

r_RyR=10
tau_transloc_RyR=int(.00025/dt) #.2ms delay before RyR relaease

  
#Check for RyR in the shaft
def check_RyR_sh(simul_yn,RyR_IDs,RyR_killed,P,jjj):
    RyRs_cyl=range(N_RyR_sh)
    np.random.shuffle(RyRs_cyl)
    inside_RyR=0
    for yy in RyRs_cyl:
        if RyR_killed[yy]==0:
            if (P[0]-RyR_centers_shaft_x[yy])**2 + (P[1]-sh_RyR_centers_y[yy])**2 + (P[2]-shaft_RyR_centers_z[yy])**2 < r_RyR**2:
                all_IDs=np.array([val for sublist in RyR_IDs for val in sublist]) #all the particles in SERCA            
                if len(RyR_IDs[yy])<4:
                    inside_RyR=1  #at least one ion was in
                    if np.sum(all_IDs==jjj)==0:
                        RyR_IDs[yy].append(jjj)
                        simul_yn[jjj]=0
    return simul_yn, inside_RyR,  RyR_IDs 
    
#Check for RyR in the cylinder
def check_RyR_cyl(simul_yn,RyR_IDs,RyR_killed,P,jjj):
    RyRs_cyl=range(N_RyR_cyl)
    np.random.shuffle(RyRs_cyl)
    inside_RyR=0
    for yy in RyRs_cyl:
        if RyR_killed[yy+N_RyR_sh]==0:
            if (P[0]-neck_RyR_centers_x[yy])**2 + (P[1]-neck_RyR_centers_y[yy])**2 + (P[2]-neck_RyR_centers_z[yy])**2 < r_RyR**2:
                all_IDs=np.array([val for sublist in RyR_IDs for val in sublist]) #all the particles in SERCA
                if len(RyR_IDs[yy+N_RyR_sh])<4:
                    inside_RyR=1  #at least one ion was in
                    if np.sum(all_IDs==jjj)==0:
                        RyR_IDs[yy+N_RyR_sh].append(jjj)
                        simul_yn[jjj]=0
    return simul_yn, inside_RyR,  RyR_IDs
    
    
    
def brownian_reflections(XYZ,XYZ_future):
    simul_yn=np.ones(len(XYZ))

    ext_flags=np.zeros(len(XYZ))

    SER_IDs=[[] for x in range(N_SER)] #starts at the top of the sphere
    SER_times1=np.zeros(N_SER)
    SER_times2=np.zeros(N_SER)
    RyR_IDs=[[] for x in range(N_RyR)] #starts at the top of the sphere
    RyR_killed=np.zeros(N_RyR)
    
    RyR_times1=np.zeros(N_RyR)
    RyR_times2=np.zeros(N_RyR)
     
    tt=0  #timesteps
    intoER=initER
    Ex_crossNum=0
    N_passed_bottom=0
    CaT=[]
    Ca_H=[]
    
    RyR_opn_time=0
    
 
    while sum(simul_yn)!=0:
        tt=tt+1     
        NumCa=0  #number of Ca below SS_ll
        NumCa_H=0  #number of Ca in head

        #each 1ms
        if tt%10000==0:
            print tt*dt*1000, "ms simulated"            
            print "took" , time.clock() - start_time, "seconds"            
            print sum(simul_yn), "particles"    


    #calculate the number of Ca
        simls=np.array(np.where(simul_yn!=0))[0]
        for nn in range(np.sum(simul_yn!=0)):
            if XYZ[simls[nn]][2]<SS_ll:
                NumCa=NumCa+1
            if XYZ[simls[nn]][2]>SS_ul :        
                NumCa_H=NumCa_H+1
 #           if (XYZ[simls[nn]][0])**2+(XYZ[simls[nn]][1])**2+(XYZ[simls[nn]][2])**2 < 500**2:
                
        CaT.append(NumCa)
        Ca_H.append(NumCa_H)
        
        
        #SERCA check
        expired_SER_refrac=np.where(SER_times1>tau_SER_steps)[0]
        expired_SER_transloc=np.where(SER_times2>tau_transloc_SER)[0]
        
        if len(expired_SER_refrac)>0:
            SER_times1[expired_SER_refrac]=0
            simul_yn[np.array(SER_IDs)[expired_SER_refrac][0]]=1  #restart simulting expired 
            for nnn in range(len(expired_SER_refrac)):
                SER_IDs[expired_SER_refrac.astype(int)[nnn]]=[]
            
        if len(expired_SER_transloc)>0:
            SER_times2[expired_SER_transloc]=0
            for xxx in range(len(expired_SER_transloc)):           
                IDs_in_expiring_SER=SER_IDs[expired_SER_transloc.astype(int)[xxx]]
                simul_yn[IDs_in_expiring_SER[0]]=0               #only the first ion is eliminated this is actually already zero
                SER_IDs[expired_SER_transloc.astype(int)[xxx]]=IDs_in_expiring_SER[1:len(IDs_in_expiring_SER)]
                #print SER_IDs
            intoER=intoER+1 

        ONE_ion_ser =np.where(np.array([len(pp) for pp in SER_IDs])==1)[0]  #SERCA occupied by one ion
        second_ion_ser =np.where(np.array([len(pp) for pp in SER_IDs])>1)[0]  #SERCA occupied by a second ion

        if len(ONE_ion_ser)>0:
            SER_times1[ONE_ion_ser]=SER_times1[ONE_ion_ser]+1  
            
        if len(second_ion_ser)>0:
            SER_times2[second_ion_ser]=SER_times2[second_ion_ser]+1  #add times
            SER_times1[second_ion_ser]=0  #add times

        #RyR check
        expired_RyR_refrac=np.where(RyR_times1>tau_RyR_steps)[0]
        
        
        if len(expired_RyR_refrac)>0:
          #  print RyR_IDs
            RyR_times1[expired_RyR_refrac]=0
            simul_yn[np.array(RyR_IDs)[expired_RyR_refrac][0]]=1  #restart simulting expired 
            for nnn in range(len(expired_RyR_refrac)):
                RyR_IDs[expired_RyR_refrac.astype(int)[nnn]]=[]
            
        len_RyRs=np.array([len(pp) for pp in RyR_IDs])
        ONE_ion_RyR       =np.where(len_RyRs==1)[0]  #RyR occupied by one ion
        second_ion_RyR    =np.where(len_RyRs>1)[0]  #RyR occupied by a second ion
 
        if len(ONE_ion_RyR)>0:
            RyR_times1[ONE_ion_RyR]=RyR_times1[ONE_ion_RyR]+1  

        if len(second_ion_RyR)>0:            
            print("second ion same RyR",tt-1)
            RyR_opn_time=tt-1
            break

            RyR_times2[second_ion_RyR]=RyR_times2[second_ion_RyR]+1  #add times
            RyR_times1[second_ion_RyR]=0  #add times
            RyR_1et2_3_particles=np.array(RyR_IDs)[second_ion_RyR]
            RyR_1et2_3_particles=np.array([val for sublist in RyR_1et2_3_particles for val in sublist])   #unique particle numbers in the SERCA occupied by 2or more ions

        part_to_proceed=np.where(simul_yn>0)[0]
        if len(part_to_proceed)==0:
            len(part_to_proceed)
            break

        for jj in part_to_proceed:
            xyz=XYZ[jj]                    

            x_n=XYZ_future[jj][0]
            y_n=XYZ_future[jj][1]
            z_n=XYZ_future[jj][2]
            finally_append=1
    
            if z_n<=c_ds: 
                finally_append=0
                N_passed_bottom=N_passed_bottom+1
                simul_yn[jj]=0
                
            #hits spine sphere
            if finally_append==1 and z_n>SS_ul:              
                if (x_n**2+y_n**2+z_n**2)>R**2:   
                    if xyz[2]<SS_ul: #when coming from cylin to sphe, do a cyl_reflex
                        P,L=cylin_reflex(x_n,y_n,z_n, xyz,r) 
                        XYZ[jj]=[P[0],P[1],P[2]]
                        x_n,y_n,z_n=L[0], L[1], L[2]
                        finally_append=0
                    else:
                        P,L=sphere_reflex(x_n,y_n,z_n, xyz,R)  
                        XYZ[jj]=[P[0],P[1],P[2]]  #p is the intersection point
                        
                        x_n,y_n,z_n=L[0], L[1], L[2]
                        finally_append=0
                        
            #hits spine cylinder
            if finally_append==1 and z_n<=SS_ul:                
                if (x_n**2+y_n**2)>r**2:   
                    if xyz[2]>SS_ul: #when coming from sphere to cyl do to a sph_reflex
                        P,L=sphere_reflex(x_n,y_n,z_n, xyz,R)   
                        XYZ[jj]=[P[0],P[1],P[2]]   #p is the intersection point
                        x_n,y_n,z_n=L[0], L[1], L[2]
                        finally_append=0
                    else:
                        P,L=cylin_reflex(x_n,y_n,z_n, xyz,r)   
                        XYZ[jj]=[P[0],P[1],P[2]]   #p is the intersection point
                        x_n,y_n,z_n=L[0], L[1], L[2]
                        finally_append=0
                        
            #hits ER head
            if  finally_append==1 and z_n>ER_ul:
                if (x_n**2+y_n**2+(z_n+C_er)**2)<R_er**2:    #this means inside ER head
                    P,L=sphere_reflex(x_n,y_n,z_n+C_er, xyz,R_er)    
                    P[2]=P[2]-C_er
                    XYZ[jj]=[P[0],P[1],P[2]]   #p is the intersection point
                    simul_yn, inside_SER,  SER_IDs = check_SERCA(simul_yn,SER_IDs,P,jj)
                    x_n,y_n,z_n=L[0], L[1], L[2]-C_er
                    finally_append=0
                        
            if  finally_append==1 and z_n<=ER_ul:
            #hits ER cylinder                
                if (x_n**2+y_n**2)<r_er**2:   
                    P,L=cylin_reflex(x_n,y_n,z_n, xyz,r_er)
                    x_p,z_p=P[0],P[2]
                    #if P is actually inside the ER shaft, do a ER shaft refl instead
                    if  (x_p**2+(z_p-c_ds)**2)<r_ers**2:
                        P,L=horiz_cylin_reflex(x_n,y_n,z_n-c_ds, xyz,r_ers)
                        P[2]=P[2]+c_ds
                        XYZ[jj]=[P[0],P[1],P[2]]   #p is the intersection point 
                        simul_yn, inside_RyR,  RyR_IDs = check_RyR_sh(simul_yn,RyR_IDs,RyR_killed,P,jj)
                        x_n,y_n,z_n=L[0], L[1], L[2]+c_ds
                    else:
                        XYZ[jj]=[P[0],P[1],P[2]]   #p is the intersection point
                        simul_yn, inside_RyR,  RyR_IDs = check_RyR_cyl(simul_yn,RyR_IDs,RyR_killed,P,jj)
                        x_n,y_n,z_n=L[0], L[1], L[2]
                    finally_append=0

            #hits er shaft
            if finally_append==1 and z_n<l_neck:
                if  (x_n**2+(z_n-c_ds)**2)<r_ers**2:
                    P,L=horiz_cylin_reflex(x_n,y_n,z_n-c_ds, xyz,r_ers)
                    P[2]=P[2]+c_ds
                    x_n,y_n,z_n=L[0], L[1], L[2]+c_ds
                    x_p,y_p=P[0], P[1]
                    if (x_p**2+y_p**2)<r_er**2: 
                        P,L=cylin_reflex(x_n,y_n,z_n, xyz,r_er)
                        simul_yn, inside_RyR,  RyR_IDs = check_RyR_cyl(simul_yn,RyR_IDs,RyR_killed,P,jj)
                        XYZ[jj]=[P[0],P[1],P[2]]   #p is the intersection point
                        x_n,y_n,z_n=L[0], L[1], L[2]
                    else:
                        XYZ[jj]=[P[0],P[1],P[2]]   #p is the intersection point
                        simul_yn, inside_RyR,  RyR_IDs = check_RyR_sh(simul_yn,RyR_IDs,RyR_killed,P,jj)
                    finally_append=0

            if finally_append==1:
                if tt!=1:
                    XYZ[jj]=[x_n,y_n,z_n]#this means x_n,y_n,z_n havent been added before
                x_n,y_n,z_n=newpositions(XYZ[jj])   
                
            XYZ_future[jj]=[x_n,y_n,z_n ]

    return(XYZ, RyR_opn_time)    
    
    


# -*- coding: utf-8 -*-
"""
Extrusion is blocked by double arrival

Created on Thu Nov 24 13:59:36 2016

@author: kanishka
"""
#has to be fixed
#import math
np.set_printoptions(threshold=np.nan)
import time

start_time = time.clock()
 
simul_yn=np.ones(N_part)

XYZ=[[0,0,999] for y in np.zeros(N_part)] #starts at the top of the sphere
XYZ_future=[newpositions(XYZ[0]) for y in np.zeros(N_part)] #starts at the top of the sphere

XYZ,RyR_opn_time = brownian_reflections(XYZ,XYZ_future) 

print time.clock() - start_time, "seconds"
 