(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    546413,       9726]
NotebookOptionsPosition[    542916,       9644]
NotebookOutlinePosition[    543253,       9659]
CellTagsIndexPosition[    543210,       9656]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{
  RowBox[{"\[Mu]", "=", "38"}], ";", 
  RowBox[{"\[Lambda]", "=", "6"}], ";", 
  RowBox[{"NR", "=", "1"}], ";", 
  RowBox[{"\[Nu]", "=", "1000"}], ";", " ", 
  RowBox[{"initca", "=", "100"}]}]], "Input",
 CellChangeTimes->{{3.810542878487732*^9, 3.8105429051355753`*^9}, {
  3.8105568285010433`*^9, 3.8105568365967283`*^9}, {3.81064483334629*^9, 
  3.810644840256584*^9}, {3.810645951004271*^9, 3.81064595428389*^9}, {
  3.8106461848941174`*^9, 3.8106461863181467`*^9}, {3.810647520555151*^9, 
  3.8106475332431307`*^9}, {3.810647932062777*^9, 3.8106479339342957`*^9}, {
  3.810648167952594*^9, 3.810648196400414*^9}, {3.810649014745693*^9, 
  3.810649019161298*^9}, {3.810649577934935*^9, 3.810649592461722*^9}, {
  3.811064312763914*^9, 3.811064313067254*^9}, {3.811081589314761*^9, 
  3.811081598706313*^9}, {3.811083181313953*^9, 3.811083183393516*^9}, {
  3.811085319590562*^9, 3.811085320438304*^9}, {3.811085473911862*^9, 
  3.811085476038965*^9}, {3.8110855097202063`*^9, 3.8110855098793907`*^9}, {
  3.811085643401826*^9, 
  3.811085669993017*^9}},ExpressionUUID->"e8f874b0-0e79-445a-b164-\
1615e372178d"],

Cell[BoxData["100"], "Output",
 CellChangeTimes->{3.811086015914402*^9, 3.81108608320541*^9, 
  3.81576057679874*^9, 
  3.815760608179429*^9},ExpressionUUID->"e7f66c78-e181-4d59-86a0-\
e1d5e701ce34"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"s", "=", 
   RowBox[{"NDSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"n1", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Mu]"}], "*", 
          RowBox[{"n1", "[", "t", "]"}]}], "+", " ", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], " ", "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"2", "*", 
             RowBox[{"n1", "[", "t", "]"}]}]}], " ", ")"}]}]}]}], " ", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"nca", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Nu]"}], "*", 
          RowBox[{"nca", "[", "t", "]"}]}], " ", "-", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"n1", "[", "t", "]"}]}], ")"}]}], "+", 
         RowBox[{"\[Mu]", "*", 
          RowBox[{"n1", "[", "t", "]"}]}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"p2", "'"}], "[", "t", "]"}], "\[Equal]", " ", 
        RowBox[{"\[Lambda]", "*", 
         RowBox[{"n1", "[", "t", "]"}], "*", 
         RowBox[{"nca", "[", "t", "]"}], "*", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"p2", "[", "t", "]"}]}], ")"}]}]}], ",", 
       "\[IndentingNewLine]", " ", 
       RowBox[{
        RowBox[{"n1", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
       RowBox[{
        RowBox[{"nca", "[", "0", "]"}], "\[Equal]", "initca"}], ",", 
       RowBox[{
        RowBox[{"p2", "[", "0", "]"}], "\[Equal]", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"n1", ",", "nca", ",", "p2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0.0", ",", "1"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"n1", "[", "t", "]"}], "/.", "s"}], "]"}], ",", 
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"nca", "[", "t", "]"}], "/.", "s"}], "]"}], ",", 
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"p2", "[", "t", "]"}], "/.", "s"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{"Orange", ",", "Green", ",", "Blue"}], "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"plotofn1Fast100", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"n1", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", "Black", "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"plotofncaFast100", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"nca", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "110"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", "Black", "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plotofp2Fast100", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"p2", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", ".1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", " ", 
      RowBox[{"{", "Black", "}"}]}], ",", 
     RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.8106455281686897`*^9, 3.8106455290652857`*^9}, {
   3.810646204270317*^9, 3.8106462185905933`*^9}, {3.810647263481286*^9, 
   3.810647417561686*^9}, 3.810647493435939*^9, {3.8106475905885553`*^9, 
   3.8106476021732473`*^9}, {3.8106482943227262`*^9, 3.810648310259087*^9}, {
   3.8106483959554234`*^9, 3.8106483970594797`*^9}, {3.8106484399563313`*^9, 
   3.810648481988969*^9}, {3.810648803368124*^9, 3.810648864280178*^9}, {
   3.810648917352507*^9, 3.810648917545014*^9}, {3.810648950553649*^9, 
   3.810649005738225*^9}, {3.810649037290298*^9, 3.8106490779310837`*^9}, {
   3.8106491356913147`*^9, 3.81064914511545*^9}, 3.8106492915810413`*^9, 
   3.810650974748695*^9, {3.8110631437302103`*^9, 3.811063184033916*^9}, 
   3.811068240080839*^9, {3.8110682992154293`*^9, 3.81106830652777*^9}, 
   3.8110683717459173`*^9, {3.811081642132269*^9, 3.8110816916204844`*^9}, {
   3.8110817572374487`*^9, 3.811081771813155*^9}, 3.811082580509531*^9, {
   3.811082643934713*^9, 3.811082654126111*^9}, 3.811082698174378*^9, {
   3.811082804159376*^9, 3.8110828496308804`*^9}, {3.81108310862635*^9, 
   3.811083114850848*^9}, {3.811084738498023*^9, 3.811084807042286*^9}, {
   3.8110848481948357`*^9, 3.811084848482135*^9}, {3.811085004195816*^9, 
   3.811085004469384*^9}, {3.8110850433651953`*^9, 3.811085046324235*^9}, {
   3.811085084021165*^9, 3.811085084244635*^9}, {3.811085442232983*^9, 
   3.811085442806896*^9}, {3.811085547657012*^9, 3.811085548888027*^9}, 
   3.811085636842061*^9, {3.8110856752899303`*^9, 3.811085680601687*^9}, {
   3.8110857939952583`*^9, 3.811085800475136*^9}, {3.8110859958386707`*^9, 
   3.811085996172696*^9}},ExpressionUUID->"d3f45db2-0caf-4157-b9a4-\
decaf29dec0e"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0.5, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtV3c4F973Fw3JByF7hUoSkhHlHmSVkS2RPULZZGaEykz2yMrem+y919t+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       "]], LineBox[CompressedData["
1:eJw9mHk0VW/Ux5GmezPcy71J/chUCCUk6ewdqWSIQkQhqSRTZSxFhuYkJJqk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       "]]},
     Annotation[#, "Charting`Private`Tag$2516#1"]& ], 
    TagBox[
     {RGBColor[0, 1, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtmnc4Fl7Yx0XK+hmZ2SNCkqJInnPbySg7hLKLSMiWLVsi2SvJzN6Z2Xs8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       "]], LineBox[CompressedData["
1:eJw9WHk0VW/UNiVJpUiRJuGHpBQhbbsMmSMklUypCFEpKkXGNCCkuYgyzzNx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       "]]},
     Annotation[#, "Charting`Private`Tag$2516#2"]& ], 
    TagBox[
     {RGBColor[0, 0, 1], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJxF1nk8lNsbAHC0IF1bCJElS9ZwS7cu9ylS1rpliZQUJWTLUlTKFmUtQprs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       "]]},
     Annotation[#, "Charting`Private`Tag$2516#3"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.1}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.811085855381557*^9, 3.8110860159767733`*^9, 
  3.8110860832665977`*^9, 3.815760577062565*^9, 
  3.815760608466412*^9},ExpressionUUID->"788dbd63-3e36-4aa2-bd6c-\
714e7d202136"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtV3c4F973Fw3JByF7hUoSkhHlHmSVkS2RPULZZGaEykz2yMrem+y919t+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       "]], LineBox[CompressedData["
1:eJw9mHk0VW/Ux5GmezPcy71J/chUCCUk6ewdqWSIQkQhqSRTZSxFhuYkJJqk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       "]]},
     Annotation[#, "Charting`Private`Tag$2623#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.1}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.811085855381557*^9, 3.8110860159767733`*^9, 
  3.8110860832665977`*^9, 3.815760577062565*^9, 
  3.815760608511793*^9},ExpressionUUID->"23a74e4e-4bf7-4384-b8d6-\
57b03fd124fe"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtl2c4Fu77xkXK+hohe0dIUhTJc1+yklF2CGWHSMiWLVsi2SvJzN7Ze6/H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       "]], LineBox[CompressedData["
1:eJw9WHk0VW/UNiVJpUiRJuGHpBQhbbsMmSMklUypCFEpKkXGNCCkuYgyzzNx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       "]]},
     Annotation[#, "Charting`Private`Tag$2665#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.1}, {0, 110}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.811085855381557*^9, 3.8110860159767733`*^9, 
  3.8110860832665977`*^9, 3.815760577062565*^9, 
  3.8157606085485497`*^9},ExpressionUUID->"a28d2fc3-2a6c-43b2-aba7-\
71d943342b2a"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJxF1nk8lNsbAHC0IF1bCJElS9ZwS7cu9ylS1rpliZQUJWTLUlTKFmUtQprs
ZDeGMYYZhiy37EtIg+xkLK0qS7/z1vzqr/fz/eM953Oe55zneaTOu524wMbC
wiLPysKCfQ0vTHfSZsz/oUlwrTs59F57va6o+7DIblgfZuV14uMd+DMlEVcq
cgjax9s9/MtSYFxMJuCq3FF4tsntxt6YXDBq7SM8ETEDXi+KCKkNDzIR4lnf
Jazgsp73quvHUlgxtEs4J2cDdA1engeW5fA2uKf+XPw5+ICbX3GXroCT9kvU
ByL28LxZw/eFNxnqdUVJz3AXQen859t0t0pQ26GN/yjhCMdcG7285asAx2ab
K5vhDOf20DQYhVXAMRqYbiHnCrXJQtf+4aVA5Zuu1mdm7hAiNr6Nz5IC7v/a
G56O94CtmrbFAREUkKN9avzYdwV0DTqyXhAoMLgrVDdSxAu0WJbjaG0UiEsR
pslae8PEv2QbtTEKGPLkaVXjfEBAWMFY9j0FWG79TbYYugrkjO2jYqsUKJ9v
2bMg4QtHvA04VTZQ4bKNDSH0nB/Y6VKFJLmoIN22oCqZcR1UEv/Su8tDhX7t
gPyK8RugFHi0sJufClGF/DuPy/mDxZcGeRNBKuiJZ2bOONyCZKWAk6pbqeDf
mMRba3YbjvdG2qcKU8HKf+xo5KfbUFGqsr9WhAq7NZUjreIDgMTJ9ThblAo8
817NsnsDIeneG3PbbVR4m0XlfN8XCAS4w/iK3HBmo371tSDwF1equi5GhVTB
Y3fuiQTDjY/9/bPI11sT6i0qgwG/eKH0qDgVLELesO2wDgG8XmzIU2R1bYWD
C8sh4FH3JvcL8uZPHreqcHdgv2dcv+52KkwVVFJDtUNByNXJ9B5ynf26FdOh
UNC289rYinytJ+4aQ+IuHAq1SDaQoIJpxGB5Be0u3J/xPB+MrHpI7lPwuXvA
dWBMg4o8XkryEM8IB1s17zoFSSocjx1wOioXBWcOX1p7h6xstCNXtCkKrFtF
liWlqMCx7vLUpEM0+L2/3XcU+Sx5raTGLAb+Yps0f4osqBCjahl/H27oNB8y
lqYCW0iZSfXkfYi41CPjibz4pv+yzN4HoJd0SuIRcnOiVP5i3wMo/KPBdxQ5
gKNU/q5IHAizTJk676CC4pH7YQT3OODq1z4ShdwV4jbzuikOCo1ZTuORZdYp
56v6PITeXd3f3yE3rmaq9nTFQ6oK+ZmzDBXctIKiVxUSwI/f2iIMWfj6uUW5
gARgdxD8MxPZ8Ys4wXdXImzf8Y3+Cnnzh/g9EhGPoP+pqZO2LBWI6t7x+mOP
4PHn2kYzZBt30yWP/UnQKXw1yhm5eI6HXD+dBPxsxa4JyCemw7Sc9HDgWm7Q
M428LOfwJBaHA2qMwPwycuYFvTXKBxzIu1lEcctR4dMoK40n/QnwO6u6aiAn
DvrpEteSgYc6teyFfFDMKnPIPAU+07mTgpHfntq7gaMwBZ5zzvfEIm9n+NoV
qqRC4ehFxRJkN0dNWRZ6Klx80/5wCrk+LOtlHHsavPy6yfojsnCOwB2FP9NA
QVegnUWeCrTJ95Mn7qXBin5wszAyv31xTtZf6XDsipuRHvLFoO1W++3TYZ1v
M+UYclV6JGd7dDrgjWpnrZDtR5ydvkymQ9Mox10XZKLNTmWjhxkgz0Zj3Efe
5J9AH6ZlwNXYKZ8kZJsnGyO9GBlQceL5i3TkjfTxuSe6mTCpzvqSgGxplVa8
+C4TcNdEEzqQF16bbUoXzQLHHa3ifch3bDgumOpmwUBjxc1B5FI7N9HyuCwY
5BlomUHmdtUOub43G07Hi9BYdlIha3FxWNk2G9Y1EHduRNbyzNw/FJYN0ZvV
PbiQna5xLR4YyEb1tCZTELkh8NWpjTefQoEce95O5NMbIomkrKfwp/wDWRXk
96EHeB3bnsIBQ/876siSkU8bmiVygHeB8W0f8o0Eb7X7dTnQvZBcbYC8RVQh
XGc2B6YbSr1NkPNw9IkPW3JhpKJM6DhyX5ruY4sLuZC1IVHYElmjgG+jGEce
7O0MV7iA/Fy1wbZVLQ8WCN3al5BtS65V+VvlgZl5FzgjR5YPu4/k5QF3Jp7b
A3maVvg62yQfcnoXR68j39I9p2npkw8Gkibu/shCjQL3OVPywfxz0PxtZN3m
64cvL+ZDXtVAdQhy8kuDEvXYAogpjqqIQt5juco1VlUAZkX8vTHILQP4i3Hj
BVB6l33qAfLX4a1iS3sK4Vv45fF4ZLO3E3co/YVwsXPELBl59vKjERfWIiDz
kgRTkQMXjLUkFIugbmpHSxoy/mPpu4DrRaB2gCyahcz1PeD0ke3FcOq/3Xr5
yImOJ22UDxdD1FdWQgGyTI+yLZ9rMbATA4WKkP/J7bN7TS0GhrxNEx6ZnBtP
JKnigUs9tpWIzHI2QDNPBw/k47yr5ciHBS6TcBZ4CDHKkq1A7vY/SA7wx0Pd
W/L5SuQ5UwbFCPVZo6u9MdXIuzn7tP8ZxUNBr2lkDbJfdW212mc8vGPlD6Yh
sysk0AS3l0BKwYBtHbLU2sH6YZcSkAtTfN2AfKlUWa8roAR2euwvbEQuurS1
sf5hCfw7GeDXhPx3N6Mpl1oCRzuV2J8jm+ckNHv+QQCnrLbZZmTcmUDji1IE
mGeLSmpBHuV3abXcQ4CwQTO9VmS3mzrt2mcI0BFxMroN+e6JuS72QgJYvwhY
6kDuYO83/UYjwAPu8bBOLP/Uuh5GDwFMLb8IdSFnyCf2dq4Q4FljkEI3MnVF
Z+CxcSnUW0opvkReT1CxjrIthfi7ghmYDR2E6be9SqGKbCDSi93fzrnBC7hS
mCCXrGJ+l504sotRCnI4xZx+5L9OB52XZimDJufmza+Q/flcxwQEykAmQdoN
M9cN3Ymvf5eB2epOlQFk2ePz08/Cy8BB9Uv0a2TRW0f2O6SVgXwu4S1m3sLU
8E2kMhDWU9elI3/jMFU9PloGM3T8HOYOGslz6C8ihLRoKA5h73metyHgKBG6
O4O9MFeKOQnJ2hNB5x0rFXPWNTGyczQRbEPy9Iex/KoFrH2ZIIIb55zRGyy+
NgPHcMtEMD3dEobZPgIVT75yCHZVqsd8bHpC945WOcTkRmuOYPcz1fDulthy
+KbJ2DSKLNKWMVCeUw7xcv9pYeZeWVE6VV0OW2mOLpi/nixuS50ph5Yw8WbM
bTwCAqoHSCCnwO07hvxM2+VCpzkJ9AUm0jBXODeWezmTIMeu8jnmjKZrVlXx
JPBh9RMaR752azBZf44ES70fMjG7FGouzrJVwEGSQyPm86+jD0YLV8Dfjzmm
MJvs1Rl/qVsBKV8mZCeQpReyFeySKkCh+VES5q3iLNc34itAJIKlHPNmI6uW
3IYKOJBc2YF5KZvLbXGxAmx37ls/idUHG/eym0fIgFfutMNcF/F8g9QZMnzZ
puuHmVQpfbL+ChmUouVjMKcLoc6UTIaBIvNKzFfb9kHiRzJwqmdwTGHxUiVO
POeohI+27SKYMyPVIpbFKgHs4hUxdxrLv7LRqwQX/TVDzErNAp6y8ZXAUPMM
xVynGCNyMq8S/BzKHmK2vMdFC6uuhF3BaRmYQwzY/mBMVkKkd2g15uGmhWzC
3iqI+bd8EbOPvLPJuFEVOHqEr2DeHDr5QdC2CpxYt3FMI+87PHjAN6wKBGTd
tmOOrX8xAK+qYNVjqz5mRZnDAR5zVXBlZOY4ZlpQrXwGKwW+3gq0xjynU+G1
UZECeaybXTEfqc3ibvWjQL9oegzmIUkp4loUmrsfPU/E7HUbZ62WQQGuJVoq
5jSIzYltRnM1fQce8zL1ts4pNGdypPa3YH4gvjIdrob61o0n3Zh33rwaTT1E
hRjP/QOYzbVc6ZIuKM4WLFOYiyutfaao6B3n9KxhPizaJybShfqWoOf6GWS6
74lnhpNUuOewyImZc58BbxF3NdAo9wQw25E087zOVsPV0hM7Mcf4qCz1hVaD
Vma4OmbqHplDf+OroeFPq/2Yt5bxDbGy1oCiQL0h5nT7ieZG5RpwOLnJFLOy
IJkcblkDJ7RmTmHW8bF9KIivgbmYQEfMrXK7gwZe14BR0WF3zAWzQRXt62gg
6EL0wayJO5kdt4sG5d8yAjHXGivFWVnTQFLXJRKz8epawPZQGiT6qCZg7i3s
chsj0MCblyUV8zmb7DM5QzSwjPvyFDOD28/IZVMtZOxSKcbsU2OyT0OzFnT6
8UTMrO5S8kvnamG7S1wV5gjJTwKUyFqYsZyiYU4LwC3qTdTCsSC+F5jLR3Vb
2rXqwGcyshMz+ZCoJGG6DhpTAumYKdmLnnFxz8CbOjqGuYajqcnnQD1w9vdP
Y65zerLNilEPQud3MX7kR99FcJ1KI3jMNCxg/iSnzVPo0gQrt2+8w7wS/ZHH
/vl/MGth9R4z29d83m2yL2A0mvLDYjfu2JEcmyF9w9QPa363LTctagG61PIP
s9YZ6kQyWiHoxvoPmFuCd7c1KrYD3zuOH9aZCcRv1OmAp3u4flgiZvZr7nwH
cBhu/uEN9RcYNdGd4Ef66dml4aGXal3gtPTT+u9aza4Md0Ev7x8/nPm26gV3
VDcYSfz0qyD1Qd99PVAh/dPc4k8Xxsd7YEH0p010VfPrgl9CMN9PRzgSL6bK
9AIb908fNMdnre/qBTrTnw/kj1+61Qd6zP2IZFILSPVDLNNeGvVlQs/64S7T
ee6HJL2uvIIWnp8eLqoP75QaAGOm5yJaYldbB0CW6WWnnscKfq9hG9NbeueM
/xOlwx6mlQ6yr12sooM102SPOI0Ix0FIYfpIupRDydYhIP5/v7O0QwaVQ/Ca
6aviZ6VHTg/DGNNqxlfOxhUMwzjT034huCMrv63MMOfqM3kDE0ynrkrfM8l8
82u9LTyLHPXf3kAP0/whDasL3CO/zLuc9H7bjhHoZnrzlB7d02gEOpheX/O4
eAduBJqZdt5d9YrTaBSamM43OJ9a/XkUqEx/mhXlnYwfg3KmiaZH1sUdGv91
3lv6ISllk+NQxrTUoGF/RsjEL+/fGxwnojH5y6e3t39l7Z789f+nF5Gj7gFT
QGI6cb2N1wmZaaj4/3mHiOls9b+94WaA2T6PGSAzzZJrUzzK/xYqmb6SVBzJ
X/fbVKUwDj7XWahims/winIgN+OX6Sod3b4UBlCYxieDzLjN3C+fKdbkE1/7
7dshaQH0vPlf8SmcFn/Mbbzwy9LBAvrs2b+dIMH16fv33/4fMvD5ng==
       "]]},
     Annotation[#, "Charting`Private`Tag$2707#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.1}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.811085855381557*^9, 3.8110860159767733`*^9, 
  3.8110860832665977`*^9, 3.815760577062565*^9, 
  3.815760608580278*^9},ExpressionUUID->"a0230344-7966-4f61-8eb7-\
9b0d9aa33f76"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Mu]", "=", "38"}], ";", 
  RowBox[{"\[Lambda]", "=", "6"}], ";", 
  RowBox[{"NR", "=", "1"}], ";", 
  RowBox[{"\[Nu]", "=", "1000"}], ";", " ", 
  RowBox[{"initca", "=", "300"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"s", "=", 
   RowBox[{"NDSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"n1", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Mu]"}], "*", 
          RowBox[{"n1", "[", "t", "]"}]}], "+", " ", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], " ", "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"2", "*", 
             RowBox[{"n1", "[", "t", "]"}]}]}], " ", ")"}]}]}]}], " ", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"nca", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Nu]"}], "*", 
          RowBox[{"nca", "[", "t", "]"}]}], " ", "-", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"n1", "[", "t", "]"}]}], ")"}]}], "+", 
         RowBox[{"\[Mu]", "*", 
          RowBox[{"n1", "[", "t", "]"}]}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"p2", "'"}], "[", "t", "]"}], "\[Equal]", " ", 
        RowBox[{"\[Lambda]", "*", 
         RowBox[{"n1", "[", "t", "]"}], "*", 
         RowBox[{"nca", "[", "t", "]"}], "*", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"p2", "[", "t", "]"}]}], ")"}]}]}], ",", 
       "\[IndentingNewLine]", " ", 
       RowBox[{
        RowBox[{"n1", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
       RowBox[{
        RowBox[{"nca", "[", "0", "]"}], "\[Equal]", "initca"}], ",", 
       RowBox[{
        RowBox[{"p2", "[", "0", "]"}], "\[Equal]", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"n1", ",", "nca", ",", "p2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0.0", ",", "1"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"n1", "[", "t", "]"}], "/.", "s"}], "]"}], ",", 
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"nca", "[", "t", "]"}], "/.", "s"}], "]"}], ",", 
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"p2", "[", "t", "]"}], "/.", "s"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", ".1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{"Orange", ",", "Green", ",", "Blue"}], "}"}]}], ",", 
   RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"plotofn1Fast300", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"n1", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", "Red", "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"plotofncaFast300", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"nca", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "320"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", "Red", "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"plotofp2Fast300", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"p2", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", "Red", "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.811084843251658*^9, 3.811084843586863*^9}, {
   3.811084994211817*^9, 3.8110849944673643`*^9}, {3.811085097893821*^9, 
   3.811085112724533*^9}, 3.8110851858640633`*^9, {3.811085417209165*^9, 
   3.811085417735263*^9}, {3.811085497930655*^9, 3.811085498280171*^9}, {
   3.811085550682229*^9, 3.8110855517205563`*^9}, 3.811085599465701*^9, {
   3.811085635449704*^9, 3.811085644841844*^9}, {3.811085686986155*^9, 
   3.811085704794312*^9}},ExpressionUUID->"6ca3c337-ebaf-4325-b8cd-\
46f73707a9a5"],

Cell[BoxData["300"], "Output",
 CellChangeTimes->{3.811085857203073*^9, 3.811086016163554*^9, 
  3.811086083450727*^9, 3.815760577176807*^9, 
  3.815760608607245*^9},ExpressionUUID->"414a2874-6261-483b-98af-\
7c6e022e877c"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0.5, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtV3c4l+/3F5WkD0JllpVUQkWo7ueYIXuFCCFE2YSUrbLLiCJCJSV77y17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       "]], 
      LineBox[CompressedData["
1:eJwtUmk4VQsXFhnKEJLmRINUlIqollVIxxzl1jUT8VUopStJCEnD6UaHJA2i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       "]]},
     Annotation[#, "Charting`Private`Tag$2772#1"]& ], 
    TagBox[
     {RGBColor[0, 1, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtW3c8l1/0R8vK/maESghJEkm5z0GSZIVCQ1ZUZlZo2DMkZCV77713Vvbe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       "]], 
      LineBox[CompressedData["
1:eJwtkXs01HkYxkW5xYh0dSlkM+oUtqT0ehVqXKKs4iAGM81gzEzaChG1dLAV
SZncVpfpMqkmHLdsZLtuptwjmSTp+v39KorUsvacfc55znue8/zzfs5jFi7y
5aqqqKgETfq/+9VBPy5jHkGV/8Vun7XhhxnBvqNbY5tdlsG+Rotsd3uCDuWb
R6qzWeCUwl3d5kBwqXq4sj/XA1SdLvQHOxIsjWq1Gc3xgvQa65ViZ4K1UsfG
A06b4aTc9ulJD4Jb++V09VQ/kBfjooEQghe1TXOtpwXBUMKQRlgYQdenqUyX
9iCw97/wvjeCoMdAH1NWEgw39PTKn/AJyqMKGnbahsDdFOW6h7GTvUJdIT3F
Bs3tOZas3QTP/J1Oir6ywXP1Bq07ewnetboo8fQNg+ZPV5pvJhLM5m+ueTQt
HHrCk0LLDhH854yz9/ntEWCKti7LMwiWb7lAEuURwDZ69VPp7wRDFj0SzFHl
wGCbFyXNJjicR1b8cZoDH12Nk07lE3wRHjN7aSsX1BffyE+5SjDwLQibxnjg
riba/4+coPEmuXr1Gj4cfm4enlBOsCvIipkazwd9SSbz12qC3T219neG+GCs
FVjNaySYYxBRbNwTCaGvdAsHbhO0SvghdzKIgjO3biWH3SPI3HzzjA8rChYn
MDcGNRHUveTl7XY9Cuzej3Z4dxJsrz1CX98TDbvvldY87CJ4fx3HMkkaDdVn
2UWsHoKSsbQst7ZogOD7nPV9BMURa5d0LBEAS5E3tPIdQcFNocysRQCZlzyf
lH2Y3DtFUqo5KgBF2kTtcpoge5WNw3eTGPB14h1kDhN0fr1mtjYvBrZfs9c3
GSd48lvlnClUDFQGjjKaVSi0+XN4+twZQmCo1+r8pkZh/3CCx0JbITQEg+Zb
zclc5q3QFQthZ3mDmg+Dwro5DKpHJgRzbdeJipkUVmqcGCt8IYQ29r2x+fMo
ZPDqnSMMRZBa5fE1xZTC8XmRjHUuIljJePRp0ILCv6YKr7OEIhjkbCFeTArz
psv2Hj4hApZBwMDcFRSGjttL9btFIKsP6RlwonB+5shBWw0x6MRwW+XuFCZU
BaRqGYlBOF/wINGPQpQsYwRaicFud3yVYRSFZVVfJRk2Yhh5fEhamkzhO1GT
UstcDIFJRwrjMik857PLd8JADHXWucddT1BYkx1g7z4uAtOu/MwZJRSqdyr6
0hQiSEk7feCZjEKdY5YzN+aKIJ8fYzB4jcLROr0vbXtEUO65+ixdQWFXr85g
pf8kj37LbdV6Cgu7XWNrJ/k9i1U0mW0U6lYrigOShMA50CSx66JwWeZOjr2f
EPZzJMy1vZP/atj9/IIpBLm1jafPawr9+nQju1tiYHZV6NHd3ykMU//l9PCs
GLDJX7IgWYXGErvx+T0DAnBPGrmWPo3GtobHedPKBZDoktVSoEfjKuW7OeGb
BND/+KZhowWNzUYWRd37ouHKG5MChheNbpLLhnebIiG9KI2t9KZR1tsddfVq
JHB8ieXVLTQGTOlwO5cdCcZ1dfJN/jTK89b2N/pFQmZW0N3D4TQGfzAyMVTy
gW9/6pN2PI2jubG97iM8cH2vUvV0H427nlxrce7hwYISfqJsP42s+wMyYT0P
OrUcNDxSaezgO3Pi03ng1ttpnJFF4/FjWkHHTXhgnmrI0jhPY+aLNQXG23ZA
N3nZev4yjclKH+2KxTsg2798+4brNBalf3vVOcaFCWvfXWl1kzyp7LP657lQ
mWs2vqiRxlYp65Xvfi4Ixz+m375HY5yhkV9sABeetWQVq7XRyIxvjys24EKu
YyjzbBeNFjh4tP0zBzylyyrWK2lc/XlVjmMHB1T1xp36X9IYMaa0e1PDgdo4
xYMDb2ksqP+4kC7hgJWX4HnDMI1oJpOG7OFA3oLpXyYmaJzur3d6+TYO/AuP
ncQI
       "]]},
     Annotation[#, "Charting`Private`Tag$2772#2"]& ], 
    TagBox[
     {RGBColor[0, 0, 1], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJxF1Hk0FNwbB3AiS3qVoiJishQhLWihJ0spoV9RSLZCtpC8EkVjTVlaJktG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       "]]},
     Annotation[#, "Charting`Private`Tag$2772#3"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.1}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.811085857203073*^9, 3.811086016163554*^9, 
  3.811086083450727*^9, 3.815760577176807*^9, 
  3.815760608656857*^9},ExpressionUUID->"9ddf1406-f5ac-41f9-be63-\
9d674b52a513"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtV3c4l+/3F5WkD0JllpVUQkWo7ueYIXuFCCFE2YSUrbLLiCJCJSV77y17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       "]], 
      LineBox[CompressedData["
1:eJwtUmk4VQsXFhnKEJLmRINUlIqollVIxxzl1jUT8VUopStJCEnD6UaHJA2i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       "]]},
     Annotation[#, "Charting`Private`Tag$2816#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.1}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.811085857203073*^9, 3.811086016163554*^9, 
  3.811086083450727*^9, 3.815760577176807*^9, 
  3.815760608697036*^9},ExpressionUUID->"9fbdd179-033d-4608-87d6-\
3aaf5db6b676"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtV3c819/3R8vKyicjVEKRJJGU+zpIkh0KDVlRmVnRsmdIyMree+9NVvbe
472MkFFJhL7v3+Pxe/3zetzHOfd5z3ne5z333NNG1ppPqCgoKLIOUFD831/p
yWJ/w7e72MkzYy3z9bYyB29w2sxyiAMPLZ6pJNBc5nJ8ZEwxhzxwhz7PSZEx
kSFx8bm9FFCDfgaK9LjWRzLK3aNFsRzaYGR7Pm+UeFeGL4A79d9JPVB+a/0D
z6Yhs6tkHGEooA/BUqmS/zJvySx5DjUbhhsC/sIFWg5TWRkdk63aEA4T8B9t
Nd//JCXTfIOz/EuMKTi+WLW63ycmI3oGFfw6+QzilJPkq7LPy8RQGWTyJ5uD
v3V18oAenww1wT3pnoAVFHpuaFuuc8tU4Qa6v2jbQBdj9t+5w8dlbDRMlB6G
v4COK5RpPRJMMgINm62/Rm3hQcj0hODMEZnpiz43AjnsodDlhVtAGKVMWDx7
A/8DB2DqU/z2eGkblBizpOtiHIFUKhv1iOcnULhcr7w38xJ25CNpBbAVKFvt
klg76QwXJI3k1kkksNDXL/IxfAU/V81tH/6dAd6eNZFTya8hxO3KkV/UozCG
3LIrSG8g1eFGYZVoPwTlspy7I/AOJLj2FWTbv8JN7pSUb2YuwJtf5Flu/wXe
tUYzNWq7AgeL2WW/qFrQe0dUC9x0hWHqdCWlujIQvyIcqBfuBnqH/jt9obAQ
GFftO/kl3aH5iJzVx7VsWEqtpfkx6g4CDwwe37VJg5ZHhxXrnDwgSAyFqBgk
QcJ/6t7+HJ5w74oVdUhNHLzujmi+V+UJX0lG04E3o+GeF47qzAMvmPlaedXn
RzhcQoKya3+9oGFqQeqqYxjQb75wqY7xBv4WPGk2IgQWcqpqfZAP5M9UH2u4
8BGaTA7sas34QJA5n7EwRzDEcqlcO+XiC7c5j5aL+gSB01CY08pJP1goWAwm
Xg0ErYDpsooGPwCTlkHGiwEgIi+w6WnoD+k5Q4e7dN4Dza7V5TtU7+HMFSbX
1VR/IBWXv+BOfg8PV29ltjH6Q705RcG3GwFwX8c67mqQH0Sfub1aSgoAQkto
8yEuP3Cc/Cjs7hUI5lq/c++W+sKd0InnagJBsHc6nVNLxxeElc9kcrYFAfPH
EPnFfz5AfcBiYd7sA/i2VvkF5PrA48r9wnrtYCCJ0Ed/PeYD/wkGi+iGf4Sh
Xd7ft8i8UHmVqNbNf4Syi3ZdoxVesI4bs+CTDIGiPZYPXi+9oDPydPb6aAho
cG78GdnyBDfq4rN+HGFgUHz8eyaVJwjd+uhbZBMGNj34njtNHjDgZf1tsi0M
2h79rut39wC+A8LZIo6fgLIPf0zhsAe07qWIDA2EA99n0Xthx92B/me4xMmA
KHD8Rakre98VSi85hCsSo6DceiO9j98V9G20tl5ci4abRYeLmUkukP+dsbJ5
MRoGjqhZjrC7gOair/TzmzGgOjgp/+rjW4icfnWjdD8OTnxXUymrfgWyXHop
M3fj4bhL1G8601ewdF/yEHVuPODpx087ML8CnhVn49wLCRAvxTFkZ+4M1s+u
8FNMJUAN33OaxvNOwGKSn5F6NQl6Fe9q9U04gKkHj941kyRQl7Nq6Q9zgOqk
QJreD0kw13FhtljdAUzw5s//zCfB9Z9/ZBjb7aFU/5yw8qdkmJ4qPDrcZAe6
eon56xspoMO3yHpn5gWsTWrTJnGmQs/163bEjBfgrU/9ROtGKswENZ4+bv8C
io2tOcvCUiHd+l2YNv0LYLBCXq8l0+BZP3b03w0baHEfv3/4bTq0iwr/Phxr
CQ8PBZaWp6bD+3gnSnd5S/jhI8P0rCcdgikH4g5/t4BTgektnSczQNPrBs0J
WQt4E+Eg+rEpAy4xnHI7t/kcxHKYD3NRZ8GsgHmpvv9T+CrSYtAtmgUiQ2b/
0cg+BYNCp+p3ellg3/3kW9AfMwgsm7XBZ2WBXVN4Lu9zM1hsyJ1MU80GHzkf
fz4dU4gbvl14KTQHcutZ2l/dMwEJ3T06YnUOKCotM1eQ62jXRIFpGCkHnAof
bmVNG8P2LBvXlkQuPIuvV840MwbtpTnvmrFc8FV+R9nnYQR0/9we3uLJB3Zc
1/dDkwYQ+UxHX1ghHxQbMyozMg2Ab0jYgNkqHz5vr6EpJwPAMkeNJ2vzIer9
m9JVdgOozAwvLRcpAAnqJt9z9frwXWulRrmnANRQnNAxuocgTjOKMEIBaNfx
H96qeACv6hrrRH8XAG11zUyn2QM4IhjR8B9PIbzOF0xF7ffh9L5s86xlIexx
zW7+DNWDuxkRnXZHi+BZJBeDmrYOxDxyVzE9XQR0T63Vdxl1gMBi2a0rUQT6
Bzd+2XTdA+u3cr3oUREEFOfJ5966B36a3weO5BbBMK9f68Vbd6F2V27is0ox
vKFACjpPteBg0YUHQQbFEMO0Oup9UQuUzNinXO2LgZp2rPfhliaM9n+ffhJT
DF6Zeo9/+WrCRlok/uJKMbhPjgvEFd8B/juri1/el8C8Pe0hVX4N4HS5dc0s
sQSs4rUpeEjqwJSb8J62vATSH21yLLxThx1qLZE7hBKYeGPCLlWhBn0N5XYz
V0vBo7CR21pKFV6Juu3/mSsF0u61T9O2SmCtP6Ee87cUaj1EElZ5lMAk4HIi
MJcB/VhhJG3XbVBfnLvhLV0Gh1jxD+8J3ga+BCW/Y6FlIMc8sUtYuwU9jKys
IjLl0G4e8IAy6yZ8QZZP+u+Ww4UlCUHpJzehwry1zN68HBy8NnU1Tt+E5DYn
verwckgiJFNQxMiDk8t0nOL3csjXItXc/HwDeNfSBI2jK0CnlE0xpU4W2Lgp
Xh8uqIBOO5sL97xlgV5ZryuzpQKWz/e3VqnJwlYanfX6egWccqotCcXLQJe+
TcnbW5Wgbehjr8AoAy97pCDyVyXoB4xINzMjYBApnftKXQVJFpdupVdLQ0qg
aMBfripIfhmr6GcqDf0qZ8f1b1bBv4Wdl1j9dTjfyWrHH14FI8cai7jeXIPZ
trW0IslquPuA3Ufw9FVwPGuuSlKuhuLnHs9TxyWB3mf+538G1YBfZU76GSIJ
UgrTMs6+1cBtYj5MQy0Joc0dEzBeDfqfB3nZdyXgVmMqQ/erGti4vfX1yxFx
mDl1unQ/qAbOZJ63tei6DPauMQ9Ek2uAOmNLvfXjZUiE0IzQzhqY49174slz
Gf7Wusrd56oFXaejQTgQg/yqB44LtbXwdh+GAxNEQYFzlItjoBYmK+uiVK1F
YcpZ84vSfC18y22Wi8dEgUbqNlMeQx2kMVGEEWovgnH5lSz7x3Xg+KDmvryK
CLCVMM9QUtbD0bqKvZro8/Aw4K826Xg9cH6mb7ggdx6STOY6W4XrocPyx5vq
JSEQ/q+y8r1uPTRf+tp5CoRAztHg038F9aBA3KIq/3UOrsTopIVdbIAz5sEz
Nh8EQM+3C+91rQECWhXSOW4JwBt7We6XNxuA5RcrXeI/fmhUOR+m96ABpryM
ft+24weVvX03Hp8GEH1rcubMEz4w1E97lDHTAINBy110NrzgqXQiKupbA+Bj
HZXnxHkh7UrwkP+vBqBhMrn4duc0rDC8UrakbYTtRV72aZ/T4FivKiV2pRHq
JMqWj2efgoBTm6w1gY3QP7pfLHWGB/Lon2vkRjbC9VAMApq4of/PzPu45EZ4
dUgax2rMDcf726ncKhtBiKcCVaZzQaJbzPrNuUboxu2cnsFOQBnhRlevdBO5
/hNT5BLZYUTRbSPwVhOoyR94GKXFDr/z6o6raDaBEhWhjHiYHSRfSxm2mzWB
Qn7SnI0NG1Qcu/i7IaQJfgBH4bDacaiU5zxVtNgEQu9LkxTEWWEiS+emzc8m
uHxN/nPMr2Oww/Tpuch+EzwN/GdcVXoMrk0zlmYd+wIqOp1u6teOQZXDIaVk
7AtU7EQpvFRhgZq0dbuwsC9gdoXjeEMIE0zRi0Rpxn+BJU3CRIA+E+zamtcx
ZX2BzwwShntCTIBgnjqw/gu0uEZ5+L5nhLrRyVivpS9QP2DBYXCIAeqp29oc
ZZphtTPTN02UDnBWB7+LKzdDSl9N4/4ELVAMy7L8vNsM7QFCr0y8aUEmseah
tXkz+Bx9EKGEo4EGqaINs/BmsCjG/TuZQA1Nz2NP6K00Q59jss6aymEo/mZu
rv+7GTZreIuk6A5DytNr1cYULeDF9GoPOg6Bl+nofSvWFliWj3D1VToEikbM
0R7SLeCvS+jTuHsQevW82PMCWiCz4Xtoqh8VNIxpPS0Ob4Hqactdbi0qKNDh
rahIaAFjc2NLI24qCLlbr/OlpAUejT8zuVxCCffubIePTbXAollElv0CBUwp
Wv534EIrfBwYGTw3uI91t11/Qi3ZCsBw+coHp32sToG29KhsK6gKu8ZRndzH
4uXTtdnvtoK6XXYjlfUeZiSDD73wthWunVa/R3NiF1uUvMui290Kn/kcLKoT
trHxsjNGj0ZboXhey9b97jbWIfGj0AjfCqxPPmqfpdvGsi9/uGO5SbaH/NP8
5/QHs7r4Ndiduw1symlHIvW3sE0BxJhr2QYTkgk6mWqbGEaQa/N3aoNrN2SE
PWg3Me9YRZenHm2wbmfGLdL2CzvOqr12JqoNpPnrc/7K/cKuUJr3Rje3AVsb
aXlA/ifmNBn5wfdEO3xV48GFWW9gDeFxt0wF2kHoqSm96tUNjFoz5d+NS+3A
ElXFW0C5gUW151v/U2gHW1OWEIPwdayqtFXd0bYd8rk/Hs4JWsN2P/xiNPna
DsemLZh9/FYweeWdNtmhdhhgrNL1F1nBAg5TuJ6cbYefsUdNSoeWMe63dOsT
v9rhefmPxwp8yxj2nLfvzqmvECLsk57c9w1zkdcIhpdf4Wzc9X2u+wtY+7+7
itzuX4EUVNTrwLiAMVU/oPgb8BV2/8gzZrbMYwmXzGzKkr6CyIWwvgbxeayB
553GhZ6v0GFNGHlxag6j2s5mOsHfQdaV5CkGbiJ2olvuJ1zsgItNvWeukgiY
eOL4sIlUB5hO+PAdziFgT24f+Zyn2gF4ujFZF0TA2qOM+OUcO0CuvFVtygyP
fbjGce1ZWwf8bZ6v+Vc4i2UwFHAF9XfAB81XvRZas1gDQeFf0WQHNNmMS+1s
zmA//O2bd9c6YNLnwJQVNoPdm+xVC2bvhArDKXrNqSmM6423cfmzTqBmPOSq
d3sCk9DgVpiy64RrJUd/O/8dx9T4Ss5RvuuEH28uf87LG8dcuvDflUI6oYvZ
EH+ffRwjcCGnmapOKHJkMF75M4pl1v4MOETfBcNiMZPOpGGs6aO/tdDxLli1
dWYUiR/GJp6c1lQ/1QUgY9TVpDeM0TOos0WJk/2tj66U9g1hNvpZicKPumB9
oY5lc3wQu/LPoEwrrwtwNdMLJLYBTEW1wf1mRReU59CgBUI/Zvz5pLpkUxf4
4qY1kvP6sWDJmQXOkS74yWZA/H6rH/tm/YCDsNcFGREBf13d+rAY3N03Nqrd
cKTsy/VHPD1YkUipopFONzQF19o9bu3G2t+w/qdt2A32Isucmtbd2Cb7YK6k
Qzcw6POUbnzpwtTuaMzux3RDHQqkd37ZiVE2KckFrnRDfvsH06VDXzF2piwG
l9/dkHq4Yzmuth0T0aeZtKHoAesXjxXOvWzH7u+02Wmz9oDYDKv67dU2rETs
ZuoJ6R5I/pvGXTDfipkmA3XW+x64d/uJX+Z0M/ZmI27o86ce6DOcSrNLbMZC
YT8hML4HcuE+buhJM9YwWSP1orgHNJY8Q7fXvmAcrNfMr072gEmQ1oIx3Res
y1O8p1WoF6QaThfoGTRi1xg7qT5K9EL7pdeXDAQbsYwoQ8kHMr2wcdbVgfln
A+aRF5SwdrcXlMxny218G7BrY4u27G69MPjrqfxPh3os43ws2/PRXuitpTu1
6VyDHS+7rCJO6IWf+v2vPE7WYJ4yHa77K73wFCtGp1ursYKsv/a3KfvAPdo9
5OXxaux9/bmZ6eN9oOcoGTHxpRKT++ZecFiuD6J2TSK0HpRjziI9Hea3+uDs
x6Xj5SzlWIEdx1yfSh8sPPulFt1RhvHs53N81ukDoeXO0izpMmybZdr9omUf
mFqH7pwULsUKpCXv6kb2gcr5UItK/mJswc3duja2D9bnLoTIfyvCeNq6/XiT
++C7fJqzXW4RFnDHpG4ltw/G79K78UgWYU9NP551+9IHPS/ZvVm0CrGTwcvb
mat9MCR3bDf5UT5WZ+iSWfSzD/jcp88TKPIx/cvH9Kr/9IHn84sMUql5WMzI
tYouqn7QobB1uLWRi7Fz+zuuHe8HG+1m14DwHIwl69xPceiHX4xuZwkMWVjh
65okJN8PSrS/WA80ZWIaqhqaCrf7wbkkXeegYyb2Yf1loY5WPxhKkpjjcBkY
vWSb9SuzfmDWirEUbkjHDjU/Wan/0A8ZnwY+taelYimftj+3h/WDiacgYdc0
FZM3C1Tuj+oHijfZvwhnUzF32tIsQnI/3Nca5SvOTsH2NQ4+O1RBxuejvFlc
nYz9mU6aU8L1w8xxi5Dje4lYRP6VT1pz/SDE5pfN0Z6IXXHrkH+41A9B9Hil
wtBEzIHvR7Llr36I/xkQFCSciP14LmsUTD0Av5sI5TJPErDlrdmZYdEBEBUN
PSxBisXKzD40KV0ZgBa/mb4Oz1jMdRRLq78+AGweXHFeArHY8fJYy0yFAVAm
HFlStYzB5Bwf7L55OACFL4wPPKf+jEX/GuHg8x2A11wVv7psI7EnJt57kYED
8B13VqeELxITHZLAHw0dAPYf5jKfRiOw1uKwjK3YAbhq4ZInLhOBbdhqSnYW
DwDf5FUhN65wTHGjW9t2dgC07zidTdoLxY4Zvr26QBoAhdRHLwxrQ7GZPmGu
h0sDwP2jX2DpbShmX/CeeHNzAIr6GK20KEOxeOvbthx0gyDI8TrRlDkE+/29
+UPDlUF40KT/CbsbjDU+sreTkB6EJcFzHbWngrGA7jM6WbKDwHM0a7ls/APG
m+vOE6YyCO+EjqkRjn7AVC1kcs2MBiHR20hpzzMQS1mq7mAIGoRv9oKmvbn+
mFWE+pnnoYMgFbh7b1nPH5OUJ75uiRyEtKSKItEj/lhHLO2FN8mDUBVMyTli
4odtaOh9+FYxCGwsboFrQr4YVv5bq5k4CEUlrkt+eC+M2sQ/5+S3QRAOpr6r
EOOFDTDxHHq9Oghl3mVGMzpe2JPnN8subQ/CnZMrFHH9nlgAdxh7PMMQtAt2
qMn1emDjHpemnaWG4MjXwe3WdTcsSbRFYhgbgslrNEb6FW6YxbRukKj8EOwF
KScXuLphFJKusKA2BERts4K3x9wwgaWeRG2TIbj3iWHDTdYVs9ewML34YQhe
Od5xaHR+i2F7/+r8w4bg2w9cZAb3W+xIVijbfNQQrN3VX4poeoNFH6huj0kZ
gjwWlq8+jG+wxjKa87RVQxCIFjWdS19hDNzpayTSECD6NE9aUSdM5p7HNPHb
EDCm8DRXLL7EbD887iSsDoFMXfGry0kvsRFK9nTcnyHYrVQz8GV7icXN++pP
0Q9DVPDhUG86R0yk4Hn3oPgw3M2O/ivGZo8ZfFOoHpAahoOa648GJu2wEN4z
mf3YMOxEnZE/lWiH/Q6b9OxVHIbqY8cZmi7YYXXOKtKdD4chfqy39LeaLaZ6
QyS7yXMYVP7Uy37Pt8HevaGNavQbhjiz59I972ywgtJ574agYRAPrnO/pWaD
sZ6LN6qLHIYPAnntO9PW2BQ9E2dVzjBcOz51Kd7KCrMY2fAtHBoG1g+2D10b
zbE4xh7HgvFhMHLP0Gy3Nsf6FLNM8meGIWd9anSRxxwTrzaSyV0chjLD1KQi
l+fYbvzgVsbuMGBBLxqNlJ9hAc9KTRP4RuDAyIwhJZ0ZtiST60snNAKxenyX
thtMsVvsqVmOF0fA+GqP4fJLU4yqLWxV5doIXG0yr6xdfII589k7bquPAAtf
BAXLiAlmOivmrfl6BHJqJ2hbx42w5jKhjFrXEQgdP61hH2uE8QbxdpzzHgGN
aueUYUMjbFqaheFf8AjYGVTN5q0YYtrRG5+y00Zg7vR/ppm0hpjs3YLUgwMj
cIWxoVavRx+LE85osx4dAen24JXX5vrY7oGEbxNTI1Aa+NJkjUYfqyj6cKFw
YQQs9eV3mpUeYSJM1qWP9kag6dOUcefkA4yr80JL2blRWGOppt0W1cNeJfEv
nBYZBWumWm1+nC426sxNE3h5FCb6Q6XVgnWxkHNHVY2xUfhwZJs1+KcORuO9
MsSoPQq/mMUvZ7fcw37LZJOeuoxCH/rrvB2ujdWkLH9+6TkKVW3c36P1tDF3
amEtb79RcDT0v3mQWxtj6MtpTA4dhZ2YzGXBNC1M4HFe3Ez6KIxzSPjcbtDE
7r0t1NXuG4WujJVATaY7GBd+g9F4eBTye7t856Y0MIK8WNuLiVHg908/R5Ol
gVnRF0t8II3C52vVbygUNDDvzyUsHX9GoYen6Y88jTpWWlneBafHIMsi9Vjk
VRXsFfcfDzWBMVh+FGdlTFTGZNyuXn90fgw631CA7AdlrEuxMvOVxBigm9P+
oktKGGm0yrv09hg8pj84+SXnNsb6u1bmvO0Y+F90e/Dc6BY2obe/JfVyDDr8
KKKzuW5hCbVYvuKbMbhHaUn8OKqACXvVc5t6jwGF1tx9dXUFTJ61cSchegzi
Oq9LRivcxOzFmkuOfxmDrmdNbwa0b2Cm4qcSPraPgclR5+N5rDcw3Stv3tP3
jMGfjtfdWsNy2PVr4kZU42MQwS038E9XDqOSS2FcXR2DLcL46rdnstiHO57P
WzjH4d7BxafUTwBz1cLdlTk1Dp+afSn99zHM9q60bDX/OGQfTOssjMKwe3q/
2ApFxyGEjdH2zxDCuAxNWmIUxuHdP4muxfvSWJaN/Cl723FIi/mP/06IFBZj
m0C39nIctOOiN82QFBZov/v72dtx2Cd81bT5dhWzcSrpfuw7DrLC7vcfyF/F
JF35XivHjYOa24hY0yFJ7Jy7q2lr8jgcfCS0G1BxBeP0nLojmzkODM9nErQt
rmD7PmHnJEvGwYWx6QxuRAJr/nBwhLdjHHyVfiUxVohjZR8NGmN7x6HPrnVi
0VYcywityWEfHofVmjzpDhFx7H2EvQcDbhw2UrkEsjMvY5rxJNGdzXGw+rTE
ezRHDJvNa37ff3oCaH+TsvSnRLG+7wdXxM5OwOZl7XSuNFGsQfimSpjwBCiw
SAY/sRHFErJa6HUkJ+CU3QT6fFgUM0prDZxSmQA6yXsqOnYi2Hxs+4eFlxPQ
bcl98YTjeWxkinpd8e0EXCn8by/3xHms7cRtjSz3CdBRo9O1bhIi96NfmSwD
J+A21y+8xzEh7Pmnjo8/kibAu4jgerL5HPY9oCt0r3sC7p991vzKQACb6aT/
pT84ATJfpjLyOQSwHlpV7YaxCfg5HZKzMMiP5fl2s3oQJ6ArrIfhgRI/ZuPZ
84l6ewLixhM99YAP+/W6L+IY3yQI/j53k0eJFyNVMf2xF5yEDDqfuhAGXmx4
W0N3RIRsb5tMqRw8jZW97GePkpqES+35kacMTmNOdgNRPOqT8J19HTNwO4X9
fT70WfDVJGje8xY62cWNaV959FHEZRLW9lYiLtlyYzmU896XPSdhJsYwyoeD
G9OP3HqBgibB8r2OCaUFF9bYwql4J2kSnlRmWsqeOoH5nDL85dQxCWKvKq7K
FrBjuOVv3972TsIfRvvyFhN27Gq57az70CSYyr6VnOZgx5ZUPTsCZiZBjo5n
/6sXG6b6Oj0h4cck1Nw+9afa5Dh2bOS7SjvnFMgTH1+ml2HFLBId5bpPToFw
2MNw9f1jWLPFP8kBvimgEEOHpGqPYY4HmM9MiUzBu3b1r1ToGDYuKr69JjcF
TtayKFSeBYt//yqVzXwKqNk+PC2yZ8L+3DvwmctmCsy3LunNISZMgzcg+LTD
FOz+p27Qf4QJo6qMfX3eZQpCb1z/VnSdEXsy33AHQqdA4ZAAU3jqUey87JF9
0+opWC0VmX7TREt+P2SfHWuYguIx3ulDprSYOKvGndutUxCj+4LKmo4Wk16I
TDnfPwVtc5az3x/QYGqBQsrr82Q8G/bBH8eoMdtx1UhnlmlgqIzWIGYfwn7L
/WhcYpuGpkznmkb9Q9jrnPDlB9zToKbwVaiA+RDm6TKLYeemQVH8FX7m5UEs
nP/FHBU2DSrVBq9sFA5glS/CxAKeTcPw5Yv2HT8pMGzy6sM9q2m4kfKhMj6b
AmuSn/aysp8Gdq/HKvQmFFgHm8C4hss09H/kvB+d+w9N1Za7/PdpGtINa6+X
+u0hg7MPM72jp6F6a/1M3sE9NBdMMbgVPw0TYlQ/HrrtolXj2wITWdMwtCM9
d9L1L6KgneyKa5iGRdcPeayftpGnnctvxtZpSFs7rxJ+chvRTJ855dY5DXNt
KZx3c/4glgILO+ORabBhy17r7tpCfPf2Oc6tTMM23ovC+/xvlFGfdCNqYxrW
VNyyO75uoguCtyxpt6Zhck5nYPD5Jrqy+6FhhXIGWA4el3pZ+gvdSjptVsg2
A7qJdzYmrX4i8UgGgVauGRh38dVbFPyJTgX9JU2cnoEyylLNwYUfaMd52Oig
8AxMPM8+/MbiB8q946evIzMDn0mhjQyBG+gY5cbdvaczQM/0qerdszVEsTXN
ymI1A8JvvHDbq6toZaVjUMBuBobLjlC32q2i1rGUOxpvZ4DmLefHvNffkXOB
rmryxxlQCl+gUPVZRrOPG+RvV82AGIRQnUlaQF13cw/o18+Avwute/TZBVSh
HN1k2zwDHvxOY6O58yhE0l4mpmcGMnwCgLJ2Dt1kPCe9RpgBytUjFp8XiUjs
0H9/DyyS80+OYu9xJCKev5RV7N9nQM1v4LDbYSL6Mz8pKbc1Ayk9IdPNQgSU
Xffh8ie6Wdjxqv6m4YdDkSVvfmQyzYIQ/SY7iwAOeWY9K6z7bxbO8DB+O+E/
i/TDb1xcPDkLQ7hTXfysM0g5QHR1l28Wkj1ML3wymEZX3blzmYVm4dYyo6Z4
0RRittoSui4+C+VDoFHzZBLtG5O+qUuR8aVPPqZqn0BLev0ZJtgscIqzxoiJ
TqDmm9kCQYqzYJOwTkt/bBwVXo+cS1KdhcodUVuWoDEUd8krpVxzFjYKrtrW
Mo6hl9yPefEPZ6F7Vz29+uwoMtIQvTdlOAvY5oKzecMIUvOg9B81nQUDFRV6
UYMRdK1soHbAfBY+ClApShwZQQLfkje6bWaBPSPoeHrpMGLhcuD/6jALaNPR
sNB8GO2pKeg1v5oFbTEZFlfBYTRUsthQ5TkLtidGRjczh5Coiu3jsJxZCHr9
lsfMYQBxudwI/VA4CyvtEn8XBQfQkSLWNv+yWdArOZ4bPN2PZtjKRdwaZiF0
+PPoZ7l+FED8u2c5NAvt2qXXMg/1ocVXXjG3dmehv8Y8qf5fB1q6d/5pIgUO
nF8IlM3rdyCD9WNUJw/gIHzubV523VekfGZOgpMaB0rfP00mu7YjXj+fWCYW
HFjEWx19xNKKInltJINYcdDicEzY41ULYqjR7adjw4Fa9ysVG1Iz2l4VPHSE
CweH8WdOi9d9QX3aXRZ7/DhYqyf+exHYiBRWSw6/PoeDnpYEFtyRRlTjE5vw
RwgHEQwK8phXA0qvshr6eREHS6EV/PUs9YhLW8fqhRh5rHdhdfxUHQr5DtRr
4jhgN4tk3peoRe9OMUsvSeFghOOl93vHavSrcnvYTBoH8glvTf2SqtBzLYL1
HIaDvxcT6ipHKtFd7+Jk3A0cKFx4/GtCtwJ1nIxB+go4KHgdZGCQXo5kKj1H
JxVxMBT2z1D2XxkSXrlLN6qKg5lvXbLQVYoqtFXq/TVw4J3XLJN/pRTdqJWz
w7RwoPzqfplPbgnq4Zc6++MumZ8TKU5nL5Wg+0EXJ1N1cZBgWP7oe2Mxmv/N
/0HvAQ6mOLOuXzUoRraPuW4c1Sfzdzxk0ZS+GO23sWw1GOCgldfr2lhrEfIT
pcm2NybzdWO+q9O/CLFG/dM/Z4oDI/NuQXm1IpRA+Ztl6ikO9k8KVxxmLkIV
A4RXN6zIfLHjNz6HFaJ5+xolFmccmKSc/GT4qQDZThftt7wmz/9QKeWtXYD2
bmYWOb/Dwb2xlVO6xwoQK1s4J94DB2fHDFyen8pHNyqtl/KDcJC8fGNTnykX
Jezx+qum4EC6t+n9z60MJGzKgVGm42B+hF3I7WUGKu9h/FGSiQOr6XMhm1vp
qCd+V48rn7xf5ZF9m3/T0J7siOByJQ6iNFPe0RxLRb5ZXdNxNWT7oXKCe0wK
Yj325aNmPVmPOm1imWdTkDApf7uyGQf9uVQZj28ko/vefl99e3HQPtSnLxia
iOZXXd5KD+AgDdVG1wsnohc6jpfWh3CgsbhEam9PQL7njKN0JnAgNni+NII6
AbF+1FOlm8ZB2Fa8D7dePIrfVqesn8VBn2UesTwtDpV1SD8TmMMB7pnhq3Kt
WCR3+TL3xAIO7BvOtroUx6Duz4L9gUs48Jvesq3iiEEki+NSm2s4aKbbZlbd
iUY2w/TfM37gIO+78n/UDtFoFx1IfLiJg0eSK5///o5CxxjXqZt3cJCdrHtX
kzkKDdT6+9zeI+e7FVtYVxCJQiz4D/f+w8H0Ky03Hp1IpHmiwVObCg8/fIoO
RR+MRCwd9w9MHMQDn/MvF73KCDTgtOn2+AgenPSm/8McIlDI2WCKORo8JOig
z9OSEUhzRMjlOT0e0gQ2CVyUEYjFq2VvjQEPHW//ZeP7wtHAZYM3Dsx40GTV
KWVOD0chhJ2dnWN4CE/8XRviEY40P35ydj2Oh56pMU8l03DELCP65xAHHnTf
/mnnUQ9HwbFPNpl48CDdOdFcLBaOmP5G/zhxBg9hN+0yXS6Eo75MiReJ/HiI
iXUM1r1M9tftWxM4R8ZPi7AqwMKRxhFzqxwhPIyx9VNZkvEYyw59v3QBD0EZ
3PT2T8JRj0mCeflFPHAxOd3Odg1HQceuL0mL4aH10KTzn4RwpNY0/LRJHA9d
MrIPZVvDEcMLm4Vbknhwd0rNN18nzz9JZ9othYdzJlSXH52MQEE9qSRNaTxQ
V2um/tWMQGpvZYzHMDxYiH9sEX4fgY4KT+IfyeLB26dCc6QtAnVNOBgQb+Ch
wPwL3Qx1JArwY5p9qoAHlcicfEG1SES/cHPKThkPdekHS87MRaKuT7j726rk
/dl+GhJ7JQoFyL8ef6dBXs8mXOfH+yhEl1Qw4ncXD0rZkiFfZKMR7aMT/fGP
8aBu8i+bf/Qz6qArU+c3wkPEd/aUCPkY5F+l0ZNlgofke/2vWEpjEA27d2fp
Mzysp9A0VMbFIurB9ZZOOzxowcHAtY/xqN3tvfwdRzyoPWvIM6El619U4MuI
Ex7+/LtK9V0lAR0JetCAf4uHTveepyeGE9Dh261VWz54WCPJpLmsJ6KD9Z/z
z8TgwU3pp/W3WyloQlpecTYOD6S4s+cffU5B+VUruOhEPDDSdPfyr6Wg+2WI
hSUdD6m4G7u2EamoMHfWnqKIrKf5no1z39KQfsyZa9Nt5PWjmnuM3TOROGfX
QGQHHk5v2eRpDGYimkh7c+1uPFRab7D4nMlCJaEtMZ0DZHyHWx8DG7MQ3Xuz
f5XTeCBwSNhd+JGNcNRMkQ448n7GWvuFXM9BZd4VopeIeJivu2hb7ZGDjNxp
jDIW8YCL4yD8R65XFc7ZzeE/8eDC6abMwZaHgra0Hmn+JvM5MXzoq3YeMnbY
3Ty6jQd8tSGuLDiPrB/Vs177eHiavMVFeyAfkVY362UoCfCE1opFTSofVVnE
6e4eIMC21i+1QMt89OTpmp8dDQGkNWiaq3rz0bX5CN6L9ARIMj4Y7LOXj5hM
ZKqXGAgQePSXiTdrAZrHL2qlMRPAQat0mkuwANU8/rhiyEqAihOnR99JF6CQ
aSkvbjYCuL9j+Z2sVoDMHhC4xzkIsBNqMuvxuABJj/uXhXERQNv+h+Rx6wLE
onNZXeMkAb5IRqRovi1Ai0OTC3S8BLD6faFD1L8A1Wp6urbxEeBt+0fVDHL9
D+kT5vA4SwC+1tjBgvgC9FRtuBATIkDwkQuUchkFCOt6q7QjTIDVFM7XWvkF
6JiSALH0IgFMy2Tnp0rI+G09r1+IEUBI++3CcEUBqrv5kvWCBNkennHmSnUB
eibbfjPlGgH+Pr2GoyWPWRHHyxMyBAhY65VjJ89fqmpkHJUjxzvgovYvtwA1
XH2eEXKTAK7LsrYn0gpQeBmLrJoiAdbvbGiaxBQgc/HqcRplAsjzPPvUH0z2
7xvOqVAlQNFg4oU4jwL0n+W6i5kGAX4bt5kG2xeg5zR0Wse1CKDhUqObYFyA
6lP5BVruEmB/2PhEqwY5HjmZbTtdAmDsCa3b18nxztzv4n1A9v+tZXuZn5wv
W7CtqwEBWgLv3xUj5qOnxVk3LxoToOGyaM/zzHxUq97CPvOEzH8o7REb83zE
sjK7HPCUAHv0+RfFBPORme9O3XVzAkhREl8mEvJQDd9/IUuWBPDqM2fMi8hD
zI0Xn0TZEEB/kkFAUTEPVW+b0G05ECCXv/LD3OdcxBTuMpPqROaLO+naTchF
T8SiC7VfE8C7+7fuybkcxGjeq1PkSoD2+uGHplgOMjmyJGToQR7/nTpXsJGN
KpMP7jN6E8C3NOb5ncxsZDwllWL5nszXJ+DS5s9GFU7aL7mCCDBZGm8b8i0L
Hf3PWqkzmABit4roCIVZyKjQj/tVKAHiW0vvX3qXhcpVU9bPhZP1V7A4YKWW
heiX6r6MRhLghIffgi9vFjL0Hg/3/kyApcoROqudTFTG++uZRByZ3wGGYvqR
TERXz4BICQT4o2ijoVWaiQweCDKFJpP1FS2lIxqZiUq3bhBl0whAfTPzWsi7
TEQbpl+2nkEAnuY9S7OnmeixqLNffDYBaD85mMTdzUQlXaEP1fLI+Yirf+RX
INePZ3kX9wrIeCe/mi1LZSL9Q1+pcooJEDF4+sGMaCYqTiQO3y8jQGhXxMyK
UCZ6NMH+pqKaAD/cho2On8tER46p8R5vJM8XcAyaJPs/zH+62fyFAPadZ5Mt
yHiFyh7tdq0EcEyy/Jsvn4kOL8Z+5v1KgIlz3rRhmpnogWeFVX8nAZwm828c
Mc5EBacGZV17CHBRUpDzj0MmOlT7nfViPwGmKkQp777PRPf1qBenBwnwcPqg
BX1yJsrf5K0OGCGfv9OkbvraTHQwBAVdHyfAHaqj0fLjmUhPRNdwaZIA73Zr
byRtZaIDZoFHFPEECBEt2vW9loV0D2RM/CYSQNzE9seqfhbKjW/KTZ0n15OU
khBxryykM7aldWCFADNQGc8+moWybxsl1P0mQK93pLduUDYSFz6NwTY5/23X
kBc12aiOATdZ/5d8nq4adhUtZ6O+wUdsjRREmF9JGrRXzUG/HukFfaElgt3q
Y7unXLkIs9V4085DhGwTU+bIyTzUps3Iefs0ESxkBrh8/stHGpI95V/PEIFa
LPZNlXo+MtpV/tlxjgj3BZfkSpvzkY/3refdYkSg+tRxvEynAPVFY7oDCkRI
rn/eUYIKkd7bvU3N20SgLOLycNIrRITHNaGDykTQHLrkvGJfiH7xXesd0iDC
4RDNpPasQsSRL6Ewep8IYZrU/v7kfjjp4y+iziMi3OC36qUWKkLC9sVuY4+J
YL3T92BftghhUpdqx02IoPLpfo+YTREy+iIsPmVFhEurbDXbzUVoOXW5/+EL
IiAJisnnY0XI3jfLetqOPL7josS5XIR8VM9lzzgRwWCDIYGNoRgxiS4oPn5N
BJ4lL0UdnmIUzZI2P/uWCGyJBq0VF4pRzugZXrw7ESbFGNqabxcjiSpCvaEX
EdTcb9Eb3itGdTGJjwg+RLjiXJhNZVSMbrkY/DXyJwLpjot3kkUx6jM8GUUM
IEKmAumtlGMx0pOfuWLygQhDH4/ZNbwrRgSB2CHSRyKUWcrcEvUuRhY0D22f
hBEhgTVu0i2gGG0uczLNhxNhtuExc97HYvSiSHWtIZEIMs0bBeeji9F3J9ee
zznk9a+8W1P1L0YBQqremvlkfOpgLnn3YnR+igOjKSICBP8+7+NUjDoC5zfr
S4iQLrFNzWBZjJ5Bca5jORGuGc3G9T4uRtQbLk8uVBGB32V9rEmjGKUnqXCT
aogQvmmXNAPFSEGbYzi6ngg1IoXzHGR+5g7NB9xpIsKX0LVgc/Zi5FleJE/d
QoSJQMeADspidOaZy25dGxFEvQObL3wrQk2cKiUOHURYn3vNF9BThAy72C2E
u4mgfNwvYqqwCFG8mztD7CXr0XWX+nhoEYq/WDQZNUAEj0Buk4u2RWg6RFn5
yBgRFCW8PacFi9AbefYDdRNE0Ep6eMqAqgid+E2qsp8mAq3OvmbcGFmPeu+E
CAQyP9KNgoLvCtEfWmVC5BxZf/AixVi1EEXUsEWrLxLhugitsQRnIRo+WUhT
+50IGle3UhXJ96l9/9tGu3UilJ/I3rn0mnzfeCg5C/0kgoOvb4yxYgG6M09c
jPhDhEXxG0Pc3fmoO+d4u+0BEkT2rl07aZyHLPSJLoKHSRBUpRDpz5CH6JgK
JHHUJOASeslxoyYX3ba7na7KQIL13rNdzjy5qEXqjfc5DhKItPAMMe9lI5Nl
RWz2BAn8jSMv7VRmowOx//3+xEMCkz8vpFecspEsRf6TA3wkCMCo4zt3sxCu
8DV3lQAJNAMEODLI/ZiLseKwjSAJ3tM89bLwzUK1rXj5GRESKHWyOb8/kYUe
OuXthl0igWLOAu/wQib6K/i6RFmcBHmbsQfmyPVfKpCVr1KKBEk7rnkSOuT6
r3XrQJg8CQYfvHyfl5uBfJUrvLhukcA67IJMg18GenhDkDr1NomslzCHM2YZ
iOoy3dEyNRK4isj8aOLPQMNCbz5gd0gQ7PnUbeNwBsrg/c7cpkWCtX+0p+99
S0dqLL3Hx3RJoG3sczqtMB2dppWJMnhAgtKvNzs8ItLRL8rCE98ekfnTvHXs
zbt09Hkj5NSOEQmyW6b+S1RPR1bfDiS7PyHB1Yt32Rqk0pEc3p6f7ikJ3pSP
K87wpaPFvntCXJYkoDrd17m7l4aq29tyUqxJEOUq8GRtOQ0FNVy9eMGWBKl/
79S1TKQh8QJOcewlCfplNoCqOg0dyXhf1upMAhW/2wX3c9LQRPzuVfU3JPj1
DWxex6Uhtw8zyMCNBM7rvVY7nmlI20e9YdGDBBWsaptKzmnonEuD3AtvEgyp
Xn6gaJWG/jpeatn2JcHhyRfNy8ZpqMcq6Zb7exK8/PtXW+R+Gko0PdZBG0QC
rdUvojR30pC9vqdKaDAJOn5Uv3ZQTEOcaqZ3Uj6RQPrCobX5q2moASneK40m
wbWUZz3K59OQ6QWhB63xJBC/81rK8mQaouemNxhNIevzQpc6639pqJh+1WQx
kwQDYquitPRp6P5u77PtPLJ+7tvtsh1MQxQrhVa0JSTwjv3ef3gvFaVNhtqd
qCTBzOZqX/zvVKTS6eAkXEeCtoc0HDnrqSgqS8pdrZ0EFNL9VDfmUtG83957
mwEyn4eH37OOp6IA59lgt1Fy/lo7nEIDqUjsWeOnkCkSnPNNKXjWkYrGdJOj
k/EkYIp9YhHTmIpcFL3iS+ZJ8Od9r+X78lTE56DMkbNMAlp8Ki2Wk4o6EplD
k9dJ8EicludOfCriqvilfvInCWhiH+aIRKYi655R+s+bJEDLmpvBwamI9W+s
d8gOCVafj0x/dUlFpsxuNxj2SFAjURkc6piKKs+aUPj/I0EJ+zJfu0Uq0tcW
euV2cA7G9BbYdHVSUcHzo5J7h+fg3p0j/mnKqeiA2/pPJ5o5iA89fVABUlFG
bpmlDcMcaJxfv6LPl4p2vkQJrTDNATXnDlXHf6lIdeLNgtmxObjonblncTgV
/Th8w/Ax+xx40qSkYnMpSJ5bgGeScw4OVsmbGgymoIjLNJP3uOfgE+eVN/EN
KUjaoFdbjXcO0nnKeh5EpqAgxyLmDr45ePMgmqfLPQXhAz713Dw7B1SvXy2B
RQryrnygiITnYClsnItdOgX1sSxeF74yBy7hjTvDPcmIV7DzT/rVOUhUviyV
W5CMHCCv9Mz1OShX3JLR/piMOC3sL56QmYNw1dODW2rJyMJdZyVcbg4KV6ds
Fs4no/rIa5ksN+fAiDZ8P+BIMjJpoThDqzQHhqRsJlxVEiqbJM56qZDjkdbP
cA1JQjQ/WmMo1edgQqbyXu3TJJTHE3h8W2sOmL1YeTaYktCflxy0i4/mAKd/
yTZTPREpBe22GhvMQd5lc0yYOxHFpsx6zBrNAf19m8cXlxOQXH/q3ojZHFjd
avcu9k0g339iGy0v5uBSjozj9dB4dHpaaSzZaw7a4vdeRzaT3+dN1/Pv+pLj
7SAo55vFoB/pwt5H3s+BT6LUzghdDGqyZRA3DybzzVxw5I7OZ2RCPfBB7PMc
8J9ael2xE4UyLuvdaiyYg2oJ0quoFxGIiUOJx66YnA9mX9rHF4Gc969t8pWR
8efl+bbHwpHSV65k3+o5SOs+UfKffDha1sftq7eS9cPXIabA/wmJ+JuVzUyS
/S++evSVORSFW+sGBs/MQebVlMcCgyHon/ZtEzk8eX8Hppe1P4WgvpPnyR3K
HKTY/yzn4QpBL0pXLS035sA6eqDkwuWPqATnwL97eB5OaBrP/aX9gLhaTXdz
aeYhIOOrGH1aEPLK1hl8TD8PWge/g6tcELrnKOX2hXkeAm9qNnu4BKItur0p
f655IEea6EcTgK5JeoZxiM2D5bttFs77fmjEiONKrPg8ZPYoRC8w+CG7oLzR
U5LzgK/iWC5u9kU5c2Oc56TngVLh4VHpy76IJ+xC4hWFebh3LV2j4IQPotoY
ydW6Pw/fpL6X6LJ5oTguC/XRh/MQovPn6McJT3RdkXLj/uN5uOVf0RAW54ns
48+LG5nMg/NRE52Nc55oXtW1ysZqHmziqm6mKnigzizBtkD3eTjlt099LtkN
PR2pe8rsNQ9tB+uvhL1wQweptGk/+cxDIYOJWqSMG8L03qnGBMzDhWyzxw9w
rqjgyOBgVvg86J3IOGgn4IrCTN7g2rLmYWVF5a1o2Fv0kKd3m3JwHqRNR3ck
CpwQA4dtafUw2V71jM3lkRNqPPbfC4exefjz+4B9CI0TEqB5sLg4PQ8m057t
/Pov0drP+ZHexXnoMhOcfrztgNy/7hfH7s9DTKRXhuBfW5RhL2IlJbQAfVhE
W5rvU3Tful/wp/ACFES1PZJINkNHn9vP5VxcgPXrWmev1Jgi28dVD09JLIBK
2xxt1jcTdF1JQfmIzAKMUU4wcV82RD0n9c8N3yXjJfPsu9BrIaTOtuFnvQAU
///9D36doG4=
       "]], LineBox[CompressedData["
1:eJwtkXs01HkYxkW5xYh0dSlkM+oUtqT0ehVqXKKs4iAGM81gzEzaChG1dLAV
SZncVpfpMqkmHLdsZLtuptwjmSTp+v39KorUsvacfc55znue8/zzfs5jFi7y
5aqqqKgETfq/+9VBPy5jHkGV/8Vun7XhhxnBvqNbY5tdlsG+Rotsd3uCDuWb
R6qzWeCUwl3d5kBwqXq4sj/XA1SdLvQHOxIsjWq1Gc3xgvQa65ViZ4K1UsfG
A06b4aTc9ulJD4Jb++V09VQ/kBfjooEQghe1TXOtpwXBUMKQRlgYQdenqUyX
9iCw97/wvjeCoMdAH1NWEgw39PTKn/AJyqMKGnbahsDdFOW6h7GTvUJdIT3F
Bs3tOZas3QTP/J1Oir6ywXP1Bq07ewnetboo8fQNg+ZPV5pvJhLM5m+ueTQt
HHrCk0LLDhH854yz9/ntEWCKti7LMwiWb7lAEuURwDZ69VPp7wRDFj0SzFHl
wGCbFyXNJjicR1b8cZoDH12Nk07lE3wRHjN7aSsX1BffyE+5SjDwLQibxnjg
riba/4+coPEmuXr1Gj4cfm4enlBOsCvIipkazwd9SSbz12qC3T219neG+GCs
FVjNaySYYxBRbNwTCaGvdAsHbhO0SvghdzKIgjO3biWH3SPI3HzzjA8rChYn
MDcGNRHUveTl7XY9Cuzej3Z4dxJsrz1CX98TDbvvldY87CJ4fx3HMkkaDdVn
2UWsHoKSsbQst7ZogOD7nPV9BMURa5d0LBEAS5E3tPIdQcFNocysRQCZlzyf
lH2Y3DtFUqo5KgBF2kTtcpoge5WNw3eTGPB14h1kDhN0fr1mtjYvBrZfs9c3
GSd48lvlnClUDFQGjjKaVSi0+XN4+twZQmCo1+r8pkZh/3CCx0JbITQEg+Zb
zclc5q3QFQthZ3mDmg+Dwro5DKpHJgRzbdeJipkUVmqcGCt8IYQ29r2x+fMo
ZPDqnSMMRZBa5fE1xZTC8XmRjHUuIljJePRp0ILCv6YKr7OEIhjkbCFeTArz
psv2Hj4hApZBwMDcFRSGjttL9btFIKsP6RlwonB+5shBWw0x6MRwW+XuFCZU
BaRqGYlBOF/wINGPQpQsYwRaicFud3yVYRSFZVVfJRk2Yhh5fEhamkzhO1GT
UstcDIFJRwrjMik857PLd8JADHXWucddT1BYkx1g7z4uAtOu/MwZJRSqdyr6
0hQiSEk7feCZjEKdY5YzN+aKIJ8fYzB4jcLROr0vbXtEUO65+ixdQWFXr85g
pf8kj37LbdV6Cgu7XWNrJ/k9i1U0mW0U6lYrigOShMA50CSx66JwWeZOjr2f
EPZzJMy1vZP/atj9/IIpBLm1jafPawr9+nQju1tiYHZV6NHd3ykMU//l9PCs
GLDJX7IgWYXGErvx+T0DAnBPGrmWPo3GtobHedPKBZDoktVSoEfjKuW7OeGb
BND/+KZhowWNzUYWRd37ouHKG5MChheNbpLLhnebIiG9KI2t9KZR1tsddfVq
JHB8ieXVLTQGTOlwO5cdCcZ1dfJN/jTK89b2N/pFQmZW0N3D4TQGfzAyMVTy
gW9/6pN2PI2jubG97iM8cH2vUvV0H427nlxrce7hwYISfqJsP42s+wMyYT0P
OrUcNDxSaezgO3Pi03ng1ttpnJFF4/FjWkHHTXhgnmrI0jhPY+aLNQXG23ZA
N3nZev4yjclKH+2KxTsg2798+4brNBalf3vVOcaFCWvfXWl1kzyp7LP657lQ
mWs2vqiRxlYp65Xvfi4Ixz+m375HY5yhkV9sABeetWQVq7XRyIxvjys24EKu
YyjzbBeNFjh4tP0zBzylyyrWK2lc/XlVjmMHB1T1xp36X9IYMaa0e1PDgdo4
xYMDb2ksqP+4kC7hgJWX4HnDMI1oJpOG7OFA3oLpXyYmaJzur3d6+TYO/AuP
ncQI
       "]]},
     Annotation[#, "Charting`Private`Tag$2858#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.1}, {0, 320}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.811085857203073*^9, 3.811086016163554*^9, 
  3.811086083450727*^9, 3.815760577176807*^9, 
  3.8157606087377357`*^9},ExpressionUUID->"afd0fe25-164f-465a-ad23-\
91abcd02909c"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJxF1Hk0FNwbB3AiS3qVoiJishQhLWihJ0spoV9RSLZCtpC8EkVjTVlaJktG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       "]]},
     Annotation[#, "Charting`Private`Tag$2900#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.1}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.811085857203073*^9, 3.811086016163554*^9, 
  3.811086083450727*^9, 3.815760577176807*^9, 
  3.815760608769902*^9},ExpressionUUID->"664d3f49-ee2f-4ccc-b7ed-\
64ed0c4ebb8e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Mu]", "=", "38"}], ";", 
  RowBox[{"\[Lambda]", "=", "6"}], ";", 
  RowBox[{"NR", "=", "1"}], ";", 
  RowBox[{"\[Nu]", "=", "100"}], ";", " ", 
  RowBox[{"initca", "=", "100"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"s", "=", 
   RowBox[{"NDSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"n1", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Mu]"}], "*", 
          RowBox[{"n1", "[", "t", "]"}]}], "+", " ", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], " ", "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"2", "*", 
             RowBox[{"n1", "[", "t", "]"}]}]}], " ", ")"}]}]}]}], " ", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"nca", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Nu]"}], "*", 
          RowBox[{"nca", "[", "t", "]"}]}], " ", "-", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"n1", "[", "t", "]"}]}], ")"}]}], "+", 
         RowBox[{"\[Mu]", "*", 
          RowBox[{"n1", "[", "t", "]"}]}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"p2", "'"}], "[", "t", "]"}], "\[Equal]", " ", 
        RowBox[{"\[Lambda]", "*", 
         RowBox[{"n1", "[", "t", "]"}], "*", 
         RowBox[{"nca", "[", "t", "]"}], "*", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"p2", "[", "t", "]"}]}], ")"}]}]}], ",", 
       "\[IndentingNewLine]", " ", 
       RowBox[{
        RowBox[{"n1", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
       RowBox[{
        RowBox[{"nca", "[", "0", "]"}], "\[Equal]", "initca"}], ",", 
       RowBox[{
        RowBox[{"p2", "[", "0", "]"}], "\[Equal]", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"n1", ",", "nca", ",", "p2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0.0", ",", "1"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"n1", "[", "t", "]"}], "/.", "s"}], "]"}], ",", 
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"nca", "[", "t", "]"}], "/.", "s"}], "]"}], ",", 
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"p2", "[", "t", "]"}], "/.", "s"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{"Orange", ",", "Green", ",", "Blue"}], "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"plotofn1Fast100NOPUMPS", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"n1", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", "Green", "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"plotofncaFast100NOPUMPS", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"nca", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "110"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", "Green", "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plotofp2Fast100NOPUMPS", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"p2", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", ".1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", " ", 
      RowBox[{"{", "Green", "}"}]}], ",", 
     RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.811085562699381*^9, 3.8110855745374737`*^9}, {
   3.811085618890011*^9, 3.811085634025485*^9}, {3.8110857067143383`*^9, 
   3.811085721417883*^9}, {3.81108580716634*^9, 3.811085824075839*^9}, {
   3.8110860032964287`*^9, 3.811086004076314*^9}, {3.811086054015686*^9, 
   3.811086068365168*^9}, 
   3.811086161744564*^9},ExpressionUUID->"0d20c634-0f2a-461a-aeec-\
dd60d482190b"],

Cell[BoxData["100"], "Output",
 CellChangeTimes->{3.811085723535047*^9, 3.811085859153616*^9, 
  3.811086016381802*^9, 3.8110860836450033`*^9, 3.811086162412344*^9, 
  3.815760577325468*^9, 
  3.815760608798629*^9},ExpressionUUID->"cd9d6d1a-8d12-44f4-9ed4-\
87476ec2c18d"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0.5, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtV3k0Fd73pZEIiUJERJqkksqHu0WZReZUSopCphRSoWSeylAKmYvMmcdX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       "]], LineBox[CompressedData["
1:eJwtknk01XsXxl3cZiq5jVQkzSmX0ntt+30lmXKjksqUIUpSHTLrUG6mDCc5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       "]]},
     Annotation[#, "Charting`Private`Tag$2965#1"]& ], 
    TagBox[
     {RGBColor[0, 1, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtWnk0Fl7QljbSD9mLiqhUQiIt3MeWCFGIIpUlpVQkZSlrJEKoiLJmJ/u+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       "]], LineBox[CompressedData["
1:eJwtknk0lXsXx4WUMhRHpZJIhurKUOjWthu9J9xKt4QUzsU5RKZKhjjkVI7h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       "]]},
     Annotation[#, "Charting`Private`Tag$2965#2"]& ], 
    TagBox[
     {RGBColor[0, 0, 1], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJxF13c41t8bB3CjQfyIECIjKYWkIqK3mYx8S1kpGighRKQhW4Uos1BGZGRm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       "]]},
     Annotation[#, "Charting`Private`Tag$2965#3"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.1}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.811085723535047*^9, 3.811085859153616*^9, 
  3.811086016381802*^9, 3.8110860836450033`*^9, 3.811086162412344*^9, 
  3.815760577325468*^9, 
  3.815760608844698*^9},ExpressionUUID->"54f0dc08-8852-4450-a939-\
36e67aa56540"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0, 1, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtV3k0Fd73pZEIiUJERJqkksqHu0WZReZUSopCphRSoWSeylAKmYvMmcdX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       "]], LineBox[CompressedData["
1:eJwtknk01XsXxl3cZiq5jVQkzSmX0ntt+30lmXKjksqUIUpSHTLrUG6mDCc5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       "]]},
     Annotation[#, "Charting`Private`Tag$3009#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.1}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.811085723535047*^9, 3.811085859153616*^9, 
  3.811086016381802*^9, 3.8110860836450033`*^9, 3.811086162412344*^9, 
  3.815760577325468*^9, 
  3.815760608880917*^9},ExpressionUUID->"13e7abd3-1db1-49a4-9766-\
f536b05e6b30"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0, 1, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtVnc819/3l5YVslchI5WQSPpwz8smZIeUslIiI5SRkZ0ZMkK27L032Xvv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       "]], LineBox[CompressedData["
1:eJwtknk0lXsXx4WUMhRHpZJIhurKUOjWthu9J9xKt4QUzsU5RKZKhjjkVI7h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       "]]},
     Annotation[#, "Charting`Private`Tag$3051#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.1}, {0, 110}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.811085723535047*^9, 3.811085859153616*^9, 
  3.811086016381802*^9, 3.8110860836450033`*^9, 3.811086162412344*^9, 
  3.815760577325468*^9, 
  3.815760608927224*^9},ExpressionUUID->"a949a72d-59f0-4a57-be54-\
d4fccf315db8"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0, 1, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJxF13c41t8bB3CjQfyIECIjKYWkIqK3mYx8S1kpGighRKQhW4Uos1BGZGRm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       "]]},
     Annotation[#, "Charting`Private`Tag$3093#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.1}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.811085723535047*^9, 3.811085859153616*^9, 
  3.811086016381802*^9, 3.8110860836450033`*^9, 3.811086162412344*^9, 
  3.815760577325468*^9, 
  3.8157606089664927`*^9},ExpressionUUID->"2a356ff4-47c0-4040-9e50-\
59fe2eb17df8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Mu]", "=", "38"}], ";", 
  RowBox[{"\[Lambda]", "=", "6"}], ";", 
  RowBox[{"NR", "=", "1"}], ";", 
  RowBox[{"\[Nu]", "=", "100"}], ";", " ", 
  RowBox[{"initca", "=", "300"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"s", "=", 
   RowBox[{"NDSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"n1", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Mu]"}], "*", 
          RowBox[{"n1", "[", "t", "]"}]}], "+", " ", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], " ", "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"2", "*", 
             RowBox[{"n1", "[", "t", "]"}]}]}], " ", ")"}]}]}]}], " ", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"nca", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Nu]"}], "*", 
          RowBox[{"nca", "[", "t", "]"}]}], " ", "-", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"n1", "[", "t", "]"}]}], ")"}]}], "+", 
         RowBox[{"\[Mu]", "*", 
          RowBox[{"n1", "[", "t", "]"}]}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"p2", "'"}], "[", "t", "]"}], "\[Equal]", " ", 
        RowBox[{"\[Lambda]", "*", 
         RowBox[{"n1", "[", "t", "]"}], "*", 
         RowBox[{"nca", "[", "t", "]"}], "*", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"p2", "[", "t", "]"}]}], ")"}]}]}], ",", 
       "\[IndentingNewLine]", " ", 
       RowBox[{
        RowBox[{"n1", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
       RowBox[{
        RowBox[{"nca", "[", "0", "]"}], "\[Equal]", "initca"}], ",", 
       RowBox[{
        RowBox[{"p2", "[", "0", "]"}], "\[Equal]", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"n1", ",", "nca", ",", "p2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0.0", ",", "1"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"n1", "[", "t", "]"}], "/.", "s"}], "]"}], ",", 
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"nca", "[", "t", "]"}], "/.", "s"}], "]"}], ",", 
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"p2", "[", "t", "]"}], "/.", "s"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{"Orange", ",", "Green", ",", "Blue"}], "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"plotofn1Fast300NOPUMPS", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"n1", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", "Magenta", "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"plotofncaFast300NOPUMPS", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"nca", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "320"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", "Magenta", "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plotofp2Fast300NOPUMPS", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"p2", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", ".1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", " ", 
      RowBox[{"{", "Magenta", "}"}]}], ",", 
     RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.8106455281686897`*^9, 3.8106455290652857`*^9}, {
   3.810646204270317*^9, 3.8106462185905933`*^9}, {3.810647263481286*^9, 
   3.810647417561686*^9}, 3.810647493435939*^9, {3.8106475905885553`*^9, 
   3.8106476021732473`*^9}, {3.8106482943227262`*^9, 3.810648310259087*^9}, {
   3.8106483959554234`*^9, 3.8106483970594797`*^9}, {3.8106484399563313`*^9, 
   3.810648481988969*^9}, {3.810648803368124*^9, 3.810648864280178*^9}, {
   3.810648917352507*^9, 3.810648917545014*^9}, {3.810648950553649*^9, 
   3.810649005738225*^9}, {3.810649037290298*^9, 3.8106490779310837`*^9}, {
   3.8106491356913147`*^9, 3.81064914511545*^9}, 3.8106492915810413`*^9, 
   3.810650974748695*^9, {3.8110631437302103`*^9, 3.811063184033916*^9}, 
   3.811068240080839*^9, {3.8110682992154293`*^9, 3.81106830652777*^9}, 
   3.8110683717459173`*^9, {3.811081642132269*^9, 3.8110816916204844`*^9}, {
   3.8110817572374487`*^9, 3.811081771813155*^9}, 3.811082580509531*^9, {
   3.811082643934713*^9, 3.811082654126111*^9}, 3.811082698174378*^9, {
   3.811082804159376*^9, 3.8110828496308804`*^9}, {3.81108310862635*^9, 
   3.811083114850848*^9}, {3.811084738498023*^9, 3.811084807042286*^9}, {
   3.8110848481948357`*^9, 3.811084848482135*^9}, {3.811085004195816*^9, 
   3.811085004469384*^9}, {3.8110850433651953`*^9, 3.811085046324235*^9}, {
   3.811085084021165*^9, 3.811085084244635*^9}, {3.811085442232983*^9, 
   3.811085442806896*^9}, {3.811085547657012*^9, 3.811085589289421*^9}, {
   3.81108563217194*^9, 3.811085646313643*^9}, {3.811085741130423*^9, 
   3.811085749626472*^9}, {3.811085785578952*^9, 3.811085785786771*^9}, {
   3.8110858283322268`*^9, 3.8110858524911833`*^9}, {3.811086008526845*^9, 
   3.811086009388908*^9}, {3.811086061312611*^9, 3.811086064205233*^9}, 
   3.811086170304772*^9, {3.8110862971538973`*^9, 3.811086298383502*^9}, 
   3.815760573492964*^9},ExpressionUUID->"b66e440f-a374-42d5-aa94-\
9b2a9a747556"],

Cell[BoxData["300"], "Output",
 CellChangeTimes->{{3.811085088857396*^9, 3.8110851136422777`*^9}, {
   3.811085174742004*^9, 3.811085186176491*^9}, 3.811085327209573*^9, {
   3.8110854192197943`*^9, 3.8110854468359547`*^9}, {3.8110854815022173`*^9, 
   3.811085512959269*^9}, 3.811085590954831*^9, 3.8110858609817467`*^9, {
   3.811086011904632*^9, 3.811086016561001*^9}, 3.811086083822824*^9, 
   3.8110861706486797`*^9, 3.811086299293765*^9, 3.815760577455697*^9, 
   3.815760608995306*^9},ExpressionUUID->"86c97ed8-fc2e-49ad-803a-\
d88eb745721d"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0.5, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtVnc0F/73RkvxQVJGu5BKqIwSr8dKRgqRLasUysyWlETJToTsihays3f2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       "]]},
     Annotation[#, "Charting`Private`Tag$3158#1"]& ], 
    TagBox[
     {RGBColor[0, 1, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtl3c4F27UxqV+JYQQkjLbkko0eG7KHiURKpQZEkmikplKVtmhiITsvVf2
3nt8faMiSiqR9Xrf6z1/PM91rnPOfX/+ea7rPPyG1homtDQ0NBxrx//eCR2o
te9IAs3/xQwa+9NMA8eSYHxWS9Hj1Q8sjHDy/D2ejCQDkWH+5mn4GzbYx+sn
Yw9N2E2f2SnsGX/UpvskGa5twS4lO6egOTnuWdSbjIOzUdlvnkzi282wUat1
Kbh5s670S9UE3H6oSvIeSEH4xojvQvQTSPud+dP1QQo6qkpUKmK+gGHV9arC
rlTQlHxz+sAxjlBzbX1h+VT43kgrfO02BqFO4Wtbb6ViPIiRc/2vTyAJPUYD
xanwDM1R8qNQ0cCWbFI2norDM/Jb7fSoEEZ5ZvvGNLjfOfT77PAo8hOCs3NF
0vCC2ffP/m8U0Bi4iieeSYOQZnQZ7T0K5Nlv5kZcSsN2GFac20hBxyOZfNdH
aWB5Hq6erjeM6YtTRSrNadj/Wvtug9IAxDb3SBFqGtgdx8QEA/pxv6S8RHQu
DX+Et/0dHO3Dpv0hZdt2pUNGatam1rcX/CsylSNW6aCJafI/KtCNG5nCcu2u
6UiyC3cRe9mFlBuc1ZVB6ZgMp2qYbOzC6Y6pmoTidPS7HF3X868DWvEhDXe2
ZEBHfsEmkqUdEXpuqqb8GRg61Hmy7HUbqKxWTTrHM8CefUhsn2gbrJ3OtEjp
ZaB6fd5zg6uteKYx3b4pOQNWTc+uRqY2oXVT78V/ZRno60vW+vqvERzFFZ1T
nRk42Gf/XVmlETF7Q7vbljKwf/7KxrJ/9SheOtMfrpqJE4/frjP0r8WGjENX
fK9lwjnNeJ0xTS2UzbgGXewy8V1i5KixXQ162qaHTCIyYRqmwDBmVo2fcaGj
h6cywVsXcjvesRInrrobCtBkgY021evGxko82nrrEzt7FtQUw6sUgz+C4eHZ
8YXTWejezVH1X2kFdl/4/vXj8yxM828qZzpaDm5nhVNm0VkQcNx1KLipDCzJ
Uc/pc9f02vKKlyzL8I/uosgFahbMd3nZ8RiWorUs987wiWxYD5dfLcksQtV3
lirXc9ngfD5NWWIrQgGPBcdu42xEdUdzJDsU4p0DT76lXzYYs2Sl2s8V4L6o
68r8eDaUXr+zsDuQB2v9/vMRi9kw6DEwfZKYC2PvY9HYmgOZD+0Om0Vycf7r
+FlPyRxEnrBV+0ZyIBSl/IwtIAdS/UlzNo+zsL05pj8nfi3PHDA6tCsLTEtL
By+X5ODofhXboPxMLGinNkdN5OBCl5M953wGmpnZ2UWkc7GJe8e63Bfp+Chl
ZdKmlQuL/uPcH6TSkWdZnWNnmYvukz5Z2d/SEFPjoFsYnIvZJfbJBrU0ODgP
vVaczsW+GAb+EvUUWCWLz3yjzYO4jdmLwupkGA74yfhx5eHVby7hFSRDTeLM
WNfZPJhnTYrMnU6CwI+4/Uav8vDT8lvVMe1EcO6kebAxLQ8ZsbKXR8YSwKii
25hQlQej6Wv2AncT8DeOwXpmJg+hcSphgpHxaNS3yXJSyEd43O9W7s3vUeFd
9x+/Xj5657Ze9UmIQ26BgHalbT623AgQY1aNw1uOrgX61/kYUW1U+S/kHe41
n0To73z4rbJVKZ2NBZNI9ngdXQGo89sN6edjEOsj6r3IUwDC+3z0dEoM2lT3
9unLFeBu/8CR5l0xONjAfmd3cAHiFgOmC5jfouKA/3btxAJkdg+JsLREQ8eL
oexpSQHSk3l2B/pF47ES7ZapzwXQezqfSs8ejZGaH3EZEoWIGTAY+7E/CvZ7
LdXGVAqhUUiVm/n0BoxPPv/adq0QGwz8/vt99w1Oyg9JOz4thMH5jVXv3rxG
QGV9P/oKMfJF4tpzukgolL9jarpfhDSDN5I1e19hmI8/e8W3CMIXlY7ItYfB
ziXiimhMEV7+C0vhfRSGaATEBzQU4cOcmlhTXygWi13OXOYpxsujVeYyUSFI
Lbhi/6W4GGkvC9ZtMQ6CPHcPz/b2Ypwy4hGR5A/CoKPGR+XPxaCdWRE1HQnE
5pNKLClMJfhFa/ozWD8QRrniiXYGJeCNy0n8YhYAzqytw+vWlWJPy5lj79++
wFXvRc0xjlI4lySLMpq/wFvj8YZq4VLoftFjVhF9AeFt+fnPdUqx9YLkPrly
f5yxvxa0La0UmZw53x/1+UE8Qjsu8HAZnG53HbrU5A3dp42jj0+VoebZpemR
2954aCez855cGYytzx5J4fRGuerBQN0rZbiT3TxAa/YcqssrrruelME0rWDj
XzYvXNeP04sfLgPnj2t8xW+fwEN5R1jYRBlkZea+HNV9gjhx/06v32WIm3Ax
jmZ5gimm+ypW9OU4/YMtUMfNE/alaiePipdDulQ5q9LmMbz5/rAX+ZSjwYi1
wN/eHSmMFurJoeWoHDknTD3ljrb54eevY8px9sHEzrlVN3C01dK65pdDofd8
qa63G6JdI2bkxsuh8XDdaEWyK3KoZxtbJCuwN/jrgc8sLuhWdP3po1ABi/GS
GYYKZ8yllHCoalRgpxNd4l0jZ0g8OHm91qwCoRtTq3MSHiGP7fBc2csKaFR9
Z3U/64R8WW6+jK8VKDx0Npoj4T76E7XlbH5VwE0+xfv45fv4xxJkIbJSgZdq
bZpyjPdxaog5O5HtI4wTH7w+cMcRBXf/U44hH3GIL+JvrooDiuJm7gQGfoS6
rXms2W57DDKKhGm8WatriReLj93Fkq1lCUviR1xBoHh9zF1I4TOdT+lH/LKi
8RfbfRclPQORjyc/Yl5crrdd1A6ldDU19tKV4JmHr5S5LSi3NkyLqVRiJs0r
R+qYLWi6ZFh/aVUiw8InaXj5NqSji65aW1YiwOhG0GLgbZSdzPhpFlwJNVol
K6t6G1RYRO7QnapEW3l38JHoW8icsLTUn6vEcobEk0C1W4i9carQiKYKE6JL
TsP/rPDYtOfyLfYqZGxXmOLRsYKi4dZX7pJVoGewkVviuYkW3cdcKd5ViJk1
izvebI6y3os3MoOrULVDQ+LTE3OkaQvk5UVVIfHFFgaNM+Z4qVWq/TGrCqab
rJQt82/g0oWF4N7BKlwLWunUSDPDoKLVtvWHquGZoCZ0rNQETTWnTegkqvFl
Iptpg4cJSuTps7fIVKM85aToPSUTvJF9r8mlVQ1BS+0ZyW5jGEqPBhxyqoZj
Sm4I+18jfJXQYtVpqgY3k0uqp6Yh+nIEDfV6qsF4SOJlmoAh6o/PphuOViPq
S999w5/X8eGY3wWrP9XInqv20vG/jluH6/zddtaATjmWyazzGv7skWJOtqoB
m9Gm55lf9EGoZ2q8HGow6CNskO6tD89IRecb7jXQNXyoWHRUHxzsmj8Ew2qQ
kDC6btpVD+LrLFteVdYgizvxrZHwVTgMhPo93VGLWI/sA1tTdVEW/FrBdE8t
GPVohB4Y6YJOI3b17JFafGzt21XJpYuw2lTrVflaKJgdwdfHOijIrj5vb1uL
Kb6erGMW2ljy+81sXFcLq/nqpRodLciq/KuR6axFlqms5dJ2LXhvpHHhHalF
1DPtyIkBzbV3wjDT/7sWR+YNtT5f1wSxEGi9wFeHOgFpqSP2F+Esq+6Pe3VI
WYrSO1dyAbWrWoo73ergmtllyed1ASyFV2gWvevwPVV8p/elC4g6YmaT87YO
7Y/j3+7/qY6yXY/UDzXXYWjRoVbtkDpoFz6w7Nhdj0faN8TcnNWwo+nMLxyu
h/4D3Q53ETWIRfd1GZ+shyGHs6TxsCpMlDaFp6jVg3lrK2OetCpqwwx3n7Gv
x5lMo3UWzCrwO7X9lHlNPdTv70z+2a6IeKY0Ht+2eoRePM7e6KuIMqr8asbA
mt8rk8/XVRQx62VXufSjHk4TTJ251Qq4NNByzp+rAbE9LoxdVfLgeehplGve
AAdV++MCY7I4rr5TfvBOA47el+yuT5TFOaGsfeseNWCxkk1wq60snBtHp5Vf
NoA11HbBmlYWVB4ph+GCBti4XBFSOHAWCcW/vP9jbITt3wnaqUAZiK9ey7mY
0oiHYUK+rKFSUFUrc5PLa4TIEL+araIUjMJ5z0tUNOJyddj8+wVJ+EsMf+Hu
bsSJwckmb31JTFhf2U5dbkTO5Q8utEdPI4Ki9dBGrQmetdYPmpdPIEMkW9FQ
uwkqOw1SAgtOoPYh+zbN602wMvJNZ3Y4gT9cHckSd5tQyPF6dMcfCZy7oD6y
EtGExcESV62/4lhXoXzGZ6oJh207/Xu4j4OLJZHJea4JMSZCVlupYhDR3zxg
Q9MM4ycfrMYSxHD5X80dTfZmPNmwS+v8aTFkHZV7t0OyGR+T6rcymByDaQzo
Ep83Q4n1dmRm+xE0eog1Vx9oAfddjRQHbhGcYm6gfXG8BQ0tDvsTKg4hPuy6
xBXpFrRrFRb3Wh6Ce4pv1A+tFkS/imc8UC6MU71fbblcW/A1cyVM7d5BxB+M
5LToaYGLWv+MBvN+cOQcUxWjtmAwn6n9VPU+eEjXu6xMtaDkAhvXvNM+pCUu
2imta0XT2Gmbrz/24nnpvuEhjlbwMHRL6QztwZkJt7SNZ1rBrR9+7MmgEBxF
mustFVqRvPFAcNIbIaTd2T7eqtqK/u6YGXcjIexaSd0ert2KExceXZOeFsQC
65DbYatWuBt3/syhE0SapISWTmgrjtpFUvv0+PHF1c26OLIVnsc37xU9yI9d
NU3PBGJacYX3pCH3Ah+8LxiXTCW3YmGjoGlsMB9umL7Y6/qxFfIlEc8q03jB
6/9tIeF7K/jnF6pkJ3lQct05IeNXKy79mHbyD+eB/jE23cL5Vvh73hxLV+NB
RPepvEbaNkQIWtpYZu0A104v+x8cbajICLZ3eM4N1sR9v8TQBpG3L8zO63Mh
/UHRWynZtfpkyNO5HVxQV1PXkFdqgyeDxpBGPyf8Zu6la19sQ1SThI2gLicY
JWqs75u1oYhH8Np3fQ78V2kyVerXBrf9Cs8fPmNHbNBCeG1gG4aNyy76X2CH
rJmPSlvYml9pm99pbna40WcnUmPaUF93o0gjmQ0r6hvM/8trw91OS/ar/ayY
H3o7rkxpQ2IKdW/Eua0ISRUPujjehqYqv9SHvFsh7love3WyDWWTTlNDMyy4
KzQbY/V7bf5gWhdPEAtmLWQM/enacVWVIlRXzYxvf0eGu0TbkZR142XTwS3I
MfOrUBZvR47tD9XCLka49JC40tPtcLXjVn/vwgiO3EirBPl2yJepyln3Mazt
X1eWHl5tR/V4ipNtMP3aXt+9XehpO840NxZQT9PBxNhzOdSnHXF28Xesfm+C
aOfx0S0B7ci6+Lm2PnkTqjMD4/9GtoPppIPerMAm/LTVkGjIbMe/aNGZVI6N
UPzZpGk70o7URl6BbQIbwHbd6cSXsXZ0uT/ekft5PYZbhXmuTrajdrfvO7qk
9bBLe/5J7k87gmuW2DJOrMcbayXb7QwdiG9z/vNJlxZz05V+ZeIdoAvaseVX
Pg3K9ezuHJfswL/f10pCntLAu0lQO1GmA41vZ9CkTQOBZLddgaodoCo5Pqz7
sUrUbkonmxl2IKv/3IiE0wqJnSysZ/LtgFnJy6aCukVyK+S8oEVAB56qs10R
d1wkErKfHlSFdiBq12Oh8P2LpD6S/tDDmA5M+x4R2ubzj/xU1/WbyOtY+z+5
iT7UXyAkd+5i5acOpIboDzDt/0vojL2SeCc6YHJP32l2fI60s+z678H3DkRH
W6x/FTNHTCzkco4sdKDy1Q0ZYf454r0zkOsNUyc+u0kfEtj9h/S5HxlyPNmJ
CCHuHVbnfpG3olXHu0gnwlRbun04fpGbQzq+orKduLxHZVh9ZJbQSLjgy7lO
FJhOHMyxnSV7JpujNY07wWewTqY26iexU79petivEwdmJlMNuWYIWV4t8Qrs
hCu/uIpfxw+yKTGA83NYJ4RtQmNN7v0gr9YX1kbEdoKFW1VDuOI7Kc/ZfJC+
oBOVw03W7UbThGnn+x9jY2t+S7ymdF2TRPqS+9CniU780/ZXfug9SWz9DBqo
3zsheH06MUN2knSv43pPme+E5Aozy7XcCfL681P9QcYurEzeKPN595WIpFk0
dYh1QaX+z9XcmM/k2oR8YfvJLnwXlMz0NP1MXgoIJrSRLuQfXlBY3v+ZzAUO
eLQodqF32FGvL2OclDiqSjZc7QK7Y8Rx1sYxonZW5EOFRxdaSgVvrnJ/Io8e
0oeVP+tCaWZ4lvkXKknL/uxZ5tu1ts+FFBhkUQn7vjeGJaFdmAjVjft6nkoG
GVm4C5K6YJ5R5CfjM0pudv98mt7ZhRCGnZd7eCnE2zzbNEqoGz3PTqUViQ+Q
SenkpwwHusFeQVez7ks/UeB6l2h/uBvyXOcWREP7CW1N4HfVU91QFhzzOLPc
RxyF7OwXznejpbuGbqytl5iOHPXUeLA2TxFv+PO2m1TmHIgvdumGvRhLTMK1
biLgK1C/z7MbesenQ/l4u8mQJCvTqn835kq1JM697iKar34GfYjrhpmv7gfj
d51ERivt3Yb2bnQcXr/hfWc7eS0cX2Pd042GjNH8x5HtZGl91ET/YDd8r+w+
uNGsneRl+B1K/9KNbzo0858W24gIi3W23nI3HMJpZfuE2whPw6GqnH096Ph+
zqJfo4Xcf7v7C79ID36G9O8pmWsmPY47N/sc64EaV9vp1PBm8nLfFjUj0gPn
1yu38r82kc2eU53Mmj1YLLvyz8qvkcxJfxi74dyD85U8rzcz1JOi2G/h9zx6
oHidW/TZxzriRid80fNZD7genjrR9LCOMLUmlccE9EDyIDXx7c9asscg5fXw
+x74W7dsdx+rIZec0nU0W3tQ3yJlsvKtivCM/mQ26uqBYLTgjvbUKkKVPVpz
u3+t36aKqmRXRW4xZh73G+tBwmap97tXK4lneBZr/XwPWoSWNvjyVJLs/NxG
8PdCPcjksdvdCnJ/57z7uT29sNuvufvc2Qoi7XritN7BXpx6W9WcuLWCNCrm
J9w/3oupL5fSmNLKyVhPgWe2Ui+iz51qkv1VRtjniqUP2vbCu8S1kUOwlNgd
rczi+NgLBGsfcSQFxFSML+pFbS/eH7g42DGTT3TEHz5nbO7FQ/uWLZyx+eT0
KTFD2r5e/CvZel9lSz6hPRPL/P37Gt/gkbQdk7nE74KHRRV3H/QCPC911GcT
l4sULWm+PtD2/RC/6pVNbLUkZQp39+Hn6l+7N8rZ5JLub8500T6ce5jkrNSU
RXiuG1dFyPfh5jw33UB/Jkm0keWzs+3D6YNs7Ye2ZZAI2yiGH/f6EOn46IXR
SDrxsVuaM3fqQ5ODd9jpxHRi45DVZPC0DwfS7vM0yKQTCRehByqv+0DHuolH
zCGNVPpt6Bao78NlcdHJXetSSM6La+WRLX04uiqlyRmfTOIDipK4uvpw3YDK
sV09mTwPsXNnovRB4djHnv0xSUTjzZjovz99YFLIjOXS+kBGUiqft/H3Q/2x
7qOC8XjSOr1h6ujefsQfUjeTiownZcJyqoHC/ag+oMYXphVPohKrGLUl+lGY
OXS6tfY9MYyr9hlU7UfQ758ffubFkc+RtX5f7vVDriNlQ1xxLOkepJtRdOpH
dt7dD7ausaRmh5J6ols/9h+/QDctF0viw+pYrHz6Mepet5PSGkMsgupfzL7t
h/tNHWW772/JtHdjwHJTP+pEXBs3K0ST4QbG3/od/egW7ZX4xB5NmunVNMt6
+9G/271C61MUSXnaxO7+qR8sT43MVlyjiI1HcxDdQj+6tpoHnvN+Q34/aA1h
ExpAYXZgsGxrBBkrYJm32z8Ayzsif+SdIkjXgrpOt8gA2FnHd0kdjCA599q4
wk4O4PKRavE/z8KJw532sF3nB7A5VUhkr8YrsmjRGb7//gAeGuVN7KUPJZri
ei9EnAdQeb6T/URdCEla99nzmMcAnofuUfv8NIToh/69LeU7gF9DqidY6ENI
eRW34oW3A5jyzZGUYQsmT/iu/3aoH4DdMeX/NkkHEsq3iQmnlgG82vzoyyW6
QHIi13bErXMARy6L9Mq0BZBJNY967+EBHO55oE41DiBqD95HRc0OoP8kkw9v
wEvC1j2tWss9CDoL0Txu+hfkZrT9mSbeQbDEHuC+NOBPKm+uSrQLDeIGg/MJ
1mR/Yr9+q+CgyCB8mpO3bdTwJ32iYgs/zqz1Szd7XD3rR948v/+O03IQrdZt
zbzJ3uSgzKYV08JB/P525poMx1OSlvhhb2/ZIEqVGTx4m54QMXb1C0rVgzhP
UWwa9nhCJL+Exh5sG8QgM7vs3zlPcs7ngMrM50HECTh9Vx1/TGz71EIdWYfQ
vPdwgN1XdzJ3ZrZ8knMIQ6fsY+WT3MmDpOBvV3YOofK/34kdNu7Ew3mEkH1D
eCHowbBtyY0E7749TkuGQM//TH6W243k3w486m0+hF/HCmloHFwIGThxdfnW
EOa2hC0ayruQCtmhx7fshsDKb114eZsLqefc06fuPIRn774uLps7k8HiXOdt
QUPgZPx2J/WPE6GhH2h8XTYErzox4VdSD4jHHec55uohdNMaFrB8u082Dwny
uTYMIfBm83ffsPuENe3mHaPuIRw1W3oXtOBIhC6tbN83NYQg5vbmO1UOROEt
v1k65zCWPnmzpT6zJ2KhTHuqeYaxO3WQM0zZnvD5Lo718w/juYUXvRSjPfnn
2GW4QXgY1YWjNvEv7pLkC8/0taWHcZQp5VRVrB1hW/dTa/nGMKhRh727J2wJ
zd8hdtZbw9j+aqD6QLYtmZqq79hzZxgWH6xqmF1tSXVv7AV1p2Hw8O1pdeW2
JY5pOmoxL4bxJYRjofjibTJiUCarVDCMAjYFalKBNWnUSl6vXzqMxlV6b9rr
1iRP5VWFbeUwPHpKxPbSWZOXEnbSEc3DCFSacxvSuUXkmPdJ/qAOo+JELOvK
eivyocTvWBDDCHadXVphcrUgoVkPZxNYRvD4a0mIppgF8Ug0Ty/ZNgJ/x9uH
zb+aE/3gs4e/8o5AWT/uyqqGOdl66++B02IjqD96/v3IkRvk3k4DgdGrI6jb
FMlgw2FKDNVFLw1eH8HsULPcWI8JOee+zqvHdAT7/u615X1lQvZMxPxsshnB
2Oz56Ek+E9KZ9bWswGMEScz3dDsljImoqq1BYNIa3zD/kT9ehoTH+WyAX/oI
BsdrfHp1DMmmDPYar5wRlIoGDbrtNSTDnLkirmUj4IlLlOGpuU68Py0uW3WO
oFHZPUOS8Tr5ev9xhMLSCOj+Hnsqqm1AJi8dvBFNQ4F3XKDVEq0BuTbDRsu7
ngKG8dfWCan6REVw/Dg3HQXszGl1cQz6RODZk0gWVgpSOaq6RJqvklbNxpvL
uyl4+Ttfzc7pMpH/nrXxwT4K3gdkLl+QuEyKnkRGzR+gILv8Uj3LrC55X3Cr
89dhCnrrw/KPWOiSR3xbJSdPUpDizzpDY6JDhKe0GHrUKNjwrbmo0+MSydNU
LfVSp0BH2qOIUfESOVt85g65SEG5f9QHNcZL5LLv4YF3OhQ8EGDSmQzRIs9E
N3+wM6LgnwQt18lCTfLZrkiZ1ZEC+tV/Mqk7LxLboYyVqgcUvPgkc/HglAZZ
lkvIcHxEwTt3L0nBQg3CzhnMPepOgcgcX4jnZQ1yNt96MtWXgrlYw5s73lwg
UcsCXmqxFBTtPxniBHUibLqdrHtPwWJV+L7cbeokt5l5NiuBgqenaYT6es+T
5jdLujypFNithvcFiZ8nyzLd+7/lU1DCvezxYVmNXPZ8Vve0hYLiNyaDCgUq
5PN3ZyfJdgoSFQxXj9urkNva9kdmOimINzVs33FMhTzdZxSm3U/Brc1WT5tT
lUlOvaT5nnEK+BKU5O5lKRE25hm6yn8UVB03fjvVqUDai72eKC1TwB8vcNfv
tQJ5eXP3xpZVCv7eGn/geUOBsNZfXt+/YRTq/+7tvr0sT1gfVy3/YBpF0aa2
rycOyhOWxVezOwRHEb6sIfoyWJYwfpEbvKMyimbN4ArLJBnSGES5vKA2ilWd
kW1BLjLEW/ZB3yP1UZSmC0eyaskQhrdp3c+0RhFXGaYyvSJN6PV2tL0xGMXU
lIikoJY0oeuYqWq4M4pYrtWqbA5CNpSGpwpGjGLLFjvfWamTpF9SVnHk9Sie
THi0JE+fIKkFU5RX0aMo5tna/CnyBLmcI8XK+n5NzzN8fdmqBElPHrGjyRhF
vIWD+sk6caIfIXhqqGYUGgV/G2TviBEx7sb20PpRdE9tqq48IEY2h9pZajaN
YknBZbGWeoxkBVRFNLSPoupeApe+5jHC8NxsNX9oFK+Kh3YUSh0leY4fKoN/
jaKR2iQnvV+U+P69qKcxN4qw0+VTm9oPE6O7S3+2LIyilza3MkTjMGG6rbb3
8cooLnqw9bVeEiEmN348u7OZiu6L/gHxlsKEVfvYeXVeKr7tDjv/vXofsRQr
7NusQoXOrNXBlJMCpKy1KylPjQrDd+J+xX38ZJvVjLOZOhWBRV5GAff5Sem7
3XuqtKgQmAR3YAkfYeP0t3W5RoUVfWDTtze7SOGCMcPfu1S4JNibnTiynbAE
Ow+/c6Di87yTuY8XFzE5+ipd8wEVj+NmDzuNcxJmyxbtDBcqVsoX3ESjOIjR
4MlYq+dr+i6X/Fb2sROGUiapsSgqaMIYr/3ZykyuXdnPEhCzxlPbd7Z2fgvJ
/nv2k0wcFV4UkXtTVEZiIOr47M0HKjzYeUoOl9OTzOhPXZdzqPANS7/R/m4j
oSMr8ZvzqaBwWRlfe/8f0evnephXuMbDsSlALWkD2cR2ToCjnIqEHtf7qmW0
5IpH3q22Biryltx4uAVWpNL4OmRcmqmYWoCj15Ulqf+Kp9kPt1ERymtG2xX+
Tyr1j0ChdzcVtveVnTYe+Su13sxnk+LoGt+Tj6qSKTNSH5QMo0rmqFA9Unr8
90CHlJgwP8ECFWWy7Fc8s5qkSpgoA6WLa3xNXZNa1I9SrR16nOU0n0DzJlbV
TfK+1OtPyR8X/zf///gffLJO/A==
       "]]},
     Annotation[#, "Charting`Private`Tag$3158#2"]& ], 
    TagBox[
     {RGBColor[0, 0, 1], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJxF1Wk41XkUB/CrVLYW0sIoyVImqVEYRceaJTVZylLZsiQpS2UNV0RJiFCu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       "]]},
     Annotation[#, "Charting`Private`Tag$3158#3"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.1}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.811085088857396*^9, 3.8110851136422777`*^9}, {
   3.811085174742004*^9, 3.811085186176491*^9}, 3.811085327209573*^9, {
   3.8110854192197943`*^9, 3.8110854468359547`*^9}, {3.8110854815022173`*^9, 
   3.811085512959269*^9}, 3.811085590954831*^9, 3.8110858609817467`*^9, {
   3.811086011904632*^9, 3.811086016561001*^9}, 3.811086083822824*^9, 
   3.8110861706486797`*^9, 3.811086299293765*^9, 3.815760577455697*^9, 
   3.815760609024878*^9},ExpressionUUID->"beaf9765-293c-4c4c-9471-\
f685912637a7"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0, 1], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtVnc0F/73RkvxQVJGu5BKqIwSr8dKRgqRLasUysyWlETJToTsihays3f2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       "]]},
     Annotation[#, "Charting`Private`Tag$3202#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.1}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.811085088857396*^9, 3.8110851136422777`*^9}, {
   3.811085174742004*^9, 3.811085186176491*^9}, 3.811085327209573*^9, {
   3.8110854192197943`*^9, 3.8110854468359547`*^9}, {3.8110854815022173`*^9, 
   3.811085512959269*^9}, 3.811085590954831*^9, 3.8110858609817467`*^9, {
   3.811086011904632*^9, 3.811086016561001*^9}, 3.811086083822824*^9, 
   3.8110861706486797`*^9, 3.811086299293765*^9, 3.815760577455697*^9, 
   3.8157606090667353`*^9},ExpressionUUID->"6d393d08-51eb-4afc-8b02-\
21d75787b8ec"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0, 1], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtV3c819/3l5bwQciKbEVCklHc85K9SraKZGZFkoxkq2zZIVv23pvsvfd8
WxGRysj6+T4ev/vHvY/zOOf5PM9/7j3Py6xvpWKEj4eH53Wy/e+UN/reV7ei
jjRoXTUPa22wMxJ01jO0AkDI8+fltWs22K24yJhCWkkwkWON7g5/iSl0jRTE
0qrBsHWU6aC7Ncbmx5ByzKgN0RqXsruOrLADeYOIZxy6QNSyNM2FZ4VpGu5U
f6I1BAaq48iXdJZYowRd6bcYY9Asv8g2wW+B8bGK5f1hNIVvvtzv7VXMMQKc
e6IGxwvI195tNEs1xaZ430v409qCSM2ollq0MRYaR1PH/vg17FbPD75eNsLk
STNEa2LswD7J8BaviBFW8rPz9gajA+RUC82UrRlgFrq6Be+fOUJJzdJdgfsG
GEv3Bg9TkhNIzfN6xBbpYwHZ5NcecrwDDXnbS18Cn2FSDMnJKyYu8Dv0tefq
6WfYu+bPZPVqrvAiuJsi8K0eJiDI7a8d7gb7/tSpOX90sfhLD7x9aD0hdFVh
rFL2MebUFdGoUeEJOWnR+BVWjzANr1l81sdeUGJaXP4mVhsj/vvSpTLGG2K+
hkc/IdbClrMqqt+LvQf96EF5BiVNrMHw9IHq9HtgPDK16w3RwOwHQ+3XGD9C
0LGBmQq/OqbqN1VSVvcRPlGrjjV/VMN4JDn+ej7zgbu71RQOS6rYQmHpS4Yk
X6gUtRD5laOCPQwZN7vPEQCRu2+yN94oY9wKrOl0LQGQwHFhk3T1AUZw2mJ5
ySQQdrK+1Rmu3ceelh/l16oFQfDICJEjgRKmeIm1jz0lCDYTtydrmBWxOy9l
Nn3/BgF3VYEf3z0F7BJnEI9WeDCsCLNNlUbIYfheRUo1S8FwA4bt9Tplsc3Z
UQs2oU+gFaC09Pi8LNYRyZy5OfIJRnfOx3kESmNuBIVXP9KGQvGmjq/tvATG
JRP8ocA6FJ68sWx+IyyB9XtZrUy0hMLSVQdysZB7GNtp7kweuzDw3xTgktUW
xzrFCYm1usIgw7pmmrcRw167frdwYwsHYS/cZ3oBDGs+TOYZ7A+HBep0sSJJ
hFmJegQeckZAySV7zXxMDKNxerbJ4RYBj7yfi1lJiWKmuwwFDryR0PSAnfzM
8zsY8e/w24x+UTB/S6R59YIQVnzzdbjsfBT0fHPhEJEUxHStVXde3vkMcXqb
drxet7HcddLyxu+fQSZK8Rk/nQCmxf2T9idEQ+KDKbVey1sYnnmnI3VENLyI
Ei8TbeHHVL5/EDWTigHCwWOqcp+b2D6HSWxITAwkt+OZmf7hw5KNpI6qfseA
SWU2IZcBH/YXd6qONDEWGK3jq7S+8GCRU44SxUdf4L/rQa6fy7kwcXrt5Gn1
OJAQzlS6MMSJrT4SOkuQHQfvWO9scO5ew66sORhk34gHF+fFX/ZqVzEbohWK
e9rxEGYSonndnwNr5tJqHPaMh+wmk75PneyYlakgO95kPLgPtXyL0WXDGj+k
DIWeT4D6s1rL/XmsGE0apTfnrQSIM0jfmSNgxeqWtpZUfBLgNFPvbmMbM0Zu
mJuWIpwIWvG8C+cpGDFjjyvadwwTwS6MZKuK8ApWmeh/oScwEcac/pqpEzFg
hnPmZrtLiSA0ufj2HMdlrAxvgs6fPAnkL6U1+wMdRswk38GMksB66UzvoB4t
Vqx7jVshLAkkXt7d+1JOjRG+i5icqUsC6S6S0cRNKkw39py/7VoSZHD7CT/n
ocLOTS6sx0okw7kXzjPq1ZSYlnZC7uavZKjNG2ruYCHHNibUCBPpUqC1cPzs
UshFzFuXwEhVIgUujUDp2wsXsUIDK7qS0BSQOJ2hE3qKDJNfYnltUp0CG9de
18afJ8Vmnw/30CylgKwYqeUhBQlG8kLMy0koFTi5P2iZSxBjKZubM9x6qVC0
evT7rDERJvoq+c70h5M8v/BOSCAhZmZPtImNp8J1kx8SqdsEWJP72KNzzl9B
vVsn+DTpOezJWf/i0pSv4GWg/vilwVls6z1GZtr9Fdy8n+xj1WcwJv+vTR2M
aVCET5Cq4XoaKyV9zOQsmwbm5YpzMiv42P1PJE48L9Mgq2zL/Y8GPvY24jVf
cEMa7Jg/tliBUxgFHafvvR9p8Erna8lSBR6WETO5+JsiHWo/1ngT38HDRhIk
ojWM0oFEas0z/sMR8GddPEdPkAGOYvsinoT70MbTpNfFlwHLRrmSXKL/QC/f
vvKddgaoOhf0gO0e+JfMWM9lZEBQ9Fnzle0dYBMJ6fg0cIInqXrEIL4DFZXS
HJIHGWDM2p+zH7QN3+uyJ1KVMiHeaVPkAPsLLhLPBLXsMsFBsXu6Nf4PUDVT
Bl+IywTTp/Nfg8/+AYkOJ2mLzUw4+0bz+6upLfgyJJd/MyQLZg+Uow0aNuG2
1iHRfGUWmFm05C9KbULneJ5x6EIWGEqoy3p+3oC9GWr6ndvZkPWUZ5q5ex2C
9Dvs0nSzgQMvysJ/aw04Ft/1ab/PBre+cNcahjVQW130rhrNhutb8cVx71fh
h0XUnOWpHLCwaKtdbloB9w1FUUauHIg+F/OTjXAF8v4U/nJzyoGBphqFhqRl
IDp2eyJzJRfwan44Z1ItQqSppi63dC4EPM+r/OK+AGyD3HoXX+TCYhgx9enf
84DSRwwmqnPBO7JELnAWBx0U2UZ1i7nAuyl90VYHB9xQX9h/Lg88Xt34IzE9
B+Xp4cWlPHkQTBrwl/PHLOA9dRPMuJcHbGoJdfhvZkGa0qI0RiMPaEG/4f65
WRh4J17u9i4PyHyjlfN1pmFdda1KoTsPOL9ovu6QmwCBCyNiCJcHlA4LAqwh
4+BYU1/Dt50Hf7kv7UzOjcF5zoi6S1fyQVxsy7o1YBSYj8QbZyzzAS+pK4if
ZRieF3JL9bvlQ5ZttKvApyHIeU7d3BiWD6vROBWjc0Nwd2CtJb06H8Zd+U+N
/BsA9bSIjlf/FYCW9J51LFk/xOi4KxozF8DUjUGRui99gCO37NK6XQCUxTcE
rvH1gZXzvR4xnQJoPl3m+/RJL3xUWe8/n10All0fn8TmdkHv+VHVf3UFMDaW
rf79XydQVTcMrg0WwPUxu5/yCp2QdDVyuO+gADh3H5+r+9cO1Qf3xqMVC0/m
SeIp/aBWOFNw43GAXiG45BmeMsRrBXkTmklX20L4KTTDb2jbAiN961NGMYVg
HCVDtGDSDL9SI+d41wqBsS3iZZpDIwg/8dBnwSsCCvxcn+fnGuHdxRfzlJRF
oCQb3SQb/g2I3kos7t0tgmF2qqaztQ3A/vDn92++RbDOfL6ehL8e6Fxk7pgk
FAGLw5Ub4V11QJYd70tYesLXV1Z9YF4H/whUeR7iisD0io8tvX4t9NaVvpoW
Lgar6fonNYVV0PSTrMntfjFQ+67PHlBUQQW9GRW7YTHEDydQZdtXQoo9fbl5
YDEQF0mK9d+vAEc+t6PdxWKQ+5JiZstVBla64w9i9ovh6chT4/cZpWDod/L4
XywB8cx++ws8pfDg+6KEt2gJxArbKP1AJcAWL/+RIqQExMaztq29ioC2O2m8
JO0kLpwwuHGlCEgODq4/qikBfk4Fm7DyQtjTzO2OXymBh0POdtS7BdBNSknJ
g5XCebrLp0qD8+GbmKVRn3opmI3fpssUy4cy8+YSW/NSGBbxLyr+kQdJLfba
leGlsHVAudqhlAf2LlNfZNdL4VoSEXONcg5YZgtu/sAvA0Frk+DK5mzQnwgU
D6Qpg89/aLiPIBuUhO4tDEmUgWnRKs/23Sxg2UjlNPhcBr/MfzTd0swAagY8
p3N5ZVCQLPloZiEdiBW0O9ObysBgXc+O5XU67KQSWW1ulkFkqkIUa2wadOpa
FznLlEN06p9eugtfocGv7SyzTjmMbl984p+eCqUVLJqNNuXw3/MQAVLFVEik
Gtoj/FIOM4qdCmcjUuBNtwhE/imHwGOKJrmTuUXCU7zYRlABuF1afcLdJEj2
5/Pbp68AxOg7dzcnCfoUr47pSlXA6/GJm91XkuB6B+Ur9vAKSN0PWa8gTYQG
riBazYwKKBye4iHrSQAtH6K6DzUVkJ9Nzx4amABecvj/rS1VgM6H3VxCygSY
adlILRCqhKSJpwsbnPFgd9VcaUGhElQqcVKb83FA/H7p9yW9SjjzNPDsn9dx
ICI9hTl8qISnD841pcR9gZDG9nEYq4SZZSE9X4JYkKlPIelyrIK8p3GiLVc/
wzQTc/FRQBVwq8rdlOqPAlvXmMd8SVXw6V9UDuO7KEiAkLSQjirI3FYS6BqL
hP1q13uP6KvhE3+TqXh8BORWPLZbrq6GvE8Vp/4zDANpuhF62v5quGNAzyPK
HAaTDirf5JeqAX/ziM94JhQuiMiR5ZDUwG9841/huqFgUCqYYfu0BhhTSzKW
TUKAuuji9KlTtcDRc+/W18RgeOK3r7ZAVQsuNdl8xKbBkGi42NHMXQvayzqk
CnzBwH2pvNxXqxYuPhS9JlUfBPfs9MIu5dVCIXXJz3djgSAYo5kaylsHzi+H
bmh0+YH2h845rzt10PJRY33mpR+8tRVneCNVB4ZWEjdzqP2gXvF6qPbjOnhV
3D2Bb+ILiodHblfe14FxXsW5HQofeKabqpM2XQfUG3pM1YnvwVP+clTUSh1I
im8v82u/h1TBoEGfP3WQuuJqmED2HtZIHBUsCevh7gZFqJa7N9jVKonwC9YD
Vitf1GjtBX5Mfymr/Ouhw4C8IsjOA3KIzZSzI+uhceY+N+6OB/TtTvt+SaoH
CacVhu1jd6Dqa8V3K68HmdEHtdp+7pDgFrMptVgPKm9PzTVku0EJTqKzR7QB
roZ/51oic4VhWbdf/jINYLZYs0nU4ALbOTVUiioNwOBMkPHawAWEnESetZo0
QOS53OaS9HdQRsG7XfepAVSafpJ7SDhDuSQdU8H3Bqi8IZFAle4I4xmaUta/
G8BdOsfv9iNH+EcWZsZz1ACflPrUpIgd4c4UaXEGxTcwzHD6wvXKASpen5VP
Qt/gBlPMTqmCPVSlbr4KDf0GyjamySbsdjBJzBOlEneSVxesFlx4DQc25jVk
Gd/gMYQKtie9BjFYIvCv/Qa/LfGCBNhfQ83IRKzX6jfYFZQa7eezhVqClhY7
rBHodyFAzNQGZl+cWRdQaITNPJ8SsVs2gDckTv5bvREKzPyzpg9fApZQ9cTK
vBFCDJ6H7Ye+hDqRgl8m4Y2ghC9nadluDQ1msZe11xqhr344/GbCCyhcMTfX
3W6EwwKh96FKLyD5+Z1KA7wmWOE7cJ7+ZwlexiOPXlA2QQGtzBq9liXI6l/8
7CHaBIRE1lIH9BbQo+1Fk+PXBElbJqm3u02hblT1eWF4EzRdVhGaf28KeZos
ZWXxTZAR/B+Ryj1T+KReq/mtqAmMz1vKm5c/B42He+Gjk02gF3Y0qJJnApOy
lpdO32gG73Qltlu1RtDVcteIQKgZlleKSc54GkGNNGHxf+LNUJ8jwvdGzgji
JL+q0ag3A6u55qbosCHoY3MhN5ybwSGnNIJyxwC+C6mTa3U1Ax2Ja663mj6M
lbDq64w0A/ENoU95LPrQfnsrX3+uGeKXxxz1fz2DzFuBDy3/NkPxdrOPVtAz
eMHbFuTO0AIE8skkJoN68JdDjDTbsgUoDM77Fi7rAsLda/Gxb4FJf+6n+X66
4B0r6/LcowW09d/KVvHrAhWl2gZrVAukp8+dWnfTAcFT5j2fG1ugiC4j0YD7
CdhPRAZ+uNwKyZ7FXBdztaEu/IuMMUcrEOvgsTkZaAOBSvKxxM1W+NY7dqWR
RhuiWnOtjqVbQcbkJnz30oKK4uYHdjatsMY0UnTLTBMOAv+QGra1guVu80GL
ljpIKvxrER9shSJjSfMDWnXwO4fnyjjTCvEfNWNXJtRO7gnR5vifVri5q6++
9EwNkBlL70OmNmhjwcRu2qmCi6RyELxpg5yDeJ37NQ+h9VhdlsG9DdwKh8yZ
fB4CWeVjvH2/NviZK8jgp/EQ4m+aWJcktkG/V1oi5y9lqLvyTvlGdxtM7du3
Kt1QBvy9TLLL7O3wTvO5gLuLElzuuvcbeNtB10l7wINHCQQSxoYMRdpBn8pF
1HBaEYzkzkfnKLUD6cVe4jJMEVqj9Nnv2bXDvUKDU2akChB4h/aOaUs7KDsy
ZP/ql4U0kjz6gL52iFS9TdkZIAt1OOnjgomTfp+Nlp4pyMKWj23jwUY7OK+Q
DJY2y4DGRM/9IJoOSB5xJR5qkgb6t94GpaYdYK9od5tlQRJuKzNIT77qAH5H
0eH2DEm4z1Z07dS7DthvpGC9aCMJLp1z6/KfOoA80mbPCl8ScPRi9tMVHWDt
+phNhksC0qt/+50l7gSbnRX8tVBxEDzWK1HN6YS3UWwB5JFioKhU5y5V1gk8
U8xKNrJiYBDN+ECooRMeNUftft0ThSCh6WW64U4Qnlzt8tMVhRWrx7S4w04o
eZTpis9/F2Jm1d9aK3WBd6uVU/ehMBTwFMvqa3aBAsPTnNAKYWh9S3lJ7VkX
WBoE5JPaC8NfmoFsodddUEn1Ze7yXyG4/1B55iimC/Yna9zUdwThVIP8Pf+1
LuC1GQwaobsNNGQZJC7bXZBkxGZ5EScAPLoXJqzxusHwfablQroAPPrX8kqN
shven7mi/uCuABTxS6VcFu2Gb1ntF4mMboFxEhBk+HaDHPnL2ML+m9DpKdDd
zNUDdK9VcuzpeOAOaQd+8O0e6Oix50xvuAFpUc+EHmM90K9eWT1qfgM8cgLi
N9R7IOFzGjFXPTfcGf1uQ+PWA98Lj6KU3lyHtOux1GYjPeCqNL6pQsoJVCW3
FAVwPTBZTtJ/p/kaeGLtrkdrPVDzkIJm1/ka5GXs28qd6oWuhbvW3zeugm/t
tekpql6gJxoW05rigHsr7nnn7vUCnW70rfeTbODA091uLtML2ee4wrPi2CDv
Fe1ir2IvjA8nbXoYsMGVo1zaaM1eEH74Tg9bZ4U98il3Xste8DAc/FVCwAp5
okLqWpG9wG8bixvTYYZlN3er6the8L594SrfdWa40tL1kSWpFx4ziujT7TGB
30PDmrXsXtg7x2qcHM4Ez42Dr7p96wXpmpiPjXmMwBj0Yy/9Zy8w7+41Sa7S
Q80zl/SC372gsbHuHBRND7q3KLQrd3shyNtiIV+JHmKG75R14vdBDKu5tXnR
ZaBh8LHboOqDhoJwO3tfOiDPuPZbAPqAJzHY5IEuDeQ7VSWKSZ7kVyM+bF+m
AWUlZRVpuT7wJlKZUhmnhsDNN/maqn0Q3yVkzapNDcRCLVaOJn1QRc+q91OX
Cs42Gq3VBvaBO6eM79uPlJActhfdGtoH04Z1qkEPKUHSxF+hL+qkX21f4F06
SnAnLM7AJfVBe9vzKpVsCjhSPmN6tqwPXg+aUz4ZJ4fdqcRF+dk+yMjBXY25
fxEicgXDVBf7oKspMPct40UQdGuXfLLaB3WrzmtTm2Twmm0ryfLPCf563hB9
GBlsmYnrBxH0wxPFWba2ZlL4sTMzPcTXD1lFzz91Xf8PSkwCG+QF+6HEZkOx
cogYXEdQau3dfnCzpVP+6koMVKWxlunS/SBdpyhlNUZ04r8eH7x90g/NiznO
NuGEJ75+mJbtQz/c6+6swN0lACND78NI/35ItU17ZfnnPPAN3p77L6QfilSX
Wtuzz0NzYWjaTmw/kIjY62yxnIdfNipCHYX98C+BbzOX6hzI/upSs5nph9xO
RpZLLGeA4pmz8PJCPwx5eF0uXToN073c9E9W+6GVPSCFIOs02Ob5zkv97Yfw
lgOKAuHTEGclZ0NLNABpfS5/57XxYXu9MbBOcAAIwi7/97scD+p1bF/dFh2A
f3/0aiI+4IFfF6tmhvgAdCZuQpcmHrBku18JVRwAnJzD27aNY6RkgWWb6A9A
0fj9GSHnI5S8WtlOEjAAJjWfuira9tGLiAesZiED8EGZ4rGgwz4Skpx3aooc
gPgrXmzRnPuoPZbwxtukAVgPuMl2yf8f+qWsHbhSNnDyf3Lne6u7h1Dptmrj
/ADkRuhOkHDuIAJDnyzGlQEweqPrvLW4jfrJrpx1+jkACQlmpz8nbSMjM6mS
m3sD0Pj5uTg38zbyYwiliSMZhCV37AYL+1805nFzykFkEGLY6C5b3v+NEvma
bg+hQYhS7Bn2p/qNLKa0AvgkB+ERh8K08swWwhNyheX7g1BhvHK9xGYLcax2
J6gZDgLT01PirfG/kK2yhTFv4CBwba7m6tNsInR4XOMTOghuzIIKgQMb6HxG
CPVS1CBwW0cmG73ZQJ9PV7bGJA8CGZ2iCnfDT1RfcuE6YcUgNE53WfUbrCMS
hq8bCwsn/Q4YjQmGVhGm4TE1vzII/zSD5N/6rSKbwKcduJ+DwPpsPaNAchUN
n6L5Ors7CKJHpGR6pSvoy9IH3UniIThafV7nn/Id8eSZdQ0IDIFC+98npUlL
SG9FurJfZAh+sooWehsvoU8srOl9aAjKefdkDjmX0HbohGeP7BCMTjvojBUs
ohoHRdGOJ0NA6RBzm7xzASlJ8GQ2eA5BTy2rxTHdPHr3ljCq/uMQ1BZGF5ku
41Be8ZJ3XcDQiZ+LqHhahEOU1+L0ayKHYCVSO/X7AxyaJCajq8gaAtOCqkBx
/zlkMfzrQ/7gEEQQMTwaYZxFfqbFxvFswzDy8U5eleAEWsWyPxBxDQNlA0HL
qeVxJEOTkmHHOwzSNPf3+CLHEX5L6E/FO8Mgz7rgee9wDDmw2drtPRiGnuEW
goW+UWQ8w++t4nSCnxXs+Js4jBpLuNKqXYfBToAsKV1vGLEEsLRf8x4Gndvr
kUyMw2hKlJzkOGgYtmvVhe5/GUJqn3+FZaYOg0mAdqZhyiASV89LOdM/DAO8
p898HexHX7jTWqxGhqGjYK7cK7YfHZyOXxmfHIaAx+zXz5n0o7KCwBv5y8Pw
Qwtvd36/D/GQWRXrHA6DfTS+5Bh3H6LvuNFUcm0EBn7eNxtX6UGOiezLzDwj
8CtinKNmuxuNODBc8L81Ako0fXdzo7vRp2v/KRmgEXD5cvSi/HsXuuC9Nkiq
NgL7dY//WQZ2om0sc+G5ywg8aKT/coGoHVUl/4h+4zkCss/o+D5+a0PuBNyq
3h9HgObtHeGut22IpDerPilkBESv4zISf7Uijqc5X6a/jkCQVQ+tx0IL0nDO
11LrHYH2HjGjox9NiH7uF6nB0AiwJrBe7s9tQjhJ/paX4yf11k04Odsm9IK4
8HbgwgikXxD7yn7ciLyji8jbd0egh+3gTAB9IyouL+0E5lFQDjPycn/dgBwZ
dj3uc4yCLaca+32JBoS5Cd/VuT4KdxKbujMuNqBO2fJ0x9ujsLaskUeSV48W
Riq8i+VGIeH+nS7J33WIcrsau24zCn41bp1UrLXIlr+xiOrbKEC45k0HVIGM
BZjig1tH4SuX6uTAZjnSEnzrS9w9Cm/tev6jTi5Hd+8I6OOPjcK/mouOCv+V
I/x7yaQ/f57om7yZd3m1FAU+9DRrohsDnRBvjYH2YuSqOquOMY0B/tiG4BOf
YmSjLipeyT4Gv453bOPki5GG9h/qfL4xuP82y0WuqwjRPzNsipEeA4tdOoKJ
8UKUYS3JZGszBnevU/TfuFSAYmziiTbejEGsw7tgg5l85G97sG3qPAZd9n5R
dzPykbV9UdfTD2PAledI3yGej4Rc2ZwUvowBAfl5egH7PNQYeGaYpX0MHgny
rV45lYNKgvXqY3vGgP9YTI06LRulhVRl0QyNwbOnOCpa5WzkG2HrQTI7BjK3
vo1wJmUhlbgFvn9/x4BEpjCZRj0TzeQ0+vYxj4Oyl/a7isU01Lt+Zo3/6jik
3VA2EYtNQ3XcUoqh3OPQzKXEFKWehuIzmog1hcahsnDqbm/rV6Sf2uw/qTgO
YX9+Zf4qS0VLsa2By2/GQWog50xqdTIaniTYlHUeh+Ky15k2bsmo5bKccob7
OHDefkiwLpWM0qLayCz9x2HOo41htjcJmYW1B28ljoOHhZa87c9EtO7XGXLY
NQ5tPG6dF2QS0HQH8R/dgXEY5hsVmqdMQN2ESmp1o+Mwzu7RoD4fj3I+dFF6
zI8D2QcDkyO3eGTt2R1GsDcOQxdNQ+/7xaE/Tr0RFGwTUFkcGi7ZG4MWKsh2
bTknwPwVz19p5xg0tKesNcwzAZTki1fErsegkjd9NFEiE/DoZrPg34/RyP5V
f9SVBxNwIZeN56rKZ7RvNhjN6TgBbw3KVq4SRiI1QZ1gHpcJaHwwSCncFoGy
Ti153/KcAN9IDqWlDxFIN3LnpVjABPyeUhQmI4xA9U10sg8TJ2AtoERUnCIc
vWd69se+fQJsb8mfPY+FotkfKyvOPRPw+cK7ZQ2CUCRcajPjPjgBNx/xjIr3
haBVJc92v+kJ4B1xUsYZhiAlp6/x8VsTMC5C4s8Y8glRDK8rttJNAoEZXxkd
YTCySLC718U4CWTJXHQaE0Go0eJYqJ9tEp4TuQiTZwchu9MXWSd5JsG/O/vS
OZUgNMYnsLdx76Qe6/Z8IhGI4nwdU6jNJ6HXqq+bMdsPXRc/f2RcOQl/ftzT
E6f6gPIyMq+O1k1CrTyRJ2PXeyRAqfxQrnkSHszKdk17vkeiy5HJ1/smYZKU
UnJn2xvd9+dS2FyahFQW55+Ki17IZkwp0oF8Crqv8obYfvdA2/e26lepp2Dq
jl2ydJYHcsoK//GYYQoaz/7JGLD2QJ4uMwhdm4JgVk+iSwfuKJz95SI+mgJC
5o/SW3TuqPxlKL+f6RT8vlWJh2fvitCE8JPDF1Ow/V/Uvr60K2qQnPJ6YTsF
5MxWlY8uuaJ2ao4xZZcp+Jjyff/Q1AVNVpe6XAqbAmriH69y/zojPMKJzi91
U+DTJsD9WcwJeb5y2SZtnoJhfP0Ksh+O6MIUK5NbxxSEWnT/DIhyROR5Fq8M
hqeA3+QgJWzPAbFpHNFeW5uCMNL+7ldN9kgmkdkkn3oaDub9KHI/2iGBSBKO
ZvppYM+dpI6St0NMAfsL48zT4GvmQyhGbIf+OQzpn+GehubKOeu04Nco++FH
XU1sGvhJcu40JdsiilO/1A+fTwMuntdveMUG4e1MUZK/mAbazxPNXMU2aG2t
fYDj1TSYZVq2kLrZoObR5IfKztNAz8TR60ZngxzytJSSgqdhOYJqr1r1JZp5
WicpVzENFRQyuKwKK9Spnn1at3YaOo8J/fCfWaEyhc8NNo3T4DlSI3CVwAp9
ErLFYrqnIVRu231K6wWSIr0muoGbhgbhZPKj05YosybwVhjRDFyRODgicTND
kUVvt9LJZsDre02EmoAZ8swwza+5NANBDi95Tb+bIt1wCd7vjDMgr5v6+FjF
FF18scN1V2AG2vkffJ25+Ry9YXjKMvdkBtrOxxJZUxkjfWU+jclnM7A11S21
MGKE7nuc8hkxnoFrO1dtGD8bIY6VpF9d1jOwsPUgYZXJCA0Wfa+r8JyBLNI3
2oNChohP0eZpaNaJvmnmm3999BG9i0RIYP4MTC62+I9q6aPzBZQtPiUzUMsX
Nul+VR9NU5fyuNXNAH1qhjh9yzPkN79/aDk4A53yHgWixM/Qd0evGJmDGSDY
ufWBT/MpWtW4/jwBbxb8UkMtD/CfIr1NCnzG07NAtPjFKj1XFymwLt6mI5gF
StK8tlQiXcTy8X0sGfks5FI1DfF0P0G9ap0Wh+yz8OlPuZKt8yMk/bPonNO1
WfgaUnj4UOgRqnofG7/LNQvF9RrtZFva6GvFi8HfvLMw2h5VftNMG71juii6
KjILOUHkm3hGWoh7TZ1oRGkWzvzorhr01EBlaoq1PsqzoIV5VhHLaiCJ6nuv
kOos1AfFZyoRa6BHAbwTKVqz4MRCorUaoY4+8l3ItDWYhX9C+DQilWpoybZK
ntxhFgiP/4nnMqgim6mCoyanWQieF1e9vqaCDqXSCxzezUKKh48oa6UKoqQO
p5vzmAWebaYI70cqSKLcajU3YBa2k/UtLsc9RPGHLD5KybNQxSkS4QzKiNuY
Fp36Ogv7TdHXSi8po9Ju0q2i9Fn4cBePbWz0AeqOO9Cmz50F2+PosTDBB+hQ
fJjzR/ks1NAdemYeKqFH3h/bPvTMQnWc0aRMhQJa+uniLNo/Cxky+se37RTQ
S027m5uDs5BmrN9/+ZYC+nDNIEpzfBZeXLD80J0rj0raRU05FmeBKV1O6k2R
HKIg3SRo/DcLTbcNE9cGZVB/tc97ucNZYE5jeR34RQZ9smA/13M8CzsvFp28
n8sg8vZHp8fPzIHyvzfsLw+lEblX0+EGyRxUne/7LnxdGpHtf966zDoH0Ycq
fJ/CJRHxstTkK4U56FYLbzDPEkedYbOP9pTm4Fhr5lKYqzjyk3Qae6c8B7X5
3LHk6uKIKDFv+KP6HKQ2RimsH2GIUOdyX9zTOVhb4xFlVccQwcBmU8erOUim
OW4qpkLoTG10LmvMHPz3n23AlpgIGheVlJ35MgfvVzx7steFUW7F2uznhDmo
pr/YPR8rjB6ViJGTfz3h844+XXcshPKzZ2zxCuYgzcxeWaRNEOnGsN6ZapkD
lYqdDslXAkiArrM/sn0OhtfONzdyCaALkbbmal1zcCDjut+Ku4WKQppiOvrn
oOlNOo2u2i1E5GtyXD41B5+rpy5XivGjMofMxvDfc9CJ65LCOPlQwI6qjsr2
HETdrV8738+LDF4f/P1vbw5G8UsbI1R4EclLpateR3Og6kkx1qvBg4yeb3x8
dQEHw6pBIWnm3Ihc89YDZUYc/GCPevCz+RoyF6gcu6CAA60ty+s5Iiyornco
q0wJB/opgoHVY8zokuWmi4kyDkKrfAxCHJlRbQo7R5M6DlhWgS60hglRUAfZ
uOrhwJIwtOtH3BVUuWdItPMaB67pdibCN2kRWbjLdIo9DpZ2nU39fWiQEf/n
fDUnHHilbvE6L1IjUvMezQJXHBzV77nzxVMhg0mRZEvfE35XjcCja5SIqJZE
bCEeB3hRxHp/L5IivcecZCFJJ3paxyRad/9DxTsS8+KpOPCZ5XmzhiNGT/kc
PsZl4sCTkr6Gt54QFSbMDz0qwUFAVP7z/pRziAAdpV0ox8EsjaWh3tezSGec
5m1Z5YkeqvMhSlln0HmK+yxU9ThIH3FzVKzDR489y170deCg7MCdno7lSCyP
aUDctRsHa3vg4PP4QOxs9Tolbx8OIhlN8Iei/4nl/mWp9BvGgY2jvPO5mzti
p038z8vOneh7/01RNGdTLFNOP75mGweKN2tv/5kYEBPgZkawh4M6ScrH3kVd
YjUksxO1+yf6uoZW1XHfxHoHdKjr8eYBLy5Z0V3UUezLfPa3/f/F/7/+Dw8d
f9Y=
       "]]},
     Annotation[#, "Charting`Private`Tag$3244#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.1}, {0, 320}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.811085088857396*^9, 3.8110851136422777`*^9}, {
   3.811085174742004*^9, 3.811085186176491*^9}, 3.811085327209573*^9, {
   3.8110854192197943`*^9, 3.8110854468359547`*^9}, {3.8110854815022173`*^9, 
   3.811085512959269*^9}, 3.811085590954831*^9, 3.8110858609817467`*^9, {
   3.811086011904632*^9, 3.811086016561001*^9}, 3.811086083822824*^9, 
   3.8110861706486797`*^9, 3.811086299293765*^9, 3.815760577455697*^9, 
   3.8157606091054153`*^9},ExpressionUUID->"b926a1b3-0c10-410e-a6d6-\
538f3fe8121e"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0, 1], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJxF1Wk41XkUB/CrVLYW0sIoyVImqVEYRceaJTVZylLZsiQpS2UNV0RJiFCu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       "]]},
     Annotation[#, "Charting`Private`Tag$3286#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.1}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.811085088857396*^9, 3.8110851136422777`*^9}, {
   3.811085174742004*^9, 3.811085186176491*^9}, 3.811085327209573*^9, {
   3.8110854192197943`*^9, 3.8110854468359547`*^9}, {3.8110854815022173`*^9, 
   3.811085512959269*^9}, 3.811085590954831*^9, 3.8110858609817467`*^9, {
   3.811086011904632*^9, 3.811086016561001*^9}, 3.811086083822824*^9, 
   3.8110861706486797`*^9, 3.811086299293765*^9, 3.815760577455697*^9, 
   3.8157606091383667`*^9},ExpressionUUID->"16b957b2-187d-48b5-998c-\
6fccca57502c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Labeled", "[", 
  RowBox[{
   RowBox[{"Show", "[", 
    RowBox[{
    "plotofn1Fast300", ",", "plotofn1Fast100", ",", "plotofn1Fast300NOPUMPS", 
     ",", "plotofn1Fast100NOPUMPS"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<# of RyR with one Ca ion\>\"", ",", "\"\<Time (s)\>\""}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"Left", ",", "Bottom", ",", "Top", ",", "Right"}], "}"}], ",", 
   RowBox[{"RotateLabel", "\[Rule]", "True"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Labeled", "[", 
  RowBox[{
   RowBox[{"Show", "[", 
    RowBox[{
    "plotofncaFast300", ",", "plotofncaFast100", ",", 
     "plotofncaFast300NOPUMPS", ",", "plotofncaFast100NOPUMPS"}], "]"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"\"\<Total Ca in head\>\"", ",", "\"\<Time (s)\>\""}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"Left", ",", "Bottom", ",", "Top", ",", "Right"}], "}"}], ",", 
   RowBox[{"RotateLabel", "\[Rule]", "True"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Labeled", "[", 
  RowBox[{
   RowBox[{"Show", "[", 
    RowBox[{
    "plotofp2Fast300", ",", "plotofp2Fast100", ",", "plotofp2Fast300NOPUMPS", 
     ",", "plotofp2Fast100NOPUMPS"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<Pr(RyR opening)\>\"", ",", "\"\<Time (s)\>\""}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"Left", ",", "Bottom", ",", "Top", ",", "Right"}], "}"}], ",", 
   RowBox[{"RotateLabel", "\[Rule]", "True"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.811082901615262*^9, 3.811082996751974*^9}, {
  3.811084923027033*^9, 3.8110849345146017`*^9}, {3.8110851287571697`*^9, 
  3.811085149782049*^9}, {3.811085366679852*^9, 3.811085401606884*^9}, {
  3.811085869772162*^9, 
  3.811085955836328*^9}},ExpressionUUID->"8b1e8813-68f3-4c36-bff2-\
7e337d8a46bc"],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{{{{}, {}, 
        TagBox[{
          Directive[
           Opacity[1.], 
           AbsoluteThickness[1.6], 
           RGBColor[1, 0, 0]], 
          LineBox[CompressedData["
1:eJwtV3c4l+/3F5WkD0JllpVUQkWo7ueYIXuFCCFE2YSUrbLLiCJCJSV77y17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           "]], 
          LineBox[CompressedData["
1:eJwtUmk4VQsXFhnKEJLmRINUlIqollVIxxzl1jUT8VUopStJCEnD6UaHJA2i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           "]]}, 
         Annotation[#, 
          "Charting`Private`Tag$2816#1"]& ]}}, {}, {}}, {{{{}, {}, 
        TagBox[{
          Directive[
           Opacity[1.], 
           AbsoluteThickness[1.6], 
           GrayLevel[0]], 
          LineBox[CompressedData["
1:eJwtV3c4F973Fw3JByF7hUoSkhHlHmSVkS2RPULZZGaEykz2yMrem+y919t+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           "]], 
          LineBox[CompressedData["
1:eJw9mHk0VW/Ux5GmezPcy71J/chUCCUk6ewdqWSIQkQhqSRTZSxFhuYkJJqk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           "]]}, 
         Annotation[#, 
          "Charting`Private`Tag$2623#1"]& ]}}, {}, {}}, {{{{}, {}, 
        TagBox[{
          Directive[
           Opacity[1.], 
           AbsoluteThickness[1.6], 
           RGBColor[1, 0, 1]], 
          LineBox[CompressedData["
1:eJwtVnc0F/73RkvxQVJGu5BKqIwSr8dKRgqRLasUysyWlETJToTsihays3f2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           "]]}, 
         Annotation[#, 
          "Charting`Private`Tag$3202#1"]& ]}}, {}, {}}, {{{{}, {}, 
        TagBox[{
          Directive[
           Opacity[1.], 
           AbsoluteThickness[1.6], 
           RGBColor[0, 1, 0]], 
          LineBox[CompressedData["
1:eJwtV3k0Fd73pZEIiUJERJqkksqHu0WZReZUSopCphRSoWSeylAKmYvMmcdX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           "]], 
          LineBox[CompressedData["
1:eJwtknk01XsXxl3cZiq5jVQkzSmX0ntt+30lmXKjksqUIUpSHTLrUG6mDCc5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           "]]}, 
         Annotation[#, "Charting`Private`Tag$3009#1"]& ]}}, {}, {}}}, {
    DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
     AxesOrigin -> {0, 0}, FrameTicks -> {{Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}}, 
     GridLines -> {None, None}, DisplayFunction -> Identity, 
     PlotRangePadding -> {{0, 0}, {0, 0}}, PlotRangeClipping -> True, 
     ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
     NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
     AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
     Identity, Frame -> {{False, False}, {False, False}}, 
     FrameLabel -> {{None, None}, {None, None}}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> 15, GridLines -> {None, None}, GridLinesStyle -> 
     Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
       AbsolutePointSize[6], "ScalingFunctions" -> None, 
       "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& ), "CopiedValueFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )}}, PlotRange -> {{0, 0.1}, {0, 1}}, 
     PlotRangeClipping -> True, 
     PlotRangePadding -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     Ticks -> {Automatic, Automatic}}],"\"# of RyR with one Ca ion\"",
   "\"Time (s)\""},
  "Labeled",
  DisplayFunction->(GridBox[{{
      ItemBox[
       RotationBox[#2, BoxRotation -> 1.5707963267948966`], DefaultBaseStyle -> 
       "LabeledLabel"], 
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"]}, {"", 
      ItemBox[#3, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, 
    GridBoxItemSize -> {"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
    BaselinePosition -> {1, 2}]& ),
  InterpretationFunction->(RowBox[{"Labeled", "[", 
     RowBox[{#, ",", 
       RowBox[{"{", 
         RowBox[{#2, ",", #3}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{"Left", ",", "Bottom", ",", "Top", ",", "Right"}], "}"}], 
       ",", 
       RowBox[{"RotateLabel", "\[Rule]", "True"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{
  3.811082905743698*^9, {3.8110829571139708`*^9, 3.8110829994995537`*^9}, 
   3.811084934919834*^9, {3.811085123251635*^9, 3.811085188767976*^9}, 
   3.811085337462805*^9, {3.811085383919279*^9, 3.811085451889051*^9}, 
   3.811085483266816*^9, 3.811085515462263*^9, 3.811085921621683*^9, 
   3.811085956916847*^9, 3.811086016738867*^9, 3.8110860840008183`*^9, 
   3.811086174894401*^9, 3.8157605775974216`*^9, 
   3.815760609180409*^9},ExpressionUUID->"98309ce8-5f41-42fb-a46a-\
1b4589838272"],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{{{{}, {}, 
        TagBox[{
          Directive[
           Opacity[1.], 
           AbsoluteThickness[1.6], 
           RGBColor[1, 0, 0]], 
          LineBox[CompressedData["
1:eJwtV3c819/3R8vKyicjVEKRJJGU+zpIkh0KDVlRmVnRsmdIyMree+9NVvbe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           "]], 
          LineBox[CompressedData["
1:eJwtkXs01HkYxkW5xYh0dSlkM+oUtqT0ehVqXKKs4iAGM81gzEzaChG1dLAV
SZncVpfpMqkmHLdsZLtuptwjmSTp+v39KorUsvacfc55znue8/zzfs5jFi7y
5aqqqKgETfq/+9VBPy5jHkGV/8Vun7XhhxnBvqNbY5tdlsG+Rotsd3uCDuWb
R6qzWeCUwl3d5kBwqXq4sj/XA1SdLvQHOxIsjWq1Gc3xgvQa65ViZ4K1UsfG
A06b4aTc9ulJD4Jb++V09VQ/kBfjooEQghe1TXOtpwXBUMKQRlgYQdenqUyX
9iCw97/wvjeCoMdAH1NWEgw39PTKn/AJyqMKGnbahsDdFOW6h7GTvUJdIT3F
Bs3tOZas3QTP/J1Oir6ywXP1Bq07ewnetboo8fQNg+ZPV5pvJhLM5m+ueTQt
HHrCk0LLDhH854yz9/ntEWCKti7LMwiWb7lAEuURwDZ69VPp7wRDFj0SzFHl
wGCbFyXNJjicR1b8cZoDH12Nk07lE3wRHjN7aSsX1BffyE+5SjDwLQibxnjg
riba/4+coPEmuXr1Gj4cfm4enlBOsCvIipkazwd9SSbz12qC3T219neG+GCs
FVjNaySYYxBRbNwTCaGvdAsHbhO0SvghdzKIgjO3biWH3SPI3HzzjA8rChYn
MDcGNRHUveTl7XY9Cuzej3Z4dxJsrz1CX98TDbvvldY87CJ4fx3HMkkaDdVn
2UWsHoKSsbQst7ZogOD7nPV9BMURa5d0LBEAS5E3tPIdQcFNocysRQCZlzyf
lH2Y3DtFUqo5KgBF2kTtcpoge5WNw3eTGPB14h1kDhN0fr1mtjYvBrZfs9c3
GSd48lvlnClUDFQGjjKaVSi0+XN4+twZQmCo1+r8pkZh/3CCx0JbITQEg+Zb
zclc5q3QFQthZ3mDmg+Dwro5DKpHJgRzbdeJipkUVmqcGCt8IYQ29r2x+fMo
ZPDqnSMMRZBa5fE1xZTC8XmRjHUuIljJePRp0ILCv6YKr7OEIhjkbCFeTArz
psv2Hj4hApZBwMDcFRSGjttL9btFIKsP6RlwonB+5shBWw0x6MRwW+XuFCZU
BaRqGYlBOF/wINGPQpQsYwRaicFud3yVYRSFZVVfJRk2Yhh5fEhamkzhO1GT
UstcDIFJRwrjMik857PLd8JADHXWucddT1BYkx1g7z4uAtOu/MwZJRSqdyr6
0hQiSEk7feCZjEKdY5YzN+aKIJ8fYzB4jcLROr0vbXtEUO65+ixdQWFXr85g
pf8kj37LbdV6Cgu7XWNrJ/k9i1U0mW0U6lYrigOShMA50CSx66JwWeZOjr2f
EPZzJMy1vZP/atj9/IIpBLm1jafPawr9+nQju1tiYHZV6NHd3ykMU//l9PCs
GLDJX7IgWYXGErvx+T0DAnBPGrmWPo3GtobHedPKBZDoktVSoEfjKuW7OeGb
BND/+KZhowWNzUYWRd37ouHKG5MChheNbpLLhnebIiG9KI2t9KZR1tsddfVq
JHB8ieXVLTQGTOlwO5cdCcZ1dfJN/jTK89b2N/pFQmZW0N3D4TQGfzAyMVTy
gW9/6pN2PI2jubG97iM8cH2vUvV0H427nlxrce7hwYISfqJsP42s+wMyYT0P
OrUcNDxSaezgO3Pi03ng1ttpnJFF4/FjWkHHTXhgnmrI0jhPY+aLNQXG23ZA
N3nZev4yjclKH+2KxTsg2798+4brNBalf3vVOcaFCWvfXWl1kzyp7LP657lQ
mWs2vqiRxlYp65Xvfi4Ixz+m375HY5yhkV9sABeetWQVq7XRyIxvjys24EKu
YyjzbBeNFjh4tP0zBzylyyrWK2lc/XlVjmMHB1T1xp36X9IYMaa0e1PDgdo4
xYMDb2ksqP+4kC7hgJWX4HnDMI1oJpOG7OFA3oLpXyYmaJzur3d6+TYO/AuP
ncQI
           "]]}, 
         Annotation[#, 
          "Charting`Private`Tag$2858#1"]& ]}}, {}, {}}, {{{{}, {}, 
        TagBox[{
          Directive[
           Opacity[1.], 
           AbsoluteThickness[1.6], 
           GrayLevel[0]], 
          LineBox[CompressedData["
1:eJwtl2c4Fu77xkXK+hohe0dIUhTJc1+yklF2CGWHSMiWLVsi2SvJzN7Ze6/H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           "]], 
          LineBox[CompressedData["
1:eJw9WHk0VW/UNiVJpUiRJuGHpBQhbbsMmSMklUypCFEpKkXGNCCkuYgyzzNx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           "]]}, 
         Annotation[#, 
          "Charting`Private`Tag$2665#1"]& ]}}, {}, {}}, {{{{}, {}, 
        TagBox[{
          Directive[
           Opacity[1.], 
           AbsoluteThickness[1.6], 
           RGBColor[1, 0, 1]], 
          LineBox[CompressedData["
1:eJwtV3c819/3l5bwQciKbEVCklHc85K9SraKZGZFkoxkq2zZIVv23pvsvfd8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           "]]}, 
         Annotation[#, 
          "Charting`Private`Tag$3244#1"]& ]}}, {}, {}}, {{{{}, {}, 
        TagBox[{
          Directive[
           Opacity[1.], 
           AbsoluteThickness[1.6], 
           RGBColor[0, 1, 0]], 
          LineBox[CompressedData["
1:eJwtVnc819/3l5YVslchI5WQSPpwz8smZIeUslIiI5SRkZ0ZMkK27L032Xvv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           "]], 
          LineBox[CompressedData["
1:eJwtknk0lXsXx4WUMhRHpZJIhurKUOjWthu9J9xKt4QUzsU5RKZKhjjkVI7h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           "]]}, 
         Annotation[#, "Charting`Private`Tag$3051#1"]& ]}}, {}, {}}}, {
    DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
     AxesOrigin -> {0, 0}, FrameTicks -> {{Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}}, 
     GridLines -> {None, None}, DisplayFunction -> Identity, 
     PlotRangePadding -> {{0, 0}, {0, 0}}, PlotRangeClipping -> True, 
     ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
     NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
     AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
     Identity, Frame -> {{False, False}, {False, False}}, 
     FrameLabel -> {{None, None}, {None, None}}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> 15, GridLines -> {None, None}, GridLinesStyle -> 
     Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
       AbsolutePointSize[6], "ScalingFunctions" -> None, 
       "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& ), "CopiedValueFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )}}, PlotRange -> {{0, 0.1}, {0, 320}}, 
     PlotRangeClipping -> True, 
     PlotRangePadding -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     Ticks -> {Automatic, Automatic}}],"\"Total Ca in head\"","\"Time (s)\""},
  
  "Labeled",
  DisplayFunction->(GridBox[{{
      ItemBox[
       RotationBox[#2, BoxRotation -> 1.5707963267948966`], DefaultBaseStyle -> 
       "LabeledLabel"], 
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"]}, {"", 
      ItemBox[#3, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, 
    GridBoxItemSize -> {"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
    BaselinePosition -> {1, 2}]& ),
  InterpretationFunction->(RowBox[{"Labeled", "[", 
     RowBox[{#, ",", 
       RowBox[{"{", 
         RowBox[{#2, ",", #3}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{"Left", ",", "Bottom", ",", "Top", ",", "Right"}], "}"}], 
       ",", 
       RowBox[{"RotateLabel", "\[Rule]", "True"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{
  3.811082905743698*^9, {3.8110829571139708`*^9, 3.8110829994995537`*^9}, 
   3.811084934919834*^9, {3.811085123251635*^9, 3.811085188767976*^9}, 
   3.811085337462805*^9, {3.811085383919279*^9, 3.811085451889051*^9}, 
   3.811085483266816*^9, 3.811085515462263*^9, 3.811085921621683*^9, 
   3.811085956916847*^9, 3.811086016738867*^9, 3.8110860840008183`*^9, 
   3.811086174894401*^9, 3.8157605775974216`*^9, 
   3.815760609186018*^9},ExpressionUUID->"ca3f39b9-e668-4c9a-92a5-\
4ae44f9e4ed2"],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{{{{}, {}, 
        TagBox[{
          Directive[
           Opacity[1.], 
           AbsoluteThickness[1.6], 
           RGBColor[1, 0, 0]], 
          LineBox[CompressedData["
1:eJxF1Hk0FNwbB3AiS3qVoiJishQhLWihJ0spoV9RSLZCtpC8EkVjTVlaJktG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           "]]}, 
         Annotation[#, 
          "Charting`Private`Tag$2900#1"]& ]}}, {}, {}}, {{{{}, {}, 
        TagBox[{
          Directive[
           Opacity[1.], 
           AbsoluteThickness[1.6], 
           GrayLevel[0]], 
          LineBox[CompressedData["
1:eJxF1nk8lNsbAHC0IF1bCJElS9ZwS7cu9ylS1rpliZQUJWTLUlTKFmUtQprs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           "]]}, 
         Annotation[#, 
          "Charting`Private`Tag$2707#1"]& ]}}, {}, {}}, {{{{}, {}, 
        TagBox[{
          Directive[
           Opacity[1.], 
           AbsoluteThickness[1.6], 
           RGBColor[1, 0, 1]], 
          LineBox[CompressedData["
1:eJxF1Wk41XkUB/CrVLYW0sIoyVImqVEYRceaJTVZylLZsiQpS2UNV0RJiFCu
fcm+XtcudFOTLVGEbKEry/8qMgrN71c9vDrP5zkvvuc558URsriia7WCRCLt
YCGRcNWyYrTWjJ46YtlRz/d6m/ARVhV+hz6+g8CclgvSyiyDA/HRlCI+VZDZ
wnzxVaIVhgREyC5iJ2DRVkkscaoLjjV1FMby6cPnTcN0quUAiNzdlvpD0Ah2
2Xreuug4BPNa56PMxUxgmnqfj7NpBD75tdPNI81hc4AI60wCAwwsZ6vu81lC
RbRvNmXtJ6Cr8Jc8pViDmqblgdA9Y7BfWCF/WtAW6rhldsmvHQfKCrMM0WQ7
WDBdF+NSMw5sg75Jp8Uuw93BqEdF/0xAef/rpqf6DjD8kUWmp24CHE5aap2N
dIQLVueNFwQnQaxmpn66wwnudszYV9hNwvt9ASrBfFdBfJfa8eyMSYiI31oj
euYaRCiHCj3smQSt9Zny1ZTrUHyPuyZ3NQEk78Nlp3tdwOWBWG2SOAG0yUZp
QtANhoLMLjcfJeCSiUlhgLk7qHbNsauaErCzmZDckewBi09ztXqdCehUIGeV
DnmCS5OxtbY/AfdyeHbriHkB15tVoX9EEKC2LSVl1MYb7EcfL1QlEOBV/2hD
rb4PXJdS9wnNIsDI68OJ4BkfYDy2a++lEnBQRiLYKJIMeXU56z5WErB+8mqD
qKwvfHWTUu95SsCn1Cr2zx2+kF0yVMb4l4Bn51ZrVLvehKs7PM/vayEgYdM/
t+7w+UGL8Kh9UxsBHk1R9NPlfsCwvSPT3UHAaf/+FcJn/EFrNmCPfTcBfymI
KxHf/WHDo/AbEb0EcM04eldQboHD1op80wECPmaXVwUoBEDHi8druz8QUGe5
cl6vNwA0HeK4uEcIiBXQPrTDOxD8n8sHczAIcG2PcB0XvA1v17492DJKgN7d
97TSmtvQwiJxx2qMAElVsRk/8zvQk64t2jZOAPv85QM6K4LAodtuUGCSgKGi
EsdtyUFQTy+fOkoQ8MSOlD+qchcu3Fs7pc8k4JGw5mTx0F0QrnzCrjVFwPXu
MAlf/2CgfCPmdn8mQCe86+IJsXvwvLlKYhpZ4phwBv/ze5Aj0VKa84UAtpWX
Po7YhEBVRqKrwTQBTue67huxhoJ2nQHHF2TTssWCJ/qhwJ7G7CHPEKC9SbhV
NDUUvleWHFj1lYBDjurMoJlQOMnFstcLeZN4qKRhZBicpYR+0J8lYIU/9Xj1
SBhU79XVpiIz+zsvicjeB9+HK6hc/xHQK78QdCfgPuwVmCk1QW6IFspidtyH
JFHpqUzk0mm1l6d3hwNp4GnHFHLayYujla7hEFxoOnBgjgAyW9Gu23wRUBX4
YyYT+U/1sMBChwiY69TYMIz82v/KaPfzCKAZtO344xu6P/241irBBzDwZtjn
OLLISoksyesPgGwc6OWJ3KjEwWXY9ABabLzN0pGv+TAukUUioSaj3aYVuX4h
RbL9dSTY6OTU//GdgCvyN0MWxKPg7/IHvgrIWz3MmWLkKJC45rf3HHJNGeic
7IwCKdPmSXdk2/+2Fbrti4YmU3dGJDKP7DxP8q1oKL5qLl+AXH6ty7nxPeoD
k/0lMteXSGnBuw/BI3ON6yxy8V/XIjU+PASF5hlNrnkCTBz0Zh0PPQLZzzYz
gsh5E+vL6IxHMKSzT1gV2VBikm8SYsCDDP/qI5PsGt23RMWAplNQsCWyLiNQ
/qIaBXwm36STkb+L2cSGUyjgoWDPF4KcYqW2WPmFAhuLqV0xyDODLDXrk2Lh
XUqMWxFynFD/Drm5WIi9lG9bjXzUrJpscTIOagZ5Xr1Ajn7vrlK8GAdj1U6C
PchKAkYpvafiId1g0+Zh5E/GsqvYcuJh03vn+Ank7eNu53P2JoD30CB5AdmJ
c3SjslECREWfHWZdQPv/05D+1i8BmswOTHEiX7GVESX1JMAMR+1GPmR6YOqb
iDWJ4PouVkoQeWs67y3xA4ng7BnOIYpcM/J5RPdOIgxfcPmyD5l3tUXUx+JE
iNRt55BGthVtVfccSISaxnMMOWQey7z01L+TIGo/laSCbH1zu9EhyySwcU5Q
VEeuSApmbwlJggfyPDrHkC0H7C7+N5IEcoa847rIpaRu/mCeZPhxgu5+Gplr
h1aD0JFkMM5UGjRCLjbZLXHsQTJ8JvkrmyFzeEX19NUkw+MvKUfOI5vErg6+
Op4Mu2OV+K2RV/cMTcSqpICthv81O2RDo8Q85lQKsOrIDlxFJrr1OZL4UyFo
Nan7OvItEzYrPZVUcN21stYVuej8FX5aRCqc1afreyJrjey8ZlOVCvHsrKxe
yP0X3rZsHUmFnRW+Sd7I6y4r+HvIpsHYzq48X+RUJrNPwiwNtoiMC/ohyzun
HOoNTAPPiiqyP/JFV06mYlcaOOYxBQKRn/m+M1594zFUtZQ/uYt8dlVwcUnq
YzAccmkMRv4coLjBtvkxCAv0N99D3hH8+FmDYDoYFOnTQpFL1p/ZcUMjHbha
xSlhyCfur/OQdEyH53JSbveRPaOu7Q+rS4fKMGn+COSN/OJBymPpsGequxc7
k9Iz/GVjBhxyXkl5gNyRqBJz2ioDSKqfSVHIUtncqwXYMiHeq9fzIfK/ks/M
mvZnQl0n29pHyGYFrhVeRplgWl8RhR1M63MYyMyET0rhsTHIInLhDffbMiG2
io+PglxecVRMdT4TNPs/h2AzanK6045nwbZyY4dYZG8VcxnD61kgJH2kC3tz
PW8Ye3wWDLYJKcYhqzR4HL3EzILIrXdI8chxbzQL/grPhhBGo0ECsrThAueH
imzg4C5NxW7syreOGMqGVd0lTOy5vi0Cs9I5kK1g6ZWIHGrRcD3dJAdeqWrU
YosNe7UaBeRA0dpcliRk/U/Dtyo7c6A15YwH9tilhwP2LLmg4NFKxfYltOUF
/8wFrsOi49j500VTZI9csBwp0U9G5vxBPqu+PQ/IubHrU5CjbQ1MJI7mgf+A
lhy2SLuEGfflPOj3um6OfSSj43x3VR4s6vrlYDdszLGqGc4DxWfkVmwJqC16
vTofNHgPTmOXZUQWl0jmg4wxQzoVmWRKlslUzoc7VStOYR/lvVRCOZ0Px7xZ
nLHbvJTKyF754DTZloU9oTdeeaw5H5xd+7jTkA+ydygcGcyHdiUJcWz36trq
/V/zYcfHNMBeIx5Vs2l7AXCOqF3EPtFLVmKTKoDD4m5e2BHhl+q+qRVAbsNs
GLbQohK9z74AdulP0bAvFEmovSYXwBcttxfYuRe21NMfFICqhvU77MNt488z
qgpApNBvDvtUelSD89pC4PKxPvAYmXLOV9taqBAuuaUrYg/y2DcZSheCNYvL
cewrN5RbFM4Vwo+xl1bYNKm9J/c7FsJ7L0NH7PmPW1p3+hdCWpyvJ/Zt3YnX
a3IKwcCtPAz71ZpOvW81hWAv2RKDvbmqrn28HeWr3UvFTt4V/bZ1vhBkpbaU
YlfNK3fFaBcBgyP5HTZr4d4z98yKQDLGaABby2Zrj8/VIqAOtzCwO1on3ltR
ikC8mnUWe3tAp4lhfhG8aH++gG0p/7RPi14EO330WNORp9KiB/aNF8FQQ8MG
7L/P3rTYSaKC1crKzdhe3Jc/8PJSoYzkKYDN6akyPHeYCh+MnXZhi+pMMp4G
UeFAlMVhbH5v9UM2iVRYkDVVxN6QkxDEUUKFZ5p/qWF/Y9OT1BmkgkHcmRPY
TJls7+lZKoTX0XSxhy1XtUatLYZq4YnT2K9qSpx7/y4GFrkpE+xnkxuekU8U
g6V5rQV2ucDFzaKWxTDS4miNneoqUGYXUgzmvK722O77yYv/DRdDveLf7thX
TLr+oXwvhq2hu29gW95Fz4mbBh0HWXyw/2EMq9ySp8Gawcv+2Kqb4YG4Lg1q
rVcFYh9SjR5ptKEB0zDgDrZIgtbtjeE0uOl4MgSbrzm5i5ZOA54f0WHY6+bn
9xhX06C5qCUce84grzlhlAZTn9ijsZvX8/JKKpZASmxtPHapXT3tql0JmKmo
J2MnP3c1qogsgXK36DRsV+/3cRoTJTDIzMzGtugOUQrZWgq26k552MdllYfe
qJRC9gXuQuydRJr4+UelMDDUT8PmOmbUmPGsFHQ6N5Vhz6ZxXmEyS0E8Y08F
dqOJA/WGehkY+7E8wU7a/GaOI64MKrc71GG7NMtB9HQZ7L9w8xl2q/audyZq
5eC7uPUF9p4GXmfRyHLo8L/yEttfc8Xa8ZFyeBcU3Ijd95xIK5StgMsDrs3Y
4fSXXfCuAkgWDa3Y6rWp65rcK4GRdrsdO6/8zPWPVVUQ3lLQib2Fyt3LwvIE
dLrCurHNTdLOpffWgE2neB82bVClsUW+Dv4setOPXZnGdI6IeAo5epQB7LqL
sX8YjdOh1vX7T/do2G9aubceNNh2DWLPiCmsz7F/DmHsCj89HzK93vLfF8DR
qPHTK+ayNvwh+hJsbU/8tIDnrfMltg2g+d/Jn5b5YUbTy22EPEXdn2ap01IO
Hm+CfR9+udHvYHP9ny3QJK3308qjvvmrlV/BUYtfFgwdm8uYfAXRLr+8im41
/iSkFc6Qf3lstq/3zf7XoHHrlzWmmvSd+l7DaOAvp3yqeLnuXhuI3/nldzf/
eu8m1w41v71u22NiaKgdOIJ++biKZFad3xvY89t3bYutE0TegsJvK53KT2V9
/RbUfvurYtbQBe8O0Prt0zcKDPVfLbu4rKQRhDrh2G9flaJTNz/tBO3f7sul
B7UKdcHx3/5+sT1G3L17yXuU1ixaV/QsWT1JyKZgS++SXbaZ7hw427dkifFT
nB3H+5e8cT2Tjf5t2axPYvKEKQNLtjtY8Y792OCSszQtEqq/LntmjH/DSOSH
JRfrqa+MUB1asreGfzx1ZNlC77U6k/2Hl3xI1i+CT2pkyWe3t8yxtC175mXw
oAP545KjWU2u6oowlufvLU5aQV/2qhtkfTnH0SWTMkzyBnk+LdnpUV4wT92y
q/YEsnFfHlsyt5aThO+68SX37H3V5la57Pw4EBkymVjyuTwZ7m2Ly/bxTyT3
ZE4uOYexLWadNrHknX68GmvSlh0lyDnz48ey/wcQbLrh
           "]]}, 
         Annotation[#, 
          "Charting`Private`Tag$3286#1"]& ]}}, {}, {}}, {{{{}, {}, 
        TagBox[{
          Directive[
           Opacity[1.], 
           AbsoluteThickness[1.6], 
           RGBColor[0, 1, 0]], 
          LineBox[CompressedData["
1:eJxF13c41t8bB3CjQfyIECIjKYWkIqK3mYx8S1kpGighRKQhW4Uos1BGZGRm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           "]]}, 
         Annotation[#, "Charting`Private`Tag$3093#1"]& ]}}, {}, {}}}, {
    DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
     AxesOrigin -> {0, 0}, FrameTicks -> {{Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}}, 
     GridLines -> {None, None}, DisplayFunction -> Identity, 
     PlotRangePadding -> {{0, 0}, {0, 0}}, PlotRangeClipping -> True, 
     ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
     NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
     AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
     Identity, Frame -> {{False, False}, {False, False}}, 
     FrameLabel -> {{None, None}, {None, None}}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> 15, GridLines -> {None, None}, GridLinesStyle -> 
     Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
       AbsolutePointSize[6], "ScalingFunctions" -> None, 
       "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& ), "CopiedValueFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )}}, PlotRange -> {{0, 0.1}, {0, 1}}, 
     PlotRangeClipping -> True, 
     PlotRangePadding -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     Ticks -> {Automatic, Automatic}}],"\"Pr(RyR opening)\"","\"Time (s)\""},
  "Labeled",
  DisplayFunction->(GridBox[{{
      ItemBox[
       RotationBox[#2, BoxRotation -> 1.5707963267948966`], DefaultBaseStyle -> 
       "LabeledLabel"], 
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"]}, {"", 
      ItemBox[#3, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, 
    GridBoxItemSize -> {"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
    BaselinePosition -> {1, 2}]& ),
  InterpretationFunction->(RowBox[{"Labeled", "[", 
     RowBox[{#, ",", 
       RowBox[{"{", 
         RowBox[{#2, ",", #3}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{"Left", ",", "Bottom", ",", "Top", ",", "Right"}], "}"}], 
       ",", 
       RowBox[{"RotateLabel", "\[Rule]", "True"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{
  3.811082905743698*^9, {3.8110829571139708`*^9, 3.8110829994995537`*^9}, 
   3.811084934919834*^9, {3.811085123251635*^9, 3.811085188767976*^9}, 
   3.811085337462805*^9, {3.811085383919279*^9, 3.811085451889051*^9}, 
   3.811085483266816*^9, 3.811085515462263*^9, 3.811085921621683*^9, 
   3.811085956916847*^9, 3.811086016738867*^9, 3.8110860840008183`*^9, 
   3.811086174894401*^9, 3.8157605775974216`*^9, 
   3.815760609190439*^9},ExpressionUUID->"fd059b46-0022-4141-9634-\
fada8f1d9311"]
}, Open  ]]
},
WindowSize->{952, 881},
WindowMargins->{{488, Automatic}, {Automatic, 120}},
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 1138, 20, 34, "Input", "ExpressionUUID" -> \
"e8f874b0-0e79-445a-b164-1615e372178d"],
Cell[1721, 44, 199, 4, 32, "Output", "ExpressionUUID" -> \
"e7f66c78-e181-4d59-86a0-e1d5e701ce34"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1957, 53, 6645, 165, 261, "Input", "ExpressionUUID" -> \
"d3f45db2-0caf-4157-b9a4-decaf29dec0e"],
Cell[8605, 220, 44182, 748, 238, "Output", "ExpressionUUID" -> \
"788dbd63-3e36-4aa2-bd6c-714e7d202136"],
Cell[52790, 970, 19643, 340, 238, "Output", "ExpressionUUID" -> \
"23a74e4e-4bf7-4384-b8d6-57b03fd124fe"],
Cell[72436, 1312, 20676, 357, 232, "Output", "ExpressionUUID" -> \
"a28d2fc3-2a6c-43b2-aba7-71d943342b2a"],
Cell[93115, 1671, 6801, 128, 238, "Output", "ExpressionUUID" -> \
"a0230344-7966-4f61-8eb7-9b0d9aa33f76"]
}, Open  ]],
Cell[CellGroupData[{
Cell[99953, 1804, 5528, 152, 218, "Input", "ExpressionUUID" -> \
"6ca3c337-ebaf-4325-b8cd-46f73707a9a5"],
Cell[105484, 1958, 223, 4, 32, "Output", "ExpressionUUID" -> \
"414a2874-6261-483b-98af-7c6e022e877c"],
Cell[105710, 1964, 50304, 850, 238, "Output", "ExpressionUUID" -> \
"9ddf1406-f5ac-41f9-be63-9d674b52a513"],
Cell[156017, 2816, 23847, 409, 238, "Output", "ExpressionUUID" -> \
"9fbdd179-033d-4608-87d6-3aaf5db6b676"],
Cell[179867, 3227, 23093, 397, 231, "Output", "ExpressionUUID" -> \
"afd0fe25-164f-465a-ad23-91abcd02909c"],
Cell[202963, 3626, 6388, 122, 238, "Output", "ExpressionUUID" -> \
"664d3f49-ee2f-4ccc-b7ed-64ed0c4ebb8e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[209388, 3753, 5575, 154, 376, "Input", "ExpressionUUID" -> \
"0d20c634-0f2a-461a-aeec-dd60d482190b"],
Cell[214966, 3909, 272, 5, 32, "Output", "ExpressionUUID" -> \
"cd9d6d1a-8d12-44f4-9ed4-87476ec2c18d"],
Cell[215241, 3916, 37233, 635, 238, "Output", "ExpressionUUID" -> \
"54f0dc08-8852-4450-a939-36e67aa56540"],
Cell[252477, 4553, 15907, 279, 238, "Output", "ExpressionUUID" -> \
"13e7abd3-1db1-49a4-9766-f536b05e6b30"],
Cell[268387, 4834, 17625, 307, 232, "Output", "ExpressionUUID" -> \
"a949a72d-59f0-4a57-be54-d4fccf315db8"],
Cell[286015, 5143, 8338, 154, 238, "Output", "ExpressionUUID" -> \
"2a356ff4-47c0-4040-9e50-59fe2eb17df8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[294390, 5302, 7116, 174, 376, "Input", "ExpressionUUID" -> \
"b66e440f-a374-42d5-aa94-9b2a9a747556"],
Cell[301509, 5478, 549, 8, 32, "Output", "ExpressionUUID" -> \
"86c97ed8-fc2e-49ad-803a-d88eb745721d"],
Cell[302061, 5488, 30574, 522, 238, "Output", "ExpressionUUID" -> \
"beaf9765-293c-4c4c-9471-f685912637a7"],
Cell[332638, 6012, 13922, 244, 238, "Output", "ExpressionUUID" -> \
"6d393d08-51eb-4afc-8b02-21d75787b8ec"],
Cell[346563, 6258, 15315, 267, 231, "Output", "ExpressionUUID" -> \
"b926a1b3-0c10-410e-a6d6-538f3fe8121e"],
Cell[361881, 6527, 6996, 130, 238, "Output", "ExpressionUUID" -> \
"16b957b2-187d-48b5-998c-6fccca57502c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[368914, 6662, 1773, 42, 149, "Input", "ExpressionUUID" -> \
"8b1e8813-68f3-4c36-bff2-7e337d8a46bc"],
Cell[370690, 6706, 71225, 1205, 258, "Output", "ExpressionUUID" -> \
"98309ce8-5f41-42fb-a46a-1b4589838272"],
Cell[441918, 7913, 74603, 1262, 251, "Output", "ExpressionUUID" -> \
"ca3f39b9-e668-4c9a-92a5-4ae44f9e4ed2"],
Cell[516524, 9177, 26376, 464, 291, "Output", "ExpressionUUID" -> \
"fd059b46-0022-4141-9634-fada8f1d9311"]
}, Open  ]]
}
]
*)

