(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     79347,       1531]
NotebookOptionsPosition[     77896,       1489]
NotebookOutlinePosition[     78232,       1504]
CellTagsIndexPosition[     78189,       1501]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"linethick", "=", "0.01"}]], "Input",
 CellChangeTimes->{{3.8112427912367*^9, 
  3.811242792548481*^9}},ExpressionUUID->"64e212aa-73d1-4319-baca-\
500445adf0f5"],

Cell[BoxData["0.01`"], "Output",
 CellChangeTimes->{3.811242793101595*^9, 3.81124423892771*^9, 
  3.811494963515093*^9},ExpressionUUID->"0993be1b-a96b-4dd5-b651-\
49659e217e1a"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Mu]", "=", "38"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Lambda]", "=", "6"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NR", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Nu]", "=", "800"}], ";"}]}], "Input",
 CellChangeTimes->{
  3.811073288162471*^9, {3.811077772558668*^9, 3.811077772942217*^9}, {
   3.811080129477234*^9, 3.811080130868372*^9}, {3.811080205461644*^9, 
   3.811080220342396*^9}, {3.811080382231839*^9, 3.811080382694668*^9}, 
   3.811080431543912*^9, {3.811089083129718*^9, 3.811089083513068*^9}, {
   3.811089145930533*^9, 3.811089159545858*^9}, {3.811089519372951*^9, 
   3.811089519820822*^9}, {3.811090325076928*^9, 
   3.811090325492319*^9}},ExpressionUUID->"d084989a-05c9-4f5c-8fd7-\
6fca90bdf8a4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fastMatrix", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"p2inf", "=", 
   RowBox[{"For", "[", 
    RowBox[{
     RowBox[{"A", "=", "1.0"}], ",", 
     RowBox[{"A", "\[LessEqual]", "3000"}], ",", 
     RowBox[{"A", "=", 
      RowBox[{"A", "+", "5"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"s", "=", 
       RowBox[{"NDSolve", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"n1", "'"}], "[", "t", "]"}], "\[Equal]", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "\[Mu]"}], "*", 
              RowBox[{"n1", "[", "t", "]"}]}], "+", " ", 
             RowBox[{"\[Lambda]", "*", 
              RowBox[{"nca", "[", "t", "]"}], " ", "*", 
              RowBox[{"(", 
               RowBox[{"NR", "-", 
                RowBox[{"2", "*", 
                 RowBox[{"n1", "[", "t", "]"}]}]}], " ", ")"}]}]}]}], " ", 
           ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"nca", "'"}], "[", "t", "]"}], "\[Equal]", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "\[Nu]"}], "*", 
              RowBox[{"nca", "[", "t", "]"}]}], " ", "-", 
             RowBox[{"\[Lambda]", "*", 
              RowBox[{"nca", "[", "t", "]"}], "*", 
              RowBox[{"(", 
               RowBox[{"NR", "-", 
                RowBox[{"n1", "[", "t", "]"}]}], ")"}]}], "+", 
             RowBox[{"\[Mu]", "*", 
              RowBox[{"n1", "[", "t", "]"}]}]}]}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"p2", "'"}], "[", "t", "]"}], "\[Equal]", " ", 
            RowBox[{"\[Lambda]", "*", 
             RowBox[{"n1", "[", "t", "]"}], "*", 
             RowBox[{"nca", "[", "t", "]"}], "*", 
             RowBox[{"(", 
              RowBox[{"1", "-", 
               RowBox[{"p2", "[", "t", "]"}]}], ")"}]}]}], ",", 
           "\[IndentingNewLine]", " ", 
           RowBox[{
            RowBox[{"n1", "[", "0", "]"}], "\[Equal]", "3"}], ",", 
           RowBox[{
            RowBox[{"nca", "[", "0", "]"}], "\[Equal]", "A"}], ",", 
           RowBox[{
            RowBox[{"p2", "[", "0", "]"}], "\[Equal]", "0"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"n1", ",", "nca", ",", "p2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", "0.0", ",", "100"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"solp2fast", "=", 
       RowBox[{"First", "[", 
        RowBox[{"Evaluate", "[", 
         RowBox[{
          RowBox[{"p2", "[", "5", "]"}], "/.", "s"}], "]"}], "]"}]}], ";", 
      RowBox[{"AppendTo", "[", 
       RowBox[{"fastMatrix", ",", 
        RowBox[{"{", 
         RowBox[{"A", ",", "solp2fast"}], "}"}]}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Transpose", "[", "fastMatrix", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.811072490043269*^9, 3.811072499738161*^9}, {
   3.8110725387951937`*^9, 3.81107256337181*^9}, {3.811073375987668*^9, 
   3.811073379939542*^9}, {3.811080488121367*^9, 3.8110804896245213`*^9}, {
   3.811080627962512*^9, 3.811080628137438*^9}, {3.811080820091875*^9, 
   3.811080820683137*^9}, {3.811089611790051*^9, 3.811089612396812*^9}, 
   3.811242509843935*^9, {3.811244234291821*^9, 
   3.811244235026908*^9}},ExpressionUUID->"fd7cb0ed-e0f9-4300-8314-\
f8a6fd0f2c55"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "=", "1.53"}], ";", 
    RowBox[{"b", "=", "1.43"}], ";", 
    RowBox[{
     RowBox[{"Jin", "[", "t_", "]"}], ":=", 
     RowBox[{
      RowBox[{"A", "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"1", "/", "2.3"}], "-", 
         RowBox[{"1", "/", "2.31"}]}], ")"}]}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"-", "2.3"}], "*", "t"}], "]"}], "-", 
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"-", "2.31"}], "*", "t"}], "]"}]}], ")"}]}]}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"slowMatrix", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"p2inf", "=", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"A", "=", "5.0"}], ",", 
       RowBox[{"A", "\[LessEqual]", "3000"}], ",", 
       RowBox[{"A", "=", 
        RowBox[{"A", "+", "1"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"s", "=", 
         RowBox[{"NDSolve", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"n1", "'"}], "[", "t", "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "\[Mu]"}], "*", 
                RowBox[{"n1", "[", "t", "]"}]}], "+", " ", 
               RowBox[{"\[Lambda]", "*", 
                RowBox[{"nca", "[", "t", "]"}], " ", "*", 
                RowBox[{"(", 
                 RowBox[{"NR", "-", 
                  RowBox[{"2", "*", 
                   RowBox[{"n1", "[", "t", "]"}]}]}], " ", ")"}]}]}]}], " ", 
             ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"nca", "'"}], "[", "t", "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{"Jin", "[", "t", "]"}], "-", 
               RowBox[{"\[Nu]", "*", 
                RowBox[{"nca", "[", "t", "]"}]}], " ", "-", 
               RowBox[{"\[Lambda]", "*", 
                RowBox[{"nca", "[", "t", "]"}], "*", 
                RowBox[{"(", 
                 RowBox[{"NR", "-", 
                  RowBox[{"n1", "[", "t", "]"}]}], ")"}]}], "+", 
               RowBox[{"\[Mu]", "*", 
                RowBox[{"n1", "[", "t", "]"}]}]}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"p2", "'"}], "[", "t", "]"}], "\[Equal]", " ", 
              RowBox[{"\[Lambda]", "*", 
               RowBox[{"n1", "[", "t", "]"}], "*", 
               RowBox[{"nca", "[", "t", "]"}], "*", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"p2", "[", "t", "]"}]}], ")"}]}]}], ",", 
             "\[IndentingNewLine]", " ", 
             RowBox[{
              RowBox[{"n1", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
             RowBox[{
              RowBox[{"nca", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
             RowBox[{
              RowBox[{"p2", "[", "0", "]"}], "\[Equal]", "0"}]}], "}"}], ",", 
           
           RowBox[{"{", 
            RowBox[{"n1", ",", "nca", ",", "p2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"t", ",", "0.0", ",", "5"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"wynik", "=", 
         RowBox[{"First", "[", 
          RowBox[{"Evaluate", "[", 
           RowBox[{
            RowBox[{"p2", "[", "5", "]"}], "/.", "s"}], "]"}], "]"}]}], ";", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"slowMatrix", ",", 
          RowBox[{"{", 
           RowBox[{"A", ",", "wynik"}], "}"}]}], "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Transpose", "[", "slowMatrix", "]"}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.811077690316111*^9, 3.811077720670526*^9}, {
  3.8110778455677023`*^9, 3.811077850207096*^9}, {3.811077882704029*^9, 
  3.811077883488249*^9}, {3.811078002768673*^9, 3.811078004928752*^9}, {
  3.811080496729504*^9, 3.811080497432322*^9}, {3.811080631497981*^9, 
  3.811080631737432*^9}, {3.811089616973691*^9, 3.811089617517106*^9}, {
  3.811244260517561*^9, 
  3.811244261619876*^9}},ExpressionUUID->"b85fdb7f-5a9e-4826-af6d-\
ebab50b50368"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"plot1", "=", 
   RowBox[{"ListPlot", "[", "fastMatrix", "]"}]}], ";", 
  RowBox[{"plot2", "=", 
   RowBox[{"ListPlot", "[", "myMatrix", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.811072564267614*^9, 3.811072585821684*^9}, {
  3.811072651628499*^9, 
  3.8110726782840137`*^9}},ExpressionUUID->"d31dcb5b-7e28-47d3-b063-\
a66ea7ff85b2"],

Cell[BoxData[
 TemplateBox[{
  "ListPlot","lpn",
   "\"\\!\\(\\*RowBox[{\\\"myMatrix\\\"}]\\) is not a list of numbers or \
pairs of numbers.\"",2,13,1,17437595144835024659,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.811494978626244*^9},ExpressionUUID->"7d3075a3-944e-4a47-8221-\
81220938ef48"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"figslowfast", "=", 
  RowBox[{"Labeled", "[", 
   RowBox[{
    RowBox[{"Show", "[", 
     RowBox[{
      RowBox[{"ListLinePlot", "[", 
       RowBox[{"fastMatrix", ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "3000"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1.01"}], "}"}]}], "}"}]}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Magenta", ",", 
           RowBox[{"Thickness", "[", "linethick", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotLegends", "\[Rule]", 
         RowBox[{"{", "\"\<Fast input\>\"", "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ListLinePlot", "[", 
       RowBox[{"slowMatrix", ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "2500"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1.1"}], "}"}]}], "}"}]}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Brown", ",", 
           RowBox[{"Thickness", "[", "linethick", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotLegends", "\[Rule]", 
         RowBox[{"{", "\"\<Slow input\>\"", "}"}]}]}], "]"}], ",", 
      RowBox[{"LabelStyle", "\[Rule]", 
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", "10"}], "]"}]}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"\"\<Pr(RyR opening)\>\"", ",", "\"\<Number of ions N\>\""}], 
     "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"Left", ",", "Bottom", ",", "Top", ",", "Right"}], "}"}], ",", 
    RowBox[{"RotateLabel", "\[Rule]", "True"}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"Black", ",", "10"}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{
  3.811072910590826*^9, {3.8110729894073963`*^9, 3.811073103824396*^9}, {
   3.811073139233431*^9, 3.81107315335424*^9}, {3.811073183713029*^9, 
   3.811073218433608*^9}, {3.811073357763467*^9, 3.81107336134746*^9}, {
   3.81107774931092*^9, 3.811077752637906*^9}, {3.811077831183481*^9, 
   3.811077863566701*^9}, {3.811080450536715*^9, 3.8110804543754597`*^9}, {
   3.811080641194734*^9, 3.811080646489613*^9}, {3.811080834139186*^9, 
   3.811080838140329*^9}, {3.8110891169388027`*^9, 3.81108912212187*^9}, {
   3.811089530908873*^9, 3.8110895772124863`*^9}, {3.81123938184673*^9, 
   3.811239460149514*^9}, {3.811242462388608*^9, 3.8112424960826*^9}, 
   3.8112425339080467`*^9, {3.811242588756384*^9, 3.8112425978291597`*^9}, {
   3.811242643749433*^9, 3.811242698996118*^9}, {3.81124273848623*^9, 
   3.811242740171623*^9}, {3.811242780006516*^9, 3.8112427831415777`*^9}, {
   3.8112442262611017`*^9, 3.811244228131585*^9}, 3.8112615236594276`*^9, {
   3.8114923666390867`*^9, 3.8114923919517393`*^9}, {3.811492530880879*^9, 
   3.811492531198983*^9}, 3.81149362695403*^9, {3.8114936849389763`*^9, 
   3.811493699608715*^9}, {3.8114937448592033`*^9, 
   3.8114937705700607`*^9}},ExpressionUUID->"16f2feb4-3629-4c68-a31e-\
426b7b9bb36c"],

Cell[BoxData[
 TemplateBox[{TemplateBox[{
     GraphicsBox[{{{}, {{{}, {}, {
           Hue[0.67, 0.6, 0.6], 
           Directive[
            PointSize[0.011111111111111112`], 
            AbsoluteThickness[1.6], 
            RGBColor[1, 0, 1], 
            Thickness[0.01]], 
           LineBox[CompressedData["
1:eJw91nlYzen7B/A0lhqiFJLGFCaJacqUSYo3Q4W0UGkSkkoShUSKTnuUOu11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            
            "]]}}}, {}, {}, {{}, {}}, {{}, {}}}, {{}, {{{}, {}, {
           Hue[0.67, 0.6, 0.6], 
           Directive[
            PointSize[0.006944444444444445], 
            AbsoluteThickness[1.6], 
            RGBColor[0.6, 0.4, 0.2], 
            Thickness[0.01]], 
           LineBox[CompressedData["
1:eJw013dYDe77B/CDEIlkJSE7FBkRwhshO0SZbSVJae/T3nVOnZWZnQohiYxj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            "]]}}}, {}, {}, {{}, {}}, {{}, {}}}}, {
      LabelStyle -> Directive[
         GrayLevel[0], 10], DisplayFunction -> Identity, 
       PlotRangePadding -> {{0, 0}, {0, 0}}, AxesOrigin -> {0, 0}, 
       PlotRange -> {{0, 3000}, {0, 1.01}}, PlotRangeClipping -> True, 
       ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
       NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
       AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
       Identity, Frame -> {{False, False}, {False, False}}, 
       FrameLabel -> {{None, None}, {None, None}}, 
       FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
       GridLines -> {None, None}, GridLinesStyle -> Directive[
         GrayLevel[0.5, 0.4]], 
       Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
             (Identity[#]& )[
              Part[#, 1]], 
             (Identity[#]& )[
              Part[#, 2]]}& ), "CopiedValueFunction" -> ({
             (Identity[#]& )[
              Part[#, 1]], 
             (Identity[#]& )[
              Part[#, 2]]}& )}}, PlotRange -> {{0, 3000}, {0, 1.01}}, 
       PlotRangeClipping -> True, PlotRangePadding -> {{0, 0}, {0, 0}}, 
       Ticks -> {Automatic, Automatic}}], 
     FormBox[
      TagBox[
       GridBox[{{
          FormBox[
           
           TemplateBox[{"\"Fast input\""}, "LineLegend", 
            DisplayFunction -> (StyleBox[
              StyleBox[
               PaneBox[
                TagBox[
                 GridBox[{{
                    TagBox[
                    GridBox[{{
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.2], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1, 0, 1], 
                    Thickness[0.18]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.2], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1, 0, 1], 
                    Thickness[0.18]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
                  GridBoxAlignment -> {
                   "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                  False, GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
                 "Grid"], Alignment -> Left, AppearanceElements -> None, 
                ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
                "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
              FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
              False]& ), InterpretationFunction :> (RowBox[{"LineLegend", "[", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    RowBox[{"PointSize", "[", "0.011111111111111112`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[1, 0, 1], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.6666666666666666, 0., 0.6666666666666666], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[1, 0, 1]"], Appearance -> None, BaseStyle -> {},
                     BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[1, 0, 1]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[1, 0, 1], Editable -> False, Selectable -> 
                    False], ",", 
                    RowBox[{"Thickness", "[", "0.01`", "]"}]}], "]"}], "}"}], 
                 ",", 
                 RowBox[{"{", #, "}"}], ",", 
                 RowBox[{"LegendMarkers", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"False", ",", "Automatic"}], "}"}], "}"}]}], ",", 
                 
                 RowBox[{"Joined", "\[Rule]", 
                   RowBox[{"{", "True", "}"}]}], ",", 
                 RowBox[{"LabelStyle", "\[Rule]", 
                   RowBox[{"{", "}"}]}], ",", 
                 RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], 
               "]"}]& ), Editable -> True], TraditionalForm]}, {
          FormBox[
           
           TemplateBox[{"\"Slow input\""}, "LineLegend", 
            DisplayFunction -> (StyleBox[
              StyleBox[
               PaneBox[
                TagBox[
                 GridBox[{{
                    TagBox[
                    GridBox[{{
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.125], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.6, 0.4, 0.2], 
                    Thickness[0.18]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.125], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.6, 0.4, 0.2], 
                    Thickness[0.18]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
                  GridBoxAlignment -> {
                   "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                  False, GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
                 "Grid"], Alignment -> Left, AppearanceElements -> None, 
                ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
                "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
              FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
              False]& ), InterpretationFunction :> (RowBox[{"LineLegend", "[", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    RowBox[{"PointSize", "[", "0.006944444444444445`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.6, 0.4, 0.2], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[0.4, 0.2666666666666667, 0.13333333333333336`], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.6, 0.4, 0.2]"], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.6, 0.4, 0.2]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.6, 0.4, 0.2], Editable -> False, Selectable -> 
                    False], ",", 
                    RowBox[{"Thickness", "[", "0.01`", "]"}]}], "]"}], "}"}], 
                 ",", 
                 RowBox[{"{", #, "}"}], ",", 
                 RowBox[{"LegendMarkers", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"False", ",", "Automatic"}], "}"}], "}"}]}], ",", 
                 
                 RowBox[{"Joined", "\[Rule]", 
                   RowBox[{"{", "True", "}"}]}], ",", 
                 RowBox[{"LabelStyle", "\[Rule]", 
                   RowBox[{"{", "}"}]}], ",", 
                 RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], 
               "]"}]& ), Editable -> True], TraditionalForm]}}, 
        GridBoxAlignment -> {"Columns" -> {{Left}}}, AutoDelete -> False, 
        GridBoxItemSize -> {
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
        GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"], TraditionalForm]}, 
    "Legended", DisplayFunction -> (GridBox[{{
        TagBox[
         ItemBox[
          PaneBox[
           TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
           BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
         "SkipImageSizeLevel"], 
        ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
      GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
      AutoDelete -> False, GridBoxItemSize -> Automatic, 
      BaselinePosition -> {1, 1}]& ), 
    InterpretationFunction -> (RowBox[{"Legended", "[", 
       RowBox[{#, ",", 
         RowBox[{"Placed", "[", 
           RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& ), Editable -> True],
   "\"Pr(RyR opening)\"","\"Number of ions N\""},
  "Labeled",
  DisplayFunction->(GridBox[{{
      ItemBox[
       RotationBox[#2, BoxRotation -> 1.5707963267948966`], BaseStyle -> 
       Directive[
         GrayLevel[0], 10], DefaultBaseStyle -> "LabeledLabel"], 
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"]}, {"", 
      ItemBox[#3, BaseStyle -> Directive[
         GrayLevel[0], 10], DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, 
    GridBoxItemSize -> {"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
    BaselinePosition -> {1, 2}]& ),
  InterpretationFunction->(RowBox[{"Labeled", "[", 
     RowBox[{#, ",", 
       RowBox[{"{", 
         RowBox[{#2, ",", #3}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{"Left", ",", "Bottom", ",", "Top", ",", "Right"}], "}"}], 
       ",", 
       RowBox[{"RotateLabel", "\[Rule]", "True"}], ",", 
       RowBox[{"LabelStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
           RowBox[{
             InterpretationBox[
              ButtonBox[
               TooltipBox[
                GraphicsBox[{{
                   GrayLevel[0], 
                   RectangleBox[{0, 0}]}, {
                   GrayLevel[0], 
                   RectangleBox[{1, -1}]}, {
                   GrayLevel[0], 
                   RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                 True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                 PlotRangePadding -> None, ImageSize -> 
                 Dynamic[{
                   Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
               Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
               Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
               With[{Typeset`box$ = EvaluationBox[]}, 
                 If[
                  Not[
                   AbsoluteCurrentValue["Deployed"]], 
                  SelectionMove[Typeset`box$, All, Expression]; 
                  FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                  FrontEnd`Private`$ColorSelectorInitialColor = GrayLevel[0]; 
                  FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                  MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
               Automatic, Method -> "Preemptive"], 
              GrayLevel[0], Editable -> False, Selectable -> False], ",", 
             "10"}], "]"}]}]}], "]"}]& )]], "Output",
 CellChangeTimes->{{3.8112394141722727`*^9, 3.8112394604515963`*^9}, 
   3.8112425147747927`*^9, {3.811242590281636*^9, 3.811242598912199*^9}, {
   3.811242655152151*^9, 3.811242699745875*^9}, 3.811242740755643*^9, {
   3.8112427841945667`*^9, 3.8112427959860373`*^9}, {3.811244228940711*^9, 
   3.811244279642789*^9}, 3.811492410970117*^9, 3.8114925327218437`*^9, {
   3.811493685520974*^9, 3.811493700343709*^9}, {3.811493745505789*^9, 
   3.811493771051971*^9}, 
   3.811494978796261*^9},ExpressionUUID->"0197d100-bdc3-41ae-a826-\
27b15c7b728b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\</media/basnayak/Data \
new/basnayak/Dropbox/STIM_ORAI_bionewmetrics/mathematica_scripts/\
compareslowfast1.pdf\>\"", ",", "figslowfast"}], "]"}]], "Input",
 CellChangeTimes->{{3.811493206235774*^9, 3.811493236070444*^9}, 
   3.811493375430859*^9, {3.811493567689763*^9, 3.811493578552019*^9}, {
   3.8114949509457417`*^9, 3.8114949579216347`*^9}, {3.81149499161843*^9, 
   3.811495013585987*^9}, {3.8114950596987886`*^9, 
   3.8114950631226254`*^9}},ExpressionUUID->"48c7015a-e0f7-4970-b9ca-\
3e059aad71ee"],

Cell[BoxData["\<\"/media/basnayak/Data \
new/basnayak/Dropbox/STIM_ORAI_bionewmetrics/mathematica_scripts/\
compareslowfast1.pdf\"\>"], "Output",
 CellChangeTimes->{
  3.811493377747348*^9, 3.811493580093277*^9, 3.811493711050331*^9, 
   3.811493751986197*^9, 3.811493788390273*^9, {3.811494979475421*^9, 
   3.811495014212676*^9}, 
   3.811495063848345*^9},ExpressionUUID->"369a1b07-55c2-4742-a03b-\
7c4d13219756"]
}, Open  ]]
},
WindowSize->{786, 990},
WindowMargins->{{Automatic, 0}, {Automatic, -551}},
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 184, 4, 32, "Input", "ExpressionUUID" -> \
"64e212aa-73d1-4319-baca-500445adf0f5"],
Cell[767, 28, 177, 3, 32, "Output", "ExpressionUUID" -> \
"0993be1b-a96b-4dd5-b651-49659e217e1a"]
}, Open  ]],
Cell[959, 34, 809, 17, 103, "Input", "ExpressionUUID" -> \
"d084989a-05c9-4f5c-8fd7-6fca90bdf8a4"],
Cell[1771, 53, 3490, 86, 218, "Input", "ExpressionUUID" -> \
"fd7cb0ed-e0f9-4300-8314-f8a6fd0f2c55"],
Cell[5264, 141, 4309, 111, 309, "Input", "ExpressionUUID" -> \
"b85fdb7f-5a9e-4826-af6d-ebab50b50368"],
Cell[CellGroupData[{
Cell[9598, 256, 373, 9, 34, "Input", "ExpressionUUID" -> \
"d31dcb5b-7e28-47d3-b063-a66ea7ff85b2"],
Cell[9974, 267, 325, 8, 23, "Message", "ExpressionUUID" -> \
"7d3075a3-944e-4a47-8221-81220938ef48"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10336, 280, 3155, 67, 171, "Input", "ExpressionUUID" -> \
"16f2feb4-3629-4c68-a31e-426b7b9bb36c"],
Cell[13494, 349, 63367, 1111, 255, "Output", "ExpressionUUID" -> \
"0197d100-bdc3-41ae-a826-27b15c7b728b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[76898, 1465, 564, 11, 101, "Input", "ExpressionUUID" -> \
"48c7015a-e0f7-4970-b9ca-3e059aad71ee"],
Cell[77465, 1478, 415, 8, 77, "Output", "ExpressionUUID" -> \
"369a1b07-55c2-4742-a03b-7c4d13219756"]
}, Open  ]]
}
]
*)

