(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    333165,       6953]
NotebookOptionsPosition[    322874,       6709]
NotebookOutlinePosition[    323211,       6724]
CellTagsIndexPosition[    323168,       6721]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{
  RowBox[{"\[Mu]", "=", "38"}], ";", 
  RowBox[{"\[Lambda]", "=", "6"}], ";", 
  RowBox[{"NR", "=", "1"}], ";", 
  RowBox[{"\[Nu]", "=", "1000"}], ";", " ", 
  RowBox[{"initca", "=", "100"}]}]], "Input",
 CellChangeTimes->{{3.815744349483822*^9, 3.8157443551147547`*^9}, 
   3.8157560014501534`*^9},ExpressionUUID->"9a151358-99d3-4405-827f-\
1a0a26cba56e"],

Cell[BoxData["100"], "Output",
 CellChangeTimes->{3.815756059398451*^9, 3.8157563712576036`*^9, 
  3.815759430631445*^9, 3.815761447021193*^9, 3.815761659240899*^9, 
  3.815761782700797*^9, 3.8157618729066467`*^9, 3.8157622527972603`*^9, 
  3.815824898787004*^9, 3.815825345526671*^9, 
  3.815846760748011*^9},ExpressionUUID->"e2d57ef9-5156-40b4-9dfe-\
dcdd77d37439"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"sfast", "=", 
   RowBox[{"NDSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"n1", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Mu]"}], "*", 
          RowBox[{"n1", "[", "t", "]"}]}], "+", " ", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], " ", "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"2", "*", 
             RowBox[{"n1", "[", "t", "]"}]}]}], " ", ")"}]}]}]}], " ", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"nca", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Nu]"}], "*", 
          RowBox[{"nca", "[", "t", "]"}]}], " ", "-", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"n1", "[", "t", "]"}]}], ")"}]}], "+", 
         RowBox[{"\[Mu]", "*", 
          RowBox[{"n1", "[", "t", "]"}]}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"p2", "'"}], "[", "t", "]"}], "\[Equal]", " ", 
        RowBox[{"\[Lambda]", "*", 
         RowBox[{"n1", "[", "t", "]"}], "*", 
         RowBox[{"nca", "[", "t", "]"}], "*", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"p2", "[", "t", "]"}]}], ")"}]}]}], ",", 
       "\[IndentingNewLine]", " ", 
       RowBox[{
        RowBox[{"n1", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
       RowBox[{
        RowBox[{"nca", "[", "0", "]"}], "\[Equal]", "initca"}], ",", 
       RowBox[{
        RowBox[{"p2", "[", "0", "]"}], "\[Equal]", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"n1", ",", "nca", ",", "p2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0.0", ",", ".2"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"n1", "[", "t", "]"}], "/.", "sfast"}], "]"}], ",", 
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"nca", "[", "t", "]"}], "/.", "sfast"}], "]"}], ",", 
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"p2", "[", "t", "]"}], "/.", "sfast"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", ".2"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "100"}], "}"}]}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{"Orange", ",", "Green", ",", "Blue"}], "}"}]}], ",", 
   RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"plotofn1Fast100", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"n1", "[", "t", "]"}], "/.", "sfast"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", ".2"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", "Black", "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"plotofncaFast100", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"nca", "[", "t", "]"}], "/.", "sfast"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", ".2"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "110"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", "Black", "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"plotofp2Fast100", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"p2", "[", "t", "]"}], "/.", "sfast"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", ".2"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", "Black", "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.8154954466784477`*^9, 3.81549546339727*^9}, {
   3.815753839511162*^9, 3.8157538397012177`*^9}, {3.815756020814352*^9, 
   3.815756055449896*^9}, {3.815756193116506*^9, 3.815756217995455*^9}, {
   3.815759452330182*^9, 3.815759452729961*^9}, 
   3.815824848204445*^9},ExpressionUUID->"1e09f38a-e9ea-4828-9016-\
c4d44cfec76c"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0.5, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtVnc0Fo77VUkqWSGbiqSECJk3IrKyRyJZhayMJGVllJEd2TOUnb1evLzG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       "]]},
     Annotation[#, "Charting`Private`Tag$2718#1"]& ], 
    TagBox[
     {RGBColor[0, 1, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwVl3c0148XxiWJKBkJJckqIUVIeT+y5zczRLIiVFRm2SuyEomSlZUysvfe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       "]]},
     Annotation[#, "Charting`Private`Tag$2718#2"]& ], 
    TagBox[
     {RGBColor[0, 0, 1], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwd1nc8le0bAHC0jEJCiIzsFX7iTXmvImXWmy0SGRUyMqKlIytZRUgqO9sx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       "]]},
     Annotation[#, "Charting`Private`Tag$2718#3"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.2}, {0, 100}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.815495469174765*^9, 3.8157443597554893`*^9, 3.815753841839561*^9, 
   3.815754157870742*^9, 3.815756066660036*^9, {3.815756196920442*^9, 
   3.815756219951748*^9}, {3.81575636219816*^9, 3.8157563724804688`*^9}, {
   3.815759431892576*^9, 3.815759453646039*^9}, 3.81576144727395*^9, 
   3.815761660280756*^9, 3.815761788121437*^9, 3.815761873015814*^9, 
   3.815762258304309*^9, 3.81582490088853*^9, 3.815825345956585*^9, 
   3.815846761138761*^9},ExpressionUUID->"31d1138b-72ce-40a0-8052-\
c3a6077f8813"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwVUGc41Q8DRaknb+Ev5bouusq4VkgLf8d+kVWEJFtGykhUIloyEpJwo+w0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       "]]},
     Annotation[#, "Charting`Private`Tag$2825#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.2}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.815495469174765*^9, 3.8157443597554893`*^9, 3.815753841839561*^9, 
   3.815754157870742*^9, 3.815756066660036*^9, {3.815756196920442*^9, 
   3.815756219951748*^9}, {3.81575636219816*^9, 3.8157563724804688`*^9}, {
   3.815759431892576*^9, 3.815759453646039*^9}, 3.81576144727395*^9, 
   3.815761660280756*^9, 3.815761788121437*^9, 3.815761873015814*^9, 
   3.815762258304309*^9, 3.81582490088853*^9, 3.815825345956585*^9, 
   3.815846761184699*^9},ExpressionUUID->"1925e5b6-e605-4925-9ccd-\
acfabfa9f19d"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwVlGc41Y8DxZFUSgkZ185OVCrRuOeLSFZWVkhGZsr+2a69R4nqEkUalJFV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       "]]},
     Annotation[#, "Charting`Private`Tag$2867#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.2}, {0, 110}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.815495469174765*^9, 3.8157443597554893`*^9, 3.815753841839561*^9, 
   3.815754157870742*^9, 3.815756066660036*^9, {3.815756196920442*^9, 
   3.815756219951748*^9}, {3.81575636219816*^9, 3.8157563724804688`*^9}, {
   3.815759431892576*^9, 3.815759453646039*^9}, 3.81576144727395*^9, 
   3.815761660280756*^9, 3.815761788121437*^9, 3.815761873015814*^9, 
   3.815762258304309*^9, 3.81582490088853*^9, 3.815825345956585*^9, 
   3.815846761221884*^9},ExpressionUUID->"a827e29e-cdc7-4f78-b1bc-\
d164333d45be"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {GrayLevel[0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwd13c4ll0YAHCZZSUjI9mhIaXSkG4in1UhWUlmyV4lK0SkyF6V7L3Ha76v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       "]]},
     Annotation[#, "Charting`Private`Tag$2909#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.2}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.815495469174765*^9, 3.8157443597554893`*^9, 3.815753841839561*^9, 
   3.815754157870742*^9, 3.815756066660036*^9, {3.815756196920442*^9, 
   3.815756219951748*^9}, {3.81575636219816*^9, 3.8157563724804688`*^9}, {
   3.815759431892576*^9, 3.815759453646039*^9}, 3.81576144727395*^9, 
   3.815761660280756*^9, 3.815761788121437*^9, 3.815761873015814*^9, 
   3.815762258304309*^9, 3.81582490088853*^9, 3.815825345956585*^9, 
   3.815846761261207*^9},ExpressionUUID->"ec90126d-259a-4463-aa0d-\
c2ed2f9efc55"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"n1new100fast", "[", "y_", "]"}], ":=", 
  RowBox[{
   RowBox[{"n1", "[", "y", "]"}], "/.", "sfast"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ncanew100fast", "[", "y_", "]"}], ":=", 
  RowBox[{
   RowBox[{"nca", "[", "y", "]"}], "/.", "sfast"}]}], "\n", 
 RowBox[{
  RowBox[{"p2new100fast", "[", "y_", "]"}], ":=", " ", 
  RowBox[{
   RowBox[{"p2", "[", "y", "]"}], "/.", "sfast"}]}]}], "Input",
 CellChangeTimes->{{3.815756078362726*^9, 3.8157560868771963`*^9}, {
  3.815756145099248*^9, 
  3.8157561629865627`*^9}},ExpressionUUID->"a70698e7-d20c-4eef-aa57-\
90f003241768"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"N", "[", 
   RowBox[{"p2new100fast", "[", ".2", "]"}], "]"}], 
  " "}], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{
   RowBox[{"This", " ", "is", " ", "p2", " ", "at", " ", "Infnty", " ", 
    RowBox[{"(", 
     RowBox[{"Infnty", " ", "is", " ", ".2", " ", "here"}], " ", ")"}]}], " ",
    ";"}], "Text"], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.8157447298466263`*^9, 3.815744783137251*^9}, 
   3.815756168027008*^9, {3.815756227628352*^9, 
   3.815756257947351*^9}},ExpressionUUID->"98d49387-a0d5-4764-8cce-\
0a11ae46c206"],

Cell[BoxData[
 RowBox[{"{", "0.11390554593335668`", "}"}]], "Output",
 CellChangeTimes->{{3.815744763082663*^9, 3.815744783644308*^9}, 
   3.815754158147615*^9, 3.815756169168201*^9, 3.815756228250605*^9, 
   3.8157563771747723`*^9, 3.815761447414768*^9, 3.815761663958027*^9, 
   3.815761791798883*^9, 3.8157618731837997`*^9, 3.815762261639073*^9, 
   3.81582490506355*^9, 3.815825346352551*^9, 
   3.815846761297235*^9},ExpressionUUID->"31d3b5bb-5018-4563-9ae3-\
444584f134ac"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Ingdtgralinexpo100fast", "[", "ti_", "]"}], ":=", 
  RowBox[{
   RowBox[{"-", "\[Lambda]"}], " ", "*", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"n1new100fast", "[", "tti", "]"}], "*", 
      RowBox[{"ncanew100fast", "[", "tti", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"tti", ",", "0", ",", "ti"}], "}"}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IngdtgralinexpoInf100fast", "[", "ti_", "]"}], ":=", 
   RowBox[{"\[Lambda]", " ", "*", 
    RowBox[{"NIntegrate", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"n1new100fast", "[", "tti", "]"}], "*", 
       RowBox[{"ncanew100fast", "[", "tti", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"tti", ",", "ti", ",", "0.2"}], "}"}]}], "]"}]}]}], ";", 
  "            ", 
  StyleBox[
   RowBox[{"(", 
    RowBox[{"Infnty", " ", "is", " ", ".2", " ", "here"}], " ", ")"}], "Text"], 
  StyleBox[" ", "Text"], 
  StyleBox[";", "Text"]}], "\[IndentingNewLine]", 
 RowBox[{"DiscretePlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"IngdtgralinexpoInf100fast", "[", "hh", "]"}], "*", 
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{"Ingdtgralinexpo100fast", "[", "hh", "]"}], "]"}], "/", 
     RowBox[{"N", "[", 
      RowBox[{"p2new100fast", "[", ".2", "]"}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"hh", ",", "0", ",", "0.01", ",", ".0005"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.8154954076212807`*^9, 3.815495421753167*^9}, {
   3.815744277036044*^9, 3.815744327422968*^9}, 3.815744397339501*^9, 
   3.815744439484407*^9, {3.8157444802535973`*^9, 3.815744493932539*^9}, {
   3.815744540959334*^9, 3.815744549886273*^9}, {3.815744787552516*^9, 
   3.815744796833095*^9}, {3.81574487376235*^9, 3.81574487846521*^9}, {
   3.8157562387640142`*^9, 3.815756337211691*^9}, {3.815756432061716*^9, 
   3.815756485421776*^9}, {3.815759137591393*^9, 3.8157591378154783`*^9}, 
   3.815761467734806*^9, {3.81582487999784*^9, 
   3.81582488276425*^9}},ExpressionUUID->"99494d26-623b-4474-9db1-\
033f1f5545e6"],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.011000000000000001`], 
    AbsoluteThickness[1.6], {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.011000000000000001`], AbsoluteThickness[1.6], Opacity[0.2], 
      LineBox[{{{0.01, 0.0015746623168608619`}, {0.01, 
       0.0015746623168608619`}}},
       VertexColors->None]}, 
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.011000000000000001`], AbsoluteThickness[1.6], Opacity[0.2], 
      LineBox[CompressedData["
1:eJxTTMoPSmVmYGAQAWImKIYB9sfLDq/488Eexj+UfPbknDOR9n9Wfrzkm+Rg
79LLqVO64hWcjyofYO/U+lDjottDOB8m/6sua0/J5Ah7d489qqW+V+F8VP0J
9pKPixa8uXUSzofJV4usc39YlWK/8v4bxx77/XA+qvkZ9qEpltVCLzfB+TD5
ypdqhhxrcuyfvT8kEc+2HM5Htb/AnremWFchcg6cD5O3ue/fOz2vyF6X1dzm
++GJcD6q+0rspdYctL9/tw3Oh8nv8uRh0m4vs/+Ul3PYu6sOzkd1f4X9T8sX
sqFJpXA+TN5qy4myffOr7J98XHoqdmk+nI/qvxr7fc1P88rOZcD5MPkdcq2v
A3fU2T/n2+7t3JoC56P6v8F+1z3/eV2HEuF8mPycIwobijIa7Q8Fd0yYezke
wUcJnyb7AqPX9zlsYuF8mPztnyAPNdvP9oq/uMI/Gs6HyQMA/K9H4Q==
       "],
       VertexColors->None]}}}, 
   {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.011000000000000001`], 
    AbsoluteThickness[1.6], {}, PointBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQDQPsj5cdXvHng/2flR8v+SY52Lv0cuqUrngF5QfY
O7U+1Ljo9tD+V13WnpLJEfbuHntUS32vQuUT7CUfFy14c+ukfbXIOveHVSn2
K++/ceyx3w9Vn2EfmmJZLfRyk33lSzVDjjU59s/eH5KIZ1sO1V9gz1tTrKsQ
Ocfe5r5/7/S8IntdVnOb74cnQs0rsZdac9D+/t02+12ePEza7WX2n/JyDnt3
1UHNr7D/aflCNjSp1N5qy4myffOr7J98XHoqdmk+1L4a+33NT/PKzmXY75Br
fR24o87+Od92b+fWFKj9Dfa77vnP6zqUaD/niMKGooxG+0PBHRPmXo6HuqfJ
vsDo9X0Om1j72z9BFjbbz/aKv7jCPxrqvhb7Q8lnT845E2kPAEmnpSM=
     "]], {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0.0015746623168608619`},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageMargins->0.,
  ImageSize->{221., Automatic},
  Method->{
   "MessagesHead" -> DiscretePlot, "AxisPadding" -> Scaled[0.02], 
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "DefaultPlotStyle" -> {
      Directive[
       RGBColor[0.368417, 0.506779, 0.709798], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.880722, 0.611041, 0.142051], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.560181, 0.691569, 0.194885], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.922526, 0.385626, 0.209179], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.528488, 0.470624, 0.701351], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.772079, 0.431554, 0.102387], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.363898, 0.618501, 0.782349], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[1, 0.75, 0], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.647624, 0.37816, 0.614037], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.571589, 0.586483, 0.], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.915, 0.3325, 0.2125], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.40082222609352647`, 0.5220066643438841, 0.85], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.9728288904374106, 0.621644452187053, 0.07336199581899142], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.736782672705901, 0.358, 0.5030266573755369], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.28026441037696703`, 0.715, 0.4292089322474965], 
       AbsoluteThickness[1.6]]}, "DomainPadding" -> Scaled[0.02], 
    "PointSizeFunction" -> "SmallPointSize", "RangePadding" -> Scaled[0.05]},
  PlotRange->{{0., 0.01}, {0.0015746623168608619`, 1.0616843836452874`}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.02]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8154954820435143`*^9, 3.8157444065896053`*^9, {3.815744448043006*^9, 
   3.815744495050384*^9}, 3.815744805396113*^9, 3.815753556744033*^9, 
   3.8157541660327063`*^9, 3.815756309944831*^9, 3.815756417614394*^9, {
   3.815756449513967*^9, 3.815756489984438*^9}, 3.815759142548971*^9, 
   3.8157614513099527`*^9, 3.815761669076599*^9, 3.815761877078026*^9, 
   3.815762266946692*^9, 3.815824911791546*^9, 3.815825350309005*^9, 
   3.8158467652619553`*^9},ExpressionUUID->"be750eda-0a0e-4569-9ca7-\
c246738acc2a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals100fastvals", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"IngdtgralinexpoInf100fast", "[", "hh", "]"}], "*", 
      RowBox[{"Exp", "[", 
       RowBox[{"Ingdtgralinexpo100fast", "[", "hh", "]"}], "]"}]}], " ", ",", 
     
     RowBox[{"{", 
      RowBox[{"hh", ",", "0", ",", "0.01", ",", ".0001"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.815744559758568*^9, 3.815744582814271*^9}, {
   3.81574484168108*^9, 3.815744862576949*^9}, {3.8157449206256332`*^9, 
   3.815744924337483*^9}, 3.8157450223386*^9, {3.815745082130978*^9, 
   3.8157451059714413`*^9}, {3.815756510605835*^9, 
   3.8157565669901648`*^9}},ExpressionUUID->"0945a5a2-7285-4a70-8127-\
9f9b1746bbb1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals100fastfunc", " ", "=", " ", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals100fastvals", ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0.", ",", "0.01"}], "}"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.8157448877074747`*^9, 3.81574494238554*^9}, {
   3.815744977714079*^9, 3.815744981746171*^9}, {3.815753276799062*^9, 
   3.8157532907833557`*^9}, 3.8157535414894238`*^9, {3.8157565742065153`*^9, 
   3.815756590958596*^9}},ExpressionUUID->"6c7dcc9a-19b6-420b-bfaf-\
0c46edd6c0dd"],

Cell[BoxData[
 TagBox[
  TemplateBox[{RowBox[{
      StyleBox[
       TagBox["InterpolatingFunction", "SummaryHead"], 
       "NonInterpretableSummary"], 
      StyleBox["[", "NonInterpretableSummary"], 
      DynamicModuleBox[{Typeset`open$$ = False}, 
       PanelBox[
        PaneSelectorBox[{False -> GridBox[{{
              PaneBox[
               ButtonBox[
                DynamicBox[
                 FEPrivate`FrontEndResource[
                 "FEBitmaps", "SquarePlusIconMedium"]], 
                ButtonFunction :> (Typeset`open$$ = True), Appearance -> None,
                 Evaluator -> Automatic, Method -> "Preemptive"], 
               Alignment -> {Center, Center}, ImageSize -> 
               Dynamic[{
                 Automatic, 3.5 CurrentValue["FontCapHeight"]/
                  AbsoluteCurrentValue[Magnification]}]], 
              GraphicsBox[{{{{}, {}, 
                  TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwBkQNu/CFib1JlAgAAADgAAAACAAAAHgVlz01jST9wD6uxDl6zPwqNTMOK
l0s/WhkJKwE1sj8WGU2euHpQP75eEkO1UK8/Rpe3Ki9jUz8Jv4lj53OqP8d4
UgMSPlY/xY6NXFVVpj9yGVSm1edYP0u3J2J+B6M/vGUZmRzLWz+z556/0/Cf
PzBxRVZEfV4/KwK2pJIXmz/679Av7JBgP8KYdyobCpc/LP1g3Pf/YT9xhUXs
LFGTP/NpJO5zVmM/rCZ/v61ikD+JrMmnsclkPxQHjMe4aos/yCCHhyU2Zj/0
F4mVhwSHP5z0d8wJimc/nBLi+n+Pgz8/nkq5r/poP9f4iAqcZ4A/d6dQC8ZS
aj+ux5tDOdx7P3+GOAWex2s/Ze4i5/Bbdz8vlzglrDVtP+wcpDz5q3M/dAds
qiqLbj/NhmxhusdwP4lNgddq/W8/jlkDhS1LbD+a+eS0jatwP1rgDM9MK2g/
Q2UVEQFVcT+S98ADP8BkP9S7NkHVDHI/3TXqts+hYT8vwvGjYbhyP0JBTXjV
X14/crOd2k5ycz+qUoB9uuxZP4m9VSTXKHQ/sNzVps9GVj9rd6egF9N0P6EH
AoeaaVM/NRzq8LiLdT+m/yb6fcxQP8lwxnMSOHY/lBsAbLp+TT8x3q4JB+F2
P8JfYnLpFUo/gTaIc1yYdz/5MghRhvZGP5w++w9qQ3g/6s8pz16BRD+eMV+A
2Px4P5OmNA3VQUI/a9RcI/+peT/mqICraXxAPwyQZtnAU3o/uMis8xwEPj+V
NmFj4wt7P8WEE27eSzs/6Iz1H763ez95aiuiaCQ5PyPOerD5cXw/oa0L4YYo
Nz8yKAxU0Ch9P2nlby/pgTU/DDI3Kl/TfT8R5Qg6iTA0P84mU9ROjH4/iFdx
9LT2Mj9aywix9jh/PwIKFqvL+jE/uojKoDnifz/UP/waPyQxP4KYPrLuTIA/
McLV1Q5aMD+MxGStnKKAPy+DGlA3ay8/CmaDEnv/gD/AhrTGCzMuP/ITKAGn
WoE/7ou1bEYmLT+/mRkJr6+BP/HQXFLsRyw/AJUDe+cLgj+P1k8YzXArPyZo
Ogb8YYI/mnjCJq68Kj/AsGn7QL+CP6oYYU6DDCo/xAUfetMagz805w0ryW8p
P60yIRJCcIM/s+X0xNbpKD8K1RsU4cyDP+LlKM34Yyg/TU9jL1wjhD/d47G8
EvAnP38320HheoQ/aNRff2qCJz+6opMV
                    "]]}, 
                   Annotation[#, 
                    "Charting`Private`Tag$47042#1"]& ]}}, {}, {}}, {
               DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
                AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
                GridLines -> {None, None}, DisplayFunction -> Identity, 
                PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                All, DisplayFunction -> Identity, AspectRatio -> 1, 
                Axes -> {False, False}, AxesLabel -> {None, None}, 
                AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                Frame -> {{True, True}, {True, True}}, 
                FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                Directive[
                  Opacity[0.5], 
                  Thickness[Tiny], 
                  RGBColor[0.368417, 0.506779, 0.709798]], 
                FrameTicks -> {{None, None}, {None, None}}, 
                GridLines -> {None, None}, GridLinesStyle -> Directive[
                  GrayLevel[0.5, 0.4]], ImageSize -> 
                Dynamic[{
                  Automatic, 3.5 CurrentValue["FontCapHeight"]/
                   AbsoluteCurrentValue[Magnification]}], 
                Method -> {
                 "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                  AbsolutePointSize[6], "ScalingFunctions" -> None, 
                  "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                PlotRange -> {{0., 0.01}, {0., 0.07565395200350422}}, 
                PlotRangeClipping -> True, PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
              GridBox[{{
                 RowBox[{
                   TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox[
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "0.01`"}], "}"}], "}"}], 
                    "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"scalar\"", "SummaryItem"]}]}}, 
               GridBoxAlignment -> {
                "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
               False, GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {
                "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
               BaseStyle -> {
                ShowStringCharacters -> False, NumberMarks -> False, 
                 PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
            GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
            BaselinePosition -> {1, 1}], True -> GridBox[{{
              PaneBox[
               ButtonBox[
                DynamicBox[
                 FEPrivate`FrontEndResource[
                 "FEBitmaps", "SquareMinusIconMedium"]], 
                ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                None, Evaluator -> Automatic, Method -> "Preemptive"], 
               Alignment -> {Center, Center}, ImageSize -> 
               Dynamic[{
                 Automatic, 3.5 CurrentValue["FontCapHeight"]/
                  AbsoluteCurrentValue[Magnification]}]], 
              GraphicsBox[{{{{}, {}, 
                  TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwBkQNu/CFib1JlAgAAADgAAAACAAAAHgVlz01jST9wD6uxDl6zPwqNTMOK
l0s/WhkJKwE1sj8WGU2euHpQP75eEkO1UK8/Rpe3Ki9jUz8Jv4lj53OqP8d4
UgMSPlY/xY6NXFVVpj9yGVSm1edYP0u3J2J+B6M/vGUZmRzLWz+z556/0/Cf
PzBxRVZEfV4/KwK2pJIXmz/679Av7JBgP8KYdyobCpc/LP1g3Pf/YT9xhUXs
LFGTP/NpJO5zVmM/rCZ/v61ikD+JrMmnsclkPxQHjMe4aos/yCCHhyU2Zj/0
F4mVhwSHP5z0d8wJimc/nBLi+n+Pgz8/nkq5r/poP9f4iAqcZ4A/d6dQC8ZS
aj+ux5tDOdx7P3+GOAWex2s/Ze4i5/Bbdz8vlzglrDVtP+wcpDz5q3M/dAds
qiqLbj/NhmxhusdwP4lNgddq/W8/jlkDhS1LbD+a+eS0jatwP1rgDM9MK2g/
Q2UVEQFVcT+S98ADP8BkP9S7NkHVDHI/3TXqts+hYT8vwvGjYbhyP0JBTXjV
X14/crOd2k5ycz+qUoB9uuxZP4m9VSTXKHQ/sNzVps9GVj9rd6egF9N0P6EH
AoeaaVM/NRzq8LiLdT+m/yb6fcxQP8lwxnMSOHY/lBsAbLp+TT8x3q4JB+F2
P8JfYnLpFUo/gTaIc1yYdz/5MghRhvZGP5w++w9qQ3g/6s8pz16BRD+eMV+A
2Px4P5OmNA3VQUI/a9RcI/+peT/mqICraXxAPwyQZtnAU3o/uMis8xwEPj+V
NmFj4wt7P8WEE27eSzs/6Iz1H763ez95aiuiaCQ5PyPOerD5cXw/oa0L4YYo
Nz8yKAxU0Ch9P2nlby/pgTU/DDI3Kl/TfT8R5Qg6iTA0P84mU9ROjH4/iFdx
9LT2Mj9aywix9jh/PwIKFqvL+jE/uojKoDnifz/UP/waPyQxP4KYPrLuTIA/
McLV1Q5aMD+MxGStnKKAPy+DGlA3ay8/CmaDEnv/gD/AhrTGCzMuP/ITKAGn
WoE/7ou1bEYmLT+/mRkJr6+BP/HQXFLsRyw/AJUDe+cLgj+P1k8YzXArPyZo
Ogb8YYI/mnjCJq68Kj/AsGn7QL+CP6oYYU6DDCo/xAUfetMagz805w0ryW8p
P60yIRJCcIM/s+X0xNbpKD8K1RsU4cyDP+LlKM34Yyg/TU9jL1wjhD/d47G8
EvAnP38320HheoQ/aNRff2qCJz+6opMV
                    "]]}, 
                   Annotation[#, 
                    "Charting`Private`Tag$47042#1"]& ]}}, {}, {}}, {
               DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
                AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
                GridLines -> {None, None}, DisplayFunction -> Identity, 
                PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                All, DisplayFunction -> Identity, AspectRatio -> 1, 
                Axes -> {False, False}, AxesLabel -> {None, None}, 
                AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                Frame -> {{True, True}, {True, True}}, 
                FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                Directive[
                  Opacity[0.5], 
                  Thickness[Tiny], 
                  RGBColor[0.368417, 0.506779, 0.709798]], 
                FrameTicks -> {{None, None}, {None, None}}, 
                GridLines -> {None, None}, GridLinesStyle -> Directive[
                  GrayLevel[0.5, 0.4]], ImageSize -> 
                Dynamic[{
                  Automatic, 3.5 CurrentValue["FontCapHeight"]/
                   AbsoluteCurrentValue[Magnification]}], 
                Method -> {
                 "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                  AbsolutePointSize[6], "ScalingFunctions" -> None, 
                  "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                PlotRange -> {{0., 0.01}, {0., 0.07565395200350422}}, 
                PlotRangeClipping -> True, PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
              GridBox[{{
                 RowBox[{
                   TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox[
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "0.01`"}], "}"}], "}"}], 
                    "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"scalar\"", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["3", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["False", "SummaryItem"]}]}}, 
               GridBoxAlignment -> {
                "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
               False, GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {
                "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
               BaseStyle -> {
                ShowStringCharacters -> False, NumberMarks -> False, 
                 PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
            GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
            BaselinePosition -> {1, 1}]}, 
         Dynamic[Typeset`open$$], ImageSize -> Automatic], BaselinePosition -> 
        Baseline], DynamicModuleValues :> {}], 
      StyleBox["]", "NonInterpretableSummary"]}]},
   "CopyTag",
   DisplayFunction->(#& ),
   InterpretationFunction->("InterpolatingFunction[{{0., 0.01}}, <>]"& )],
  False,
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{3.815753604548572*^9, 3.815754180792033*^9, 
  3.815756592349368*^9, 3.8157616904975452`*^9, 3.815761896056267*^9, 
  3.815762289159781*^9, 3.815824937387642*^9, 3.815825369873026*^9, 
  3.815846784388315*^9},ExpressionUUID->"bb3e18e3-390a-4616-939f-\
a9a89e9a31ce"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tau2for100fast", "=", 
  RowBox[{
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
     "IngdtgralinexpoInfIngdtgralinexpovals100fastfunc", "[", "ww", "]"}], 
     ",", " ", 
     RowBox[{"{", 
      RowBox[{"ww", ",", "0", ",", "0.01"}], "}"}]}], "]"}], "/", 
   RowBox[{"N", "[", 
    RowBox[{"p2new100fast", "[", "0.2", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.815745024257978*^9, 3.8157450584986153`*^9}, {
  3.815753254031543*^9, 3.815753254670862*^9}, {3.815753587458639*^9, 
  3.815753615250682*^9}, {3.815753669810672*^9, 3.815753732499239*^9}, {
  3.815756599231925*^9, 3.81575665619074*^9}, {3.815761867006518*^9, 
  3.815761868030348*^9}},ExpressionUUID->"8b2e73ec-9d18-4a6c-ab16-\
e873809871b1"],

Cell[BoxData[
 RowBox[{"{", "0.00138185661090375`", "}"}]], "Output",
 CellChangeTimes->{{3.8157536885805893`*^9, 3.815753696462763*^9}, 
   3.8157537329431343`*^9, 3.815754180815572*^9, {3.815756615766677*^9, 
   3.8157566570517683`*^9}, 3.8157616923421373`*^9, {3.815761869059272*^9, 
   3.815761896102499*^9}, 3.8157622909594584`*^9, 3.8158249401715*^9, 
   3.815825370029728*^9, 
   3.815846784434284*^9},ExpressionUUID->"3532710b-8fdc-452d-a15a-\
d61d680a42c9"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.815759317305605*^9, 
  3.815759317863373*^9}},ExpressionUUID->"1e247c1d-763f-4e23-ae4d-\
ee146905b198"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Mu]", "=", "38"}], ";", 
  RowBox[{"\[Lambda]", "=", "6"}], ";", 
  RowBox[{"NR", "=", "1"}], ";", 
  RowBox[{"\[Nu]", "=", "1000"}], ";", " ", 
  RowBox[{"initca", "=", "300"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sfast", "=", 
   RowBox[{"NDSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"n1", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Mu]"}], "*", 
          RowBox[{"n1", "[", "t", "]"}]}], "+", " ", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], " ", "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"2", "*", 
             RowBox[{"n1", "[", "t", "]"}]}]}], " ", ")"}]}]}]}], " ", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"nca", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Nu]"}], "*", 
          RowBox[{"nca", "[", "t", "]"}]}], " ", "-", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"n1", "[", "t", "]"}]}], ")"}]}], "+", 
         RowBox[{"\[Mu]", "*", 
          RowBox[{"n1", "[", "t", "]"}]}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"p2", "'"}], "[", "t", "]"}], "\[Equal]", " ", 
        RowBox[{"\[Lambda]", "*", 
         RowBox[{"n1", "[", "t", "]"}], "*", 
         RowBox[{"nca", "[", "t", "]"}], "*", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"p2", "[", "t", "]"}]}], ")"}]}]}], ",", 
       "\[IndentingNewLine]", " ", 
       RowBox[{
        RowBox[{"n1", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
       RowBox[{
        RowBox[{"nca", "[", "0", "]"}], "\[Equal]", "initca"}], ",", 
       RowBox[{
        RowBox[{"p2", "[", "0", "]"}], "\[Equal]", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"n1", ",", "nca", ",", "p2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0.0", ",", ".2"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"n1", "[", "t", "]"}], "/.", "sfast"}], "]"}], ",", 
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"nca", "[", "t", "]"}], "/.", "sfast"}], "]"}], ",", 
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"p2", "[", "t", "]"}], "/.", 
       StyleBox["sfast",
        FontWeight->"Plain"]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", ".2"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "300"}], "}"}]}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{"Orange", ",", "Green", ",", "Blue"}], "}"}]}], ",", 
   RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"plotofn1Fast300", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"n1", "[", "t", "]"}], "/.", "sfast"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", "Red", "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"plotofncaFast300", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"nca", "[", "t", "]"}], "/.", "sfast"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "320"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", "Red", "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"plotofp2Fast300", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"p2", "[", "t", "]"}], "/.", "sfast"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", "Red", "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.8154954466784477`*^9, 3.81549546339727*^9}, 
   3.815753817031386*^9, {3.815753869238617*^9, 3.815753878614464*^9}, 
   3.815754800592188*^9, 3.8157567447246933`*^9, {3.815756824162347*^9, 
   3.815756833393868*^9}, 3.815759270201292*^9, {3.815759417659731*^9, 
   3.815759418957642*^9}, {3.815759459067713*^9, 3.815759466570953*^9}, {
   3.8157614900569677`*^9, 3.815761511594452*^9}, {3.815762317827971*^9, 
   3.815762318387146*^9}},ExpressionUUID->"af44b988-93a1-4044-8aad-\
3dc723ba5bd4"],

Cell[BoxData["300"], "Output",
 CellChangeTimes->{
  3.815495469174765*^9, 3.8157443597554893`*^9, 3.81575385430024*^9, 
   3.815753887260633*^9, 3.815754180838479*^9, 3.8157548033066*^9, 
   3.815756754384927*^9, 3.815756834268799*^9, {3.815759423180813*^9, 
   3.815759427159539*^9}, 3.815759467218947*^9, {3.8157614778208513`*^9, 
   3.815761513169115*^9}, 3.8157618961336117`*^9, 3.8157623188154297`*^9, 
   3.815824968728059*^9, 3.815825370116317*^9, 
   3.815846784462534*^9},ExpressionUUID->"f43d9180-2989-49f6-8dfe-\
d3a160eeafcc"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0.5, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtlnc0FozjxRWV8GZERlKZ9doKIa69Z8hMMotEGSFllBUiKyR7RMmej/GY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       "]]},
     Annotation[#, "Charting`Private`Tag$47149#1"]& ], 
    TagBox[
     {RGBColor[0, 1, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtVnk01Yv3RZGhUIaMZU5l6lWm+OxrlgzJlELKVIQrkldKZgoJiZJkHpLx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       "]]},
     Annotation[#, "Charting`Private`Tag$47149#2"]& ], 
    TagBox[
     {RGBColor[0, 0, 1], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwd1Xc8Vf8fB3CjUPqiQpEdiqxkVMY7o5TVT5Qkq2TLSEVKXSKFKEJ1jayM
7M3Ftcsqe1+5RrKuikqh3+fjr/N4Ph6fcz7n8zrv9/sIX3E7d42Bjo5Onp6O
Dl91r810kr+eV1e/xaDIXSqivkWL132MRwH+J22QbkssgiMJscRCHm3YR3B+
Xr3/PUzyiRJuixsCwbdH/YlVJ+i19xfE8ZjA33GVW1xCvSAayp/6T9AMGNVr
hM6R+2FN92qMjbglvGVykaPGDsLsw54Gm2gb4AysifP7MgSmtr+qnvPYgomQ
59WtfcPQoMVbWk+0A84G0aN/H4yA3H61vGVBRzDXLdRlWhsBIoN1hliyMywk
fPQaNhkFFqp/0gXx6/Dz2pGT+1+MQsXnrvZ6E3dgev/jYmX9KLj/z1b3crQH
7HNwKg+dGgVx8krTcr8nZIZNdAlsjMKo7COtMB4vAGMJ6XV2CkQl7CWLmd8E
Zj7z3g0+CuiyZ6pWE2/BobMl497iFKC7r1J+gXIbumRnE69IU6BksU2RJugD
JvWmQW7yFHCxtCx4ZHMHMrXuDQkrUUCkgyYjlOwLJ5QNVQeOUmBAjZBVNnkX
hEgXHfqPU+Bp9q6DRuJ+QFJpOWukSoGT/CkpX+3vw7zvBxUnNQr4Nb3iqDV5
AJ9SpUNU1Slg5jdhGLbyAOQ+MjsMIysoSYWZRRPghPZKjQlQgH3Rq1VM2R9I
u2MLCpBnU6u2fe/3B2o/y+s15EYLptPV3gFQf9+vW/kEBRK5zgY94XkI6tUH
wAHZtz2m4ULFQ9jN8a4gAvlC4GeG/eaBkN/7TrUQ+bCahAbtbyDktFIvdyLv
WPG4X0kMAnGDMMl55C/vKqoeqT2CUyOXPbZoUKDOlnHNmIJMN9fIi+zdE+U9
L/gYqB/SpLWQjUNHS8rIj2G7c0fLeWQZbfGVhzZPoH73xRh75MnCUg/+5BBQ
3BhVfIxsFDnkZCj+FEwS6tybkKX09mfwNj+FBI6Jih5kFkaXL9P24WB0SDKD
imxVvpFfYxIBi9kW/uvIXBIRMhejn0G1W6yvrCYFGAKLDKqnn0F8t6yGCvLS
5wEXUeXnoG5PIZ9Cbo0Vzlrqfw6pdwJWLiMTWAoPPOaJAnG1WesgZEmdZ8EF
7lHAfT5yOQK5K9Dt63BzFBwOqtN+jSzKKJUlc+sFRNp6CuciN62nyPR0RUOS
0sDvbmQ31YDwdYkYsHvWEjeCvNfXZkmcEANJE2msU8iOv/kLfGRjYWghRGcF
ecePaEXB0JeQWhhmu1uLAsWHb0afnngJ6W7ON3mRLd2Nf3kcfwWejKfNhJFz
F9jLG2ZewZFQz3gZ5HMzwapOJ4mQyX9KVQf5r7h9XCSRCCaljIwGyCnXTm6Q
fhBhg+NPyjnkFSo9mT0pDmo+i/lZIMeO3tEq3oiHwMmZOA9kDT6zFMr5BPBq
/nDhFvLsJeWtLNkJMDxO/HYHWWDe52q2dCKM2jJ9CkB2c1QSoxtJhGrqiFYU
ckNwam8U8xswWz4sFIu8N50zSOLIG9jzenniNTJ5+vv0uSdvQHHqsGgy8i7b
3PTUo0lgpkCKyUO2CxAwO26bBN9522oKkSuTwrZ9DE8CZVJzdwmy7biz0+/p
JMjbe7eWhPOyPCil9yIZ9piy1TYjb/eLGRkjJ8M/wabzLTi/OKYwr/lk+C+K
c6gNmWlkciFOKwVqx7cXdiJfNHuTu/QtBULkdfOHkGnDJtuTeFNB7qtk5ghy
kCXLNWOtVHjFbRRDQS686sZbEpUKFKOQs1Rktutqgb7KaZDSP6H+FTl1aWlM
yjoNpB10xmeRVW+kHKcEp4GR9bLPPLKTN+vSiaE0UPH5L5yG3Og/eInp3lsI
4DU0XEG+vDWsuDT1Ldjt2JrxE/n7oxMcjh1vIWcl9+8vZKGwt42tgunQWJL4
+A/y3Zibcs/q0sH+4bj+P+TdvBIhmnPp8MZK2YVOmwKZxJGpH7szQEWS+pAe
uf+N1usL1zLggFFPEiOy/LudTHwsmeBbp/OCGfmDTKN1u1wmnH7rGMCCbJ3v
Xelnlgnf5re4bEMOKxlzH89E6y0kpFmRZ8jZw2kGWaCe/dKTDfm+lo3SxVtZ
sLBvRZkdmbuJ89m2hCzwIJB+Y2u1+p5yWcqCqfFVl53I8b1n8g9HvoP2TKb9
nMiKF9dZJyrfwXRbTBN221CeXdTkO+Dus7DjQl4d28P3SzEbjsR+fsWNbDI7
FUQayIbaFZ6hvchzLi/HXelzwPBApg0Psj9NX1VQMgdEH3BNY+ctF34j+OZA
sELzFC8y6z/CZR2BXPDPf1THhxzraGopdSoXBEKK5fiRRXukrHdezwXOXBsi
tnpG/9Xhqlw4/tzNRQC5PCO6uFQmD1qfTi0JItNZEZQyNfOAwfGpvhDyKU6X
UuKFPBC9KZyG3e2nUU7wywPOx4rGwsgLxvMkvY48SGy1ihZBVtjWr6ZOzQOT
jUQq9p3q2mq5n3mQ81lMej8ys0QMmUsgH55FiFRhC29oNIy55sO7pD8fRJEd
CqVOdhHy4ep5x21iyDkOe5oaXuQD5Z6dDrZK93xzRhW6f16mBvt8ekzrjf8K
4MhMX7w4MtHCX99OuADEeInd2NRdru0XFQsgQlOG+QCy2z3Nj2oWBUBH7nHC
fnxuoYs5uwA2Dk+KHkT+xDxg/IdcAINTLf/D5q6q65nvKYA/LAW+2MkHYvs6
1wrgQFVsB3bVmubQa/1CWAu74iiBvKVA2vypdSHUm82EYeva7x154FUIbOEv
87H7OxdGrxELocL52U/sb2mx47LzhZD33PS2JPLRywFXROiKQJap4gW2387r
E5ycRUBtcC7EZr2rNbWqUgQ8K23z2GJGizP1IUUwGrZoegiZ977Ocfs3RRAR
Y3wDmyM7MWR7aRHk6Ox4iv2HxVjGiFoEO64H12J/IpfeoBwtBv4lHmEp5MZF
jkaCYTGMuj9Rxq7gc+IWsy0GbydXA+xUb75y5/BiWIXY29h35Agbv6eKoVd/
rBHbzXLoLPFvMdAHnBjAtg1Fw3NnCSjmSs9in52Z0gpSLYE5vdId0rg+E3Uf
744sgeN6vfrYPB3JQyXpJUATmjDHZltbO3SpugROzj5zwl41ze1I/FoCr+aG
g7A72Dk5ZU6UwuKoVSV2vZrrtc7zpeDhWtSMXebcVOLlXAoOZyq7sZObvc0q
o0tBQOPLLLb3/dH40wulQM86xyWD7JqttDTHUAZvYrYIYV8ZDtcI31sGOT4U
CWwDZc3JXq0yOOM6qIotQkuTuPqqDMQ9uayx9/DT+TLllUG5obkD9g49s7aM
xjLw2nBxx/6Vxuq2tFQGUT9/38dus3QvuqdTDq81eonYdaEftgpblMMiHTEZ
u7RCxLTBsxxy/ylnYidx965ujy+HrvUfJdi3O45B7HI5HGmO6cBmkyme+sBS
AT/Wm7qxU8LkQv/yVcCxyv4B7E79A4OWJyvgrG8iFftQK+cNsegKuLZ1fHlz
f8kIHtPMCthTILOKffEJKzm4ugLcd11dxw48w/Df/HQFHLD33yqLPNZMSytQ
roTS+gxO7FsHnA0m9Sph2kp1L/aOR9M/uKwrgX2mfB/2sVOjJ3yCK6Hw3W0R
7MiGliEYrAQ9ZVZZbEnRUwSPhUrgtmKQxyYH1B5IpidB6q4ZBewFzTIvJkkS
nE59cBxbpzaVrf0OCRbgmza21wOiuVwyCRJ4Pp7BfgOR6ZGtJMg/5WWI/bfq
geYlvirIFxM0xT5473Z4lXYV+PlImGOfV70+IuRaBa9Nt1hh51aY3/pSVQXj
1op22CM+5+p1p6uA9324I/a2Y2c4ctiqwUSg3gX7aqlSppdVNajVVXpiVymK
aqvkVUMYQcobe0/RTgo9fQ1scRa+hy3FVV4ecrEG6Pro/bE1b1m/4MqrgV/6
TkHY7+YCyj4ykmGPk90TbCWiaVqULBmK3tI9xa7VPxRlZk4GdWvNZ9j66xsE
gUdkeMmpEIXdl93lNlFAhim/0WhsG8s0i3QKWh928uXm96oxOCavVAuSPo5x
2KFCK5yksFr4M9GauJkfgbh0cqoWxpkjkrFLqFptH1XroPZXVyo2KW3pRlRU
PdRHmWdh1znF7TObb4DDv0eyN/M67crFKN0E7PA9B3tFXI0927UZ2uNv5WKv
hS+z2354D3pW5ZtmWM3i2CfWAhWX+jfNdzfoaqljK3SmTm9a6Z91iXFOG+z/
t7pp+jpdzbD5dig/IZSH3fZQoaNJ8iOIFTlsWvOrfx6T5icYcqNtWjBibjVj
8ROIqtXnY29tuDZfE94Ji1pjBdhzv8YovXJdoJhkWYR9+lu7iedYF6zeelCC
nTJb2cL2tBvahNTKsQcDDo/6HOsBztpoEjYb/1va5GQPhNzMImMbaMlk1T3s
hZQx+cbNfB2L7RJF+8Ar6G4Ltt2YfNA53z74o5Lfjq1xPi91S1cfBP4S69w8
f6t0Y8nBfpAWH+3B/nkia9Lhfj9sUxwcwL5wL/+iyad+EI3pHMEuLi9tA+EB
sOHYPr7ZD/INRdz1A+AkpTW7ma9mCvvi4gCkGn+fxw43eujUyDsIP01LaNiZ
7tpCXp6DIHjMb2Wzv3MaQjqFh8BLnJtBDs/DtKawEf0hUOW8thV7Ou59+Jfb
Q2Ac3MKCvRDaFrnePgR3jgyxY/916nktcWcYaFOcgti1jbynjZKGwYV7SAT7
kZDNsnfLMEguFolj7+5b0H/POwIaT97JYB/SYN6wqxyBIYVMwNZJErbP34Pq
IPGlI/ZtfiuR8ctj0Dl+NwZbav48a7/BZ+hd02ndfB77EkvDn88wap/Cehj/
n2te5+4njoO36+RZbGeFysFtelSIW7RMxs46cyWx+icVLnkG/8NemePlmI6e
gMdrwlbyOF9jHcYo7UlIeDzRiX3/dGBC0fQkfFD+pnMEWXhUdyA5cAp2Jds3
YR9XfhjFIz8NHtPylxWQLwt8XKXvnobUPO1l7JWWMKo74QvEPxV4q4gcu8XS
65zoDByR6TBXwu9PKU5iaJiBYueTvMq4Xu8RTI55fAUe8Qu/sekyLHOpu2Yh
sv9N31Fkz1e5YbvqZqEPCAPH8Pw5FMyy8/ocBPp7fjmOvFPXU8qfbR4yydHL
Krg/pT91+5DmQU/us6Qacl48iE5aLkB/i5OlOrJFrtJO/o0FiBIViwPkB4Fv
CCOZixDq3rpdAzl7hv81mz4NvOj239BEDo4LtKYY0kCzNtoH2/bcgliOEQ1K
11gfYPORSHkGpjQQn/wTiv0k3Lwp9AoNzdXZNGwHpZfftvvQIH6aYxhb5CHn
aeY0Gsiu+GprIW8cvftffzoN3lsI6mEPLkx0pWWh/U81GGFHmBZanMqnwd3Y
XVbY/yTP3Qgk0SBSu9YHe6QzPJ6xmwaGVLtc7LKgX1e7e9H+ViIl2FEqVhLJ
AzQ4ZD1GwtZLlSnSpNCg5qtFC3aFd/sHwlcaaIi5TmFHSyuGG83TIKJKYR7b
g0o0EabRgGFo/Tv2QX2XMfIyDVoToui0cf3R96RE/KLBkzNXmLE/F6s4Wf+h
wS7vw2zYJKdkWbl1Gjw9xMCFHSPIuvLvHw0UbHv2Yf8fn6s1Eg==
       "]]},
     Annotation[#, "Charting`Private`Tag$47149#3"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.2}, {0, 300}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.815495469174765*^9, 3.8157443597554893`*^9, 3.81575385430024*^9, 
   3.815753887260633*^9, 3.815754180838479*^9, 3.8157548033066*^9, 
   3.815756754384927*^9, 3.815756834268799*^9, {3.815759423180813*^9, 
   3.815759427159539*^9}, 3.815759467218947*^9, {3.8157614778208513`*^9, 
   3.815761513169115*^9}, 3.8157618961336117`*^9, 3.8157623188154297`*^9, 
   3.815824968728059*^9, 3.815825370116317*^9, 
   3.815846784535397*^9},ExpressionUUID->"0b92ff68-20a2-4a02-9f0e-\
4938670571a9"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtlnc0FozjxRWV8GZERlKZ9doKIa69Z8hMMotEGSFllBUiKyR7RMmej/GY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       "]]},
     Annotation[#, "Charting`Private`Tag$47193#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.2}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.815495469174765*^9, 3.8157443597554893`*^9, 3.81575385430024*^9, 
   3.815753887260633*^9, 3.815754180838479*^9, 3.8157548033066*^9, 
   3.815756754384927*^9, 3.815756834268799*^9, {3.815759423180813*^9, 
   3.815759427159539*^9}, 3.815759467218947*^9, {3.8157614778208513`*^9, 
   3.815761513169115*^9}, 3.8157618961336117`*^9, 3.8157623188154297`*^9, 
   3.815824968728059*^9, 3.815825370116317*^9, 
   3.8158467845810423`*^9},ExpressionUUID->"4ed93a92-fdeb-4b0b-a4dd-\
ab58658ef053"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtVnk01Yv3RZGhUIaMZU5l6lWm+OxrlgzJlELKVIQrkldKZgoJiZJkHpLx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       "]]},
     Annotation[#, "Charting`Private`Tag$47235#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.2}, {0, 320}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.815495469174765*^9, 3.8157443597554893`*^9, 3.81575385430024*^9, 
   3.815753887260633*^9, 3.815754180838479*^9, 3.8157548033066*^9, 
   3.815756754384927*^9, 3.815756834268799*^9, {3.815759423180813*^9, 
   3.815759427159539*^9}, 3.815759467218947*^9, {3.8157614778208513`*^9, 
   3.815761513169115*^9}, 3.8157618961336117`*^9, 3.8157623188154297`*^9, 
   3.815824968728059*^9, 3.815825370116317*^9, 
   3.815846784626445*^9},ExpressionUUID->"63ba463a-8992-4c1d-a551-\
b7fd64b6d6ac"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwd1Xc8Vf8fB3CjUPqiQpEdiqxkVMY7o5TVT5Qkq2TLSEVKXSKFKEJ1jayM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       "]]},
     Annotation[#, "Charting`Private`Tag$47277#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.2}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.815495469174765*^9, 3.8157443597554893`*^9, 3.81575385430024*^9, 
   3.815753887260633*^9, 3.815754180838479*^9, 3.8157548033066*^9, 
   3.815756754384927*^9, 3.815756834268799*^9, {3.815759423180813*^9, 
   3.815759427159539*^9}, 3.815759467218947*^9, {3.8157614778208513`*^9, 
   3.815761513169115*^9}, 3.8157618961336117`*^9, 3.8157623188154297`*^9, 
   3.815824968728059*^9, 3.815825370116317*^9, 
   3.815846784668518*^9},ExpressionUUID->"a074d187-56a3-42ca-914f-\
fce9091cb0e9"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"n1new300fast", "[", "y_", "]"}], ":=", 
  RowBox[{
   RowBox[{"n1", "[", "y", "]"}], "/.", "sfast"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ncanew300fast", "[", "y_", "]"}], ":=", 
  RowBox[{
   RowBox[{"nca", "[", "y", "]"}], "/.", "sfast"}]}], "\n", 
 RowBox[{
  RowBox[{"p2new300fast", "[", "y_", "]"}], ":=", " ", 
  RowBox[{
   RowBox[{"p2", "[", "y", "]"}], "/.", "sfast"}]}]}], "Input",
 CellChangeTimes->{
  3.815753917669983*^9, {3.815756776400749*^9, 
   3.815756783007972*^9}},ExpressionUUID->"fdfa7f0a-f122-412f-897a-\
55ec00362352"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"N", "[", 
   RowBox[{"p2new300fast", "[", "0.1", "]"}], "]"}], 
  " "}], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{
   RowBox[{"This", " ", "is", " ", "p2", " ", "at", " ", "Infnty", " ", 
    RowBox[{"(", 
     RowBox[{"Infnty", " ", "is", " ", "0.1", " ", "here"}], " ", ")"}]}], 
   " ", ";"}], "Text"], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.8157447298466263`*^9, 3.815744783137251*^9}, {
   3.815753924421751*^9, 3.8157539320382347`*^9}, {3.815756802336828*^9, 
   3.8157568072162323`*^9}, 3.8157568524010344`*^9, {3.815756967842266*^9, 
   3.8157569682260427`*^9}, {3.815757548615101*^9, 3.815757565352697*^9}, {
   3.815759576875471*^9, 
   3.8157595785390253`*^9}},ExpressionUUID->"7e9093f8-8b25-46db-9b52-\
6679a91bdc68"],

Cell[BoxData[
 RowBox[{"{", "0.472911527077481`", "}"}]], "Output",
 CellChangeTimes->{{3.815744763082663*^9, 3.815744783644308*^9}, 
   3.815753932842183*^9, 3.81575418103263*^9, {3.81575755213589*^9, 
   3.8157575663900146`*^9}, 3.815761520786273*^9, 3.815761896323412*^9, 
   3.815762323723357*^9, 3.8158249825858517`*^9, 3.815825370641006*^9, 
   3.815846784701415*^9},ExpressionUUID->"d6e0a4ed-2543-463c-b10c-\
8d146377a228"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Ingdtgralinexpo300fast", "[", "ti_", "]"}], ":=", 
  RowBox[{
   RowBox[{"-", "\[Lambda]"}], " ", "*", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"n1new300fast", "[", "tti", "]"}], "*", 
      RowBox[{"ncanew300fast", "[", "tti", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"tti", ",", "0", ",", "ti"}], "}"}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IngdtgralinexpoInf300fast", "[", "ti_", "]"}], ":=", 
   RowBox[{"\[Lambda]", " ", "*", 
    RowBox[{"NIntegrate", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"n1new300fast", "[", "tti", "]"}], "*", 
       RowBox[{"ncanew300fast", "[", "tti", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"tti", ",", "ti", ",", "0.1"}], "}"}]}], "]"}]}]}], ";", 
  "            ", 
  StyleBox[
   RowBox[{"(", 
    RowBox[{"Infnty", " ", "is", " ", "0.1", " ", "here"}], " ", ")"}], 
   "Text"], 
  StyleBox[" ", "Text"], 
  StyleBox[";", "Text"]}], "\[IndentingNewLine]", 
 RowBox[{"DiscretePlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"IngdtgralinexpoInf300fast", "[", "hh", "]"}], "*", 
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{"Ingdtgralinexpo300fast", "[", "hh", "]"}], "]"}], "/", 
     RowBox[{"N", "[", 
      RowBox[{"p2new300fast", "[", ".1", "]"}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"hh", ",", "0", ",", ".008", ",", ".001"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0.009"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1.6"}], "}"}]}], "}"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.8154954076212807`*^9, 3.815495421753167*^9}, {
   3.815744277036044*^9, 3.815744327422968*^9}, 3.815744397339501*^9, 
   3.815744439484407*^9, {3.8157444802535973`*^9, 3.815744493932539*^9}, {
   3.815744540959334*^9, 3.815744549886273*^9}, {3.815744787552516*^9, 
   3.815744796833095*^9}, {3.81574487376235*^9, 3.81574487846521*^9}, {
   3.815753945429372*^9, 3.815754022757749*^9}, {3.815757987628726*^9, 
   3.815758017291955*^9}, {3.815758645555209*^9, 3.815758646001885*^9}, {
   3.815758760291101*^9, 3.815758762258614*^9}, {3.8157588083882*^9, 
   3.815758810915347*^9}, {3.8157589287420073`*^9, 3.815758934677033*^9}, {
   3.815759119303996*^9, 3.815759123222238*^9}, {3.815759581228259*^9, 
   3.8157595814667873`*^9}, {3.81576155484344*^9, 3.81576155524305*^9}, {
   3.815762211473843*^9, 3.815762235617611*^9}, 
   3.815824998573935*^9},ExpressionUUID->"670bfddc-7e70-44f1-a2e3-\
ce2921a27a22"],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.012833333333333334`], 
    AbsoluteThickness[1.6], {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.012833333333333334`], AbsoluteThickness[1.6], Opacity[0.2], LineBox[{},
       VertexColors->None]}, 
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.012833333333333334`], AbsoluteThickness[1.6], Opacity[0.2], 
      LineBox[{{{0., 1.3541367138200207`}, {0., 0}}, {{0.001, 
         0.4505649435339748}, {0.001, 0}}, {{0.002, 0.13723248466460145`}, {
         0.002, 0}}, {{0.003, 0.046305036796314474`}, {0.003, 0}}, {{0.004, 
         0.01648443005104598}, {0.004, 0}}, {{0.005, 0.006187997533442298}, {
         0.005, 0}}, {{0.006, 0.0025532074437722018`}, {0.006, 0}}, {{0.007, 
         0.001246205971485643}, {0.007, 0}}, {{0.008, 
         0.0007600233889913091}, {0.008, 0}}},
       VertexColors->None]}}}, 
   {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.012833333333333334`], 
    AbsoluteThickness[1.6], {}, 
    PointBox[{{0., 1.3541367138200207`}, {0.001, 0.4505649435339748}, {0.002, 
     0.13723248466460145`}, {0.003, 0.046305036796314474`}, {0.004, 
     0.01648443005104598}, {0.005, 0.006187997533442298}, {0.006, 
     0.0025532074437722018`}, {0.007, 0.001246205971485643}, {0.008, 
     0.0007600233889913091}}], {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{
   "MessagesHead" -> DiscretePlot, "AxisPadding" -> Scaled[0.02], 
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "DefaultPlotStyle" -> {
      Directive[
       RGBColor[0.368417, 0.506779, 0.709798], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.880722, 0.611041, 0.142051], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.560181, 0.691569, 0.194885], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.922526, 0.385626, 0.209179], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.528488, 0.470624, 0.701351], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.772079, 0.431554, 0.102387], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.363898, 0.618501, 0.782349], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[1, 0.75, 0], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.647624, 0.37816, 0.614037], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.571589, 0.586483, 0.], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.915, 0.3325, 0.2125], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.40082222609352647`, 0.5220066643438841, 0.85], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.9728288904374106, 0.621644452187053, 0.07336199581899142], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.736782672705901, 0.358, 0.5030266573755369], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.28026441037696703`, 0.715, 0.4292089322474965], 
       AbsoluteThickness[1.6]]}, "DomainPadding" -> Scaled[0.02], 
    "PointSizeFunction" -> "SmallPointSize", "RangePadding" -> Scaled[0.05]},
  PlotRange->{{0, 0.009}, {0, 1.6}},
  PlotRangePadding->{{Automatic, Automatic}, {Automatic, Automatic}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8154954820435143`*^9, 3.8157444065896053`*^9, {3.815744448043006*^9, 
   3.815744495050384*^9}, 3.815744805396113*^9, 3.815753556744033*^9, 
   3.8157539947624474`*^9, 3.815754062608033*^9, 3.8157541886938334`*^9, 
   3.8157580481458893`*^9, 3.815758769624716*^9, 3.815758816133396*^9, 
   3.815758946610743*^9, 3.8157591257553883`*^9, {3.81576152858003*^9, 
   3.815761557381792*^9}, 3.815761897676449*^9, 3.815762238689086*^9, 
   3.815762326975909*^9, 3.8158250090080957`*^9, 3.815825372069837*^9, 
   3.8158467860927553`*^9},ExpressionUUID->"86083cad-856c-4e5f-825a-\
f1fa9628b7dd"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals300fastvals", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"IngdtgralinexpoInf300fast", "[", "hh", "]"}], "*", 
      RowBox[{"Exp", "[", 
       RowBox[{"Ingdtgralinexpo300fast", "[", "hh", "]"}], "]"}]}], " ", ",", 
     
     RowBox[{"{", 
      RowBox[{"hh", ",", "0", ",", ".006", ",", ".0001"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.815744559758568*^9, 3.815744582814271*^9}, {
   3.81574484168108*^9, 3.815744862576949*^9}, {3.8157449206256332`*^9, 
   3.815744924337483*^9}, 3.8157450223386*^9, {3.815745082130978*^9, 
   3.8157451059714413`*^9}, {3.8157540340390472`*^9, 
   3.8157540685826473`*^9}, {3.8157589096528482`*^9, 3.815758941509307*^9}, {
   3.815758982389289*^9, 3.815758994180831*^9}, {3.815761540010294*^9, 
   3.815761563659485*^9}, 
   3.8158250212936573`*^9},ExpressionUUID->"703b7f27-4707-4d5e-b778-\
63f2ca2cf53d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals300fastfunc", " ", "=", " ", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals300fastvals", ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0", ",", ".006"}], "}"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.8157448877074747`*^9, 3.81574494238554*^9}, {
   3.815744977714079*^9, 3.815744981746171*^9}, {3.815753276799062*^9, 
   3.8157532907833557`*^9}, 3.8157535414894238`*^9, {3.8157540463262253`*^9, 
   3.815754049670093*^9}, {3.8157589544854727`*^9, 3.815758962581257*^9}, {
   3.8157590026614857`*^9, 3.815759013237715*^9}, 3.8157590482938213`*^9, {
   3.8157620399951973`*^9, 3.8157620424473743`*^9}, 
   3.815825044893701*^9},ExpressionUUID->"786af418-e090-4277-bf6c-\
9557d35cb45f"],

Cell[BoxData[
 TagBox[
  TemplateBox[{RowBox[{
      StyleBox[
       TagBox["InterpolatingFunction", "SummaryHead"], 
       "NonInterpretableSummary"], 
      StyleBox["[", "NonInterpretableSummary"], 
      DynamicModuleBox[{Typeset`open$$ = False}, 
       PanelBox[
        PaneSelectorBox[{False -> GridBox[{{
              PaneBox[
               ButtonBox[
                DynamicBox[
                 FEPrivate`FrontEndResource[
                 "FEBitmaps", "SquarePlusIconMedium"]], 
                ButtonFunction :> (Typeset`open$$ = True), Appearance -> None,
                 Evaluator -> Automatic, Method -> "Preemptive"], 
               Alignment -> {Center, Center}, ImageSize -> 
               Dynamic[{
                 Automatic, 3.5 CurrentValue["FontCapHeight"]/
                  AbsoluteCurrentValue[Magnification]}]], 
              GraphicsBox[{{{{}, {}, 
                  TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwVxXk0GwYAB+A4X7WmtNrNWh192romNd1zZX4lLR4zR2RhlIijjgaJJO44
q44pGuroLFhLi6Lua61mQ4t5D0+mVZTEbIynLXNMZ9sf3/u0GRFugbIEAoH0
n/+/1DnerbMx/UVgYl2hMl+KEO6pss0fNNASOUL3EEuwoSUSynfqo9xhd6yL
tICSlOLO0y9McOXyEcIT1mvYqotYDz+3wHWt2OvVtBmM3xhU0bp5EfYW0N/o
eYHkdG+d6AEyGkndLTKPxMhoszEZJ9uB3hBnTRyYgPsWI3ShyQFrJRllOnZj
0O409iNInOAzmyYe44/irvi+rtpDF8Tw+wnPa4fQrppP0HN0Qynxj42w/EEY
UgqvnZinQOhA+/3bpZ8xSrSezCulgquQdSzMX4R1x37NnAs0lMreIcjR+mAl
+5Zx4K0H/hYcbBSO9GK9z5JEr/kGcWS2k0tcF7SfeG9awRtlLrxZztN2JNHO
1gl3rsD3RGvgV7qt8CYOXrxx2xclus4XWArNaHHJDNmupaMp8pVBwWYjlnN7
Esoy/ECPiqvyDK/H69CX+0kUBnRaLp28k/YAq4VOKdXG/kgOjiWHtlWjy6ee
rSoTgHu1E1MUxl101Gs0XB0JQBtNZdnMswrDdtNL+/cDQe5/9ybWrwLC1MyC
aV4Q0g26F5USy5F1MNt8m3oVikwjW1dKGe4dLzOQNQ6GF+/Vodj8YqSIinKd
3wfjU5K68rxNEaJ6FldnXobgyF6C/raiAGfctR83PghF23qmNEOvAEqssKlw
Thh+qZLbcVDKg9y00ptwl2vYUZnjWopz8KNUENusyYRzpb/Jeb0s5FqyCaZ7
TOz+9G42PS8DJz8jbf0zHA5Jn+jYLUY6ZurVzVqLI0BvKzYc4KXCq7vCkmoR
iY9uf/J1R3Eyzq0ZHmVXRmJDRebwc2U++PaSEKIaC1XLTr+ZEeKxJq0IlPBZ
IM08Hal3i4GVq7uG+SILtdYrCv1HedCQGn9JdGdjzmtJJ0MShQlbBdPBHjYi
fNUi2j9go3plboCqHYVfa1WntpiRkO+QTqbnRaFXNKR5vIkJG7e576h/RcE+
zcu0VzEMh9TlJQOBHMw2VOl0hQdj9cPzo0YTHCwF7LLizwahccWVZWbORXB1
TsozywDsLZYLFmq4uFVXSW3yZkCvaY5pdJgHTqmhjMcQHfMVjoMfJ/HAzRZ8
n5jug+aJx/3v/+Qhmx9TRBz3gr/4XEIqJRrmldJJ2ZueEO53P6oRReNM13hQ
No2Gnm2yMFw/Bqcz+9i8eCqGucw2jiAGpw5IrOnPKPgXTeTB4g==
                    "]]},
                    Annotation[#, 
                    "Charting`Private`Tag$68259#1"]& ]}}, {}, {}}, {
               DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
                AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
                GridLines -> {None, None}, DisplayFunction -> Identity, 
                PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                All, DisplayFunction -> Identity, AspectRatio -> 1, 
                Axes -> {False, False}, AxesLabel -> {None, None}, 
                AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                Frame -> {{True, True}, {True, True}}, 
                FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                Directive[
                  Opacity[0.5], 
                  Thickness[Tiny], 
                  RGBColor[0.368417, 0.506779, 0.709798]], 
                FrameTicks -> {{None, None}, {None, None}}, 
                GridLines -> {None, None}, GridLinesStyle -> Directive[
                  GrayLevel[0.5, 0.4]], ImageSize -> 
                Dynamic[{
                  Automatic, 3.5 CurrentValue["FontCapHeight"]/
                   AbsoluteCurrentValue[Magnification]}], 
                Method -> {
                 "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                  AbsolutePointSize[6], "ScalingFunctions" -> None, 
                  "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                PlotRange -> {{0., 0.006}, {0., 0.6403868583401332}}, 
                PlotRangeClipping -> True, PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
              GridBox[{{
                 RowBox[{
                   TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox[
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "0.006`"}], "}"}], "}"}], 
                    "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"scalar\"", "SummaryItem"]}]}}, 
               GridBoxAlignment -> {
                "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
               False, GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {
                "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
               BaseStyle -> {
                ShowStringCharacters -> False, NumberMarks -> False, 
                 PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
            GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
            BaselinePosition -> {1, 1}], True -> GridBox[{{
              PaneBox[
               ButtonBox[
                DynamicBox[
                 FEPrivate`FrontEndResource[
                 "FEBitmaps", "SquareMinusIconMedium"]], 
                ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                None, Evaluator -> Automatic, Method -> "Preemptive"], 
               Alignment -> {Center, Center}, ImageSize -> 
               Dynamic[{
                 Automatic, 3.5 CurrentValue["FontCapHeight"]/
                  AbsoluteCurrentValue[Magnification]}]], 
              GraphicsBox[{{{{}, {}, 
                  TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwVxXk0GwYAB+A4X7WmtNrNWh192romNd1zZX4lLR4zR2RhlIijjgaJJO44
q44pGuroLFhLi6Lua61mQ4t5D0+mVZTEbIynLXNMZ9sf3/u0GRFugbIEAoH0
n/+/1DnerbMx/UVgYl2hMl+KEO6pss0fNNASOUL3EEuwoSUSynfqo9xhd6yL
tICSlOLO0y9McOXyEcIT1mvYqotYDz+3wHWt2OvVtBmM3xhU0bp5EfYW0N/o
eYHkdG+d6AEyGkndLTKPxMhoszEZJ9uB3hBnTRyYgPsWI3ShyQFrJRllOnZj
0O409iNInOAzmyYe44/irvi+rtpDF8Tw+wnPa4fQrppP0HN0Qynxj42w/EEY
UgqvnZinQOhA+/3bpZ8xSrSezCulgquQdSzMX4R1x37NnAs0lMreIcjR+mAl
+5Zx4K0H/hYcbBSO9GK9z5JEr/kGcWS2k0tcF7SfeG9awRtlLrxZztN2JNHO
1gl3rsD3RGvgV7qt8CYOXrxx2xclus4XWArNaHHJDNmupaMp8pVBwWYjlnN7
Esoy/ECPiqvyDK/H69CX+0kUBnRaLp28k/YAq4VOKdXG/kgOjiWHtlWjy6ee
rSoTgHu1E1MUxl101Gs0XB0JQBtNZdnMswrDdtNL+/cDQe5/9ybWrwLC1MyC
aV4Q0g26F5USy5F1MNt8m3oVikwjW1dKGe4dLzOQNQ6GF+/Vodj8YqSIinKd
3wfjU5K68rxNEaJ6FldnXobgyF6C/raiAGfctR83PghF23qmNEOvAEqssKlw
Thh+qZLbcVDKg9y00ptwl2vYUZnjWopz8KNUENusyYRzpb/Jeb0s5FqyCaZ7
TOz+9G42PS8DJz8jbf0zHA5Jn+jYLUY6ZurVzVqLI0BvKzYc4KXCq7vCkmoR
iY9uf/J1R3Eyzq0ZHmVXRmJDRebwc2U++PaSEKIaC1XLTr+ZEeKxJq0IlPBZ
IM08Hal3i4GVq7uG+SILtdYrCv1HedCQGn9JdGdjzmtJJ0MShQlbBdPBHjYi
fNUi2j9go3plboCqHYVfa1WntpiRkO+QTqbnRaFXNKR5vIkJG7e576h/RcE+
zcu0VzEMh9TlJQOBHMw2VOl0hQdj9cPzo0YTHCwF7LLizwahccWVZWbORXB1
TsozywDsLZYLFmq4uFVXSW3yZkCvaY5pdJgHTqmhjMcQHfMVjoMfJ/HAzRZ8
n5jug+aJx/3v/+Qhmx9TRBz3gr/4XEIqJRrmldJJ2ZueEO53P6oRReNM13hQ
No2Gnm2yMFw/Bqcz+9i8eCqGucw2jiAGpw5IrOnPKPgXTeTB4g==
                    "]]},
                    Annotation[#, 
                    "Charting`Private`Tag$68259#1"]& ]}}, {}, {}}, {
               DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
                AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
                GridLines -> {None, None}, DisplayFunction -> Identity, 
                PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                All, DisplayFunction -> Identity, AspectRatio -> 1, 
                Axes -> {False, False}, AxesLabel -> {None, None}, 
                AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                Frame -> {{True, True}, {True, True}}, 
                FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                Directive[
                  Opacity[0.5], 
                  Thickness[Tiny], 
                  RGBColor[0.368417, 0.506779, 0.709798]], 
                FrameTicks -> {{None, None}, {None, None}}, 
                GridLines -> {None, None}, GridLinesStyle -> Directive[
                  GrayLevel[0.5, 0.4]], ImageSize -> 
                Dynamic[{
                  Automatic, 3.5 CurrentValue["FontCapHeight"]/
                   AbsoluteCurrentValue[Magnification]}], 
                Method -> {
                 "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                  AbsolutePointSize[6], "ScalingFunctions" -> None, 
                  "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                PlotRange -> {{0., 0.006}, {0., 0.6403868583401332}}, 
                PlotRangeClipping -> True, PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
              GridBox[{{
                 RowBox[{
                   TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox[
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "0.006`"}], "}"}], "}"}], 
                    "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"scalar\"", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["3", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["False", "SummaryItem"]}]}}, 
               GridBoxAlignment -> {
                "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
               False, GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {
                "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
               BaseStyle -> {
                ShowStringCharacters -> False, NumberMarks -> False, 
                 PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
            GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
            BaselinePosition -> {1, 1}]}, 
         Dynamic[Typeset`open$$], ImageSize -> Automatic], BaselinePosition -> 
        Baseline], DynamicModuleValues :> {}], 
      StyleBox["]", "NonInterpretableSummary"]}]},
   "CopyTag",
   DisplayFunction->(#& ),
   InterpretationFunction->("InterpolatingFunction[{{0., 0.006}}, <>]"& )],
  False,
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{3.815753604548572*^9, 3.8157541110055447`*^9, 
  3.8157542243625793`*^9, 3.815758970658704*^9, 3.815759013968568*^9, 
  3.815759048621996*^9, 3.81576157316042*^9, 3.8157619052806787`*^9, 
  3.81576234375066*^9, 3.8158250464626837`*^9, 3.8158253815910063`*^9, 
  3.815846795449069*^9},ExpressionUUID->"385296b7-8d99-47d4-9562-\
7886cac6ed67"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tau2for300fast", "=", 
  RowBox[{
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
     "IngdtgralinexpoInfIngdtgralinexpovals300fastfunc", "[", "ww", "]"}], 
     ",", " ", 
     RowBox[{"{", 
      RowBox[{"ww", ",", "0.0", ",", ".005"}], "}"}]}], "]"}], "  ", "/", 
   RowBox[{"N", "[", 
    RowBox[{"p2new300fast", "[", ".1", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.815745024257978*^9, 3.8157450584986153`*^9}, {
   3.815753254031543*^9, 3.815753254670862*^9}, {3.815753587458639*^9, 
   3.815753615250682*^9}, {3.815753669810672*^9, 3.815753732499239*^9}, {
   3.8157541011909513`*^9, 3.815754118823043*^9}, {3.815759018357753*^9, 
   3.815759059271838*^9}, {3.815762045391664*^9, 3.815762045455379*^9}, 
   3.815825070206133*^9},ExpressionUUID->"50586490-d038-4212-a339-\
1f7c13659f48"],

Cell[BoxData[
 RowBox[{"{", "0.0012679111962683586`", "}"}]], "Output",
 CellChangeTimes->{{3.8157536885805893`*^9, 3.815753696462763*^9}, 
   3.8157537329431343`*^9, 3.8157541192042723`*^9, 3.815754224383259*^9, {
   3.815759052790461*^9, 3.815759060593623*^9}, 3.815761576342861*^9, 
   3.8157619053088207`*^9, 3.815762345212533*^9, 3.8158250711267147`*^9, 
   3.815825381674142*^9, 
   3.8158467954872*^9},ExpressionUUID->"05d2292e-7419-4916-823f-2786079d799e"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.815754291003084*^9, 
  3.815754291336782*^9}},ExpressionUUID->"02c84d93-e0c9-4662-b6eb-\
e1763752b1b7"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Mu]", "=", "38"}], ";", 
  RowBox[{"\[Lambda]", "=", "6"}], ";", 
  RowBox[{"NR", "=", "1"}], ";", 
  RowBox[{"\[Nu]", "=", "100"}], ";", " ", 
  RowBox[{"initca", "=", "100"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"s", "=", 
   RowBox[{"NDSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"n1", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Mu]"}], "*", 
          RowBox[{"n1", "[", "t", "]"}]}], "+", " ", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], " ", "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"2", "*", 
             RowBox[{"n1", "[", "t", "]"}]}]}], " ", ")"}]}]}]}], " ", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"nca", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Nu]"}], "*", 
          RowBox[{"nca", "[", "t", "]"}]}], " ", "-", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"n1", "[", "t", "]"}]}], ")"}]}], "+", 
         RowBox[{"\[Mu]", "*", 
          RowBox[{"n1", "[", "t", "]"}]}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"p2", "'"}], "[", "t", "]"}], "\[Equal]", " ", 
        RowBox[{"\[Lambda]", "*", 
         RowBox[{"n1", "[", "t", "]"}], "*", 
         RowBox[{"nca", "[", "t", "]"}], "*", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"p2", "[", "t", "]"}]}], ")"}]}]}], ",", 
       "\[IndentingNewLine]", " ", 
       RowBox[{
        RowBox[{"n1", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
       RowBox[{
        RowBox[{"nca", "[", "0", "]"}], "\[Equal]", "initca"}], ",", 
       RowBox[{
        RowBox[{"p2", "[", "0", "]"}], "\[Equal]", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"n1", ",", "nca", ",", "p2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0.0", ",", ".2"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"n1", "[", "t", "]"}], "/.", "s"}], "]"}], ",", 
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"nca", "[", "t", "]"}], "/.", "s"}], "]"}], ",", 
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"p2", "[", "t", "]"}], "/.", "s"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "100"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{"Orange", ",", "Green", ",", "Blue"}], "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"plotofn1Fast100NOPUMPS", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"n1", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", "Green", "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"plotofncaFast100NOPUMPS", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"nca", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "110"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", "Green", "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"plotofp2Fast100NOPUMPS", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"p2", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", "Green", "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.815754342443674*^9, 3.815754363897985*^9}, 
   3.8157547936640882`*^9, 3.815754854048726*^9, {3.8157593278533363`*^9, 
   3.8157593782342978`*^9}},ExpressionUUID->"5f2fa522-b712-487d-ba2a-\
1222db6afccd"],

Cell[BoxData["100"], "Output",
 CellChangeTimes->{
  3.8157543303787107`*^9, 3.8157543660284557`*^9, 3.8157548082007933`*^9, 
   3.815754855042717*^9, {3.815759331508915*^9, 3.815759379075883*^9}, 
   3.815761585426304*^9, 3.81576190533954*^9, 3.8157621525287313`*^9, 
   3.815762438868767*^9, 3.8158250846989098`*^9, 3.815825214101321*^9, 
   3.815825381757506*^9, 
   3.81584679552164*^9},ExpressionUUID->"d686ab39-dfeb-45e1-b3a1-\
08078d528753"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0.5, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtjHk0FIrDhlEJSRKKbCWqe22ViBtvyBLKNvaIxlJcjBJKJcqSrTC2GvtS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       "]]},
     Annotation[#, "Charting`Private`Tag$68349#1"]& ], 
    TagBox[
     {RGBColor[0, 1, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtVmc814/j1CRkZGQmWQ2EQqTubcvIDikRsisZlS0ZhQgZkey9x8fmY28a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       "]]},
     Annotation[#, "Charting`Private`Tag$68349#2"]& ], 
    TagBox[
     {RGBColor[0, 0, 1], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwd1nc41l8fB3C0iEeRhAgZUVYSKfqEKLNsIhoissmIZEeIskO2jGTvdZsN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       "]]},
     Annotation[#, "Charting`Private`Tag$68349#3"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.2}, {0, 100}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8157543303787107`*^9, 3.8157543660284557`*^9, 3.8157548082007933`*^9, 
   3.815754855042717*^9, {3.815759331508915*^9, 3.815759379075883*^9}, 
   3.815761585426304*^9, 3.81576190533954*^9, 3.8157621525287313`*^9, 
   3.815762438868767*^9, 3.8158250846989098`*^9, 3.815825214101321*^9, 
   3.815825381757506*^9, 
   3.815846795580037*^9},ExpressionUUID->"aae9b33c-eae0-43ae-b59f-\
dc075e1b12b0"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0, 1, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtjHk0FIrDhlEJSRKKbCWqe22ViBtvyBLKNvaIxlJcjBJKJcqSrTC2GvtS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       "]]},
     Annotation[#, "Charting`Private`Tag$68393#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.2}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8157543303787107`*^9, 3.8157543660284557`*^9, 3.8157548082007933`*^9, 
   3.815754855042717*^9, {3.815759331508915*^9, 3.815759379075883*^9}, 
   3.815761585426304*^9, 3.81576190533954*^9, 3.8157621525287313`*^9, 
   3.815762438868767*^9, 3.8158250846989098`*^9, 3.815825214101321*^9, 
   3.815825381757506*^9, 
   3.815846795625188*^9},ExpressionUUID->"cd00beb2-262f-4466-9156-\
e26f39421715"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0, 1, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtVmc814/j1CRkZGQmWQ2EQqTubcvIDikRsisZlS0ZhQgZkey9x8fmY28a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       "]]},
     Annotation[#, "Charting`Private`Tag$68435#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.2}, {0, 110}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8157543303787107`*^9, 3.8157543660284557`*^9, 3.8157548082007933`*^9, 
   3.815754855042717*^9, {3.815759331508915*^9, 3.815759379075883*^9}, 
   3.815761585426304*^9, 3.81576190533954*^9, 3.8157621525287313`*^9, 
   3.815762438868767*^9, 3.8158250846989098`*^9, 3.815825214101321*^9, 
   3.815825381757506*^9, 
   3.8158467956702433`*^9},ExpressionUUID->"4bfaf352-c37b-4e4f-bdda-\
4693e982225e"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0, 1, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwd1nc41l8fB3C0iEeRhAgZUVYSKfqEKLNsIhoissmIZEeIskO2jGTvdZsN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       "]]},
     Annotation[#, "Charting`Private`Tag$68477#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.2}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8157543303787107`*^9, 3.8157543660284557`*^9, 3.8157548082007933`*^9, 
   3.815754855042717*^9, {3.815759331508915*^9, 3.815759379075883*^9}, 
   3.815761585426304*^9, 3.81576190533954*^9, 3.8157621525287313`*^9, 
   3.815762438868767*^9, 3.8158250846989098`*^9, 3.815825214101321*^9, 
   3.815825381757506*^9, 
   3.815846795708972*^9},ExpressionUUID->"6f2a7a5b-1998-41c6-9517-\
b10cc9640a48"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"n1new100fastNOPUMPS", "[", "y_", "]"}], ":=", 
  RowBox[{
   RowBox[{"n1", "[", "y", "]"}], "/.", "s"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ncanew100fastNOPUMPS", "[", "y_", "]"}], ":=", 
  RowBox[{
   RowBox[{"nca", "[", "y", "]"}], "/.", "s"}]}], "\n", 
 RowBox[{
  RowBox[{"p2new100fastNOPUMPS", "[", "y_", "]"}], ":=", " ", 
  RowBox[{
   RowBox[{"p2", "[", "y", "]"}], "/.", "s"}]}]}], "Input",
 CellChangeTimes->{
  3.8157543166016607`*^9, {3.815759397545491*^9, 3.8157593984568157`*^9}, {
   3.815759506489458*^9, 
   3.81575954681077*^9}},ExpressionUUID->"d89d4ee7-d877-491b-9704-\
42a8be4c113e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"N", "[", 
   RowBox[{"p2new100fastNOPUMPS", "[", "0.2", "]"}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.815759483418754*^9, 3.81575948375366*^9}, {
   3.815759551722645*^9, 3.815759552877048*^9}, 
   3.815761595852792*^9},ExpressionUUID->"f85391d3-be09-415f-bd98-\
31cc1d86d371"],

Cell[BoxData[
 RowBox[{"{", "0.9126304991386015`", "}"}]], "Output",
 CellChangeTimes->{
  3.8157543911841087`*^9, 3.815759484664563*^9, 3.815759553892874*^9, {
   3.815761592325368*^9, 3.815761596024377*^9}, 3.815761905529744*^9, 
   3.815762155482038*^9, 3.81576244313313*^9, 3.815825100170404*^9, 
   3.81582538227801*^9, 
   3.815846795749837*^9},ExpressionUUID->"354204ec-9c1a-4eec-bffd-\
5e5a0c7b9644"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Ingdtgralinexpo100fastNOPUMPS", "[", "ti_", "]"}], ":=", 
  RowBox[{
   RowBox[{"-", "\[Lambda]"}], " ", "*", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"n1new100fastNOPUMPS", "[", "tti", "]"}], "*", 
      RowBox[{"ncanew100fastNOPUMPS", "[", "tti", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"tti", ",", "0", ",", "ti"}], "}"}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IngdtgralinexpoInf100fastNOPUMPS", "[", "ti_", "]"}], ":=", 
   RowBox[{"\[Lambda]", " ", "*", 
    RowBox[{"NIntegrate", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"n1new100fastNOPUMPS", "[", "tti", "]"}], "*", 
       RowBox[{"ncanew100fastNOPUMPS", "[", "tti", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"tti", ",", "ti", ",", "0.2"}], "}"}]}], "]"}]}]}], ";", 
  "            ", 
  StyleBox[
   RowBox[{"(", 
    RowBox[{"Infnty", " ", "is", " ", ".2", " ", "here"}], " ", ")"}], "Text"], 
  StyleBox[" ", "Text"], 
  StyleBox[";", "Text"]}], "\[IndentingNewLine]", 
 RowBox[{"DiscretePlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"IngdtgralinexpoInf100fastNOPUMPS", "[", "hh", "]"}], "*", 
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{"Ingdtgralinexpo100fastNOPUMPS", "[", "hh", "]"}], "]"}], "/", 
     RowBox[{"N", "[", 
      RowBox[{"p2new100fastNOPUMPS", "[", ".2", "]"}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"hh", ",", "0", ",", "0.04", ",", ".001"}], "}"}], ",", " ", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", ".04"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "2.7"}], "}"}]}], "}"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.815759610283414*^9, 3.8157596595314827`*^9}, {
   3.815759689820765*^9, 3.815759700510004*^9}, {3.815759732189041*^9, 
   3.8157597448616457`*^9}, 3.815761605916493*^9, {3.815762093599942*^9, 
   3.815762114544168*^9}, {3.815762166001727*^9, 
   3.815762174449771*^9}},ExpressionUUID->"dab21d13-6f14-4b4e-ab7e-\
61323c068fd1"],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.009166666666666668], 
    AbsoluteThickness[1.6], {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.009166666666666668],
       AbsoluteThickness[1.6], Opacity[0.2], LineBox[{},
       VertexColors->None]}, 
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.009166666666666668],
       AbsoluteThickness[1.6], Opacity[0.2], 
      LineBox[{{{0., 2.670969899823282}, {0., 0}}, {{0.001, 
         2.2729927091226485`}, {0.001, 0}}, {{0.002, 1.698483228614102}, {
         0.002, 0}}, {{0.003, 1.2447362235130803`}, {0.003, 0}}, {{0.004, 
         0.9197817671796459}, {0.004, 0}}, {{0.005, 0.6899919021599998}, {
         0.005, 0}}, {{0.006, 0.525992295913315}, {0.006, 0}}, {{0.007, 
         0.4071643718569101}, {0.007, 0}}, {{0.008, 0.3196575345753038}, {
         0.008, 0}}, {{0.009000000000000001, 0.2541897180042241}, {
         0.009000000000000001, 0}}, {{0.01, 0.20447606838911725`}, {
         0.01, 0}}, {{0.011, 0.1661999923116365}, {0.011, 0}}, {{0.012, 
         0.1363513520402586}, {0.012, 0}}, {{0.013000000000000001`, 
         0.11279933212938109`}, {0.013000000000000001`, 0}}, {{0.014, 
         0.09401371615225154}, {0.014, 0}}, {{0.015, 0.07888051572302492}, {
         0.015, 0}}, {{0.016, 0.06657825810350565}, {0.016, 0}}, {{0.017, 
         0.05649379327209543}, {0.017, 0}}, {{0.018000000000000002`, 
         0.048164212565812096`}, {0.018000000000000002`, 0}}, {{0.019, 
         0.041236253302599425`}, {0.019, 0}}, {{0.02, 
         0.035437573568129155`}, {0.02, 0}}, {{0.021, 
         0.030556188231855585`}, {0.021, 0}}, {{0.022, 
         0.026425583597642348`}, {0.022, 0}}, {{0.023, 0.02291382802729444}, {
         0.023, 0}}, {{0.024, 0.01991553071367509}, {0.024, 0}}, {{0.025, 
         0.01734584440053166}, {0.025, 0}}, {{0.026000000000000002`, 
         0.015135954468893565`}, {0.026000000000000002`, 0}}, {{0.027, 
         0.013229657113444088`}, {0.027, 0}}, {{0.028, 
         0.011580742859953254`}, {0.028, 0}}, {{0.029, 
         0.010150980933691009`}, {0.029, 0}}, {{0.03, 0.008908553267451328}, {
         0.03, 0}}, {{0.031, 0.007826832842111527}, {0.031, 0}}, {{0.032, 
         0.006883420920655557}, {0.032, 0}}, {{0.033, 0.006059384528637939}, {
         0.033, 0}}, {{0.034, 0.005338648611412242}, {0.034, 0}}, {{0.035, 
         0.0047075084592321055`}, {0.035, 0}}, {{0.036000000000000004`, 
         0.004154236255726045}, {0.036000000000000004`, 0}}, {{0.037, 
         0.0036687615636998025`}, {0.037, 0}}, {{0.038, 
         0.0032424102493058575`}, {0.038, 0}}, {{0.039, 
         0.002867690213051722}, {0.039, 0}}, {{0.04, 0.002538113383681784}, {
         0.04, 0}}},
       VertexColors->None]}}}, 
   {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.009166666666666668], 
    AbsoluteThickness[1.6], {}, PointBox[CompressedData["
1:eJxTTMoPSmViYGDQBGIQDQM6u5vKVeNYHf6s/HjJNynAPvmy7lkxfSYoP8F+
sfXv/X90ftv/qsvaUzI5w/6x5qH2glef7SHyBfbSZ/R1buW9ta8WWef+sKrE
Po3t5NNMkWdQ9RX2UivnnH575YF95Us1Q441NfZaRn7qv/luQfU32Id/sHrg
UnrF3ua+f+/0vCb7M+uLPy9xuQA1r8V+yQPXqa46p+x3efIwabe32feUnZzK
5XYUan6HvcL8x1zfig/aW205UbZvfpe9xPzGQ1kP9kDt67G3umqf4yG4w36H
XOvrwB199j/zgoqbDbdA7Z9g7/NA96Ir90b7OUcUNhRlTLSPWs+vevDNGqh7
JtmLT5p7+teKFfa3f4IttD9qv4HvtcxSqPum2C9YxrP8vsoie2n9uypsjVPt
H++fKiLvNR/q3mn2dfWBT/34Z9tHpViDTLTfUcX8Y0fZdKj7Z9gbC6Qs2ZMy
xX7WTDCwt3+5/qX04YlQ/8yyf+vVkD3zf5/9zXPfgx8vnW0ve1S2VU2iG+q/
OfaN2cf+Ldnebi/JEsanu2mu/et0/pmcp1qg/p1nz3Sm8fhSuyb7CEuwgfaB
NVt2NLM3QP2/wH6p0SXrU4Y19j7mnY4JTxfYx5eoLdt5sQIaHgvtDXbxTv51
t9T+TSDIxIX22pU8enoexdDwWWR/yWC3LwdLoX13zvPfKz8usnfKvhX7mTcP
Gl6L7d0sUvZf7s+y124XA3phsX1T8+HS37Xp0PBbYr9Fyt7+/KkUewDvbj38

     "]], {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{
   "MessagesHead" -> DiscretePlot, "AxisPadding" -> Scaled[0.02], 
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "DefaultPlotStyle" -> {
      Directive[
       RGBColor[0.368417, 0.506779, 0.709798], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.880722, 0.611041, 0.142051], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.560181, 0.691569, 0.194885], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.922526, 0.385626, 0.209179], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.528488, 0.470624, 0.701351], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.772079, 0.431554, 0.102387], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.363898, 0.618501, 0.782349], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[1, 0.75, 0], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.647624, 0.37816, 0.614037], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.571589, 0.586483, 0.], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.915, 0.3325, 0.2125], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.40082222609352647`, 0.5220066643438841, 0.85], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.9728288904374106, 0.621644452187053, 0.07336199581899142], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.736782672705901, 0.358, 0.5030266573755369], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.28026441037696703`, 0.715, 0.4292089322474965], 
       AbsoluteThickness[1.6]]}, "DomainPadding" -> Scaled[0.02], 
    "PointSizeFunction" -> "SmallPointSize", "RangePadding" -> Scaled[0.05]},
  PlotRange->{{0, 0.04}, {0, 2.7}},
  PlotRangePadding->{{Automatic, Automatic}, {Automatic, Automatic}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.815759693449555*^9, 3.8157597051532183`*^9}, {
   3.815759737427073*^9, 3.815759750213318*^9}, {3.8157616007659483`*^9, 
   3.815761608383205*^9}, 3.815761907809979*^9, {3.815762143926168*^9, 
   3.81576217917071*^9}, 3.8157624489962378`*^9, 3.8158251274994707`*^9, 
   3.815825222701078*^9, 3.8158253868306837`*^9, 
   3.815846800274967*^9},ExpressionUUID->"4640a8a4-bd53-4a37-b468-\
30ffae57dbee"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals100fastNOPUMPSvals", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"IngdtgralinexpoInf100fastNOPUMPS", "[", "hh", "]"}], "*", 
      RowBox[{"Exp", "[", 
       RowBox[{"Ingdtgralinexpo100fastNOPUMPS", "[", "hh", "]"}], "]"}]}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"hh", ",", "0.", ",", ".04", ",", ".0005"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.815754473162491*^9, 3.8157544773224277`*^9}, {
   3.815759768782044*^9, 3.81575982596537*^9}, {3.815759879646081*^9, 
   3.815759879997738*^9}, 
   3.815762185553238*^9},ExpressionUUID->"f2b1d554-00a7-4ae9-8da7-\
2a688caf4744"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
  "IngdtgralinexpoInfIngdtgralinexpovals100fastNOPUMPSfunc", " ", "=", " ", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals100fastNOPUMPSvals", ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0", ",", ".04"}], "}"}], "}"}]}], "]"}]}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.815754467786021*^9, 3.815754501034259*^9}, {
   3.815759814782406*^9, 3.81575999798273*^9}, 3.815760062224975*^9, {
   3.8157621884971523`*^9, 3.815762188929167*^9}, {3.815825189150482*^9, 
   3.815825189326501*^9}},ExpressionUUID->"7895801e-c655-4ecd-a0d8-\
39fad394ed2d"],

Cell[BoxData[
 TagBox[
  TemplateBox[{RowBox[{
      StyleBox[
       TagBox["InterpolatingFunction", "SummaryHead"], 
       "NonInterpretableSummary"], 
      StyleBox["[", "NonInterpretableSummary"], 
      DynamicModuleBox[{Typeset`open$$ = False}, 
       PanelBox[
        PaneSelectorBox[{False -> GridBox[{{
              PaneBox[
               ButtonBox[
                DynamicBox[
                 FEPrivate`FrontEndResource[
                 "FEBitmaps", "SquarePlusIconMedium"]], 
                ButtonFunction :> (Typeset`open$$ = True), Appearance -> None,
                 Evaluator -> Automatic, Method -> "Preemptive"], 
               Alignment -> {Center, Center}, ImageSize -> 
               Dynamic[{
                 Automatic, 3.5 CurrentValue["FontCapHeight"]/
                  AbsoluteCurrentValue[Magnification]}]], 
              GraphicsBox[{{{{}, {}, 
                  TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwBgQN+/CFib1JlAgAAADcAAAACAAAAMFct1W+SbT+0XFx7OlXuPxYZTZ64
enA/fgYys2et6j9Gl7cqL2NzP1AcIxrGuOU/x3hSAxI+dj+xGZo3C+XhP3IZ
VKbV53g/ojnhZjEU3j+8ZRmZHMt7PwReVQDfF9k/MHFFVkR9fj+Tg9mtSFPV
P/rv0C/skIA/+fDJ2uhI0j8s/WDc9/+BP0Sw3O8VIs8/82kk7nNWgz9AqUwx
tO7KP4msyaexyYQ/5C4+23wjxz/IIIeHJTaGP/0Opxq1CMQ/nPR3zAmKhz+m
9Zi4c5bBPz+eSrmv+og/VH59EVWrvj93p1ALxlKKP/TiViKXFbs/f4Y4BZ7H
iz8I+EGtKcK3Py+XOCWsNY0/hdHDB3P2tD90B2yqKouOPxbThciHtLI/iU2B
12r9jz9JX40lNpSwP5r55LSNq5A/C7BhTviyrT9DZRURAVWRP/HkqgV4t6o/
1Ls2QdUMkj9Hm1MdW9+nPy/C8aNhuJI/KQjmer2IpT9ys53aTnKTP366S0i0
S6M/ib1VJNcolD/G7kO/QVuhP2t3p6AX05Q/0ycbwst+nz81HOrwuIuVP2qh
49GrYpw/yXDGcxI4lj8Zp8rSVMuZPzHergkH4ZY/wtlWVciClz+BNohzXJiX
PzjEySFcSZU/nD77D2pDmD8cIXAp5GuTP54xX4DY/Jg/2RUAbh6akT9r1Fwj
/6mZP/+kQbJjEpA/DJBm2cBTmj9bdWlQvWyNP5U2YWPjC5s/tAhcQLzBij/o
jPUfvrebPyLQX2C4gIg/I856sPlxnD/kYvJKREqGPzIoDFTQKJ0/IFO4X3JT
hD8MMjcqX9OdP3H7Ou8ZqYI/ziZT1E6Mnj/wQTnfsASBP1rLCLH2OJ8/KwLD
GFs/fz+6iMqgOeKfP2iC/zN2v3w/gpg+su5MoD8Ec3WFI0Z6P4zEZK2coqA/
OeoWAAQreD8KZoMSe/+gP/mY7GTMFXY/8hMoAadaoT980FAPOzl0P7+ZGQmv
r6E/HOYDn8Cicj8AlQN75wuiP2o6jdWOD3E/Jmg6Bvxhoj/Fdrb80m5vP8Cw
aftAv6I/qQb/otfEbD/EBR960xqjP9OKXmoAYmo/rTIhEkJwoz+v88uL5ldo
PwrVGxThzKM/rKZqvFlRZj9NT2MvXCOkP0tOTYXslWQ/fzfbQeF6pD+KYSM9
wvliP1xvnHc=
                    "]]}, 
                   Annotation[#, 
                    "Charting`Private`Tag$97809#1"]& ]}}, {}, {}}, {
               DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
                AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
                GridLines -> {None, None}, DisplayFunction -> Identity, 
                PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                All, DisplayFunction -> Identity, AspectRatio -> 1, 
                Axes -> {False, False}, AxesLabel -> {None, None}, 
                AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                Frame -> {{True, True}, {True, True}}, 
                FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                Directive[
                  Opacity[0.5], 
                  Thickness[Tiny], 
                  RGBColor[0.368417, 0.506779, 0.709798]], 
                FrameTicks -> {{None, None}, {None, None}}, 
                GridLines -> {None, None}, GridLinesStyle -> Directive[
                  GrayLevel[0.5, 0.4]], ImageSize -> 
                Dynamic[{
                  Automatic, 3.5 CurrentValue["FontCapHeight"]/
                   AbsoluteCurrentValue[Magnification]}], 
                Method -> {
                 "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                  AbsolutePointSize[6], "ScalingFunctions" -> None, 
                  "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                PlotRange -> {{0., 0.04}, {0., 0.947903862895052}}, 
                PlotRangeClipping -> True, PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
              GridBox[{{
                 RowBox[{
                   TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox[
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "0.04`"}], "}"}], "}"}], 
                    "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"scalar\"", "SummaryItem"]}]}}, 
               GridBoxAlignment -> {
                "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
               False, GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {
                "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
               BaseStyle -> {
                ShowStringCharacters -> False, NumberMarks -> False, 
                 PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
            GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
            BaselinePosition -> {1, 1}], True -> GridBox[{{
              PaneBox[
               ButtonBox[
                DynamicBox[
                 FEPrivate`FrontEndResource[
                 "FEBitmaps", "SquareMinusIconMedium"]], 
                ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                None, Evaluator -> Automatic, Method -> "Preemptive"], 
               Alignment -> {Center, Center}, ImageSize -> 
               Dynamic[{
                 Automatic, 3.5 CurrentValue["FontCapHeight"]/
                  AbsoluteCurrentValue[Magnification]}]], 
              GraphicsBox[{{{{}, {}, 
                  TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwBgQN+/CFib1JlAgAAADcAAAACAAAAMFct1W+SbT+0XFx7OlXuPxYZTZ64
enA/fgYys2et6j9Gl7cqL2NzP1AcIxrGuOU/x3hSAxI+dj+xGZo3C+XhP3IZ
VKbV53g/ojnhZjEU3j+8ZRmZHMt7PwReVQDfF9k/MHFFVkR9fj+Tg9mtSFPV
P/rv0C/skIA/+fDJ2uhI0j8s/WDc9/+BP0Sw3O8VIs8/82kk7nNWgz9AqUwx
tO7KP4msyaexyYQ/5C4+23wjxz/IIIeHJTaGP/0Opxq1CMQ/nPR3zAmKhz+m
9Zi4c5bBPz+eSrmv+og/VH59EVWrvj93p1ALxlKKP/TiViKXFbs/f4Y4BZ7H
iz8I+EGtKcK3Py+XOCWsNY0/hdHDB3P2tD90B2yqKouOPxbThciHtLI/iU2B
12r9jz9JX40lNpSwP5r55LSNq5A/C7BhTviyrT9DZRURAVWRP/HkqgV4t6o/
1Ls2QdUMkj9Hm1MdW9+nPy/C8aNhuJI/KQjmer2IpT9ys53aTnKTP366S0i0
S6M/ib1VJNcolD/G7kO/QVuhP2t3p6AX05Q/0ycbwst+nz81HOrwuIuVP2qh
49GrYpw/yXDGcxI4lj8Zp8rSVMuZPzHergkH4ZY/wtlWVciClz+BNohzXJiX
PzjEySFcSZU/nD77D2pDmD8cIXAp5GuTP54xX4DY/Jg/2RUAbh6akT9r1Fwj
/6mZP/+kQbJjEpA/DJBm2cBTmj9bdWlQvWyNP5U2YWPjC5s/tAhcQLzBij/o
jPUfvrebPyLQX2C4gIg/I856sPlxnD/kYvJKREqGPzIoDFTQKJ0/IFO4X3JT
hD8MMjcqX9OdP3H7Ou8ZqYI/ziZT1E6Mnj/wQTnfsASBP1rLCLH2OJ8/KwLD
GFs/fz+6iMqgOeKfP2iC/zN2v3w/gpg+su5MoD8Ec3WFI0Z6P4zEZK2coqA/
OeoWAAQreD8KZoMSe/+gP/mY7GTMFXY/8hMoAadaoT980FAPOzl0P7+ZGQmv
r6E/HOYDn8Cicj8AlQN75wuiP2o6jdWOD3E/Jmg6Bvxhoj/Fdrb80m5vP8Cw
aftAv6I/qQb/otfEbD/EBR960xqjP9OKXmoAYmo/rTIhEkJwoz+v88uL5ldo
PwrVGxThzKM/rKZqvFlRZj9NT2MvXCOkP0tOTYXslWQ/fzfbQeF6pD+KYSM9
wvliP1xvnHc=
                    "]]}, 
                   Annotation[#, 
                    "Charting`Private`Tag$97809#1"]& ]}}, {}, {}}, {
               DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
                AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
                GridLines -> {None, None}, DisplayFunction -> Identity, 
                PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                All, DisplayFunction -> Identity, AspectRatio -> 1, 
                Axes -> {False, False}, AxesLabel -> {None, None}, 
                AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                Frame -> {{True, True}, {True, True}}, 
                FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                Directive[
                  Opacity[0.5], 
                  Thickness[Tiny], 
                  RGBColor[0.368417, 0.506779, 0.709798]], 
                FrameTicks -> {{None, None}, {None, None}}, 
                GridLines -> {None, None}, GridLinesStyle -> Directive[
                  GrayLevel[0.5, 0.4]], ImageSize -> 
                Dynamic[{
                  Automatic, 3.5 CurrentValue["FontCapHeight"]/
                   AbsoluteCurrentValue[Magnification]}], 
                Method -> {
                 "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                  AbsolutePointSize[6], "ScalingFunctions" -> None, 
                  "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                PlotRange -> {{0., 0.04}, {0., 0.947903862895052}}, 
                PlotRangeClipping -> True, PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
              GridBox[{{
                 RowBox[{
                   TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox[
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "0.04`"}], "}"}], "}"}], 
                    "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"scalar\"", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["3", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["False", "SummaryItem"]}]}}, 
               GridBoxAlignment -> {
                "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
               False, GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {
                "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
               BaseStyle -> {
                ShowStringCharacters -> False, NumberMarks -> False, 
                 PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
            GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
            BaselinePosition -> {1, 1}]}, 
         Dynamic[Typeset`open$$], ImageSize -> Automatic], BaselinePosition -> 
        Baseline], DynamicModuleValues :> {}], 
      StyleBox["]", "NonInterpretableSummary"]}]},
   "CopyTag",
   DisplayFunction->(#& ),
   InterpretationFunction->("InterpolatingFunction[{{0., 0.04}}, <>]"& )],
  False,
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{3.815761616511989*^9, 3.815761912249879*^9, 
  3.8157624684877243`*^9, 3.815825152688246*^9, 3.8158252063707314`*^9, 
  3.815825239666428*^9, 3.815825395922317*^9, 
  3.8158468092511797`*^9},ExpressionUUID->"e7d1fe37-beef-49b4-81c1-\
33ccfe62da55"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tau2for100fastNOPUMPS", "=", 
  RowBox[{
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
     "IngdtgralinexpoInfIngdtgralinexpovals100fastNOPUMPSfunc", "[", "ww", 
      "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"ww", ",", "0.0", ",", ".04"}], "}"}]}], "]"}], "  ", "/", 
   RowBox[{"N", "[", 
    RowBox[{"p2new100fastNOPUMPS", "[", "0.2", "]"}], "]"}], " "}]}]], "Input",\

 CellChangeTimes->{{3.81576006876746*^9, 3.815760069039469*^9}, 
   3.815761621884942*^9, {3.815762192385824*^9, 3.815762194896747*^9}, {
   3.815825184751047*^9, 
   3.8158251849428263`*^9}},ExpressionUUID->"9523c687-7614-454b-87ec-\
d095150218bc"],

Cell[BoxData[
 RowBox[{"{", "0.010928240861699318`", "}"}]], "Output",
 CellChangeTimes->{
  3.815754525924816*^9, {3.8157599476515217`*^9, 3.8157599990396214`*^9}, 
   3.8157600695613213`*^9, {3.8157616185912237`*^9, 3.815761622153846*^9}, 
   3.81576191227978*^9, 3.815762470797269*^9, 3.8157625205106707`*^9, 
   3.815825154970462*^9, 3.815825202652326*^9, 3.8158252412447567`*^9, 
   3.8158253959999647`*^9, 
   3.815846809296035*^9},ExpressionUUID->"656790da-becb-44c3-81b7-\
dc11b987363b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.815825342027359*^9, 
  3.815825342287635*^9}},ExpressionUUID->"c013fa0b-5698-42b3-a779-\
c33fca880a11"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Mu]", "=", "38"}], ";", 
  RowBox[{"\[Lambda]", "=", "6"}], ";", 
  RowBox[{"NR", "=", "1"}], ";", 
  RowBox[{"\[Nu]", "=", "100"}], ";", " ", 
  RowBox[{"initca", "=", "300"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"s", "=", 
   RowBox[{"NDSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"n1", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Mu]"}], "*", 
          RowBox[{"n1", "[", "t", "]"}]}], "+", " ", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], " ", "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"2", "*", 
             RowBox[{"n1", "[", "t", "]"}]}]}], " ", ")"}]}]}]}], " ", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"nca", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Nu]"}], "*", 
          RowBox[{"nca", "[", "t", "]"}]}], " ", "-", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"n1", "[", "t", "]"}]}], ")"}]}], "+", 
         RowBox[{"\[Mu]", "*", 
          RowBox[{"n1", "[", "t", "]"}]}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"p2", "'"}], "[", "t", "]"}], "\[Equal]", " ", 
        RowBox[{"\[Lambda]", "*", 
         RowBox[{"n1", "[", "t", "]"}], "*", 
         RowBox[{"nca", "[", "t", "]"}], "*", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"p2", "[", "t", "]"}]}], ")"}]}]}], ",", 
       "\[IndentingNewLine]", " ", 
       RowBox[{
        RowBox[{"n1", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
       RowBox[{
        RowBox[{"nca", "[", "0", "]"}], "\[Equal]", "initca"}], ",", 
       RowBox[{
        RowBox[{"p2", "[", "0", "]"}], "\[Equal]", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"n1", ",", "nca", ",", "p2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0.0", ",", ".2"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"n1", "[", "t", "]"}], "/.", "s"}], "]"}], ",", 
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"nca", "[", "t", "]"}], "/.", "s"}], "]"}], ",", 
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"p2", "[", "t", "]"}], "/.", "s"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "100"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{"Orange", ",", "Green", ",", "Blue"}], "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"plotofn1Fast300NOPUMPS", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"n1", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", "Magenta", "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"plotofncaFast300NOPUMPS", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"nca", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "320"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", "Magenta", "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"plotofp2Fast300NOPUMPS", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"p2", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", ".2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", "Magenta", "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.815754342443674*^9, 3.815754363897985*^9}, 
   3.8157547936640882`*^9, 3.815754854048726*^9, {3.8157593278533363`*^9, 
   3.8157593782342978`*^9}, {3.815760110128631*^9, 3.815760116352397*^9}, {
   3.8157602188825274`*^9, 3.8157602193290863`*^9}, {3.815846478155038*^9, 
   3.8158464843780537`*^9}},ExpressionUUID->"5e3ca941-9625-4c1f-9c55-\
9187990e3757"],

Cell[BoxData["300"], "Output",
 CellChangeTimes->{
  3.8157543303787107`*^9, 3.8157543660284557`*^9, 3.8157548082007933`*^9, 
   3.815754855042717*^9, {3.815759331508915*^9, 3.815759379075883*^9}, 
   3.8157601190470333`*^9, 3.8157602199653807`*^9, 3.815761250170176*^9, 
   3.815761624977667*^9, 3.815761912311769*^9, 3.815825251018384*^9, 
   3.815825396081484*^9, 
   3.815846809422958*^9},ExpressionUUID->"7646477a-3b0d-4e76-acdf-\
1a9a3b0424cd"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0.5, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtk3c0FY7/xlEhyYrKbqAlo8gn6ykjq5KVcSWhhEIZWRmFzMyuvUeRlex5
zWtcREoZ96ISLQolim+/c37POe/znNd5n/M+z/uPZ6+Vk/5VBjo6upl/83+u
fXV2kDRnpDxj8Njh5elN2KzK50zjlYFO3C+7w3yvcDwjMfU5rxqUrDLVbBjG
8V5AJOCO2Hn8dsndtGZMhU7fSHkaryHOB6ayXD9Ag0iEYN6GsCl43wlo33Wm
4Y+2dcIVMQsodRZ7vQil4VPgcPsV4hUwqppYpMTQYGzzqzGW1wa9fwdSG2Jp
aFflq25LvYbklfFd8v/2UvuVypaE7VDl0BWW8pCGVAbLAtEcB1g5hk55htPA
PH0v+6KYI4S8/Hm5QmiomxzqazN0hm/W0IJPIA3OF2y0zYm3sP2lvVu7Pw0T
kg9UI3ldYe5u1fjTg4b4jN0kUYIbZGW0ud+50qDNXqjYlOqOd9c99Z/9y1/1
jSI7L+wJ+tklte+2NDws5jqoJ+aLU89ub3wypEFdMDd3ztYPdnN+aS91afDt
TOZoMfRH+mSoRqI2DTInxCNNiQFwk82zLQcNmTy6wWG8gZjTorRwHqTBuy+h
/WJdID6/d2xv3UvDxaBJhv2EIMTXObzR5KeBdfmWX31qMN4c8Ax+sZ0Gj+F4
jy/CoZBylR56vkCFQcREVQ0pFEeUFdUWZ6mQUBNbDrwShksij5Xopqh4/7z6
lmBOOJbYCTO+L6jQixu1Py/2EJvLpzoXi6gQ19lfwEd+iHlbbpnAHCqYN934
OGMbBaYzbwijSVRcrl1/1mwYDSntwJ8vg6jgORQtYUKMQfm0uf6UGRUMQRXn
mmZiYJBrEhGoS8XC5JsbInKxOMaWOfpBlYrexL1PF0ZiUTqqxUw7QkUA8/MD
obzxIGcJPY5dmcBhjZiQcud4sGTQbczMTWAoyGlujByPsbuH4j+MTkBkk/hT
CfdHiEqsvzFRP4HOv7kSw0NENEsn26R5TsBJ8X7U30MJWHR7/vfg9Qns9r6y
IBaQgOp79GnGFydgtyJY7imZiC8hjzhSpCfAukiUFY5Igh/1++cn78ZRKe1G
1HyXhFCm5Tz5gXFYOBv8uiWfDE/a3m77unGUfmWvbZ9NxsuPK79zo8ahPxui
aK+eClKtopKX7DgSJ7xUK9fTkVEgxZ/rOIbTAqa5VKMMbNbtVuU0HMMnM7kt
zMUZeHi/lF7o5BiEvnhaFx/NREvCu8zdDGNwsjshSjeeCW/rzg/5UaPgsil9
kvdfNsQlQlnWkt7CxDSrdOF7Lg7uuqb92XUE82OGLNl8eUistGr6qj+CYAvm
qwaqeeDZZszUJjWC59ZOfFXxebBiL6r58vk12ByVgrzl8vFqtkDGwfI1Ou69
NWO8+xjpj+sVo1Vf4VgRJ6MAcyH6qt2Y9NeH0C3RYdknVQi3oHG9+bdDsHzm
Ue9rWohKNvaD8ZVDiKyiOU8VFkLvj5bu6o0hzJKKx/LPPQXHea6hy+ODSH+l
9Uw6rgh0Vk8ya5peYNtGgLmGUCkMU3ykJI73IdHO2EL8TClUv9rd1v9Bgciw
uCWnYynyFKeekp9RoFwwYj3WWIr9TyX2FUpTUFtArKyWKAPj5NYSR9lefDX4
0qDTXwb2mxLGg+e6IbN1REl5ugwBGYyM97i64dXU0iT1swzHit2MY0e6wHQo
gcQj9Azzo6/PDVt1Ye/66XbazWewMHaW/HyXDKMnCb0u28sRrjdwtqqzA6mX
7p29trcc3Rm3FONiOjDNdbPPRLYcsqSdy8PmHXC6qzKgdKkc9INbdz5Yakeo
/tchpuJybN0l7Zh/sB2Nf1RGU84+hxPxcHRzTitE9b7NtoVXYFtVlG0suRl8
fhrytlkV+BLey8/i1AyO4sxwluoK2D/YTDHf1YxVZgMJvekKiHCLCT60b8IL
UrUL9b9KTP2e2vWXrxFeUgHrKx8qIdPjQZjOroOTxahu6lol0k/3R9wwroNN
xPEscFah5/hnngbWOujOflANVqwC+1qAaZ5nLUQytUN3xFWhIm9y1x3zGvSz
c3NLnKqG1ZvNt7vUqtCmdPPqoFE1vmlGPFjeXIUah84qV4dqsOtW07/oqEQO
2cO0nliNVHs2vgdalfDwm0jX/FqNMMPFjpcmFdg3n3/IOrkGjAecJJMelWOX
IJ03Y1kNhpvnVOYul4NVx5RS0FGDH7Pbtg4cLsev/G1OCws1+LahO2/U+gwU
C+eKuxq1IGzcVzu0UoY7/SeRuPQvt13a60trJWCTqPzQzVwHqZZ52UuPS5Ab
KRWxJlAH8/WbAgqGJRg8e+CthXodHven7g4rK8aRXm4XUWIdfqScF5Z3KQKN
PJ9fLleP5OnQST7hQrgfcDj3Xqceviv0PqxvCsD6YGaRx7IeojenbjXEFODk
mYlTniH1mP7O9FKXqQBx7T2jeFuPUuo4HefaY2i05LH1eTXgZ0etl/2mfFD3
7K1cf9iAJObJ97bkPLj6pxKkchrA9W5RjykiD1mIexLX2wCCa0mB6K48rDX6
q5gJNEL+wXhRuUwuSusI7h8bG2EztG+2LDwbZ/hGBHiHGkH07S/hMM3GuKd+
m/ZMI+JYGN7+FsvG1pNaHCVsTSAQk9Ot2rNgXX2i0PVyE5o8stOubcnCrgpO
Kj19M7y4q2m8yhkwj1gzfL+zGe9HJUdyptKRbfOht1O8GQ+mHvoqB6dDnKe2
NtykGTGtLzWThtKg4m75iKesGWNiojtj7qTiRKpxfrwkCYNmeusb80kwDaFM
BcmTcCpawet4ThJ8XE8L3lEngbX/52ct4yS0nD0Sb0ogwS1MNYSnNRFn/64H
CD0gocLqfPxkVgKuWORfekIlIXyLUL5IyCMEavMnJc2RILfsz2qp+Qj5J6KH
w5ZIsCHcljfZ+ghf2Lx0brK0IEiQKukeGQ/35nMnj51oQcEUR7p4ehwi9ixz
N0S2QIQgrNBMi0EJq/2F4sQW1C/zig8UxmBwhRqentOCfDn2RW/3GOwc7GII
qG2B2p+qvFz2GGQFpC6of2hBrNPHeTqtaFRNq1IGFFuhT/mh8LYoEq81A75H
arSC8dtf4sOLkfhZ0rTzrH4r+s0WmEAfCTnvk1e6bFshfWFvcJBpBGp2SP4k
xbbCdvL4HgJPOGrV+PaUz7ZiebB49XV1CEYLjdWdF1vx0eq2yopTCFY5HtlL
rLfCPymz+NPBEMhPsFcW7mjD26KK4yfTHqDObYt2jnIbZGqcVxWigtGQv+AS
H98GoU9GWp+JgRhnlUjSz2jDx540M3ZCIP7cdmjiKPzHg9K5U8KBUMIMc2Tz
v3tLgfShT++jaWQsLehTG3x+5b592nMPzcxksvupduxmi92dIxaAScfNX2V0
2jH1hlW8a8kfdK9Ocy0atSPj5MBB3zZ/nMpqMHdyaMfT5gsRRCt/kE6Wf7cl
tkOsYUt/0nk/tNqn8Zt+acfvIVOd2VgfPJ9zcLD42Y5Ad9Ntduo+yL0uX29N
1wGfR77HGla8EXRtxMyRuwNKcd0xL654Q9OKM/m+Ygc2ohwuuyh5YcA0aHdJ
RAfcUieLhnZ7gPTG4PpzYgd+1U1d8hy5gzLjfTU1mR2oTFk3GyTeQaxRs3Fb
RQdEc8SXInfdwUW938Q34x0o6yA1MO51x7jmTZ5NRztRH/vX46q+K/rICleZ
5TqRIq9YoM3viqYzLJXbT3eCbGR+u+O9CzLUHhvuNuoEQ5i1lZunC6xOTcUd
vduJJasrazEFtzErZ8Rl0teJxvhhB5f9t7AspsRefJMMii53qdPsDShPq5DD
PMgQO8LJeTfuBoLTNP2u3yfjvhCrRiBuYCe34fz+JDIMt+fRXJMdcILeYSC5
nYwzZ+kSowj28BhLjArh78KrUWW2c8zXQSKma1wT60JW0ypnWYstmPVzN1Sl
u+D6VDtl2tsWSV2lThtnumDQqHW66Mc11FV26rrf7oJZ61BNzNxV/IlaYrfp
7gJWexObVq2hprNKPj3chSj5/dzbSNaIYKTzF6Z1Ie2EwbtNwdYQvLttYXSp
C9Ne6zsWd1hD2X7fC7093SgW7GyMlbOCn9qFaNzpRpZCj9iJVEt0bRhpCt7r
hs2ZtGg7B0tw1BPo1iK68awixEZcwRKZ0rbOVdnd6FIc+lZecxkkId8LR/u7
wVUmukVV2wIMv59y8Iv2gGtG+furNAL4+1QWIdmDlLq6qnk9AmSy3r6yOdmD
O4UsO4YZCbiqxZRScq4HPxpWXb/fNkNXkpWoinsPpIZmhKUNTf/9xStvR+5B
76zGnov/GUPAJ9i62q4XfEK/lMguBpC9IHhm3KUXTIoJFUMKBjgvUnGQ3rcX
dt6Fs7qbDeBHmfqqHdsLI6zfjCfqY1pAyYNa1ws2ejHJlWY9FDQuRmxhpWBL
wkBSw/4LOLFhWWVQQsHh7ieMcXLaOHuOdE+9hgKK1xin9JgWrFOEdeVaKf/6
kMC+4auFaDnqR77XFDSZEpZ5yJqYcyLwTv+l4NjRd19STTSQOmnk43yuD9M/
3bK9fdRA36qtEvmlD5n8ftW16krYzVHI5vezD5ab28OKAhUhYbF1zJmuH8wm
Ao5lrQowWyW7GHL3I9PMNqxFQR4Vx9Tz+BX74RHCJPx+jxyu5YC5MLwfZVfd
PzCUSIESKNPfeXgAe0pnPVUMNkOevZchRnYAdPqUnm0HVpSfJF2RI5z6x03v
Ph1anlAmfbzGvk/9H/+//gfZMfO/
       "]]},
     Annotation[#, "Charting`Private`Tag$97899#1"]& ], 
    TagBox[
     {RGBColor[0, 1, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtWPc71Q/AvRQJXxSphFIoQsiI6HxsGQ0jVCQjK6GQUqKSCiE7ssnIdu1x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       "]]},
     Annotation[#, "Charting`Private`Tag$97899#2"]& ], 
    TagBox[
     {RGBColor[0, 0, 1], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwd13c8V18YB3ArGUWkQUpmKakkpegJiYQyklFWthSRrPAVUcgeZWTP7K89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       "]]},
     Annotation[#, "Charting`Private`Tag$97899#3"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.2}, {0, 100}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8157543303787107`*^9, 3.8157543660284557`*^9, 3.8157548082007933`*^9, 
   3.815754855042717*^9, {3.815759331508915*^9, 3.815759379075883*^9}, 
   3.8157601190470333`*^9, 3.8157602199653807`*^9, 3.815761250170176*^9, 
   3.815761624977667*^9, 3.815761912311769*^9, 3.815825251018384*^9, 
   3.815825396081484*^9, 
   3.815846809470443*^9},ExpressionUUID->"317b43d5-ca19-45ab-acab-\
56ddbe8b7ca0"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0, 1], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtk3c0FY7/xlEhyYrKbqAlo8gn6ykjq5KVcSWhhEIZWRmFzMyuvUeRlex5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       "]]},
     Annotation[#, "Charting`Private`Tag$97943#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.2}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8157543303787107`*^9, 3.8157543660284557`*^9, 3.8157548082007933`*^9, 
   3.815754855042717*^9, {3.815759331508915*^9, 3.815759379075883*^9}, 
   3.8157601190470333`*^9, 3.8157602199653807`*^9, 3.815761250170176*^9, 
   3.815761624977667*^9, 3.815761912311769*^9, 3.815825251018384*^9, 
   3.815825396081484*^9, 
   3.815846809514889*^9},ExpressionUUID->"12ee75cf-df0f-4527-9004-\
5bb86af341bc"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0, 1], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwtl/c71o/DxVEkfFBEZDQQsjMiOm8rMhq2lMzsUEgpIVJGiIzIJiN779u6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       "]]},
     Annotation[#, "Charting`Private`Tag$97985#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.2}, {0, 320}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8157543303787107`*^9, 3.8157543660284557`*^9, 3.8157548082007933`*^9, 
   3.815754855042717*^9, {3.815759331508915*^9, 3.815759379075883*^9}, 
   3.8157601190470333`*^9, 3.8157602199653807`*^9, 3.815761250170176*^9, 
   3.815761624977667*^9, 3.815761912311769*^9, 3.815825251018384*^9, 
   3.815825396081484*^9, 
   3.8158468095606937`*^9},ExpressionUUID->"95d8b8d0-63b0-42c4-8758-\
d960e7694f34"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0, 1], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwd13c8V18YB3ArGUWkQUpmKakkpegJiYQyklFWthSRrPAVUcgeZWTP7K89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       "]]},
     Annotation[#, "Charting`Private`Tag$98027#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.2}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8157543303787107`*^9, 3.8157543660284557`*^9, 3.8157548082007933`*^9, 
   3.815754855042717*^9, {3.815759331508915*^9, 3.815759379075883*^9}, 
   3.8157601190470333`*^9, 3.8157602199653807`*^9, 3.815761250170176*^9, 
   3.815761624977667*^9, 3.815761912311769*^9, 3.815825251018384*^9, 
   3.815825396081484*^9, 
   3.815846809600625*^9},ExpressionUUID->"e662da7b-76d9-4572-8ed3-\
22789326cab4"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"n1new300fastNOPUMPS", "[", "y_", "]"}], ":=", 
  RowBox[{
   RowBox[{"n1", "[", "y", "]"}], "/.", "s"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ncanew300fastNOPUMPS", "[", "y_", "]"}], ":=", 
  RowBox[{
   RowBox[{"nca", "[", "y", "]"}], "/.", "s"}]}], "\n", 
 RowBox[{
  RowBox[{"p2new300fastNOPUMPS", "[", "y_", "]"}], ":=", " ", 
  RowBox[{
   RowBox[{"p2", "[", "y", "]"}], "/.", "s"}]}]}], "Input",
 CellChangeTimes->{
  3.8157543166016607`*^9, {3.815759397545491*^9, 3.8157593984568157`*^9}, {
   3.815759506489458*^9, 3.81575954681077*^9}, {3.8157606820211973`*^9, 
   3.81576068664476*^9}},ExpressionUUID->"81ddc7c3-0836-4847-bdd6-\
790b3d8ce608"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"N", "[", 
   RowBox[{"p2new300fastNOPUMPS", "[", "0.2", "]"}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.815759483418754*^9, 3.81575948375366*^9}, {
  3.815759551722645*^9, 
  3.815759552877048*^9}},ExpressionUUID->"9aaf857c-ac1a-4eb6-99fa-\
b97033166f2f"],

Cell[BoxData[
 RowBox[{"{", "0.999714319220515`", "}"}]], "Output",
 CellChangeTimes->{3.8157543911841087`*^9, 3.815759484664563*^9, 
  3.815759553892874*^9, 3.815760695239368*^9, 3.815761253646537*^9, 
  3.815761629766223*^9, 3.815761912495205*^9, 3.81582539658529*^9, 
  3.815846809635631*^9},ExpressionUUID->"87f46ef7-bb42-45ea-bc22-\
1855aea3dff9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Ingdtgralinexpo300fastNOPUMPS", "[", "ti_", "]"}], ":=", 
  RowBox[{
   RowBox[{"-", "\[Lambda]"}], " ", "*", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"n1new300fastNOPUMPS", "[", "tti", "]"}], "*", 
      RowBox[{"ncanew300fastNOPUMPS", "[", "tti", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"tti", ",", "0", ",", "ti"}], "}"}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IngdtgralinexpoInf300fastNOPUMPS", "[", "ti_", "]"}], ":=", 
   RowBox[{"\[Lambda]", " ", "*", 
    RowBox[{"NIntegrate", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"n1new300fastNOPUMPS", "[", "tti", "]"}], "*", 
       RowBox[{"ncanew300fastNOPUMPS", "[", "tti", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"tti", ",", "ti", ",", "0.2"}], "}"}]}], "]"}]}]}], ";", 
  "            ", 
  StyleBox[
   RowBox[{"(", 
    RowBox[{"Infnty", " ", "is", " ", ".2", " ", "here"}], " ", ")"}], "Text"], 
  StyleBox[" ", "Text"], 
  StyleBox[";", "Text"]}], "\[IndentingNewLine]", 
 RowBox[{"DiscretePlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"IngdtgralinexpoInf300fastNOPUMPS", "[", "hh", "]"}], "*", 
    RowBox[{
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{"Ingdtgralinexpo300fastNOPUMPS", "[", "hh", "]"}], "]"}], "/", 
      
      RowBox[{"N", "[", 
       RowBox[{"p2new300fastNOPUMPS", "[", ".2", "]"}], "]"}]}], "/", 
     RowBox[{"N", "[", 
      RowBox[{"p2new300fastNOPUMPS", "[", ".2", "]"}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"hh", ",", "0", ",", "0.02", ",", ".001"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.815759610283414*^9, 3.8157596595314827`*^9}, {
  3.815759689820765*^9, 3.815759700510004*^9}, {3.815759732189041*^9, 
  3.8157597448616457`*^9}, {3.8157606997816763`*^9, 3.8157607397176867`*^9}, {
  3.815761246290262*^9, 
  3.815761276496599*^9}},ExpressionUUID->"e55bc0b5-bedd-4d05-94a8-\
8a7b6527d439"],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.011000000000000001`], 
    AbsoluteThickness[1.6], {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.011000000000000001`], AbsoluteThickness[1.6], Opacity[0.2], 
      LineBox[{{{0.02, 0.0007089177212967989}, {0.02, 0.0007089177212967989}}},
       VertexColors->None]}, 
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.011000000000000001`], AbsoluteThickness[1.6], Opacity[0.2], 
      LineBox[CompressedData["
1:eJxTTMoPSmVmYGAQAWImKIaDnMPvFoUoOMC4157cNLtq5W7/Z+XHS75JAfaX
rBZkHS8ScIDxUeUT7Ne4e649dvM3nA+T/1WXtadkcob9ZZUXhgvNX8L5qPoL
7K+43319M+cGnA+TrxZZ5/6wqsSeZ4XCtaOqJ+F8VPMr7KMeHz7gE70bzofJ
V75UM+RYU2OfKKNzmddtPZyPan+DPY/ehcUFGxfB+TB5m/v+vdPzmuwjs+Qe
vHGeDuejuq/F/kqjnO0stj44Hya/y5OHSbu9zV4i8uq7aywtcD6q+zvsm435
dXfWVsP5MHmrLSfK9s3vstdoFNn4NbEYzkf1X499sULpyYl/s+F8mPwOudbX
gTv67N9pyxR/W5oC56P6f4J94bNvaXV88XA+TH7OEYUNRRkT7f9kLrleezgc
zkcNn0n2c5sY+O6VB8H5MPnbP8EespfkaTL8Ju0L58PkAY4PPwo=
       "],
       VertexColors->None]}}}, 
   {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.011000000000000001`], 
    AbsoluteThickness[1.6], {}, PointBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQDQc5h98tClFw+LPy4yXfpAD7S1YLso4XCUD5CfZr
3D3XHrv52/5XXdaekskZ9pdVXhguNH9pD5EvsL/ifvf1zZwb9tUi69wfVpXY
86xQuHZU9SRUfYV91OPDB3yid9tXvlQz5FhTY58oo3OZ1209VH+DPY/ehcUF
GxfZ29z3752e12QfmSX34I3zdKh5LfZXGuVsZ7H12e/y5GHSbm+zl4i8+u4a
SwvU/A77ZmN+3Z211fZWW06U7ZvfZa/RKLLxa2Ix1L4e+2KF0pMT/2bb75Br
fR24o8/+nbZM8belKVD7J9gXPvuWVscXbz/niMKGooyJ9n8yl1yvPRwOdc8k
+7lNDHz3yoPsb/8EW2gvydNk+E3aF+q+KfbXntw0u2rlbg8AkSKiEw==
     "]], {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0.0007089177212967989},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{
   "MessagesHead" -> DiscretePlot, "AxisPadding" -> Scaled[0.02], 
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "DefaultPlotStyle" -> {
      Directive[
       RGBColor[0.368417, 0.506779, 0.709798], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.880722, 0.611041, 0.142051], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.560181, 0.691569, 0.194885], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.922526, 0.385626, 0.209179], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.528488, 0.470624, 0.701351], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.772079, 0.431554, 0.102387], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.363898, 0.618501, 0.782349], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[1, 0.75, 0], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.647624, 0.37816, 0.614037], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.571589, 0.586483, 0.], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.915, 0.3325, 0.2125], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.40082222609352647`, 0.5220066643438841, 0.85], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.9728288904374106, 0.621644452187053, 0.07336199581899142], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.736782672705901, 0.358, 0.5030266573755369], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.28026441037696703`, 0.715, 0.4292089322474965], 
       AbsoluteThickness[1.6]]}, "DomainPadding" -> Scaled[0.02], 
    "PointSizeFunction" -> "SmallPointSize", "RangePadding" -> Scaled[0.05]},
  PlotRange->{{0., 0.02}, {0.0007089177212967989, 8.165305577616891}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.02]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.815759693449555*^9, 3.8157597051532183`*^9}, {
   3.815759737427073*^9, 3.815759750213318*^9}, 3.815760725453082*^9, {
   3.8157612554807243`*^9, 3.8157612824929132`*^9}, 3.815761634493127*^9, 
   3.815761915293388*^9, 3.8158252760415087`*^9, 3.81582539951927*^9, 
   3.815846812485918*^9},ExpressionUUID->"879ab516-20d8-48af-8640-\
076de7dd3374"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals300fastNOPUMPSvals", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"IngdtgralinexpoInf300fastNOPUMPS", "[", "hh", "]"}], "*", 
      RowBox[{"Exp", "[", 
       RowBox[{"Ingdtgralinexpo300fastNOPUMPS", "[", "hh", "]"}], "]"}]}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"hh", ",", "0.", ",", ".01", ",", ".0001"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.815754473162491*^9, 3.8157544773224277`*^9}, {
  3.815759768782044*^9, 3.81575982596537*^9}, {3.815759879646081*^9, 
  3.815759879997738*^9}, {3.815760744101619*^9, 3.815760747637506*^9}, {
  3.8157613010159883`*^9, 
  3.815761328905676*^9}},ExpressionUUID->"4beb6b52-d71a-4796-8589-\
91ee244f8cda"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
  "IngdtgralinexpoInfIngdtgralinexpovals300fastNOPUMPSfunc", " ", "=", " ", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals300fastNOPUMPSvals", ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0", ",", ".01"}], "}"}], "}"}]}], "]"}]}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.815754467786021*^9, 3.815754501034259*^9}, {
   3.815759814782406*^9, 3.81575999798273*^9}, 3.815760062224975*^9, {
   3.81576132732244*^9, 3.81576133467899*^9}, 3.815761381974921*^9, {
   3.81582529896012*^9, 
   3.815825299135222*^9}},ExpressionUUID->"86bd5dff-8d95-4bd9-8461-\
0784a6ae583f"],

Cell[BoxData[
 TagBox[
  TemplateBox[{RowBox[{
      StyleBox[
       TagBox["InterpolatingFunction", "SummaryHead"], 
       "NonInterpretableSummary"], 
      StyleBox["[", "NonInterpretableSummary"], 
      DynamicModuleBox[{Typeset`open$$ = False}, 
       PanelBox[
        PaneSelectorBox[{False -> GridBox[{{
              PaneBox[
               ButtonBox[
                DynamicBox[
                 FEPrivate`FrontEndResource[
                 "FEBitmaps", "SquarePlusIconMedium"]], 
                ButtonFunction :> (Typeset`open$$ = True), Appearance -> None,
                 Evaluator -> Automatic, Method -> "Preemptive"], 
               Alignment -> {Center, Center}, ImageSize -> 
               Dynamic[{
                 Automatic, 3.5 CurrentValue["FontCapHeight"]/
                  AbsoluteCurrentValue[Magnification]}]], 
              GraphicsBox[{{{{}, {}, 
                  TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwBkQNu/CFib1JlAgAAADgAAAACAAAAqv6pNOYxRj9Y0Tz4msYVQAqNTMOK
l0s/KuB1qsnhEkAWGU2euHpQP9VPVPHgWhBARpe3Ki9jUz/4JlwMt/sLQMd4
UgMSPlY/oa0p0mUHCEByGVSm1edYP4t8I3fp3wRAvGUZmRzLWz/gQltDKvQB
QDBxRVZEfV4/C0Vlhd9A/z/679Av7JBgP3YAYgDeU/s/LP1g3Pf/YT/kFAP+
dKz3P/NpJO5zVmM/6A1E0Ea/9D+JrMmnsclkP+bHEzdOBfI/yCCHhyU2Zj+W
+iULCnTvP5z0d8wJimc/GnTJICrB6z8/nkq5r/poP6089r45SOg/d6dQC8ZS
aj8LYQX3cnnlP3+GOAWex2s/kX4ecsjV4j8vlzglrDVtPzFO0ga+l+A/dAds
qiqLbj+eOtBIQondP4lNgddq/W8/ipmAwJsU2j+a+eS0jatwP36wpjmiQtc/
Q2UVEQFVcT/G+oGtMdPUP9S7NkHVDHI/wieVW8WA0j8vwvGjYbhyP1kUcNng
mNA/crOd2k5ycz+8Z/urfI7NP4m9VSTXKHQ/WAZZrj1ryj9rd6egF9N0P1jg
gaJR1Mc/NRzq8LiLdT/UrjMzglfFP8lwxnMSOHY/OjFXZJVIwz8x3q4JB+F2
P9S75J6Re8E/gTaIc1yYdz8yH8ykBXy/P5w++w9qQ3g/PDLIlgiXvD+eMV+A
2Px4PyzdxmZqyrk/a9RcI/+peT8WT1igDnW3PwyQZtnAU3o/FBbUr+ZmtT+V
NmFj4wt7PwY4pP8kZ7M/6Iz1H763ez8HJNkSnLqxPyPOerD5cXw/Lxi7MpMZ
sD8yKAxU0Ch9P7hojQ07Va0/DDI3Kl/TfT/LkKQ49+uqP84mU9ROjH4/2Kig
tAKQqD9aywix9jh/P/2lbKLvkqY/uojKoDnifz9kirFQw82kP4KYPrLuTIA/
GitTBBwQoz+MxGStnKKAP965UN79lqE/CmaDEnv/gD8xlW+9BCSgP/ITKAGn
WoE/p+kfLS+0nT+/mRkJr6+BP14ehQWyg5s/AJUDe+cLgj80XgkgrlmZPyZo
Ogb8YYI/ciA6IyeClz/AsGn7QL+CPyKGroz4r5U/xAUfetMagz8uzqH7Dg+U
P60yIRJCcIM/RTY8m/uqkj8K1RsU4cyDP69BNFFZSZE/TU9jL1wjhD9ha1CJ
vxqQP38320HheoQ/Ku9AOzYCjj/JdZrD
                    "]]}, 
                   Annotation[#, 
                    "Charting`Private`Tag$132117#1"]& ]}}, {}, {}}, {
               DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
                AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
                GridLines -> {None, None}, DisplayFunction -> Identity, 
                PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                All, DisplayFunction -> Identity, AspectRatio -> 1, 
                Axes -> {False, False}, AxesLabel -> {None, None}, 
                AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                Frame -> {{True, True}, {True, True}}, 
                FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                Directive[
                  Opacity[0.5], 
                  Thickness[Tiny], 
                  RGBColor[0.368417, 0.506779, 0.709798]], 
                FrameTicks -> {{None, None}, {None, None}}, 
                GridLines -> {None, None}, GridLinesStyle -> Directive[
                  GrayLevel[0.5, 0.4]], ImageSize -> 
                Dynamic[{
                  Automatic, 3.5 CurrentValue["FontCapHeight"]/
                   AbsoluteCurrentValue[Magnification]}], 
                Method -> {
                 "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                  AbsolutePointSize[6], "ScalingFunctions" -> None, 
                  "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                PlotRange -> {{0., 0.01}, {0., 5.443950537406941}}, 
                PlotRangeClipping -> True, PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
              GridBox[{{
                 RowBox[{
                   TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox[
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "0.01`"}], "}"}], "}"}], 
                    "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"scalar\"", "SummaryItem"]}]}}, 
               GridBoxAlignment -> {
                "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
               False, GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {
                "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
               BaseStyle -> {
                ShowStringCharacters -> False, NumberMarks -> False, 
                 PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
            GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
            BaselinePosition -> {1, 1}], True -> GridBox[{{
              PaneBox[
               ButtonBox[
                DynamicBox[
                 FEPrivate`FrontEndResource[
                 "FEBitmaps", "SquareMinusIconMedium"]], 
                ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                None, Evaluator -> Automatic, Method -> "Preemptive"], 
               Alignment -> {Center, Center}, ImageSize -> 
               Dynamic[{
                 Automatic, 3.5 CurrentValue["FontCapHeight"]/
                  AbsoluteCurrentValue[Magnification]}]], 
              GraphicsBox[{{{{}, {}, 
                  TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwBkQNu/CFib1JlAgAAADgAAAACAAAAqv6pNOYxRj9Y0Tz4msYVQAqNTMOK
l0s/KuB1qsnhEkAWGU2euHpQP9VPVPHgWhBARpe3Ki9jUz/4JlwMt/sLQMd4
UgMSPlY/oa0p0mUHCEByGVSm1edYP4t8I3fp3wRAvGUZmRzLWz/gQltDKvQB
QDBxRVZEfV4/C0Vlhd9A/z/679Av7JBgP3YAYgDeU/s/LP1g3Pf/YT/kFAP+
dKz3P/NpJO5zVmM/6A1E0Ea/9D+JrMmnsclkP+bHEzdOBfI/yCCHhyU2Zj+W
+iULCnTvP5z0d8wJimc/GnTJICrB6z8/nkq5r/poP6089r45SOg/d6dQC8ZS
aj8LYQX3cnnlP3+GOAWex2s/kX4ecsjV4j8vlzglrDVtPzFO0ga+l+A/dAds
qiqLbj+eOtBIQondP4lNgddq/W8/ipmAwJsU2j+a+eS0jatwP36wpjmiQtc/
Q2UVEQFVcT/G+oGtMdPUP9S7NkHVDHI/wieVW8WA0j8vwvGjYbhyP1kUcNng
mNA/crOd2k5ycz+8Z/urfI7NP4m9VSTXKHQ/WAZZrj1ryj9rd6egF9N0P1jg
gaJR1Mc/NRzq8LiLdT/UrjMzglfFP8lwxnMSOHY/OjFXZJVIwz8x3q4JB+F2
P9S75J6Re8E/gTaIc1yYdz8yH8ykBXy/P5w++w9qQ3g/PDLIlgiXvD+eMV+A
2Px4PyzdxmZqyrk/a9RcI/+peT8WT1igDnW3PwyQZtnAU3o/FBbUr+ZmtT+V
NmFj4wt7PwY4pP8kZ7M/6Iz1H763ez8HJNkSnLqxPyPOerD5cXw/Lxi7MpMZ
sD8yKAxU0Ch9P7hojQ07Va0/DDI3Kl/TfT/LkKQ49+uqP84mU9ROjH4/2Kig
tAKQqD9aywix9jh/P/2lbKLvkqY/uojKoDnifz9kirFQw82kP4KYPrLuTIA/
GitTBBwQoz+MxGStnKKAP965UN79lqE/CmaDEnv/gD8xlW+9BCSgP/ITKAGn
WoE/p+kfLS+0nT+/mRkJr6+BP14ehQWyg5s/AJUDe+cLgj80XgkgrlmZPyZo
Ogb8YYI/ciA6IyeClz/AsGn7QL+CPyKGroz4r5U/xAUfetMagz8uzqH7Dg+U
P60yIRJCcIM/RTY8m/uqkj8K1RsU4cyDP69BNFFZSZE/TU9jL1wjhD9ha1CJ
vxqQP38320HheoQ/Ku9AOzYCjj/JdZrD
                    "]]}, 
                   Annotation[#, 
                    "Charting`Private`Tag$132117#1"]& ]}}, {}, {}}, {
               DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
                AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
                GridLines -> {None, None}, DisplayFunction -> Identity, 
                PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                All, DisplayFunction -> Identity, AspectRatio -> 1, 
                Axes -> {False, False}, AxesLabel -> {None, None}, 
                AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                Frame -> {{True, True}, {True, True}}, 
                FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                Directive[
                  Opacity[0.5], 
                  Thickness[Tiny], 
                  RGBColor[0.368417, 0.506779, 0.709798]], 
                FrameTicks -> {{None, None}, {None, None}}, 
                GridLines -> {None, None}, GridLinesStyle -> Directive[
                  GrayLevel[0.5, 0.4]], ImageSize -> 
                Dynamic[{
                  Automatic, 3.5 CurrentValue["FontCapHeight"]/
                   AbsoluteCurrentValue[Magnification]}], 
                Method -> {
                 "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                  AbsolutePointSize[6], "ScalingFunctions" -> None, 
                  "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                PlotRange -> {{0., 0.01}, {0., 5.443950537406941}}, 
                PlotRangeClipping -> True, PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
              GridBox[{{
                 RowBox[{
                   TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox[
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "0.01`"}], "}"}], "}"}], 
                    "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"scalar\"", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["3", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["False", "SummaryItem"]}]}}, 
               GridBoxAlignment -> {
                "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
               False, GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {
                "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
               BaseStyle -> {
                ShowStringCharacters -> False, NumberMarks -> False, 
                 PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
            GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
            BaselinePosition -> {1, 1}]}, 
         Dynamic[Typeset`open$$], ImageSize -> Automatic], BaselinePosition -> 
        Baseline], DynamicModuleValues :> {}], 
      StyleBox["]", "NonInterpretableSummary"]}]},
   "CopyTag",
   DisplayFunction->(#& ),
   InterpretationFunction->("InterpolatingFunction[{{0., 0.01}}, <>]"& )],
  False,
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{3.8157613829398003`*^9, 3.8157616511693373`*^9, 
  3.815761928584743*^9, 3.81582530889909*^9, 3.815825413268175*^9, 
  3.815846826071438*^9},ExpressionUUID->"ebe1a5f0-1426-4dec-b778-\
b1b823373e61"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tau2for300fastNOPUMPS", "=", 
  RowBox[{
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
     "IngdtgralinexpoInfIngdtgralinexpovals300fastNOPUMPSfunc", "[", "ww", 
      "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"ww", ",", "0.0", ",", ".01"}], "}"}]}], "]"}], "  ", "/", 
   RowBox[{"N", "[", 
    RowBox[{"p2new300fastNOPUMPS", "[", "0.2", "]"}], "]"}], " "}]}]], "Input",\

 CellChangeTimes->{{3.81576006876746*^9, 3.815760069039469*^9}, {
  3.815761337414315*^9, 3.815761339397098*^9}, {3.815761393140409*^9, 
  3.815761395555648*^9}, {3.815825302861163*^9, 
  3.8158253030396557`*^9}},ExpressionUUID->"26ca2216-fc95-4db9-8a87-\
e6153baabcc8"],

Cell[BoxData[
 RowBox[{"{", "0.01138008270989321`", "}"}]], "Output",
 CellChangeTimes->{
  3.815754525924816*^9, {3.8157599476515217`*^9, 3.8157599990396214`*^9}, 
   3.8157600695613213`*^9, 3.8157613965262938`*^9, 3.8157616532885313`*^9, 
   3.815761928717265*^9, 3.8158253107338333`*^9, 3.815825413339161*^9, 
   3.815846826104105*^9},ExpressionUUID->"085f597f-594f-4442-a231-\
b251b46f68b7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"First", "[", "tau2for100fast", "]"}], ",", " ", 
     RowBox[{"First", "[", "tau2for300fast", "]"}], ",", " ", 
     RowBox[{"First", "[", "tau2for100fastNOPUMPS", "]"}], ",", 
     RowBox[{"First", "[", "tau2for300fastNOPUMPS", "]"}]}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "4.1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", ".1"}], "}"}]}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.81575527053059*^9, 3.815755294498303*^9}, {
  3.815755424932152*^9, 3.815755443299721*^9}, {3.815755646742036*^9, 
  3.8157556627575808`*^9}, {3.815755736903865*^9, 3.815755758198778*^9}, {
  3.815755815303916*^9, 3.8157558442636757`*^9}, {3.815755899656681*^9, 
  3.815755906312367*^9}, {3.815761347778976*^9, 3.815761370746572*^9}, {
  3.815761704668754*^9, 
  3.81576171823736*^9}},ExpressionUUID->"1ec2251f-fd42-4e44-8460-\
81834f34e10b"],

Cell[BoxData[
 GraphicsBox[{{}, {{}, 
    {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.012833333333333334`],
      AbsoluteThickness[1.6], 
     PointBox[{{1., 0.00138185661090375}, {2., 0.0012679111962683586`}, {3., 
      0.010928240861699318`}, {4., 
      0.01138008270989321}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->{383., Automatic},
  Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 4.1}, {0, 0.1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.815755431442951*^9, 3.815755444017701*^9}, 
   3.81575564852374*^9, 3.815755759033992*^9, {3.815755817802909*^9, 
   3.815755844598254*^9}, {3.815755900001688*^9, 3.8157559074443703`*^9}, 
   3.815761654730236*^9, {3.815761696834853*^9, 3.8157617192075977`*^9}, 
   3.8157619287697363`*^9, 3.815762537047719*^9, 3.815825312964147*^9, 
   3.815825413476755*^9, 
   3.8158468261580544`*^9},ExpressionUUID->"4e2cd4a5-554d-4013-bbdc-\
0e5bded0b7f0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"First", "[", "tau2for100fast", "]"}], ",", " ", 
   RowBox[{"First", "[", "tau2for300fast", "]"}], ",", " ", 
   RowBox[{"First", "[", "tau2for100fastNOPUMPS", "]"}], ",", 
   RowBox[{"First", "[", "tau2for300fastNOPUMPS", "]"}]}], "}"}]], "Input",Exp\
ressionUUID->"4580815a-221d-45df-9008-5a1eef5a83c2"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.00138185661090375`", ",", "0.0012679111962683586`", ",", 
   "0.010928240861699318`", ",", "0.01138008270989321`"}], "}"}]], "Output",
 CellChangeTimes->{3.8157627539875307`*^9, 3.815825413543242*^9, 
  3.81584682616818*^9, 3.8158474272357273`*^9, 
  3.815847511134202*^9},ExpressionUUID->"677d93d0-bde1-4c18-a68a-\
ab05355f36c3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"timesvector", "=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"First", "[", "tau2for100fast", "]"}], ",", " ", 
     RowBox[{"First", "[", "tau2for300fast", "]"}], ",", " ", 
     RowBox[{"First", "[", "tau2for100fastNOPUMPS", "]"}], ",", 
     RowBox[{"First", "[", "tau2for300fastNOPUMPS", "]"}]}], "}"}], "*", 
   "1000"}]}], "\[IndentingNewLine]", 
 RowBox[{"xticks", "=", 
  RowBox[{"{", 
   RowBox[{
   "\"\<N=100\>\"", ",", "\"\<N=300\>\"", ",", "\"\<N=100nopumps\>\"", ",", 
    "\"\<N=300nopumps\>\""}], "}"}]}]}], "Input",
 CellChangeTimes->{{3.815827894381819*^9, 3.815827894382124*^9}, {
  3.815827953751704*^9, 3.815827960616466*^9}, {3.815828002968965*^9, 
  3.815828122361771*^9}, {3.8158460664054537`*^9, 3.81584607080518*^9}, {
  3.8158464127451773`*^9, 3.815846438553027*^9}, {3.8158470176948853`*^9, 
  3.815847018990258*^9}},ExpressionUUID->"375ede50-d6ff-4627-8b22-\
a127d522b326"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1.38185661090375`", ",", "1.2679111962683587`", ",", "10.928240861699319`",
    ",", "11.38008270989321`"}], "}"}]], "Output",
 CellChangeTimes->{3.8158468262023478`*^9, 3.815847019639648*^9, 
  3.815847440298367*^9, 3.8158474766078587`*^9, 
  3.815847512527602*^9},ExpressionUUID->"b860cfd9-5889-4a58-9197-\
eca2fc6fe7f0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"N=100\"\>", ",", "\<\"N=300\"\>", ",", "\<\"N=100nopumps\"\>", 
   ",", "\<\"N=300nopumps\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.8158468262023478`*^9, 3.815847019639648*^9, 
  3.815847440298367*^9, 3.8158474766078587`*^9, 
  3.8158475125291862`*^9},ExpressionUUID->"b8d6b184-4cac-4e17-84bd-\
4d145b5b322c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"d", "=", 
   RowBox[{"Range", "[", "4", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.8158345963464003`*^9, 3.815834628618585*^9}, 
   3.815834800476544*^9},ExpressionUUID->"c8dd9c3f-894a-4245-9ee4-\
56a09ded1c9d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"colorList", "=", 
   RowBox[{"{", 
    RowBox[{"Black", ",", "Red", ",", "Green", ",", "Magenta"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"bList", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"{", "#", "}"}], "&"}], "/@", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"n", ",", 
        RowBox[{"timesvector", "[", 
         RowBox[{"[", "n", "]"}], "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "d"}], "}"}]}], "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{
  3.8158346735942163`*^9, 3.8158348022688847`*^9, {3.8158348988452587`*^9, 
   3.8158349187207823`*^9}, {3.81584652304913*^9, 
   3.8158465269899197`*^9}},ExpressionUUID->"cd8ddd83-0075-4bb2-891e-\
3f21133a0980"],

Cell[CellGroupData[{

Cell[BoxData["bList"], "Input",
 CellChangeTimes->{{3.815834676475243*^9, 
  3.81583467745444*^9}},ExpressionUUID->"218b3d2d-dd1f-4edf-8c82-\
4e9723b1b255"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1.38185661090375`"}], "}"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"2", ",", "1.2679111962683587`"}], "}"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"3", ",", "10.928240861699319`"}], "}"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"4", ",", "11.38008270989321`"}], "}"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.815834677921139*^9, {3.8158347652691393`*^9, 3.815834804821867*^9}, 
   3.8158349210922737`*^9, 3.815846826246039*^9, 3.8158470334468803`*^9, 
   3.8158475175478983`*^9},ExpressionUUID->"0083d689-2137-4cf8-bc3e-\
a263728cc9e1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"center", "=", 
   RowBox[{
    RowBox[{"Row", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"#", ",", 
        RowBox[{"Invisible", "[", "#", "]"}]}], "}"}], ",", 
      "\"\<\[NegativeThickSpace]\>\""}], "]"}], "&"}]}], ";", 
  RowBox[{"xticks", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"center", "@", 
        RowBox[{"Rotate", "[", 
         RowBox[{"\"\<N=100 \>\"", " ", ",", 
          RowBox[{"45", " ", "Degree"}]}], "]"}]}]}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"center", "@", 
        RowBox[{"Rotate", "[", 
         RowBox[{"\"\<N=300 \>\"", " ", ",", 
          RowBox[{"45", " ", "Degree"}]}], "]"}]}]}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"3", ",", 
       RowBox[{"center", "@", 
        RowBox[{"Rotate", "[", 
         RowBox[{"\"\<N=100 no pumps\>\"", " ", ",", 
          RowBox[{"45", " ", "Degree"}]}], "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", 
       RowBox[{"center", "@", 
        RowBox[{"Rotate", "[", 
         RowBox[{"\"\<N=300 no pumps \>\"", " ", ",", 
          RowBox[{"45", " ", "Degree"}]}], "]"}]}]}], "}"}]}], 
    "}"}]}]}]], "Input",
 CellChangeTimes->{{3.815846541065504*^9, 3.815846550649909*^9}, 
   3.815846976751371*^9},ExpressionUUID->"c34331cc-88c5-4a3b-a18e-\
38dcd1328ee1"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", 
     TemplateBox[{
      "\[NegativeThickSpace]","\"\[NegativeThickSpace]\"",RotationBox[
       "\"N=100 \"", BoxRotation -> 0.7853981633974483],StyleBox[
        RotationBox["\"N=100 \"", BoxRotation -> 0.7853981633974483], 
        ShowContents -> False, StripOnInput -> False]},
      "RowWithSeparators"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     TemplateBox[{
      "\[NegativeThickSpace]","\"\[NegativeThickSpace]\"",RotationBox[
       "\"N=300 \"", BoxRotation -> 0.7853981633974483],StyleBox[
        RotationBox["\"N=300 \"", BoxRotation -> 0.7853981633974483], 
        ShowContents -> False, StripOnInput -> False]},
      "RowWithSeparators"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", 
     TemplateBox[{
      "\[NegativeThickSpace]","\"\[NegativeThickSpace]\"",RotationBox[
       "\"N=100 no pumps\"", BoxRotation -> 0.7853981633974483],StyleBox[
        RotationBox["\"N=100 no pumps\"", BoxRotation -> 0.7853981633974483], 
        ShowContents -> False, StripOnInput -> False]},
      "RowWithSeparators"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", 
     TemplateBox[{
      "\[NegativeThickSpace]","\"\[NegativeThickSpace]\"",RotationBox[
       "\"N=300 no pumps \"", BoxRotation -> 0.7853981633974483],StyleBox[
        RotationBox["\"N=300 no pumps \"", BoxRotation -> 0.7853981633974483],
         ShowContents -> False, StripOnInput -> False]},
      "RowWithSeparators"]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.815846014351861*^9, 3.8158468262744837`*^9, 
  3.81584697794911*^9, 3.8158470334629498`*^9, 
  3.815847519073427*^9},ExpressionUUID->"8565b1b1-b16c-4d09-811f-\
3b219261de71"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"plotofp2fast", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{"bList", ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"xticks", ",", "None"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", "colorList"}], ",", 
    RowBox[{"PlotMarkers", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Graphics", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Disk", "[", "]"}], "}"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "15"}]}], "]"}], "}"}]}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "4.1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "20"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"Black", ",", "20"}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.815837474601446*^9, 3.8158374844696283`*^9}, {
  3.815837667055241*^9, 3.815837752968227*^9}, {3.815846026613381*^9, 
  3.815846047317108*^9}, {3.815846115878439*^9, 3.815846180903454*^9}, {
  3.815846238422658*^9, 3.815846243831258*^9}, {3.815846561226273*^9, 
  3.815846561546343*^9}, {3.815847044223651*^9, 3.815847044430895*^9}, {
  3.815847217120895*^9, 
  3.8158472175844307`*^9}},ExpressionUUID->"e1ad6af0-08f2-49a9-84b3-\
934a23f6e7af"],

Cell[BoxData[
 GraphicsBox[{{}, {
    {GrayLevel[0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
     GeometricTransformationBox[InsetBox[
       GraphicsBox[
        {GrayLevel[0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
         DiskBox[{0, 0}]},
        ImageSize->15], {0., 0.}], {{{1., 1.38185661090375}}, {{1., 
      1.38185661090375}}}]}, 
    {RGBColor[1, 0, 0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
     GeometricTransformationBox[InsetBox[
       GraphicsBox[
        {RGBColor[1, 0, 0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
         DiskBox[{0, 0}]},
        ImageSize->15], {0., 0.}], {{{2., 1.2679111962683587`}}, {{2., 
      1.2679111962683587`}}}]}, 
    {RGBColor[0, 1, 0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
     GeometricTransformationBox[InsetBox[
       GraphicsBox[
        {RGBColor[0, 1, 0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
         DiskBox[{0, 0}]},
        ImageSize->15], {0., 0.}], {{{3., 10.928240861699319`}}, {{3., 
      10.928240861699319`}}}]}, 
    {RGBColor[1, 0, 1], AbsolutePointSize[6], AbsoluteThickness[1.6], 
     GeometricTransformationBox[InsetBox[
       GraphicsBox[
        {RGBColor[1, 0, 1], AbsolutePointSize[6], AbsoluteThickness[1.6], 
         DiskBox[{0, 0}]},
        ImageSize->15], {0., 0.}], {{{4., 11.38008270989321}}, {{4., 
      11.38008270989321}}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, None}, {{{1, 
       FormBox[
        TemplateBox[{"\[NegativeThickSpace]", "\"\[NegativeThickSpace]\"", 
          RotationBox["\"N=100 \"", BoxRotation -> 0.7853981633974483], 
          StyleBox[
           RotationBox["\"N=100 \"", BoxRotation -> 0.7853981633974483], 
           ShowContents -> False, StripOnInput -> False]}, 
         "RowWithSeparators"], TraditionalForm]}, {2, 
       FormBox[
        TemplateBox[{"\[NegativeThickSpace]", "\"\[NegativeThickSpace]\"", 
          RotationBox["\"N=300 \"", BoxRotation -> 0.7853981633974483], 
          StyleBox[
           RotationBox["\"N=300 \"", BoxRotation -> 0.7853981633974483], 
           ShowContents -> False, StripOnInput -> False]}, 
         "RowWithSeparators"], TraditionalForm]}, {3, 
       FormBox[
        TemplateBox[{"\[NegativeThickSpace]", "\"\[NegativeThickSpace]\"", 
          RotationBox[
          "\"N=100 no pumps\"", BoxRotation -> 0.7853981633974483], 
          StyleBox[
           RotationBox[
           "\"N=100 no pumps\"", BoxRotation -> 0.7853981633974483], 
           ShowContents -> False, StripOnInput -> False]}, 
         "RowWithSeparators"], TraditionalForm]}, {4, 
       FormBox[
        TemplateBox[{"\[NegativeThickSpace]", "\"\[NegativeThickSpace]\"", 
          RotationBox[
          "\"N=300 no pumps \"", BoxRotation -> 0.7853981633974483], 
          StyleBox[
           RotationBox[
           "\"N=300 no pumps \"", BoxRotation -> 0.7853981633974483], 
           ShowContents -> False, StripOnInput -> False]}, 
         "RowWithSeparators"], TraditionalForm]}}, None}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->{507., Automatic},
  LabelStyle->Directive[
    GrayLevel[0], 20],
  Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 4.1}, {0, 20}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.815846035456442*^9, 3.81584604779907*^9}, {
   3.81584611950458*^9, 3.815846167926982*^9}, {3.815846244361161*^9, 
   3.815846270197864*^9}, 3.815846826324099*^9, 3.815846981627191*^9, {
   3.815847033494626*^9, 3.81584704529478*^9}, 3.815847484700616*^9, 
   3.815847521361155*^9},ExpressionUUID->"2a37828b-7fb5-4546-a956-\
895679956e6b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"figurefastp2", "=", 
  RowBox[{"Labeled", "[", 
   RowBox[{
    RowBox[{"Show", "[", 
     RowBox[{"plotofp2fast", ",", 
      RowBox[{"LabelStyle", "\[Rule]", 
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", "20"}], "]"}]}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Conditional opening time (ms)\>\"", ",", "\"\<Condition\>\""}], 
     "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"Left", ",", "Bottom", ",", "Top", ",", "Right"}], "}"}], ",", 
    RowBox[{"RotateLabel", "\[Rule]", "True"}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"Black", ",", "20"}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.815846251255488*^9, 3.8158462969030237`*^9}, {
   3.815847082335636*^9, 3.81584708366254*^9}, {3.815847222592043*^9, 
   3.815847222992309*^9}, 
   3.815847466370422*^9},ExpressionUUID->"b61d1e25-2223-47cd-8751-\
47e245f47164"],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{}, {{{
        Directive[
         PointSize[0.012833333333333334`], 
         AbsoluteThickness[1.6], 
         GrayLevel[0], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          GraphicsBox[{
            Directive[
             PointSize[0.012833333333333334`], 
             AbsoluteThickness[1.6], 
             GrayLevel[0], 
             AbsolutePointSize[6]], 
            DiskBox[{0, 0}]}, ImageSize -> 15], {0., 0.}], {{{1., 
         1.38185661090375}}, {{1., 1.38185661090375}}}]}, {
        Directive[
         PointSize[0.012833333333333334`], 
         AbsoluteThickness[1.6], 
         RGBColor[1, 0, 0], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          GraphicsBox[{
            Directive[
             PointSize[0.012833333333333334`], 
             AbsoluteThickness[1.6], 
             RGBColor[1, 0, 0], 
             AbsolutePointSize[6]], 
            DiskBox[{0, 0}]}, ImageSize -> 15], {0., 0.}], {{{2., 
         1.2679111962683587`}}, {{2., 1.2679111962683587`}}}]}, {
        Directive[
         PointSize[0.012833333333333334`], 
         AbsoluteThickness[1.6], 
         RGBColor[0, 1, 0], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          GraphicsBox[{
            Directive[
             PointSize[0.012833333333333334`], 
             AbsoluteThickness[1.6], 
             RGBColor[0, 1, 0], 
             AbsolutePointSize[6]], 
            DiskBox[{0, 0}]}, ImageSize -> 15], {0., 0.}], {{{3., 
         10.928240861699319`}}, {{3., 10.928240861699319`}}}]}, {
        Directive[
         PointSize[0.012833333333333334`], 
         AbsoluteThickness[1.6], 
         RGBColor[1, 0, 1], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          GraphicsBox[{
            Directive[
             PointSize[0.012833333333333334`], 
             AbsoluteThickness[1.6], 
             RGBColor[1, 0, 1], 
             AbsolutePointSize[6]], 
            DiskBox[{0, 0}]}, ImageSize -> 15], {0., 0.}], {{{4., 
         11.38008270989321}}, {{4., 
         11.38008270989321}}}]}, {}}}, {}, {}, {{}, {}}, {{}, {}}}, {
    LabelStyle -> Directive[
       GrayLevel[0], 20], DisplayFunction -> Identity, 
     PlotRangePadding -> {{0, 0}, {0, 0}}, AxesOrigin -> {0, 0}, 
     PlotRange -> {{0, 4.1}, {0, 20}}, PlotRangeClipping -> True, 
     ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
     NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
     AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
     Identity, Frame -> {{True, True}, {True, True}}, 
     FrameLabel -> {{None, None}, {None, None}}, 
     FrameTicks -> {{Automatic, None}, {{{1, 
          FormBox[
           
           TemplateBox[{
            "\[NegativeThickSpace]", "\"\[NegativeThickSpace]\"", 
             RotationBox["\"N=100 \"", BoxRotation -> 0.7853981633974483], 
             StyleBox[
              RotationBox["\"N=100 \"", BoxRotation -> 0.7853981633974483], 
              ShowContents -> False, StripOnInput -> False]}, 
            "RowWithSeparators"], TraditionalForm]}, {2, 
          FormBox[
           
           TemplateBox[{
            "\[NegativeThickSpace]", "\"\[NegativeThickSpace]\"", 
             RotationBox["\"N=300 \"", BoxRotation -> 0.7853981633974483], 
             StyleBox[
              RotationBox["\"N=300 \"", BoxRotation -> 0.7853981633974483], 
              ShowContents -> False, StripOnInput -> False]}, 
            "RowWithSeparators"], TraditionalForm]}, {3, 
          FormBox[
           
           TemplateBox[{
            "\[NegativeThickSpace]", "\"\[NegativeThickSpace]\"", 
             RotationBox[
             "\"N=100 no pumps\"", BoxRotation -> 0.7853981633974483], 
             StyleBox[
              RotationBox[
              "\"N=100 no pumps\"", BoxRotation -> 0.7853981633974483], 
              ShowContents -> False, StripOnInput -> False]}, 
            "RowWithSeparators"], TraditionalForm]}, {4, 
          FormBox[
           
           TemplateBox[{
            "\[NegativeThickSpace]", "\"\[NegativeThickSpace]\"", 
             RotationBox[
             "\"N=300 no pumps \"", BoxRotation -> 0.7853981633974483], 
             StyleBox[
              RotationBox[
              "\"N=300 no pumps \"", BoxRotation -> 0.7853981633974483], 
              ShowContents -> False, StripOnInput -> False]}, 
            "RowWithSeparators"], TraditionalForm]}}, None}}, 
     GridLines -> {None, None}, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], LabelStyle -> Directive[
       GrayLevel[0], 20], 
     Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& ), "CopiedValueFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )}}, PlotRange -> {{0, 4.1}, {0, 20}}, 
     PlotRangeClipping -> True, PlotRangePadding -> {{0, 0}, {0, 0}}, 
     Ticks -> {Automatic, Automatic}}],"\"Conditional opening time (ms)\"",
   "\"Condition\""},
  "Labeled",
  DisplayFunction->(GridBox[{{
      ItemBox[
       RotationBox[#2, BoxRotation -> 1.5707963267948966`], BaseStyle -> 
       Directive[
         GrayLevel[0], 20], DefaultBaseStyle -> "LabeledLabel"], 
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"]}, {"", 
      ItemBox[#3, BaseStyle -> Directive[
         GrayLevel[0], 20], DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, 
    GridBoxItemSize -> {"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
    BaselinePosition -> {1, 2}]& ),
  InterpretationFunction->(RowBox[{"Labeled", "[", 
     RowBox[{#, ",", 
       RowBox[{"{", 
         RowBox[{#2, ",", #3}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{"Left", ",", "Bottom", ",", "Top", ",", "Right"}], "}"}], 
       ",", 
       RowBox[{"RotateLabel", "\[Rule]", "True"}], ",", 
       RowBox[{"LabelStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
           RowBox[{
             InterpretationBox[
              ButtonBox[
               TooltipBox[
                GraphicsBox[{{
                   GrayLevel[0], 
                   RectangleBox[{0, 0}]}, {
                   GrayLevel[0], 
                   RectangleBox[{1, -1}]}, {
                   GrayLevel[0], 
                   RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                 True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                 PlotRangePadding -> None, ImageSize -> 
                 Dynamic[{
                   Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
               Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
               Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
               With[{Typeset`box$ = EvaluationBox[]}, 
                 If[
                  Not[
                   AbsoluteCurrentValue["Deployed"]], 
                  SelectionMove[Typeset`box$, All, Expression]; 
                  FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                  FrontEnd`Private`$ColorSelectorInitialColor = GrayLevel[0]; 
                  FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                  MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
               Automatic, Method -> "Preemptive"], 
              GrayLevel[0], Editable -> False, Selectable -> False], ",", 
             "20"}], "]"}]}]}], "]"}]& )]], "Output",
 CellChangeTimes->{
  3.815846254798067*^9, 3.815846297866547*^9, 3.815846826345293*^9, 
   3.8158469857615547`*^9, {3.815847033525466*^9, 3.815847047885975*^9}, 
   3.81584746743793*^9, 
   3.815847525558672*^9},ExpressionUUID->"c5623cba-3ef4-4c8a-a9db-\
c44f61e9433e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\</media/basnayak/Data \
new/basnayak/Dropbox/STIM_ORAI_bionewmetrics/mathematica_scripts/\
fastp2conditions.pdf\>\"", ",", "figurefastp2"}], "]"}]], "Input",
 CellChangeTimes->{{3.815847249680176*^9, 3.815847327457233*^9}, {
  3.815847538819253*^9, 
  3.8158475543570833`*^9}},ExpressionUUID->"bb5f379d-b065-4be8-a3b8-\
84bdc5919885"],

Cell[BoxData["\<\"/media/basnayak/Data \
new/basnayak/Dropbox/STIM_ORAI_bionewmetrics/mathematica_scripts/\
fastp2conditions.pdf\"\>"], "Output",
 CellChangeTimes->{{3.815847543271937*^9, 
  3.815847555542519*^9}},ExpressionUUID->"7ae5e571-4dcd-4ab5-b12d-\
bc4e5f791ac5"]
}, Open  ]]
},
WindowSize->{1200, 1140},
WindowMargins->{{45, Automatic}, {Automatic, 33}},
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 380, 9, 34, "Input", "ExpressionUUID" -> \
"9a151358-99d3-4405-827f-1a0a26cba56e"],
Cell[963, 33, 367, 6, 32, "Output", "ExpressionUUID" -> \
"e2d57ef9-5156-40b4-9dfe-dcdd77d37439"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1367, 44, 5169, 144, 240, "Input", "ExpressionUUID" -> \
"1e09f38a-e9ea-4828-9016-c4d44cfec76c"],
Cell[6539, 190, 23229, 402, 237, "Output", "ExpressionUUID" -> \
"31d1138b-72ce-40a0-8052-c3a6077f8813"],
Cell[29771, 594, 4742, 94, 238, "Output", "ExpressionUUID" -> \
"1925e5b6-e605-4925-9ccd-acfabfa9f19d"],
Cell[34516, 690, 7135, 133, 232, "Output", "ExpressionUUID" -> \
"a827e29e-cdc7-4f78-b1bc-d164333d45be"],
Cell[41654, 825, 10818, 194, 238, "Output", "ExpressionUUID" -> \
"ec90126d-259a-4463-aa0d-c2ed2f9efc55"]
}, Open  ]],
Cell[52487, 1022, 617, 16, 80, "Input", "ExpressionUUID" -> \
"a70698e7-d20c-4eef-aa57-90f003241768"],
Cell[CellGroupData[{
Cell[53129, 1042, 578, 14, 77, "Input", "ExpressionUUID" -> \
"98d49387-a0d5-4764-8cce-0a11ae46c206"],
Cell[53710, 1058, 479, 8, 32, "Output", "ExpressionUUID" -> \
"31d3b5bb-5018-4563-9ae3-444584f134ac"]
}, Open  ]],
Cell[CellGroupData[{
Cell[54226, 1071, 2127, 51, 102, "Input", "ExpressionUUID" -> \
"99494d26-623b-4474-9db1-033f1f5545e6"],
Cell[56356, 1124, 4523, 105, 148, "Output", "ExpressionUUID" -> \
"be750eda-0a0e-4569-9ca7-c246738acc2a"]
}, Open  ]],
Cell[60894, 1232, 787, 18, 56, "Input", "ExpressionUUID" -> \
"0945a5a2-7285-4a70-8127-9f9b1746bbb1"],
Cell[CellGroupData[{
Cell[61706, 1254, 646, 12, 56, "Input", "ExpressionUUID" -> \
"6c7dcc9a-19b6-420b-bfaf-0c46edd6c0dd"],
Cell[62355, 1268, 12827, 254, 65, "Output", "ExpressionUUID" -> \
"bb3e18e3-390a-4616-939f-a9a89e9a31ce"]
}, Open  ]],
Cell[CellGroupData[{
Cell[75219, 1527, 749, 17, 34, "Input", "ExpressionUUID" -> \
"8b2e73ec-9d18-4a6c-ab16-e873809871b1"],
Cell[75971, 1546, 466, 8, 32, "Output", "ExpressionUUID" -> \
"3532710b-8fdc-452d-a15a-d61d680a42c9"]
}, Open  ]],
Cell[76452, 1557, 278, 5, 143, "Input", "ExpressionUUID" -> \
"1e247c1d-763f-4e23-ae4d-ee146905b198"],
Cell[CellGroupData[{
Cell[76755, 1566, 5603, 154, 241, "Input", "ExpressionUUID" -> \
"af44b988-93a1-4044-8aad-3dc723ba5bd4"],
Cell[82361, 1722, 539, 9, 32, "Output", "ExpressionUUID" -> \
"f43d9180-2989-49f6-8dfe-d3a160eeafcc"],
Cell[82903, 1733, 18442, 324, 236, "Output", "ExpressionUUID" -> \
"0b92ff68-20a2-4a02-9f0e-4938670571a9"],
Cell[101348, 2059, 6857, 129, 238, "Output", "ExpressionUUID" -> \
"4ed93a92-fdeb-4b0b-a4dd-ab58658ef053"],
Cell[108208, 2190, 7382, 138, 231, "Output", "ExpressionUUID" -> \
"63ba463a-8992-4c1d-a551-b7fd64b6d6ac"],
Cell[115593, 2330, 7481, 139, 238, "Output", "ExpressionUUID" -> \
"a074d187-56a3-42ca-914f-fce9091cb0e9"]
}, Open  ]],
Cell[123089, 2472, 590, 16, 80, "Input", "ExpressionUUID" -> \
"fdfa7f0a-f122-412f-897a-55ec00362352"],
Cell[CellGroupData[{
Cell[123704, 2492, 786, 17, 77, "Input", "ExpressionUUID" -> \
"7e9093f8-8b25-46db-9b52-6679a91bdc68"],
Cell[124493, 2511, 430, 7, 32, "Output", "ExpressionUUID" -> \
"d6e0a4ed-2543-463c-b10c-8d146377a228"]
}, Open  ]],
Cell[CellGroupData[{
Cell[124960, 2523, 2586, 62, 103, "Input", "ExpressionUUID" -> \
"670bfddc-7e70-44f1-a2e3-ce2921a27a22"],
Cell[127549, 2587, 4176, 92, 240, "Output", "ExpressionUUID" -> \
"86083cad-856c-4e5f-825a-f1fa9628b7dd"]
}, Open  ]],
Cell[131740, 2682, 965, 21, 56, "Input", "ExpressionUUID" -> \
"703b7f27-4707-4d5e-b778-63f2ca2cf53d"],
Cell[CellGroupData[{
Cell[132730, 2707, 849, 15, 56, "Input", "ExpressionUUID" -> \
"786af418-e090-4277-bf6c-9557d35cb45f"],
Cell[133582, 2724, 13067, 257, 65, "Output", "ExpressionUUID" -> \
"385296b7-8d99-47d4-9562-7886cac6ed67"]
}, Open  ]],
Cell[CellGroupData[{
Cell[146686, 2986, 835, 18, 34, "Input", "ExpressionUUID" -> \
"50586490-d038-4212-a339-1f7c13659f48"],
Cell[147524, 3006, 464, 7, 32, "Output", "ExpressionUUID" -> \
"05d2292e-7419-4916-823f-2786079d799e"]
}, Open  ]],
Cell[148003, 3016, 232, 5, 99, "Input", "ExpressionUUID" -> \
"02c84d93-e0c9-4662-b6eb-e1763752b1b7"],
Cell[CellGroupData[{
Cell[148260, 3025, 5326, 149, 285, "Input", "ExpressionUUID" -> \
"5f2fa522-b712-487d-ba2a-1222db6afccd"],
Cell[153589, 3176, 448, 8, 32, "Output", "ExpressionUUID" -> \
"d686ab39-dfeb-45e1-b3a1-08078d528753"],
Cell[154040, 3186, 21890, 381, 237, "Output", "ExpressionUUID" -> \
"aae9b33c-eae0-43ae-b59f-dc075e1b12b0"],
Cell[175933, 3569, 6338, 121, 238, "Output", "ExpressionUUID" -> \
"cd00beb2-262f-4466-9156-e26f39421715"],
Cell[182274, 3692, 8115, 150, 232, "Output", "ExpressionUUID" -> \
"4bfaf352-c37b-4e4f-bdda-4693e982225e"],
Cell[190392, 3844, 10535, 190, 238, "Output", "ExpressionUUID" -> \
"6f2a7a5b-1998-41c6-9517-b10cc9640a48"]
}, Open  ]],
Cell[200942, 4037, 652, 17, 80, "Input", "ExpressionUUID" -> \
"d89d4ee7-d877-491b-9704-42a8be4c113e"],
Cell[CellGroupData[{
Cell[201619, 4058, 319, 7, 32, "Input", "ExpressionUUID" -> \
"f85391d3-be09-415f-bd98-31cc1d86d371"],
Cell[201941, 4067, 408, 8, 32, "Output", "ExpressionUUID" -> \
"354204ec-9c1a-4eec-bffd-5e5a0c7b9644"]
}, Open  ]],
Cell[CellGroupData[{
Cell[202386, 4080, 2067, 53, 125, "Input", "ExpressionUUID" -> \
"dab21d13-6f14-4b4e-ab7e-61323c068fd1"],
Cell[204456, 4135, 6340, 126, 233, "Output", "ExpressionUUID" -> \
"4640a8a4-bd53-4a37-b468-30ffae57dbee"]
}, Open  ]],
Cell[210811, 4264, 705, 17, 56, "Input", "ExpressionUUID" -> \
"f2b1d554-00a7-4ae9-8da7-2a688caf4744"],
Cell[CellGroupData[{
Cell[211541, 4285, 658, 14, 78, "Input", "ExpressionUUID" -> \
"7895801e-c655-4ecd-a0d8-39fad394ed2d"],
Cell[212202, 4301, 12765, 254, 65, "Output", "ExpressionUUID" -> \
"e7d1fe37-beef-49b4-81c1-33ccfe62da55"]
}, Open  ]],
Cell[CellGroupData[{
Cell[225004, 4560, 669, 17, 56, "Input", "ExpressionUUID" -> \
"9523c687-7614-454b-87ec-d095150218bc"],
Cell[225676, 4579, 495, 9, 32, "Output", "ExpressionUUID" -> \
"656790da-becb-44c3-81b7-dc11b987363b"]
}, Open  ]],
Cell[226186, 4591, 232, 5, 99, "Input", "ExpressionUUID" -> \
"c013fa0b-5698-42b3-a779-c33fca880a11"],
Cell[CellGroupData[{
Cell[226443, 4600, 5484, 151, 329, "Input", "ExpressionUUID" -> \
"5e3ca941-9625-4c1f-9c55-9187990e3757"],
Cell[231930, 4753, 450, 8, 32, "Output", "ExpressionUUID" -> \
"7646477a-3b0d-4e76-acdf-1a9a3b0424cd"],
Cell[232383, 4763, 18670, 328, 237, "Output", "ExpressionUUID" -> \
"317b43d5-ca19-45ab-acab-56ddbe8b7ca0"],
Cell[251056, 5093, 6514, 124, 238, "Output", "ExpressionUUID" -> \
"12ee75cf-df0f-4527-9004-5bb86af341bc"],
Cell[257573, 5219, 8336, 154, 231, "Output", "ExpressionUUID" -> \
"95d8b8d0-63b0-42c4-8758-d960e7694f34"],
Cell[265912, 5375, 7388, 138, 238, "Output", "ExpressionUUID" -> \
"e662da7b-76d9-4572-8ed3-22789326cab4"]
}, Open  ]],
Cell[273315, 5516, 699, 17, 80, "Input", "ExpressionUUID" -> \
"81ddc7c3-0836-4847-bdd6-790b3d8ce608"],
Cell[CellGroupData[{
Cell[274039, 5537, 295, 7, 32, "Input", "ExpressionUUID" -> \
"9aaf857c-ac1a-4eb6-99fa-b97033166f2f"],
Cell[274337, 5546, 352, 6, 32, "Output", "ExpressionUUID" -> \
"87f46ef7-bb42-45ea-bc22-1855aea3dff9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[274726, 5557, 1996, 51, 146, "Input", "ExpressionUUID" -> \
"e55bc0b5-bedd-4d05-94a8-8a7b6527d439"],
Cell[276725, 5610, 4287, 99, 239, "Output", "ExpressionUUID" -> \
"879ab516-20d8-48af-8640-076de7dd3374"]
}, Open  ]],
Cell[281027, 5712, 777, 18, 56, "Input", "ExpressionUUID" -> \
"4beb6b52-d71a-4796-8589-91ee244f8cda"],
Cell[CellGroupData[{
Cell[281829, 5734, 679, 15, 78, "Input", "ExpressionUUID" -> \
"86bd5dff-8d95-4bd9-8461-0784a6ae583f"],
Cell[282511, 5751, 12757, 253, 65, "Output", "ExpressionUUID" -> \
"ebe1a5f0-1426-4dec-b778-b1b823373e61"]
}, Open  ]],
Cell[CellGroupData[{
Cell[295305, 6009, 690, 17, 56, "Input", "ExpressionUUID" -> \
"26ca2216-fc95-4db9-8a87-e6153baabcc8"],
Cell[295998, 6028, 395, 7, 32, "Output", "ExpressionUUID" -> \
"085f597f-594f-4442-a231-b251b46f68b7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[296430, 6040, 1036, 23, 57, "Input", "ExpressionUUID" -> \
"1ec2251f-fd42-4e44-8460-81834f34e10b"],
Cell[297469, 6065, 1678, 40, 255, "Output", "ExpressionUUID" -> \
"4e2cd4a5-554d-4013-bbdc-0e5bded0b7f0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[299184, 6110, 357, 7, 34, "Input", "ExpressionUUID" -> \
"4580815a-221d-45df-9008-5a1eef5a83c2"],
Cell[299544, 6119, 375, 8, 34, "Output", "ExpressionUUID" -> \
"677d93d0-bde1-4c18-a68a-ab05355f36c3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[299956, 6132, 939, 20, 57, "Input", "ExpressionUUID" -> \
"375ede50-d6ff-4627-8b22-a127d522b326"],
Cell[300898, 6154, 366, 8, 34, "Output", "ExpressionUUID" -> \
"b860cfd9-5889-4a58-9197-eca2fc6fe7f0"],
Cell[301267, 6164, 358, 7, 34, "Output", "ExpressionUUID" -> \
"b8d6b184-4cac-4e17-84bd-4d145b5b322c"]
}, Open  ]],
Cell[301640, 6174, 251, 6, 34, "Input", "ExpressionUUID" -> \
"c8dd9c3f-894a-4245-9ee4-56a09ded1c9d"],
Cell[301894, 6182, 785, 23, 57, "Input", "ExpressionUUID" -> \
"cd8ddd83-0075-4bb2-891e-3f21133a0980"],
Cell[CellGroupData[{
Cell[302704, 6209, 156, 3, 32, "Input", "ExpressionUUID" -> \
"218b3d2d-dd1f-4edf-8c82-4e9723b1b255"],
Cell[302863, 6214, 717, 20, 34, "Output", "ExpressionUUID" -> \
"0083d689-2137-4cf8-bc3e-a263728cc9e1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[303617, 6239, 1404, 40, 57, "Input", "ExpressionUUID" -> \
"c34331cc-88c5-4a3b-a18e-38dcd1328ee1"],
Cell[305024, 6281, 1747, 38, 115, "Output", "ExpressionUUID" -> \
"8565b1b1-b16c-4d09-811f-3b219261de71"]
}, Open  ]],
Cell[CellGroupData[{
Cell[306808, 6324, 1511, 37, 57, "Input", "ExpressionUUID" -> \
"e1ad6af0-08f2-49a9-84b3-934a23f6e7af"],
Cell[308322, 6363, 4252, 95, 387, "Output", "ExpressionUUID" -> \
"2a37828b-7fb5-4546-a956-895679956e6b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[312611, 6463, 940, 23, 34, "Input", "ExpressionUUID" -> \
"b61d1e25-2223-47cd-8751-47e245f47164"],
Cell[313554, 6488, 8603, 197, 418, "Output", "ExpressionUUID" -> \
"c5623cba-3ef4-4c8a-a9db-c44f61e9433e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[322194, 6690, 390, 9, 34, "Input", "ExpressionUUID" -> \
"bb5f379d-b065-4be8-a3b8-84bdc5919885"],
Cell[322587, 6701, 271, 5, 89, "Output", "ExpressionUUID" -> \
"7ae5e571-4dcd-4ab5-b12d-bc4e5f791ac5"]
}, Open  ]]
}
]
*)

