(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    494036,       9894]
NotebookOptionsPosition[    489409,       9750]
NotebookOutlinePosition[    489746,       9765]
CellTagsIndexPosition[    489703,       9762]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"nopumpingrate", "=", "90"}], ";", 
  RowBox[{"pumpingrate", "=", "800"}], ";", " ", 
  RowBox[{"linethick", "=", "0.01"}], ";"}]], "Input",
 CellChangeTimes->{{3.815744349483822*^9, 
  3.8157443551147547`*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Mu]", "=", "38"}], ";", 
  RowBox[{"\[Lambda]", "=", "6"}], ";", 
  RowBox[{"NR", "=", "1"}], ";", 
  RowBox[{"\[Nu]", "=", "pumpingrate"}], ";", " ", 
  RowBox[{"A", "=", "100"}]}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{"a", "=", "1.53"}], ";", 
   RowBox[{"b", "=", "1.43"}], ";", 
   RowBox[{
    RowBox[{"Jin", "[", "t_", "]"}], ":=", 
    RowBox[{
     RowBox[{"A", "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"1", "/", "2.3"}], "-", 
        RowBox[{"1", "/", "2.31"}]}], ")"}]}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"-", "2.3"}], "*", "t"}], "]"}], "-", 
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"-", "2.31"}], "*", "t"}], "]"}]}], 
      ")"}]}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"s", "=", 
   RowBox[{"NDSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"n1", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Mu]"}], "*", 
          RowBox[{"n1", "[", "t", "]"}]}], "+", " ", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], " ", "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"2", "*", 
             RowBox[{"n1", "[", "t", "]"}]}]}], " ", ")"}]}]}]}], " ", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"nca", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{"Jin", "[", "t", "]"}], "-", 
         RowBox[{"\[Nu]", "*", 
          RowBox[{"nca", "[", "t", "]"}]}], " ", "-", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"n1", "[", "t", "]"}]}], ")"}]}], "+", 
         RowBox[{"\[Mu]", "*", 
          RowBox[{"n1", "[", "t", "]"}]}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"p2", "'"}], "[", "t", "]"}], "\[Equal]", " ", 
        RowBox[{"\[Lambda]", "*", 
         RowBox[{"n1", "[", "t", "]"}], "*", 
         RowBox[{"nca", "[", "t", "]"}], "*", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"p2", "[", "t", "]"}]}], ")"}]}]}], ",", 
       "\[IndentingNewLine]", " ", 
       RowBox[{
        RowBox[{"n1", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
       RowBox[{
        RowBox[{"nca", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
       RowBox[{
        RowBox[{"p2", "[", "0", "]"}], "\[Equal]", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"n1", ",", "nca", ",", "p2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0.0", ",", "10"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"n1", "[", "t", "]"}], "/.", "s"}], "]"}], ",", 
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"nca", "[", "t", "]"}], "/.", "s"}], "]"}], ",", 
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"p2", "[", "t", "]"}], "/.", "s"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "10"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "10"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{"Orange", ",", 
       RowBox[{"Darker", "[", "Green", "]"}], ",", "Blue"}], "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"plotofn1Slow100", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"n1", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "10"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "10"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{"Black", ",", 
       RowBox[{"Thickness", "[", "linethick", "]"}]}], "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"{", "\"\<N=100\>\"", "}"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"plotofncaSlow100", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"nca", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "10"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "10"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.001"}], ",", ".11"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{"Black", ",", 
       RowBox[{"Thickness", "[", "linethick", "]"}]}], "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"{", "\"\<N=100\>\"", "}"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"plotofp2Slow100", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"p2", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "10"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "10"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.01"}], ",", ".11"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{"Black", ",", 
       RowBox[{"Thickness", "[", "linethick", "]"}]}], "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"{", "\"\<N=100\>\"", "}"}]}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.8154954466784477`*^9, 3.81549546339727*^9}, {
   3.815753839511162*^9, 3.8157538397012177`*^9}, 
   3.815825606115587*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData["100"], "Output",
 CellChangeTimes->{3.815495469174765*^9, 3.8157443597554893`*^9, 
  3.815753841839561*^9, 3.815754157870742*^9, 3.8157619288567047`*^9, 
  3.8158256162217283`*^9, 3.815826452752221*^9, 
  3.8158471087849503`*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[1, 0.5, 0], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJwVVXc4Fl4btrP3Xu9SlJUShfecJ6uIFJmhIqOUbCqV7MyXyiwkipLZEj+r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       "]]},
     Annotation[#, "Charting`Private`Tag$137136#1"]& ], 
    TagBox[
     {RGBColor[0, 
       NCache[
        Rational[2, 3], 0.6666666666666666], 0], AbsoluteThickness[1.6], 
      Opacity[1.], LineBox[CompressedData["
1:eJwVV3c8198Xtvfe22cI4UtJlHTvMUOoyCgaZIuMSCKRUCgkUWZRVkgkI9mb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       "]]},
     Annotation[#, "Charting`Private`Tag$137136#2"]& ], 
    TagBox[
     {RGBColor[0, 0, 1], AbsoluteThickness[1.6], Opacity[1.], 
      LineBox[CompressedData["
1:eJxF13k01c8bB/CLa99VimS7ISLpqyK6z5Qoa7In+15KFGV3aSHZs0VKoqgk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       "]]},
     Annotation[#, "Charting`Private`Tag$137136#3"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 10}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.815495469174765*^9, 3.8157443597554893`*^9, 
  3.815753841839561*^9, 3.815754157870742*^9, 3.8157619288567047`*^9, 
  3.8158256162217283`*^9, 3.815826452752221*^9, 
  3.815847108856688*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{{{}, {}, 
       TagBox[{
         Directive[
          Opacity[1.], 
          AbsoluteThickness[1.6], 
          GrayLevel[0], 
          Thickness[0.01]], 
         LineBox[CompressedData["
1:eJwVVXc4Fl4btrP3Xu9SlJUShfecJ6uIFJmhIqOUbCqV7MyXyiwkipLZEj+r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          "]]}, 
        Annotation[#, "Charting`Private`Tag$137180#1"]& ]}}, {}, {}}, {
    DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
     AxesOrigin -> {0, 0}, FrameTicks -> {{Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}}, 
     GridLines -> {None, None}, DisplayFunction -> Identity, 
     PlotRangePadding -> {{0, 0}, {0, 0}}, PlotRangeClipping -> True, 
     ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
     NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
     AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
     Identity, Frame -> {{False, False}, {False, False}}, 
     FrameLabel -> {{None, None}, {None, None}}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> 15, GridLines -> {None, None}, GridLinesStyle -> 
     Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
       AbsolutePointSize[6], "ScalingFunctions" -> None, 
       "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& ), "CopiedValueFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )}}, PlotRange -> {{0, 10}, {0, 1}}, 
     PlotRangeClipping -> True, 
     PlotRangePadding -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{"\"N=100\""}, "LineLegend", DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    GrayLevel[0], 
                    Thickness[0.18]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    GrayLevel[0], 
                    Thickness[0.18]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"LineLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Directive", "[", 
               RowBox[{
                 RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                 RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                 InterpretationBox[
                  ButtonBox[
                   TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                   Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                   Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                   With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                   Automatic, Method -> "Preemptive"], 
                  GrayLevel[0], Editable -> False, Selectable -> False], ",", 
                 
                 RowBox[{"Thickness", "[", "0.01`", "]"}]}], "]"}], "}"}], 
           ",", 
           RowBox[{"{", #, "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
      Editable -> True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{3.815495469174765*^9, 3.8157443597554893`*^9, 
  3.815753841839561*^9, 3.815754157870742*^9, 3.8157619288567047`*^9, 
  3.8158256162217283`*^9, 3.815826452752221*^9, 
  3.81584710891879*^9},ExpressionUUID->"00000000-0000-0000-0000-000000000000"],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{{{}, {}, 
       TagBox[{
         Directive[
          Opacity[1.], 
          AbsoluteThickness[1.6], 
          GrayLevel[0], 
          Thickness[0.01]], 
         LineBox[CompressedData["
1:eJwVV3c8198Xtvfe22cI4UtJlHTvMUOoyCgaZIuMSCKRUCgkUWZRVkgkI9mb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          "]]}, 
        Annotation[#, "Charting`Private`Tag$137298#1"]& ]}}, {}, {}}, {
    DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
     AxesOrigin -> {0, 0}, FrameTicks -> {{Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}}, 
     GridLines -> {None, None}, DisplayFunction -> Identity, 
     PlotRangePadding -> {{0, 0}, {0, 0}}, PlotRangeClipping -> True, 
     ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
     NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
     AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
     Identity, Frame -> {{False, False}, {False, False}}, 
     FrameLabel -> {{None, None}, {None, None}}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> 15, GridLines -> {None, None}, GridLinesStyle -> 
     Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
       AbsolutePointSize[6], "ScalingFunctions" -> None, 
       "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& ), "CopiedValueFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )}}, PlotRange -> {{0, 10}, {-0.001, 0.11}}, 
     PlotRangeClipping -> True, 
     PlotRangePadding -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{"\"N=100\""}, "LineLegend", DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    GrayLevel[0], 
                    Thickness[0.18]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    GrayLevel[0], 
                    Thickness[0.18]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"LineLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Directive", "[", 
               RowBox[{
                 RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                 RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                 InterpretationBox[
                  ButtonBox[
                   TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                   Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                   Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                   With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                   Automatic, Method -> "Preemptive"], 
                  GrayLevel[0], Editable -> False, Selectable -> False], ",", 
                 
                 RowBox[{"Thickness", "[", "0.01`", "]"}]}], "]"}], "}"}], 
           ",", 
           RowBox[{"{", #, "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
      Editable -> True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{3.815495469174765*^9, 3.8157443597554893`*^9, 
  3.815753841839561*^9, 3.815754157870742*^9, 3.8157619288567047`*^9, 
  3.8158256162217283`*^9, 3.815826452752221*^9, 
  3.8158471089769573`*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{{{}, {}, 
       TagBox[{
         Directive[
          Opacity[1.], 
          AbsoluteThickness[1.6], 
          GrayLevel[0], 
          Thickness[0.01]], 
         LineBox[CompressedData["
1:eJxF13k01c8bB/CLa99VimS7ISLpqyK6z5Qoa7In+15KFGV3aSHZs0VKoqgk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          "]]}, 
        Annotation[#, "Charting`Private`Tag$137365#1"]& ]}}, {}, {}}, {
    DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
     AxesOrigin -> {0, 0}, FrameTicks -> {{Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}}, 
     GridLines -> {None, None}, DisplayFunction -> Identity, 
     PlotRangePadding -> {{0, 0}, {0, 0}}, PlotRangeClipping -> True, 
     ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
     NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
     AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
     Identity, Frame -> {{False, False}, {False, False}}, 
     FrameLabel -> {{None, None}, {None, None}}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> 15, GridLines -> {None, None}, GridLinesStyle -> 
     Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
       AbsolutePointSize[6], "ScalingFunctions" -> None, 
       "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& ), "CopiedValueFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )}}, PlotRange -> {{0, 10}, {-0.01, 0.11}}, 
     PlotRangeClipping -> True, 
     PlotRangePadding -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{"\"N=100\""}, "LineLegend", DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    GrayLevel[0], 
                    Thickness[0.18]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    GrayLevel[0], 
                    Thickness[0.18]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"LineLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Directive", "[", 
               RowBox[{
                 RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                 RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                 InterpretationBox[
                  ButtonBox[
                   TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
                   Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
                   Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
                   With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                   Automatic, Method -> "Preemptive"], 
                  GrayLevel[0], Editable -> False, Selectable -> False], ",", 
                 
                 RowBox[{"Thickness", "[", "0.01`", "]"}]}], "]"}], "}"}], 
           ",", 
           RowBox[{"{", #, "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
      Editable -> True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{3.815495469174765*^9, 3.8157443597554893`*^9, 
  3.815753841839561*^9, 3.815754157870742*^9, 3.8157619288567047`*^9, 
  3.8158256162217283`*^9, 3.815826452752221*^9, 
  3.815847109031147*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"n1new100", "[", "y_", "]"}], ":=", 
  RowBox[{
   RowBox[{"n1", "[", "y", "]"}], "/.", "s"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ncanew100", "[", "y_", "]"}], ":=", 
  RowBox[{
   RowBox[{"nca", "[", "y", "]"}], "/.", "s"}]}], "\n", 
 RowBox[{
  RowBox[{"p2new100", "[", "y_", "]"}], ":=", " ", 
  RowBox[{
   RowBox[{"p2", "[", "y", "]"}], "/.", "s"}]}]}], "Input",ExpressionUUID->\
"00000000-0000-0000-0000-000000000000"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"N", "[", 
   RowBox[{"p2new100", "[", "10", "]"}], "]"}], " "}], "\[IndentingNewLine]", 

 StyleBox[
  RowBox[{
   RowBox[{"This", " ", "is", " ", "p2", " ", "at", " ", "Infnty", " ", 
    RowBox[{"(", 
     RowBox[{"Infnty", " ", "is", " ", "10", " ", "here"}], " ", ")"}]}], " ",
    ";"}], "Text"], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.8157447298466263`*^9, 
  3.815744783137251*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 RowBox[{"{", "0.008244291598479217`", "}"}]], "Output",
 CellChangeTimes->{{3.815744763082663*^9, 3.815744783644308*^9}, 
   3.815754158147615*^9, 3.815761929093395*^9, 3.815825630471006*^9, 
   3.815826453109921*^9, 
   3.815847109073242*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Ingdtgralinexpo100", "[", "ti_", "]"}], ":=", 
  RowBox[{
   RowBox[{"-", "\[Lambda]"}], " ", "*", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"n1new100", "[", "tti", "]"}], "*", 
      RowBox[{"ncanew100", "[", "tti", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"tti", ",", "0", ",", "ti"}], "}"}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IngdtgralinexpoInf100", "[", "ti_", "]"}], ":=", 
   RowBox[{"\[Lambda]", " ", "*", 
    RowBox[{"NIntegrate", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"n1new100", "[", "tti", "]"}], "*", 
       RowBox[{"ncanew100", "[", "tti", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"tti", ",", "ti", ",", "10"}], "}"}]}], "]"}]}]}], ";", 
  "            ", 
  StyleBox[
   RowBox[{"(", 
    RowBox[{"Infnty", " ", "is", " ", "10", " ", "here"}], " ", ")"}], "Text"], 
  StyleBox[" ", "Text"], 
  StyleBox[";", "Text"]}], "\[IndentingNewLine]", 
 RowBox[{"DiscretePlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"IngdtgralinexpoInf100", "[", "hh", "]"}], "*", 
    RowBox[{"Exp", "[", 
     RowBox[{"Ingdtgralinexpo100", "[", "hh", "]"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"hh", ",", "0", ",", "3", ",", ".1"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.8154954076212807`*^9, 3.815495421753167*^9}, {
   3.815744277036044*^9, 3.815744327422968*^9}, 3.815744397339501*^9, 
   3.815744439484407*^9, {3.8157444802535973`*^9, 3.815744493932539*^9}, {
   3.815744540959334*^9, 3.815744549886273*^9}, {3.815744787552516*^9, 
   3.815744796833095*^9}, {3.81574487376235*^9, 
   3.81574487846521*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.011000000000000001`], 
    AbsoluteThickness[1.6], {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.011000000000000001`], AbsoluteThickness[1.6], Opacity[0.2], 
      LineBox[{{{3., 9.773199013403866*^-7}, {3., 9.773199013403866*^-7}}},
       VertexColors->None]}, 
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.011000000000000001`], AbsoluteThickness[1.6], Opacity[0.2], 
      LineBox[CompressedData["
1:eJxTTMoPSmVmYGCQA2ImKIaBpP7+fx5fGuxhfL2f5TP6UjfYzZoJAjvtT8ox
Hma83GAP46PKn7Q31em818EEkz8JlzcxBoHL9ic2CN3Z/a7GHsZH1X/T/rru
9aCC3xX2MD5MHuKaB/Zf/dozU06U2MP4qOY/tp94bb2izrECexgfJp+eBgLP
7Je8/bfEOCvLHsZHtf+lfeIWIX7ZhBR7GB8mf/YMCLyx39/0Ii7maZw9jI/q
vg/280y+fbAQDbeH8VHN/2jvsfNTUS17oD2Mj+r+z/bOajt5LG552MP4qPZ/
sV82p+uC3DdHexgf1X/f7DNad76322dpD+Ojuu+Hfd7+dyyB/kb2MD6q+37a
i0y5G8t5X9Mexkd132/7h/M3ML7SUrKH8VHd98fe5lCd3qQESXsYH9V9/+zF
AmwO/F0kaA/jo7qPweHi+dOuvekcsPTngGo+g4P0z6V5py8w2MP4qO5ndMiI
k9QSFfsO56Paz+RgYqLoyjrtPZyP6j9mh/TMy45fOp/C+ajuY3F4btcx95Pn
XTgf1X0sDoWrVBb/u30Zzkd1H6uDeOGKgtd3TsH5qO5jc9jKH8UprHAIzkd1
H7vDf9eDF4+l74DzYfIAGlutZw==
       "],
       VertexColors->None]}}}, 
   {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.011000000000000001`], 
    AbsoluteThickness[1.6], {}, PointBox[CompressedData["
1:eJxTTMoPSmViYGCQB2IQDQNJ/f3/PL402M+aCQI77U/KMR5mvAzjn7Q31em8
18HUYG9iDAKX7U9sELqz+10NVP6m/XXd60EFvyvsIaY9sP/q156ZcqIEqv6x
/cRr6xV1jhXYp6eBwDP7JW//LTHOyoLqf2mfuEWIXzYhxf7sGRB4Y7+/6UVc
zNM4qHkf7OeZfPtgIRoOVf/R3mPnp6Ja9kCo+Z/tndV28ljc8oDq/2K/bE7X
BblvjlD7vtlntO58b7fPEmreD/u8/e9YAv2NoOb9tBeZcjeW874m1Lzf9g/n
b2B8paUENe+Pvc2hOr1JCZJQ8/7ZiwXYHPi7SBBqHoPDxfOnXXvTOaDqGRyk
fy7NO32BAWo+o0NGnKSWqNh3O4h+JgcTE0VX1mnv7SD2MTukZ152/NL51A5i
HIvDc7uOuZ8879pBzGNxKFylsvjf7ct2EPNYHcQLVxS8vnMKah6bw1b+KE5h
hUNQ89gd/rsevHgsfQfUPA4HvZ/lM/pSN9gBAMow1pY=
     "]], {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 9.773199013403866*^-7},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{
   "MessagesHead" -> DiscretePlot, "AxisPadding" -> Scaled[0.02], 
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "DefaultPlotStyle" -> {
      Directive[
       RGBColor[0.368417, 0.506779, 0.709798], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.880722, 0.611041, 0.142051], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.560181, 0.691569, 0.194885], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.922526, 0.385626, 0.209179], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.528488, 0.470624, 0.701351], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.772079, 0.431554, 0.102387], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.363898, 0.618501, 0.782349], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[1, 0.75, 0], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.647624, 0.37816, 0.614037], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.571589, 0.586483, 0.], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.915, 0.3325, 0.2125], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.40082222609352647`, 0.5220066643438841, 0.85], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.9728288904374106, 0.621644452187053, 0.07336199581899142], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.736782672705901, 0.358, 0.5030266573755369], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.28026441037696703`, 0.715, 0.4292089322474965], 
       AbsoluteThickness[1.6]]}, "DomainPadding" -> Scaled[0.02], 
    "PointSizeFunction" -> "SmallPointSize", "RangePadding" -> Scaled[0.05]},
  PlotRange->{{0., 3.}, {9.773199013403866*^-7, 0.008278436916903057}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.02]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8154954820435143`*^9, 3.8157444065896053`*^9, {3.815744448043006*^9, 
   3.815744495050384*^9}, 3.815744805396113*^9, 3.815753556744033*^9, 
   3.8157541660327063`*^9, 3.815761936614101*^9, 3.815825667547573*^9, 
   3.8158264608684*^9, 
   3.815847116944976*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals100vals", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"IngdtgralinexpoInf100", "[", "hh", "]"}], "*", 
      RowBox[{"Exp", "[", 
       RowBox[{"Ingdtgralinexpo100", "[", "hh", "]"}], "]"}]}], " ", ",", 
     RowBox[{"{", 
      RowBox[{"hh", ",", "0.", ",", "3", ",", ".05"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.815744559758568*^9, 3.815744582814271*^9}, {
   3.81574484168108*^9, 3.815744862576949*^9}, {3.8157449206256332`*^9, 
   3.815744924337483*^9}, 3.8157450223386*^9, {3.815745082130978*^9, 
   3.8157451059714413`*^9}, {3.815825679987281*^9, 
   3.8158256804186907`*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals100func", " ", "=", " ", 
  RowBox[{"ListInterpolation", "[", 
   RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals100vals", ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0.0", ",", "3"}], "}"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8157448877074747`*^9, 3.81574494238554*^9}, {
   3.815744977714079*^9, 3.815744981746171*^9}, {3.815753276799062*^9, 
   3.8157532907833557`*^9}, 3.8157535414894238`*^9, {3.815825686403079*^9, 
   3.815825689587508*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 TagBox[
  TemplateBox[{RowBox[{
      StyleBox[
       TagBox["InterpolatingFunction", "SummaryHead"], 
       "NonInterpretableSummary"], 
      StyleBox["[", "NonInterpretableSummary"], 
      DynamicModuleBox[{Typeset`open$$ = False}, 
       PanelBox[
        PaneSelectorBox[{False -> GridBox[{{
              PaneBox[
               ButtonBox[
                DynamicBox[
                 FEPrivate`FrontEndResource[
                 "FEBitmaps", "SquarePlusIconMedium"]], 
                ButtonFunction :> (Typeset`open$$ = True), Appearance -> None,
                 Evaluator -> Automatic, Method -> "Preemptive"], 
               Alignment -> {Center, Center}, ImageSize -> 
               Dynamic[{
                 Automatic, 3.5 CurrentValue["FontCapHeight"]/
                  AbsoluteCurrentValue[Magnification]}]], 
              GraphicsBox[{{{{}, {}, 
                  TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAA88dx3mtMaz7Mw8P+SPSAP6m+gdgd
Cqk/cM74MEzxgD8vlAOEtBe6P2T52Srt0IA/j/RD6Atiwz+EQkcfGoKAP8yH
F2FrmMk/Al3Jg6UCgD+j2m5OyyrQP0enQvpai34/ZlmCWdBP0z/9tC6jeN58
P0YlD0Y7uNY/bHoWOhXTej+JpeQbvRDaP8SMlnnLrXg/0o3qXq4v3T8+WxOD
hKB2P5zhtMECSeA/8MwEJrlpdD9SsIwKZt3hP6fzWwFTZ3I/OdkIyNRp4z9z
/kVKUIVwP6+oQXb2F+U/p6ZShZwzbT8orBLbT6nmP2GODMkh4Wk/MFagMFxc
6D9aCCAqi5RmP2pa0vpzB+o/W+mh8MKmYz+mkpx7w5XrP9+1VqcwMWE/cXEj
7cVF7T+6jZaEsJ5dPz+EQhUA2e4/NKxHZ4itWT/OHg+X9kbwP3cC3f6u6lU/
lijP3XId8T9T75CpYLJSP19M2/+K5fE/uRlBQUsTUD9ww0WafL7yPyS3V9Ea
N0s/glT8DwqJ8z+WY/eKHDxHP60SBUCdT/Q/e4CyZKraQz8fJGzoCSf1P+N8
oE6Zs0A/k08fbBLw9T8O9cwO+l08P07OMGj0yfY/YxxS4WW2Nz8iepQe3J/3
P3kZg3q72DM/9z9EsF9n+D/KWvQcV8gwPxRZUrq8P/k/B6XN0mXvKz8yjKyf
tQn6P8slWbigfyc/aexYP7TP+j/axGCKe84jP+efY1eMpvs/TXCYNOxtID9n
bbpKAG/8P3KfS90ykBs/Lo5vtk1I/T+tCVYqTcAWP/fIcP02E/4/5mZbZQT/
Ej/YMMT+Jdr+PxcB3KGrzA8/Aex1eO6x/z+JGdMfATAKP5bguWapPQBAhu6X
vv7SBT/O9GdNyKoAQMi+Jaqp5AE/kx8/EeoVAUBzmRG0fmr9PlhXvMLZeQFA
JAGPrFt6+D7BuGgwNuYBQK9P6Xx4CfQ+Kye7i2BLAkCkAIsDbJvwPiGsNsSN
rgJAf05aFQSc6z67WuG4JxoDQBAHPIMSk+Y+VhYym49+A0Br0pr7q7HiPpT7
sTlk6wNATAB2O5pz3j5f91q1O1YEQNupf6hY4Ng+KgCqHuG5BEDsSd+nR5bU
PpkyKETzJQVAoqLZFWnB0D4JckxX04oFQKVcdLcposs+HdufJiD4BUCKed3V
hmjGPr1aHNNvYwZAAaszYZ86wj5e5z5tjccGQCBQNhMSDr4+op2Qwxc0B0Bc
6gKB+Vy4PudgiAdwmQdAjYJc3PgDtD4I5Sz5//8HQPbxXdCOZbA+Q0XDYg==

                    "]]}, 
                   Annotation[#, 
                    "Charting`Private`Tag$172386#1"]& ]}}, {}, {}}, {
               DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
                AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
                GridLines -> {None, None}, DisplayFunction -> Identity, 
                PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                All, DisplayFunction -> Identity, AspectRatio -> 1, 
                Axes -> {False, False}, AxesLabel -> {None, None}, 
                AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                Frame -> {{True, True}, {True, True}}, 
                FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                Directive[
                  Opacity[0.5], 
                  Thickness[Tiny], 
                  RGBColor[0.368417, 0.506779, 0.709798]], 
                FrameTicks -> {{None, None}, {None, None}}, 
                GridLines -> {None, None}, GridLinesStyle -> Directive[
                  GrayLevel[0.5, 0.4]], ImageSize -> 
                Dynamic[{
                  Automatic, 3.5 CurrentValue["FontCapHeight"]/
                   AbsoluteCurrentValue[Magnification]}], 
                Method -> {
                 "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                  AbsolutePointSize[6], "ScalingFunctions" -> None, 
                  "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                PlotRange -> {{0., 3.}, {0., 0.00827843692283805}}, 
                PlotRangeClipping -> True, PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
              GridBox[{{
                 RowBox[{
                   TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox[
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "3.`"}], "}"}], "}"}], 
                    "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"scalar\"", "SummaryItem"]}]}}, 
               GridBoxAlignment -> {
                "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
               False, GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {
                "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
               BaseStyle -> {
                ShowStringCharacters -> False, NumberMarks -> False, 
                 PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
            GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
            BaselinePosition -> {1, 1}], True -> GridBox[{{
              PaneBox[
               ButtonBox[
                DynamicBox[
                 FEPrivate`FrontEndResource[
                 "FEBitmaps", "SquareMinusIconMedium"]], 
                ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                None, Evaluator -> Automatic, Method -> "Preemptive"], 
               Alignment -> {Center, Center}, ImageSize -> 
               Dynamic[{
                 Automatic, 3.5 CurrentValue["FontCapHeight"]/
                  AbsoluteCurrentValue[Magnification]}]], 
              GraphicsBox[{{{{}, {}, 
                  TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAA88dx3mtMaz7Mw8P+SPSAP6m+gdgd
Cqk/cM74MEzxgD8vlAOEtBe6P2T52Srt0IA/j/RD6Atiwz+EQkcfGoKAP8yH
F2FrmMk/Al3Jg6UCgD+j2m5OyyrQP0enQvpai34/ZlmCWdBP0z/9tC6jeN58
P0YlD0Y7uNY/bHoWOhXTej+JpeQbvRDaP8SMlnnLrXg/0o3qXq4v3T8+WxOD
hKB2P5zhtMECSeA/8MwEJrlpdD9SsIwKZt3hP6fzWwFTZ3I/OdkIyNRp4z9z
/kVKUIVwP6+oQXb2F+U/p6ZShZwzbT8orBLbT6nmP2GODMkh4Wk/MFagMFxc
6D9aCCAqi5RmP2pa0vpzB+o/W+mh8MKmYz+mkpx7w5XrP9+1VqcwMWE/cXEj
7cVF7T+6jZaEsJ5dPz+EQhUA2e4/NKxHZ4itWT/OHg+X9kbwP3cC3f6u6lU/
lijP3XId8T9T75CpYLJSP19M2/+K5fE/uRlBQUsTUD9ww0WafL7yPyS3V9Ea
N0s/glT8DwqJ8z+WY/eKHDxHP60SBUCdT/Q/e4CyZKraQz8fJGzoCSf1P+N8
oE6Zs0A/k08fbBLw9T8O9cwO+l08P07OMGj0yfY/YxxS4WW2Nz8iepQe3J/3
P3kZg3q72DM/9z9EsF9n+D/KWvQcV8gwPxRZUrq8P/k/B6XN0mXvKz8yjKyf
tQn6P8slWbigfyc/aexYP7TP+j/axGCKe84jP+efY1eMpvs/TXCYNOxtID9n
bbpKAG/8P3KfS90ykBs/Lo5vtk1I/T+tCVYqTcAWP/fIcP02E/4/5mZbZQT/
Ej/YMMT+Jdr+PxcB3KGrzA8/Aex1eO6x/z+JGdMfATAKP5bguWapPQBAhu6X
vv7SBT/O9GdNyKoAQMi+Jaqp5AE/kx8/EeoVAUBzmRG0fmr9PlhXvMLZeQFA
JAGPrFt6+D7BuGgwNuYBQK9P6Xx4CfQ+Kye7i2BLAkCkAIsDbJvwPiGsNsSN
rgJAf05aFQSc6z67WuG4JxoDQBAHPIMSk+Y+VhYym49+A0Br0pr7q7HiPpT7
sTlk6wNATAB2O5pz3j5f91q1O1YEQNupf6hY4Ng+KgCqHuG5BEDsSd+nR5bU
PpkyKETzJQVAoqLZFWnB0D4JckxX04oFQKVcdLcposs+HdufJiD4BUCKed3V
hmjGPr1aHNNvYwZAAaszYZ86wj5e5z5tjccGQCBQNhMSDr4+op2Qwxc0B0Bc
6gKB+Vy4PudgiAdwmQdAjYJc3PgDtD4I5Sz5//8HQPbxXdCOZbA+Q0XDYg==

                    "]]}, 
                   Annotation[#, 
                    "Charting`Private`Tag$172386#1"]& ]}}, {}, {}}, {
               DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
                AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
                GridLines -> {None, None}, DisplayFunction -> Identity, 
                PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                All, DisplayFunction -> Identity, AspectRatio -> 1, 
                Axes -> {False, False}, AxesLabel -> {None, None}, 
                AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                Frame -> {{True, True}, {True, True}}, 
                FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                Directive[
                  Opacity[0.5], 
                  Thickness[Tiny], 
                  RGBColor[0.368417, 0.506779, 0.709798]], 
                FrameTicks -> {{None, None}, {None, None}}, 
                GridLines -> {None, None}, GridLinesStyle -> Directive[
                  GrayLevel[0.5, 0.4]], ImageSize -> 
                Dynamic[{
                  Automatic, 3.5 CurrentValue["FontCapHeight"]/
                   AbsoluteCurrentValue[Magnification]}], 
                Method -> {
                 "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                  AbsolutePointSize[6], "ScalingFunctions" -> None, 
                  "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                PlotRange -> {{0., 3.}, {0., 0.00827843692283805}}, 
                PlotRangeClipping -> True, PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
              GridBox[{{
                 RowBox[{
                   TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox[
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "3.`"}], "}"}], "}"}], 
                    "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"scalar\"", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["3", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["False", "SummaryItem"]}]}}, 
               GridBoxAlignment -> {
                "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
               False, GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {
                "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
               BaseStyle -> {
                ShowStringCharacters -> False, NumberMarks -> False, 
                 PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
            GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
            BaselinePosition -> {1, 1}]}, 
         Dynamic[Typeset`open$$], ImageSize -> Automatic], BaselinePosition -> 
        Baseline], DynamicModuleValues :> {}], 
      StyleBox["]", "NonInterpretableSummary"]}]},
   "CopyTag",
   DisplayFunction->(#& ),
   InterpretationFunction->("InterpolatingFunction[{{0., 3.}}, <>]"& )],
  False,
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{3.815753604548572*^9, 3.815754180792033*^9, 
  3.815761951012051*^9, 3.815825698947338*^9, 3.815826475699855*^9, 
  3.815847131579977*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tau2for100", "=", 
  RowBox[{
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals100func", "[", "ww", "]"}],
      ",", " ", 
     RowBox[{"{", 
      RowBox[{"ww", ",", "0.0", ",", "3"}], "}"}]}], "]"}], "  ", "/", 
   RowBox[{"N", "[", 
    RowBox[{"p2new100", "[", "10", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.815745024257978*^9, 3.8157450584986153`*^9}, {
   3.815753254031543*^9, 3.815753254670862*^9}, {3.815753587458639*^9, 
   3.815753615250682*^9}, {3.815753669810672*^9, 3.815753732499239*^9}, 
   3.815825703443811*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 RowBox[{"{", "0.6692334403265496`", "}"}]], "Output",
 CellChangeTimes->{{3.8157536885805893`*^9, 3.815753696462763*^9}, 
   3.8157537329431343`*^9, 3.815754180815572*^9, 3.8157619510380163`*^9, 
   3.8158257060652113`*^9, 3.815826475745264*^9, 
   3.8158471316138897`*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.815825724430285*^9, 
  3.8158257249854*^9}},ExpressionUUID->"00000000-0000-0000-0000-000000000000"],

Cell[BoxData[
 RowBox[{
  RowBox[{"nopumpingrate", "=", "90"}], ";", 
  RowBox[{"pumpingrate", "=", "800"}], ";", " ", 
  RowBox[{"linethick", "=", "0.01"}], ";"}]], "Input",
 CellChangeTimes->{{3.815744349483822*^9, 
  3.8157443551147547`*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Mu]", "=", "38"}], ";", 
  RowBox[{"\[Lambda]", "=", "6"}], ";", 
  RowBox[{"NR", "=", "1"}], ";", 
  RowBox[{"\[Nu]", "=", "pumpingrate"}], ";", " ", 
  RowBox[{"A", "=", "300"}]}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{"a", "=", "1.53"}], ";", 
   RowBox[{"b", "=", "1.43"}], ";", 
   RowBox[{
    RowBox[{"Jin", "[", "t_", "]"}], ":=", 
    RowBox[{
     RowBox[{"A", "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"1", "/", "2.3"}], "-", 
        RowBox[{"1", "/", "2.31"}]}], ")"}]}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"-", "2.3"}], "*", "t"}], "]"}], "-", 
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"-", "2.31"}], "*", "t"}], "]"}]}], 
      ")"}]}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"s", "=", 
   RowBox[{"NDSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"n1", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Mu]"}], "*", 
          RowBox[{"n1", "[", "t", "]"}]}], "+", " ", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], " ", "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"2", "*", 
             RowBox[{"n1", "[", "t", "]"}]}]}], " ", ")"}]}]}]}], " ", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"nca", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{"Jin", "[", "t", "]"}], "-", 
         RowBox[{"\[Nu]", "*", 
          RowBox[{"nca", "[", "t", "]"}]}], " ", "-", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"n1", "[", "t", "]"}]}], ")"}]}], "+", 
         RowBox[{"\[Mu]", "*", 
          RowBox[{"n1", "[", "t", "]"}]}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"p2", "'"}], "[", "t", "]"}], "\[Equal]", " ", 
        RowBox[{"\[Lambda]", "*", 
         RowBox[{"n1", "[", "t", "]"}], "*", 
         RowBox[{"nca", "[", "t", "]"}], "*", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"p2", "[", "t", "]"}]}], ")"}]}]}], ",", 
       "\[IndentingNewLine]", " ", 
       RowBox[{
        RowBox[{"n1", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
       RowBox[{
        RowBox[{"nca", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
       RowBox[{
        RowBox[{"p2", "[", "0", "]"}], "\[Equal]", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"n1", ",", "nca", ",", "p2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0.0", ",", "5"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"n1", "[", "t", "]"}], "/.", "s"}], "]"}], ",", 
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"nca", "[", "t", "]"}], "/.", "s"}], "]"}], ",", 
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"p2", "[", "t", "]"}], "/.", "s"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "5"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "5"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Thickness", "[", "0.01", "]"}], ",", 
      RowBox[{"Thickness", "[", "0.02", "]"}], ",", 
      RowBox[{"Thickness", "[", "0.02", "]"}]}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{"Orange", ",", 
      RowBox[{"Darker", "[", "Green", "]"}], ",", "Blue"}], "}"}]}], ",", 
   RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"plotofn1Slow300", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"n1", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "5"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "5"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{"Red", ",", 
       RowBox[{"Thickness", "[", "linethick", "]"}]}], "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"{", "\"\<N=300\>\"", "}"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"plotofncaSlow300", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"nca", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "5"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "5"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "2"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{"Red", ",", 
       RowBox[{"Thickness", "[", "linethick", "]"}]}], "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"{", "\"\<N=300\>\"", "}"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"plotofp2Slow300", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"p2", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "5"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "5"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{"Red", ",", 
       RowBox[{"Thickness", "[", "linethick", "]"}]}], "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"{", "\"\<N=300\>\"", "}"}]}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.8154954466784477`*^9, 3.81549546339727*^9}, 
   3.815753817031386*^9, {3.815753869238617*^9, 3.815753878614464*^9}, 
   3.815754800592188*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData["300"], "Output",
 CellChangeTimes->{3.815495469174765*^9, 3.8157443597554893`*^9, 
  3.81575385430024*^9, 3.815753887260633*^9, 3.815754180838479*^9, 
  3.8157548033066*^9, 3.815761951067636*^9, 3.81582574480345*^9, 
  3.815826475779072*^9, 
  3.815847131691846*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], Thickness[0.01], Opacity[1.], 
      LineBox[CompressedData["
1:eJwVlXc4Fe4bxu29zjml7JGVFdnfOM8rsiOzjMjKJhUKSZSVrGQ17HOEUFEZ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       "]]},
     Annotation[#, "Charting`Private`Tag$172476#1"]& ], 
    TagBox[
     {RGBColor[0.880722, 0.611041, 0.142051], Thickness[0.02], Opacity[1.], 
      LineBox[CompressedData["
1:eJwVlnc8Fe4Xx+09rnspJHuvIrNwHiOySnaIyCZSGRkRsjLLlpmZlEqFZEX2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       "]]},
     Annotation[#, "Charting`Private`Tag$172476#2"]& ], 
    TagBox[
     {RGBColor[0.560181, 0.691569, 0.194885], Thickness[0.02], Opacity[1.], 
      LineBox[CompressedData["
1:eJwt13c8le/7APBj791HpIwSQoqklM51S1SSSilKkj0iIyMrZWVLMsqOZJ9j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       "]]},
     Annotation[#, "Charting`Private`Tag$172476#3"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 5}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.815495469174765*^9, 3.8157443597554893`*^9, 
  3.81575385430024*^9, 3.815753887260633*^9, 3.815754180838479*^9, 
  3.8157548033066*^9, 3.815761951067636*^9, 3.81582574480345*^9, 
  3.815826475779072*^9, 
  3.815847131780691*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{{{}, {}, 
       TagBox[{
         Directive[
          Opacity[1.], 
          AbsoluteThickness[1.6], 
          RGBColor[1, 0, 0], 
          Thickness[0.01]], 
         LineBox[CompressedData["
1:eJwVlXc4Fe4bxu29zjml7JGVFdnfOM8rsiOzjMjKJhUKSZSVrGQ17HOEUFEZ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          "]]}, 
        Annotation[#, "Charting`Private`Tag$172520#1"]& ]}}, {}, {}}, {
    DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
     AxesOrigin -> {0, 0}, FrameTicks -> {{Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}}, 
     GridLines -> {None, None}, DisplayFunction -> Identity, 
     PlotRangePadding -> {{0, 0}, {0, 0}}, PlotRangeClipping -> True, 
     ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
     NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
     AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
     Identity, Frame -> {{False, False}, {False, False}}, 
     FrameLabel -> {{None, None}, {None, None}}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> 15, GridLines -> {None, None}, GridLinesStyle -> 
     Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
       AbsolutePointSize[6], "ScalingFunctions" -> None, 
       "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& ), "CopiedValueFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )}}, PlotRange -> {{0, 5}, {0, 1}}, 
     PlotRangeClipping -> True, 
     PlotRangePadding -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{"\"N=300\""}, "LineLegend", DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1, 0, 0], 
                    Thickness[0.18]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1, 0, 0], 
                    Thickness[0.18]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"LineLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Directive", "[", 
               RowBox[{
                 RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                 RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                 InterpretationBox[
                  ButtonBox[
                   TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[1, 0, 0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.6666666666666666, 0., 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[1, 0, 0]"], Appearance -> None, BaseStyle -> {},
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                   ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[1, 0, 0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                   Automatic, Method -> "Preemptive"], 
                  RGBColor[1, 0, 0], Editable -> False, Selectable -> False], 
                 ",", 
                 RowBox[{"Thickness", "[", "0.01`", "]"}]}], "]"}], "}"}], 
           ",", 
           RowBox[{"{", #, "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
      Editable -> True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{3.815495469174765*^9, 3.8157443597554893`*^9, 
  3.81575385430024*^9, 3.815753887260633*^9, 3.815754180838479*^9, 
  3.8157548033066*^9, 3.815761951067636*^9, 3.81582574480345*^9, 
  3.815826475779072*^9, 
  3.815847131829427*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{{{}, {}, 
       TagBox[{
         Directive[
          Opacity[1.], 
          AbsoluteThickness[1.6], 
          RGBColor[1, 0, 0], 
          Thickness[0.01]], 
         LineBox[CompressedData["
1:eJwVlnc8Fe4Xx+09rnspJHuvIrNwHiOySnaIyCZSGRkRsjLLlpmZlEqFZEX2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          "]]}, 
        Annotation[#, "Charting`Private`Tag$172587#1"]& ]}}, {}, {}}, {
    DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
     AxesOrigin -> {0, 0}, FrameTicks -> {{Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}}, 
     GridLines -> {None, None}, DisplayFunction -> Identity, 
     PlotRangePadding -> {{0, 0}, {0, 0}}, PlotRangeClipping -> True, 
     ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
     NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
     AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
     Identity, Frame -> {{False, False}, {False, False}}, 
     FrameLabel -> {{None, None}, {None, None}}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> 15, GridLines -> {None, None}, GridLinesStyle -> 
     Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
       AbsolutePointSize[6], "ScalingFunctions" -> None, 
       "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& ), "CopiedValueFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )}}, PlotRange -> {{0, 5}, {0, 2}}, 
     PlotRangeClipping -> True, 
     PlotRangePadding -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{"\"N=300\""}, "LineLegend", DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1, 0, 0], 
                    Thickness[0.18]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1, 0, 0], 
                    Thickness[0.18]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"LineLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Directive", "[", 
               RowBox[{
                 RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                 RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                 InterpretationBox[
                  ButtonBox[
                   TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[1, 0, 0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.6666666666666666, 0., 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[1, 0, 0]"], Appearance -> None, BaseStyle -> {},
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                   ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[1, 0, 0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                   Automatic, Method -> "Preemptive"], 
                  RGBColor[1, 0, 0], Editable -> False, Selectable -> False], 
                 ",", 
                 RowBox[{"Thickness", "[", "0.01`", "]"}]}], "]"}], "}"}], 
           ",", 
           RowBox[{"{", #, "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
      Editable -> True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{3.815495469174765*^9, 3.8157443597554893`*^9, 
  3.81575385430024*^9, 3.815753887260633*^9, 3.815754180838479*^9, 
  3.8157548033066*^9, 3.815761951067636*^9, 3.81582574480345*^9, 
  3.815826475779072*^9, 
  3.815847131883395*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{{{}, {}, 
       TagBox[{
         Directive[
          Opacity[1.], 
          AbsoluteThickness[1.6], 
          RGBColor[1, 0, 0], 
          Thickness[0.01]], 
         LineBox[CompressedData["
1:eJwt13c8le/7APBj791HpIwSQoqklM51S1SSSilKkj0iIyMrZWVLMsqOZJ9j
hWTLlowyS3b23vJ7nu/rd/445/V+3ed1X9dz3ddz388jpP9Yw4iSQCAcwL7w
31h3fVppQxci4f8/NR2CancEtWHbY3mAQSv53O7XMk9BQTPwYTh2zmB0/Rxr
WCGJsdsWdPOkj6veFiXGVgQJ0Ag+BYmX/6UPdakQJecMg3dNnkGw1+JsYdED
4gBr3L/tny+gr2H/rvAvG6LwBwa5zS1vmD3aezLa7Tnx0Tl7yzUBP/C8vGnG
thFMzOscTF5WCoS275kc16yjiZsWav0LJiEw+nHZo7/gPTGBot9vTfkVKOcu
lwmKZREvtLw6vPozDKifUR++Vp1PnIi6WLlsFg7p8nYK9qmlxEDDHZ2lrTeQ
TY6SGEHVxOPH89YXgiJh3e6i9bZqA7FjyzR8XiAatjn9086rthEd6viPz5Hf
Avfx1HyfhE7ivtedTTNKMSA/9GbubEkPsUzX32S6Kxb4fpYPRqf9JuqLI6op
k3hI+Rkb54KGiZRbzt+WXRPgwWHLj4ZHxomdg5oHlpUTQeEL59jXqCnih6/H
LZZYk+CL9/3t+SvzRKdMpuLFn0lQH9dkvLp3iagaNka7mPAe+D5efMp/cpW4
36ny1oJZMuwXVUypSt0gzt6PSZqXSYFZ2TClp092iBVKjvNzWykggsZC578R
IOyIBnGu5gMIyhqKi+6lAkO2o4GzQamwWGq7yxFGA3R9Q6IzAmlwMdxP1kGC
CborvthPT6RBLBdzoag6K6R/iKqeIqeDceZpqic/2ME10I5jyjkDXpTfU+lL
5gR1W/UHk0qZEG0qUnbx9R4Q1DqS9Zc5C5bPVXtkJnHD4jnqrYmuLBDv7RFZ
7+CBCIaSiHGTHKCklAufjT8A+Y6qtnY8JOC8IJMqzi8IMZOneJdcSRAfWBbE
/kwIrNo4TRaVyXBRXvxAkrMw3FEisNqmk8HxlN8Pbm4RQIUz+QusufCDlCXb
VSsKnDH1lAs/c2HhV+G/RAMJ2GItTLNWyIM6GWtpA42jMPL8/fX5hDx42FGp
2HH7GBSauMfNmeXDveaPOpTfpSG+10L5cWs+UJgKSJKXZeDlVe3pWZkCOCpY
cbzjkCzcPSF7ZnarAF4YMRjsJMuB0gehP5Z6hXBm/afTpbVTIMnL9nKmphAC
j5p9CNSUh3///nZNB32C2L1T+Y5yCpDYGG8zJVAM9ztus1moKMJyVIH478Bi
oI88M5t84jyomDQNt28Uw6jjiwB9MSWYplrTLOkogdMT/zhjxJTh9Dn1M36+
pXDXMsL9gvdlCGAyXHJdLoVdQ+2vAzmq8Kvnaab1wy9w3/0ZhfrQFfBySOHX
OlsGf9yK+r7pqkNbzjal6Fw5OJoreLv33QBOYNBlkaoAb5Z9hi6hGnBWJPyM
r2EFsGqFEJ0u34Tg5bQl5+8VMN5RmOVQdwtkX3UZ6WdUAk2BkFH00h141iip
Kv2gGmzesg8rMT+Aj+RPIhlvqoF2Lok5laAH7VHnqQ43V8PPvy4bom56IGyi
VcojXwPxg7qJPK4PoZHKS4rAVQuzDgWlIa8MgPtcH+e3r1/B4eSzPya8poCE
jecu7XwFfqd79Uu5pmDGtNBUdaIO1DhvjT5QN4PSHlrvwoQ6iFJN8vrmbw76
DjJrsc71MC2hU1nPawnZOX59j6QaQejshbezKjYwyTkZqPqwERi7muqZY2xA
1EGVKBbeCAINvL//LthAggJT4vBGI5TPtv/ui7eFsIZA47u1TTAjIHXdlfoJ
OAyHLFzUaYEbV4jDwXMOEM/U5Mmh3AZZ0ypf/ZXcgHjORcdDtw0uXxnd2Mhy
g34riZNzjtj4Tf62bR534GkPGGtObwOpAz+TP827w6sotcsv2b8Dn0hQ86Ob
HuB5uJV1t+87XJr66K7M/QJM4Hv0tG0H8Bx7s1vd4A2EpNWSvoAOeJl2nzeW
xgeiqPf3NyZ3wHzVAluqog/UNxjzp/3ogCCdimnVEh8Qu7WdZHSmE0gD89Pl
Wb4wYSqa+YuiCwTPl1Y1x/iBeZhbWVvoD9BRoZjbjAgCq9Ejw/nZPdAoROlF
mAkDRiEv0d+nB2FP7j64yxoDwexN4ol6wzD9OeD0OHMSFJ86UKBuNQx3xfs+
Wh5IghHdx7DtMgxBOUeOTx1NgrNZXLfuRA5D3k2KO03qSTBxWceNpXUYmA+R
uvhDk0DJc+bb07MjcHdtIYuB4z2sr7DZa3CPQotPuhmJKRn0+26VUzWPgYOz
Du33oRRgfPfH0qZnDBqqd4ti51Mg967V/t9jY3DQrfu63r8UoOr1fVpCMQ7H
R+rE6ng/QHJ3yQmbU+OgxB14he/6BxjrEvz4K2kccnkGzvWXfADztunQ4qcT
8E6iML/0ZSrY1HrpPxadBD+h/td8tGnAP6JCu3piEraHpkLi2dOgiZIh3RVN
Qtb9P1P7+NLgMApa8NOehJq6Ay1rx9Kgp+SNR3LAJLymtXRW1U4DRdKHuJ65
SdAKjWjWTE8Djnf1vUpFU4Bod3x4VNKhrNjfvbFmCkwVR7qDrqWDRbfawRvf
p6BGon9iUysdav/7bqY7OQXcvZ3XSy3S4Wloz7rT/mmwP3PlfX9oOvzxnuTO
9piG23tPOUf0pAPZmvkmz+UZ0E2XMmYwyoDmt1xPs27PgNsJq94TVhkwVrMv
/rzhDORProppOmbAPt4jU4+ezYBBHLW5q18GeFUqe1YWzECfpguHblYG3OZ8
lmd+cBbEOblybZcyYDNvgevL1ixk/J3YQ/80E/b8WpfXYJiDoZ5ia57nmSBF
T9Ab556DI3lS2oJ+mWCgw5rJITMHtZOK49zRmdBMLXHB2HQOwmRT3sUXZUKc
puETtq45+FhW5Se8mgmJLhaTx+/MA/nbAwURiyw4XsGw7nt/Hvqnvv35bJMF
FdQfaX4bzIOZbXObqlMWDAaNCAZZz0NBll3kLe8s4E+4f+ev3zzE0q8+4InP
grc112oSS+chlXEPr9H3LAhjkY3jPLgAqjleNiels+GgRnuGmdgCHIo1erMj
lw3kCOviCqkFUGjejC1XyIY2gaxOq7MLcCT3q7X0pWxglRFharq1AIsbGsnN
utngf5vHydMXG3cK9h71z4YX8ds3lqcXYL6seK3qVzZcP15kI7G0AHY9pWmf
hrOBv9Lulf7GAvx3Xp0jdSIbSoYm29poFoHBroTTYTEbFg/3XMviXwRif9vd
Lpoc0M8suGp8fREU6nMHYyRyQLHY6nJ33iIsKuc8sLLLAVZVcTO2kkUIcBpQ
rnLMgf7e0ZcqFYugnzz4iMM1B5y2derzmxdhl2AcnOiVAyS4cvHV6CLYuVtG
+L3JAcGvosqqe5dAFOVZuhbmAKFjEJU6L8GceeFexpUc8Ppbluj8fAmGP6vM
CWzkAAMhllL+5RLQHe5tOr6TA5xHtWsK3izBCV6FzkRKEhz2/X4xh7QEQY8u
QyQjCVTPVqknjS2BQPfOM9Z9JHj9/r3OS41lGHge1AqnSMBT8vyLivYytJjT
9OyeJkFM2wN+Gr1lqL7Ik//lDAk+7PANPrdchiB6zVEZIgmK7oQbuLxchuvf
/7OnUiZBP5O3uVXZMtSo5V8FDRKIPDF2uiW+AieQYLm0BQmOnvl9M/74CjT4
uVREPCKBLEHr2KTcCsS+S9+zaUmC84GXx54prcDS3rmOz9Yk0E2WvJWhswIS
Tu/eSTiQIKJz8RhlyAoc1yGwlXmQgObks/GcJez/5fI2JeEkYN5aq9rcWAGy
Xa3fzBvsOabSOk6ZsAqGCTelBCJJIHhVX7OPeRUUiwIE3aNJoGCkXE0rsgq3
qb3axeNI8OQNU/x9rVU4uyesFaWSYGQl8jbTl1X4RVYNMysiQZLiCbuB6lVg
NZXf71tMggdBrSE5jasw9NBO7H0JCXqFaRpudq9Cdp7Etx+lJPh+0/ZszNIq
jCeo+klWkqCMrCZ4VHwNdr8HnHjdQIJIS4pJ9cg1cO+cOazdQ4JbxTG0QnFr
wJcUfV21F8uf5vShpeQ1UPYMOnGmjwTBMVY6kblrQEtpLsY9QAKvpr7W3y1r
8NXty3rZIAmsjxTmWVOvwx0VtsCucWy9R83dwmzWwVSFckNwhQQqbocyLzit
w9cPaQYTmM//19+76r4O/1RWy7NXSXBG+erpe4HYuFejxul1EoinHFs6lLoO
Fz9Y0sIWCZiMlk0L+tchl7/8Kx8FGZpH3G51X9wAWbnDiI+ZDPWucp7+6htQ
XkJ7oxpzzZ45soLmBrhGDzqbs5Ch9IIeW6L+Bpi9XD1QyEqGzOTzjWZuGyAj
uFVxnoMMQYZ0aCt3A7gGr9nLcJNBfSRUgp9/E74amEnbCWDxJEY6dYQ3wXVf
IGEN8xW7U+7vxDfhX0KisLMgGS5R/mrjObUJPkfrrdyFyHBeUMKB6/omUFo/
EXx2iAwndWor6F9sQv5Ke/JDUTLs79zQXBrdBN56uUCSFBne8l3dlZ7eBNND
Gk8Ej5GB1yDho/XiJhjF3mwIwcy9qLI1828TDsf/LH10nAzs7OEJE3u34E+B
/4CADBmo1KSmBi5vgdTV6CSLk2SYrNb3qM/agqp9QYOxZ8kg8KrbPDh/Cyis
mAupFchwS1dd89bnLdi747dmjrlsXV58sH4LWpWrK0+eI0PYUY7OteEtoPPY
9K0hkuFsZLmo6L5tcBpq9KhTJEOg+f5v3j7bIPRG55rpRTJUngorvhK0DdJd
xnvKMK9S0ydzhG+DbmiwDtclMujFLznFJmLOG3UqxSzb2XiwoHQbZK+4LdOr
kmHg3FOHkcVtWEg5FhigRgYpjh8HlB7sAMXV55Fnb5BhLGjsxRujHaDk8QF3
zLGMa+PjFjvQd54psAIzMzVPbqDTDvj+9thzQQO7/lVtlR+vduCU+885lZtk
SOkfsDKr2QHXiWcnFTSx+n8cLQ858g9qvD8xTWiRoVN4VXjo2D8omjstKKhN
hoBEWn9ZuX8gcodn/A7mzbeit3rO/wPU6RH0FXN3kNnEQZ1/4KL+52LCXTK8
tpthLwz+B/57WBuVdcjACCsP+5f+wYSx6ft7D8jgpChGX7j5D0zKqbOCMY8p
3csOodgF1zYLs0rMVZcqN8+z7YIJ9Z3tw3pkcNYIep0mvgsRZq0RU5injA7X
OjzchQN7T++Y6mP9GKgpxvFtF7r/6RoeMyLDmZCXrZNdu3DpUEq4NuaPrz4/
qenfBeHA116emL0ihCodJ3fB+0p38g/M/G2rknOUBJRlwLTw1JgMP3qqajX5
CejUnzmGAhPsPWvm7tpBTQIKfxrybteMDHF7PDueaRHQ9E2tJiFzMiyfzcjp
v0dAJxl96pQwJ/hvmUToE9AGlZ2IL+ZN0ZhuBmsCKqBy8WWywO43/YHieX8C
0is4wMH0COvf7geuZRWYXWN4xy3JYLzrq8VXQ0BXRGT0qKyw+1WEJOtUR0Df
HH67CGA2syfMSLcS0LqvyYk7mKs4E++n9BGQ6HfntBrMT64OEQNXCWhFmnck
8jG2PlWGFHclKdCVsM/SQjZkmFfs3ed2jAIZnD2zLYeZrvKabIIMBcr7+ypV
DbNc+RmTsdMUKLvXKtERc/hn9hZbZQo0lX1dpBnztfzSqABdCrRf0izqsS0Z
vqbsOf4llAI1DM1cSrQjwy9h/8uDrymQWRWNex7mlfe7+lSRFMh7dCSqFrNw
0uSby7EUiDfex+Mv5hdxFVtdaRRoye0U3/EnZCBGPqqbraJAz1WYEoswF7ys
0RVcoUAJkVyDn+yx9VRt4vFdp0Aur9S16zG/ZW5vn9miQIpFKUXdmD1Cf6t8
pqREQ53nxTcwq0VtSt1mp0RZF6wHTjuQYSj1+G6ABCWavfMqIw8za11M/NpD
SvSXRvl3pCMZKPzea+saUaKwVk7jFMzLqulctaaU6FCf/c9czD2tn3zDHlMi
0WkX5xbMyT/aHx91o0QSBRu1FE5Y/43RI4MoSnR2n3G4MWZjGvvB1lZKdP6H
XIvQUzLsE2j4ufWdEgW4KR2RxNx6+sA3sS5KJHJ6xF4Os9yj2i8v+ihRJY3T
H1XMtB3/vZOboES3CXE0dphTEgo14yioEGn3QlgF5pGz642WslSoWvwU8YYz
GaI01arenqJCGsKjP7Uxqz1OKK47Q4WSCooN9THnJ136KKRIhfguBWnZYfZi
iPbuukqFlg82pYdjFv4pj86ZUCF+HxW6LswGti4FzG+pkDxZn+WqC5afzK+C
I7FUqKCrgukWZsZFVKiSQIXK4mZ372Im2dB+8vhAhQo3/jWYYt62flW0nEuF
YgpujHlijnic+rm/iQod1ypULcLc8KijMnOHCokMyu7b50qGGEm5qgYCNZoT
fDclgNl6OqpqjIoaxcSY5h/GzP1It1qQkRrtGFpISmPWt/hbE85NjU7sf/zp
IuZts90612PUSPVH+AU7zMdMJFrVHlKjtsdvAmow/zITeJxlSI1MY6saGjAH
PuJiZzWlRtUtL3dbMf+12brxzYoaiQrzavRgfu/a1HXDlRpZHO4On8G8N8xi
4HYkNXoZoPF2jxsZdkszpvVaqFFO+N41HczZ5fFBlW3UyDyEBj3ErFP1Wupg
JzV64MD9wghzcZ2L9XAvll9Tx4IlZrv2K8tGE9QoWor9uTvm8fGpLXMqGnTn
3jPDOMzfOCWZ7OVpkKrLB88ezERLy7/vFGhQjcduXT8ery67rgpoEN1da7pB
zMGu0l7sKjRI8G+J4xhmtTG5nQwNGnT4WyX/EubGYsW5IQsa5HPSJ4DJnQy1
enc6rsfRIBW9OWZ5zLKfo8iOiTRIjTBZcRZz8n+9IXHJNIiw1mRNxOzVqKM2
nU6DBtoe1ChhPi+rX+v7CbPQs7PqmCvoLD+VtdEgjt4hK33Mn7NfvJOkokX3
V+3YXmKmVdPcF0lLi0Qm1Fz8Md/4KxpNwUiLTu+KDAdiHj/UEvGDnRYleW98
eIWZK3pvmAc/LTrj27n7FrOFZ+bLTnla1J3SvpWJmU/rh72rNS3S/5av3IrZ
eOXj8pgdLXL6HHyuDTM5zMXuhiMtMhA+ItOO+WKLoI2IOy0Szijk+IHZ7rzF
o7YAWvT6TWL6AOYmSYKBcCotup3z5eI0ZhcK8evNA7SoyVddg+4Zdl5dYOoW
+UOLTLsOjtBjvv5y+sHzEVrUaWJpx4hZmC3nsdwULXoCj/1ZMDfvlw1JWKdF
HVoWb7kw858mtj7hokO7jjHKApirrDTUDlymQ8nlBcOymCVzT3Q6qtEh9z9i
EnKYI1b26LRfo0PRtC+tT2G2cP1p4XubDv1XuXdFHvMef52ABQPsmW1/6ygR
s3GKcWOtOx2qURIwvYSZsd/5klU+HTKbj6a+i1nOMY0l5BMdcjilu4P7IWd3
e04JHVLwSF++h7no0sn7CxV0yPTS0K/7+HwFczZPWuiQMwtF0kPMlcGG75zH
6NAJheAR02f4ea4+68NDj0yK3UwcMCf3u+al8tEjHfkyWUfM3xwznOr56RFB
vJbghFkkm56K8TA96meWe/MUc8e+6r1B0vTIOrk5xxWz1PIpxdeq9OigI1fW
C8yjH4TC413pUWfAmfYgzNNefzaoPOhRrkalXzDmRf3EB6ae9CjenhOFYCYI
CElI+9OjmidH00Ix74sUrKqKpEc0/p6Wr/H18hWYH83F9ugHrBVRmEtNDqhJ
/qVHA0dfRSZhrlYeIIdO06OES3qS7zE3HorduzJHjz7tl6/A/fP3/uEvq/Ro
2oBlNBmPf2e/8zVqBmTDYXQoFbPYJb6PtgIMqJ2wapeBOVyMl7pYkwHtNW6y
zMOsoyuSOqzFgDoGjH7hFg4/ocqqw4D4c26o52PO370aaqDPgBj6BSULMHf+
eLGf9TEDqm8t+F2Imct7WtbgJQOKDHcTLcEc9qfciOUzA/LaToQKzHf3ttCf
LmNACYoHYnAfvNqboV/JgKrm6Ndx5xYtL3yqw/J7KJtdibk95Ii7ficDUoqa
46rGzEF8HfFphgFpi0bW1mIOfWtc91CQEWmVpX1txOzo8MLO9RAj0qjk4WjC
rKsRJxApwogOK3Lfwy3J+MOxWZIReU+VzeBueKosdkqeEWVq/WBpwUypLezH
rMGIjhGi5b9htt87pPrJkxEx/bmk1IHXZ2ln9bsPIwptivLAfeEb7/tpP0ak
Iu3/BTen740toVBGtH7gtlwn5uzViozAGEa0xBR/qAvzRFc8s34BIzpZqD3z
A69H+P1W5nFGpHkoAvVi3p/HyGcxyYje72g74v79/ZNJwwwjykuqyMJtyMZJ
4bPMiCJd3Hj7MFv5fz2xS8GEHI41T+N+4XEsemE/E6ogiHoOYE57RGH4Q4MJ
3bt5wHYQ86OAbJLsbSZ0Sc82DrdU+r2dMG0mFHPdrRF37nhBxDU9JqTm8Uno
D95/+uYN9ZZMaJu1vhl3m1aH1OeXTGjjBfm/YczrF1I24sswr+jbj2J2/Rzv
WVPJhGo2ByJwE2TesvytYUJrHcJFuOkEQoRkmpjQZ+a9m7i5N5wu1/xkQr0/
w13GMJ/IUouemGdC0HXMfhy/vv+WT0sfYkaidnkX/uL9HDBbpSnCjKzWjujh
tqf8q+Z8hBl5Z9u74HadG9CrPsaMkgODyLgDGupeaiowo7TxGr5JzB/d3nU/
1WRGlzmeT+AeHj3vVOXLjCxXPxhOYz4f35okHsCMXNpZ3XAnaN1tCQtmRkYM
V9/g1m2yOWjwhhlp+qvX4u4lJTRTvWdGqpsWh2bwfnX5J6hcxoy64xW7cVdx
lDTULTOj0vrBw3OYhZqUl4+tMyPmsCB53B5e3/mjtpgR5TzPVdzEtQk7U0oW
dPpgsx3ukv69/AzsLEjBPK0cd26qva2qBAua7DO5MY856Zw0X8tDFjSrIq+7
gMdTZ/TcMmRBMvvoLXEPPRiePGLKgpLvlLvgPvTiTYmPFQuiCxyPwp38dUMb
ubCg56cOtuNOuVYVlRfOgtbd76FFvF4Pb3K/rWNBiQaFzEuY620l3esbWdBn
2288uCc8acZWW1gQ4VSXMG6xD58KbnayICulVAXcaZN8mix/WFCGuKkF7nS7
kdcemyyI94hdLe4sb3sOk6Os6JOu7qNlfP9UuP/C+zgruqnM6oBbcvnC0vsT
rCicMucZ7nT9PV2D8qzogHp1GO6PkBd1V4UVbVyQL8KdvDEvoP6AFUmHWBBW
ML+1fCR18hUrSvlo7YO7V/hW/M1wVlRy9WEwbt7+s+y2kaxINVo5AneUKtNi
diwW/+HfFNxvRNMLxNJZUbBBfA3u0D/jCvurWZFpcvsubl9NgytUK6yIrrDS
chVfj2v9OkbrrKgo5/sT3KWXNa3qtlgRtXGXC+7FcxdfBVCyoenbRX64dUQk
fnKxsyHNx7PJuGXWFvWFJdhQSopkD+5fUS+clR+yoYldd/k1zBthWwGphmzo
wy9JwL0n6Eksgykb0vnVdgH35efGFS1WbGjNc+sa7nwzVdrbrmxojjhghNv/
DGeYcSQb2pT4E4L7ZH9imm8LGyK+1xvAzS5lup7TxoY6DFP+4J5+JnWxu4MN
8T8cHsWdfOjziFgvls/RK7P/i2/RKdA4xoYMz9T9w73pSnWFlsCOml858a9j
7mGSq7zEy468fPZp486/v81ms58dUYRS6+EOzanSjRZgR/Z3uo1xX7p5bfvv
YXbE+oX4BHfRW9NTATLsyFeSMxh31JF3WS1X2BExZU8Z7mtlizHy19hRn+zJ
Gty0N1UDUzTYkbc+NOK2d90wd9NmR2linD9wa3y7I3bUhB39ulU6jZvZfs/7
wBfsSLXdmXsDP18ZHoWte7OjHDlDPtzOcdXPDf3YUZPLOUHcf+ts9RRC2VHn
6cojuL/u+35gOpYdFZxkUMD9rCIo6koxO9p7P+0+bkm5u35UFdh81+8Z4e7O
EHH+/JUdmdl1P8ItE1l+T6KTHfEfPeuCe8xygZ9pjh0tWrS9wf16+Atb9Qo7
Gsqii8GNtP0JLtvsqD9zTxLutxcODU0ycCCTgrws3Ff5NFMahTnQmWLBatyu
qJSdTYIDiTY31eHONDrkelOaA23kajXjZiQtaPSf40CXzfm6cNddCCbM3uZA
BIe7o7hFQnR+OhhwoDKfwWncXj3i2buPOdBMJu0ybkWrunscfhxIylCFYhOv
Z01v/scIDhRqPkmHu5t3Ftt8ONC1IhlW3Na1eyqsyjnQQnwxL24FPjFe2hYO
VG5IJYCb3uasbWwvBzr6jkoYd/x+feHmFQ7Ux0Y8ihv5LFVIsnGikQ6qk7iH
5rzuB4lxImHTzbO4PbW5N2cUOdH1OIXzuIWrUyPU73Gij7fGL+Iuv5/tcuwJ
J/LOW1bDfXc9X489iBPx2nrcwL0S9ll5IYUTXZ6J0sQderRKvL2MEyU+uqqN
2yV0eKdlmROZisjo4TZeov7eIM6F7rSXGuE2bN9yOnKfCynST5jh1icvCvqF
cCFC8yXL/83XzhxUU8eFFp9ft8ZdtiSysbvLhUSfl9ji/j8w0jF2
          "]]}, 
        Annotation[#, "Charting`Private`Tag$172654#1"]& ]}}, {}, {}}, {
    DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
     AxesOrigin -> {0, 0}, FrameTicks -> {{Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}}, 
     GridLines -> {None, None}, DisplayFunction -> Identity, 
     PlotRangePadding -> {{0, 0}, {0, 0}}, PlotRangeClipping -> True, 
     ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
     NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
     AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
     Identity, Frame -> {{False, False}, {False, False}}, 
     FrameLabel -> {{None, None}, {None, None}}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> 15, GridLines -> {None, None}, GridLinesStyle -> 
     Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
       AbsolutePointSize[6], "ScalingFunctions" -> None, 
       "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& ), "CopiedValueFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )}}, PlotRange -> {{0, 5}, {0, 1}}, 
     PlotRangeClipping -> True, 
     PlotRangePadding -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{"\"N=300\""}, "LineLegend", DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1, 0, 0], 
                    Thickness[0.18]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1, 0, 0], 
                    Thickness[0.18]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"LineLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Directive", "[", 
               RowBox[{
                 RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                 RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                 InterpretationBox[
                  ButtonBox[
                   TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[1, 0, 0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.6666666666666666, 0., 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[1, 0, 0]"], Appearance -> None, BaseStyle -> {},
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                   ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[1, 0, 0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                   Automatic, Method -> "Preemptive"], 
                  RGBColor[1, 0, 0], Editable -> False, Selectable -> False], 
                 ",", 
                 RowBox[{"Thickness", "[", "0.01`", "]"}]}], "]"}], "}"}], 
           ",", 
           RowBox[{"{", #, "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
      Editable -> True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{3.815495469174765*^9, 3.8157443597554893`*^9, 
  3.81575385430024*^9, 3.815753887260633*^9, 3.815754180838479*^9, 
  3.8157548033066*^9, 3.815761951067636*^9, 3.81582574480345*^9, 
  3.815826475779072*^9, 
  3.8158471319387913`*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"n1new300", "[", "y_", "]"}], ":=", 
  RowBox[{
   RowBox[{"n1", "[", "y", "]"}], "/.", "s"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ncanew300", "[", "y_", "]"}], ":=", 
  RowBox[{
   RowBox[{"nca", "[", "y", "]"}], "/.", "s"}]}], "\n", 
 RowBox[{
  RowBox[{"p2new300", "[", "y_", "]"}], ":=", " ", 
  RowBox[{
   RowBox[{"p2", "[", "y", "]"}], "/.", "s"}]}]}], "Input",
 CellChangeTimes->{
  3.815753917669983*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"N", "[", 
   RowBox[{"p2new300", "[", "5", "]"}], "]"}], " "}], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{
   RowBox[{"This", " ", "is", " ", "p2", " ", "at", " ", "Infnty", " ", 
    RowBox[{"(", 
     RowBox[{"Infnty", " ", "is", " ", "5", " ", "here"}], " ", ")"}]}], " ", 
   ";"}], "Text"], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.8157447298466263`*^9, 3.815744783137251*^9}, {
  3.815753924421751*^9, 
  3.8157539320382347`*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 RowBox[{"{", "0.06835904408445051`", "}"}]], "Output",
 CellChangeTimes->{{3.815744763082663*^9, 3.815744783644308*^9}, 
   3.815753932842183*^9, 3.81575418103263*^9, 3.8157619512409*^9, 
   3.815825753776703*^9, 3.8158264760163317`*^9, 
   3.8158471319804087`*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Ingdtgralinexpo300", "[", "ti_", "]"}], ":=", 
  RowBox[{
   RowBox[{"-", "\[Lambda]"}], " ", "*", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"n1new300", "[", "tti", "]"}], "*", 
      RowBox[{"ncanew300", "[", "tti", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"tti", ",", "0", ",", "ti"}], "}"}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IngdtgralinexpoInf300", "[", "ti_", "]"}], ":=", 
   RowBox[{"\[Lambda]", " ", "*", 
    RowBox[{"NIntegrate", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"n1new300", "[", "tti", "]"}], "*", 
       RowBox[{"ncanew300", "[", "tti", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"tti", ",", "ti", ",", "5"}], "}"}]}], "]"}]}]}], ";", 
  "            ", 
  StyleBox[
   RowBox[{"(", 
    RowBox[{"Infnty", " ", "is", " ", "5", " ", "here"}], " ", ")"}], "Text"], 
  StyleBox[" ", "Text"], 
  StyleBox[";", "Text"]}], "\[IndentingNewLine]", 
 RowBox[{"DiscretePlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"IngdtgralinexpoInf300", "[", "hh", "]"}], "*", 
    RowBox[{"Exp", "[", 
     RowBox[{"Ingdtgralinexpo300", "[", "hh", "]"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"hh", ",", "0", ",", "3", ",", ".1"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.8154954076212807`*^9, 3.815495421753167*^9}, {
   3.815744277036044*^9, 3.815744327422968*^9}, 3.815744397339501*^9, 
   3.815744439484407*^9, {3.8157444802535973`*^9, 3.815744493932539*^9}, {
   3.815744540959334*^9, 3.815744549886273*^9}, {3.815744787552516*^9, 
   3.815744796833095*^9}, {3.81574487376235*^9, 3.81574487846521*^9}, {
   3.815753945429372*^9, 
   3.815754022757749*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.011000000000000001`], 
    AbsoluteThickness[1.6], {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.011000000000000001`], AbsoluteThickness[1.6], Opacity[0.2], 
      LineBox[{{{3., 8.252862464572445*^-6}, {3., 8.252862464572445*^-6}}},
       VertexColors->None]}, 
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.011000000000000001`], AbsoluteThickness[1.6], Opacity[0.2], 
      LineBox[CompressedData["
1:eJxTTMoPSmVmYGCQA2ImKIaB6vA1W0sUNtnD+BUJB47v8HtoN2smCOy0l7yn
+Nz+50Z7GB9V/qT9/pVtkpGcMPmTcHkTYxC4bC97YpFNzex19jA+qv6b9mz8
oWHRLqvsYXyYPMQ1D+yZuf0lpPcstYfxUc1/bM+YLrzKv2KhPYwPk09PA4Fn
9gd/b3z2KW+2PYyPav9Le/3Felv2KEy1h/Fh8mfPgMAb+83XAz5PZJpgD+Oj
uu+DvVz80ess79rtYXxU8z/aswVoP8pZ3WgP46O6/7N9/6FYr0cXK+1hfFT7
v9hbmrdaeW4osofxUf33zX6bL8tjjitZ9jA+qvt+2JsXTt+xUybZHsZHdd9P
e8GDxlzvuaPtYXxU9/22tzOPcTRjDbaH8VHd98d+S3n1qdxZXvYwPqr7/tkX
9qhmr29ysofxUd3H4LBj1h7RZ4stYenPAdV8Bge9P55b7q0ztIfxUd3P6NCR
ImR1zVvDHsZHtZ/JgXdlE/uhhQr2MD6q/5gd9i9qvi+/Scwexkd1H4vDo9qa
2IIHfPYwPqr7WBx6A/682/mRxR7GR3UfqwP7z5jZb8L+wPmo7mNzaD9bphmt
8BnOR3Ufu4OwjpK04KGXcD5MHgBBo7N6
       "],
       VertexColors->None]}}}, 
   {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.011000000000000001`], 
    AbsoluteThickness[1.6], {}, PointBox[CompressedData["
1:eJxTTMoPSmViYGCQB2IQDQPV4Wu2lihssp81EwR22kveU3xu/3MjlH/Sfv/K
NslIzo32JsYgcNle9sQim5rZ66DyN+3Z+EPDol1W2UNMe2DPzO0vIb1nKVT9
Y3vGdOFV/hUL7dPTQOCZ/cHfG599ypsN1f/SXn+x3pY9ClPtz54BgTf2m68H
fJ7INAFq3gd7ufij11netUPVf7RnC9B+lLO6EWr+Z/v+Q7Fejy5WQvV/sbc0
b7Xy3FAEte+b/TZflsccV7Kg5v2wNy+cvmOnTDLUvJ/2ggeNud5zR0PN+21v
Zx7jaMYaDDXvj/2W8upTubO8oOb9sy/sUc1e3+QENY/BYcesPaLPFltC1TM4
6P3x3HJvnSHUfEaHjhQhq2veGlD9TA68K5vYDy1UgNrH7LB/UfN9+U1iUPNY
HB7V1sQWPOCDmsfi0Bvw593OjyxQ81gd2H/GzH4T9scOYh6bQ/vZMs1ohc92
EPPYHYR1lKQFD720g5jH4VCRcOD4Dr+HdgBlzdBQ
     "]], {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 8.252862464572445*^-6},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{
   "MessagesHead" -> DiscretePlot, "AxisPadding" -> Scaled[0.02], 
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "DefaultPlotStyle" -> {
      Directive[
       RGBColor[0.368417, 0.506779, 0.709798], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.880722, 0.611041, 0.142051], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.560181, 0.691569, 0.194885], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.922526, 0.385626, 0.209179], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.528488, 0.470624, 0.701351], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.772079, 0.431554, 0.102387], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.363898, 0.618501, 0.782349], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[1, 0.75, 0], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.647624, 0.37816, 0.614037], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.571589, 0.586483, 0.], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.915, 0.3325, 0.2125], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.40082222609352647`, 0.5220066643438841, 0.85], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.9728288904374106, 0.621644452187053, 0.07336199581899142], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.736782672705901, 0.358, 0.5030266573755369], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.28026441037696703`, 0.715, 0.4292089322474965], 
       AbsoluteThickness[1.6]]}, "DomainPadding" -> Scaled[0.02], 
    "PointSizeFunction" -> "SmallPointSize", "RangePadding" -> Scaled[0.05]},
  PlotRange->{{0., 3.}, {8.252862464572445*^-6, 0.07080773768788433}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.02]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8154954820435143`*^9, 3.8157444065896053`*^9, {3.815744448043006*^9, 
   3.815744495050384*^9}, 3.815744805396113*^9, 3.815753556744033*^9, 
   3.8157539947624474`*^9, 3.815754062608033*^9, 3.8157541886938334`*^9, 
   3.815761958773839*^9, 3.81582577790125*^9, 3.815826483661811*^9, 
   3.8158471396307297`*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals300vals", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"IngdtgralinexpoInf300", "[", "hh", "]"}], "*", 
      RowBox[{"Exp", "[", 
       RowBox[{"Ingdtgralinexpo300", "[", "hh", "]"}], "]"}]}], " ", ",", 
     RowBox[{"{", 
      RowBox[{"hh", ",", "0.0", ",", "3", ",", ".02"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.815744559758568*^9, 3.815744582814271*^9}, {
   3.81574484168108*^9, 3.815744862576949*^9}, {3.8157449206256332`*^9, 
   3.815744924337483*^9}, 3.8157450223386*^9, {3.815745082130978*^9, 
   3.8157451059714413`*^9}, {3.8157540340390472`*^9, 3.8157540685826473`*^9}, 
   3.815825785620489*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals300func", " ", "=", " ", 
  RowBox[{"ListInterpolation", "[", 
   RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals300vals", ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0.0", ",", "3"}], "}"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8157448877074747`*^9, 3.81574494238554*^9}, {
   3.815744977714079*^9, 3.815744981746171*^9}, {3.815753276799062*^9, 
   3.8157532907833557`*^9}, 3.8157535414894238`*^9, {3.8157540463262253`*^9, 
   3.815754049670093*^9}, {3.815825803827887*^9, 
   3.8158258082285547`*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 TagBox[
  TemplateBox[{RowBox[{
      StyleBox[
       TagBox["InterpolatingFunction", "SummaryHead"], 
       "NonInterpretableSummary"], 
      StyleBox["[", "NonInterpretableSummary"], 
      DynamicModuleBox[{Typeset`open$$ = False}, 
       PanelBox[
        PaneSelectorBox[{False -> GridBox[{{
              PaneBox[
               ButtonBox[
                DynamicBox[
                 FEPrivate`FrontEndResource[
                 "FEBitmaps", "SquarePlusIconMedium"]], 
                ButtonFunction :> (Typeset`open$$ = True), Appearance -> None,
                 Evaluator -> Automatic, Method -> "Preemptive"], 
               Alignment -> {Center, Center}, ImageSize -> 
               Dynamic[{
                 Automatic, 3.5 CurrentValue["FontCapHeight"]/
                  AbsoluteCurrentValue[Magnification]}]], 
              GraphicsBox[{{{{}, {}, 
                  TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAA88dx3mtMaz6pdKO1dCCyP6m+gdgd
Cqk/O5f8s9kcsj8vlAOEtBe6PyhHj/nc9rE/j/RD6Atiwz8pmc+7XpuxP8yH
F2FrmMk/GTENyXkJsT+j2m5OyyrQP9hAEsMGNLA/ZlmCWdBP0z8RK8FUbYmu
P0YlD0Y7uNY/O0fX+8xHrD+JpeQbvRDaPxVyO8Te76k/0o3qXq4v3T9E+MhP
UbenP5zhtMECSeA/kwv3B8FWpT9SsIwKZt3hPwczhGJuMqM/OdkIyNRp4z9h
VQSQuzOhP6+oQXb2F+U/HAfk2oFbnj8orBLbT6nmP+WRAHtf35o/MFagMFxc
6D8DwZJ2z2yXP2pa0vpzB+o/yrKkEttflD+mkpx7w5XrP2+V0qC40ZE/cXEj
7cVF7T98QJ4girKOPz+EQhUA2e4/uMsJNW6dij/OHg+X9kbwP943wwM0uYY/
lijP3XId8T8wX4PLymSDP19M2/+K5fE/FfFHLfaugD9ww0WafL7yP1dJhiCA
Q3w/glT8DwqJ8z+l8OpfiyV4P60SBUCdT/Q/+hj2SPmldD8fJGzoCSf1P3lY
LEVJYnE/k08fbBLw9T/OFkgen4xtP07OMGj0yfY/6TZziNG4aD8iepQe3J/3
P692col3tWQ/9z9EsF9n+D9F/zxhc4ZhPxRZUrq8P/k/uz/yXu4xXT8yjKyf
tQn6P9yHtI2Rk1g/aexYP7TP+j9tc12uwrpUP+efY1eMpvs/6Gr3xBc1UT9n
bbpKAG/8PxSklaYW40w/Lo5vtk1I/T9ip4kmC9xHP/fIcP02E/4/jyhX9+Pu
Qz/YMMT+Jdr+P/RXq6VlsUA/Aex1eO6x/z+wjM6ASYI7P5bguWapPQBA1v2t
IbPvNj/O9GdNyKoAQAdaTbhi0DI/kx8/EeoVAUCQP3Kdc/EuP1hXvMLZeQFA
lxxrgizCKT/BuGgwNuYBQLZC28rVFyU/Kye7i2BLAkBTyVzm9XwhPyGsNsSN
rgJA7BXRLiwVHT+7WuG4JxoDQE1lZW02yRc/VhYym49+A0DhU0YtxLMTP5T7
sTlk6wNA6ySiBwINED9f91q1O1YEQL2v6hrgOgo/KgCqHuG5BEDCH2p1GbYF
P5kyKETzJQVAPjCui3esAT8JckxX04oFQD/mEon2Jv0+HdufJiD4BUAC0T61
paT3Pr1aHNNvYwZArZsrCV888z5e5z5tjccGQFF8+s/Zt+8+op2Qwxc0B0B5
S0cfrbbpPudgiAdwmQdASaLBglQg5T4I5Sz5//8HQD7DnQK5TuE+e7nDCQ==

                    "]]}, 
                   Annotation[#, 
                    "Charting`Private`Tag$237963#1"]& ]}}, {}, {}}, {
               DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
                AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
                GridLines -> {None, None}, DisplayFunction -> Identity, 
                PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                All, DisplayFunction -> Identity, AspectRatio -> 1, 
                Axes -> {False, False}, AxesLabel -> {None, None}, 
                AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                Frame -> {{True, True}, {True, True}}, 
                FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                Directive[
                  Opacity[0.5], 
                  Thickness[Tiny], 
                  RGBColor[0.368417, 0.506779, 0.709798]], 
                FrameTicks -> {{None, None}, {None, None}}, 
                GridLines -> {None, None}, GridLinesStyle -> Directive[
                  GrayLevel[0.5, 0.4]], ImageSize -> 
                Dynamic[{
                  Automatic, 3.5 CurrentValue["FontCapHeight"]/
                   AbsoluteCurrentValue[Magnification]}], 
                Method -> {
                 "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                  AbsolutePointSize[6], "ScalingFunctions" -> None, 
                  "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                PlotRange -> {{0., 3.}, {0., 0.07080773767980254}}, 
                PlotRangeClipping -> True, PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
              GridBox[{{
                 RowBox[{
                   TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox[
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "3.`"}], "}"}], "}"}], 
                    "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"scalar\"", "SummaryItem"]}]}}, 
               GridBoxAlignment -> {
                "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
               False, GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {
                "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
               BaseStyle -> {
                ShowStringCharacters -> False, NumberMarks -> False, 
                 PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
            GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
            BaselinePosition -> {1, 1}], True -> GridBox[{{
              PaneBox[
               ButtonBox[
                DynamicBox[
                 FEPrivate`FrontEndResource[
                 "FEBitmaps", "SquareMinusIconMedium"]], 
                ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                None, Evaluator -> Automatic, Method -> "Preemptive"], 
               Alignment -> {Center, Center}, ImageSize -> 
               Dynamic[{
                 Automatic, 3.5 CurrentValue["FontCapHeight"]/
                  AbsoluteCurrentValue[Magnification]}]], 
              GraphicsBox[{{{{}, {}, 
                  TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAA88dx3mtMaz6pdKO1dCCyP6m+gdgd
Cqk/O5f8s9kcsj8vlAOEtBe6PyhHj/nc9rE/j/RD6Atiwz8pmc+7XpuxP8yH
F2FrmMk/GTENyXkJsT+j2m5OyyrQP9hAEsMGNLA/ZlmCWdBP0z8RK8FUbYmu
P0YlD0Y7uNY/O0fX+8xHrD+JpeQbvRDaPxVyO8Te76k/0o3qXq4v3T9E+MhP
UbenP5zhtMECSeA/kwv3B8FWpT9SsIwKZt3hPwczhGJuMqM/OdkIyNRp4z9h
VQSQuzOhP6+oQXb2F+U/HAfk2oFbnj8orBLbT6nmP+WRAHtf35o/MFagMFxc
6D8DwZJ2z2yXP2pa0vpzB+o/yrKkEttflD+mkpx7w5XrP2+V0qC40ZE/cXEj
7cVF7T98QJ4girKOPz+EQhUA2e4/uMsJNW6dij/OHg+X9kbwP943wwM0uYY/
lijP3XId8T8wX4PLymSDP19M2/+K5fE/FfFHLfaugD9ww0WafL7yP1dJhiCA
Q3w/glT8DwqJ8z+l8OpfiyV4P60SBUCdT/Q/+hj2SPmldD8fJGzoCSf1P3lY
LEVJYnE/k08fbBLw9T/OFkgen4xtP07OMGj0yfY/6TZziNG4aD8iepQe3J/3
P692col3tWQ/9z9EsF9n+D9F/zxhc4ZhPxRZUrq8P/k/uz/yXu4xXT8yjKyf
tQn6P9yHtI2Rk1g/aexYP7TP+j9tc12uwrpUP+efY1eMpvs/6Gr3xBc1UT9n
bbpKAG/8PxSklaYW40w/Lo5vtk1I/T9ip4kmC9xHP/fIcP02E/4/jyhX9+Pu
Qz/YMMT+Jdr+P/RXq6VlsUA/Aex1eO6x/z+wjM6ASYI7P5bguWapPQBA1v2t
IbPvNj/O9GdNyKoAQAdaTbhi0DI/kx8/EeoVAUCQP3Kdc/EuP1hXvMLZeQFA
lxxrgizCKT/BuGgwNuYBQLZC28rVFyU/Kye7i2BLAkBTyVzm9XwhPyGsNsSN
rgJA7BXRLiwVHT+7WuG4JxoDQE1lZW02yRc/VhYym49+A0DhU0YtxLMTP5T7
sTlk6wNA6ySiBwINED9f91q1O1YEQL2v6hrgOgo/KgCqHuG5BEDCH2p1GbYF
P5kyKETzJQVAPjCui3esAT8JckxX04oFQD/mEon2Jv0+HdufJiD4BUAC0T61
paT3Pr1aHNNvYwZArZsrCV888z5e5z5tjccGQFF8+s/Zt+8+op2Qwxc0B0B5
S0cfrbbpPudgiAdwmQdASaLBglQg5T4I5Sz5//8HQD7DnQK5TuE+e7nDCQ==

                    "]]}, 
                   Annotation[#, 
                    "Charting`Private`Tag$237963#1"]& ]}}, {}, {}}, {
               DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
                AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
                GridLines -> {None, None}, DisplayFunction -> Identity, 
                PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                All, DisplayFunction -> Identity, AspectRatio -> 1, 
                Axes -> {False, False}, AxesLabel -> {None, None}, 
                AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                Frame -> {{True, True}, {True, True}}, 
                FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                Directive[
                  Opacity[0.5], 
                  Thickness[Tiny], 
                  RGBColor[0.368417, 0.506779, 0.709798]], 
                FrameTicks -> {{None, None}, {None, None}}, 
                GridLines -> {None, None}, GridLinesStyle -> Directive[
                  GrayLevel[0.5, 0.4]], ImageSize -> 
                Dynamic[{
                  Automatic, 3.5 CurrentValue["FontCapHeight"]/
                   AbsoluteCurrentValue[Magnification]}], 
                Method -> {
                 "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                  AbsolutePointSize[6], "ScalingFunctions" -> None, 
                  "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                PlotRange -> {{0., 3.}, {0., 0.07080773767980254}}, 
                PlotRangeClipping -> True, PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
              GridBox[{{
                 RowBox[{
                   TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox[
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "3.`"}], "}"}], "}"}], 
                    "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"scalar\"", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["3", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["False", "SummaryItem"]}]}}, 
               GridBoxAlignment -> {
                "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
               False, GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {
                "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
               BaseStyle -> {
                ShowStringCharacters -> False, NumberMarks -> False, 
                 PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
            GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
            BaselinePosition -> {1, 1}]}, 
         Dynamic[Typeset`open$$], ImageSize -> Automatic], BaselinePosition -> 
        Baseline], DynamicModuleValues :> {}], 
      StyleBox["]", "NonInterpretableSummary"]}]},
   "CopyTag",
   DisplayFunction->(#& ),
   InterpretationFunction->("InterpolatingFunction[{{0., 3.}}, <>]"& )],
  False,
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{3.815753604548572*^9, 3.8157541110055447`*^9, 
  3.8157542243625793`*^9, 3.815761994094266*^9, 3.815825827780079*^9, 
  3.815826520105122*^9, 
  3.8158471753144903`*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tau2for300", "=", 
  RowBox[{
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals300func", "[", "ww", "]"}],
      ",", " ", 
     RowBox[{"{", 
      RowBox[{"ww", ",", "0.0", ",", "3"}], "}"}]}], "]"}], "  ", "/", 
   RowBox[{"N", "[", 
    RowBox[{"p2new300", "[", "5", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.815745024257978*^9, 3.8157450584986153`*^9}, {
  3.815753254031543*^9, 3.815753254670862*^9}, {3.815753587458639*^9, 
  3.815753615250682*^9}, {3.815753669810672*^9, 3.815753732499239*^9}, {
  3.8157541011909513`*^9, 3.815754118823043*^9}, {3.815825834484707*^9, 
  3.815825834836623*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 RowBox[{"{", "0.6803428392539929`", "}"}]], "Output",
 CellChangeTimes->{{3.8157536885805893`*^9, 3.815753696462763*^9}, 
   3.8157537329431343`*^9, 3.8157541192042723`*^9, 3.815754224383259*^9, 
   3.815761994119343*^9, {3.815825830047329*^9, 3.8158258357934027`*^9}, 
   3.815826520134828*^9, 
   3.8158471753389053`*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.815754291003084*^9, 
  3.815754291336782*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Mu]", "=", "38"}], ";", 
  RowBox[{"\[Lambda]", "=", "6"}], ";", 
  RowBox[{"NR", "=", "1"}], ";", 
  RowBox[{"\[Nu]", "=", "pumpingrate"}], ";", " ", 
  RowBox[{"A", "=", "500"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Jin", "[", "t_", "]"}], ":=", 
  RowBox[{
   RowBox[{"A", "/", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"1", "/", "2.3"}], "-", 
      RowBox[{"1", "/", "2.31"}]}], ")"}]}], "*", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"-", "2.3"}], "*", "t"}], "]"}], "-", 
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"-", "2.31"}], "*", "t"}], "]"}]}], 
    ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"s", "=", 
   RowBox[{"NDSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"n1", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Mu]"}], "*", 
          RowBox[{"n1", "[", "t", "]"}]}], "+", " ", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], " ", "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"2", "*", 
             RowBox[{"n1", "[", "t", "]"}]}]}], " ", ")"}]}]}]}], " ", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"nca", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{"Jin", "[", "t", "]"}], "-", 
         RowBox[{"\[Nu]", "*", 
          RowBox[{"nca", "[", "t", "]"}]}], " ", "-", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"n1", "[", "t", "]"}]}], ")"}]}], "+", 
         RowBox[{"\[Mu]", "*", 
          RowBox[{"n1", "[", "t", "]"}]}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"p2", "'"}], "[", "t", "]"}], "\[Equal]", " ", 
        RowBox[{"\[Lambda]", "*", 
         RowBox[{"n1", "[", "t", "]"}], "*", 
         RowBox[{"nca", "[", "t", "]"}], "*", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"p2", "[", "t", "]"}]}], ")"}]}]}], ",", 
       "\[IndentingNewLine]", " ", 
       RowBox[{
        RowBox[{"n1", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
       RowBox[{
        RowBox[{"nca", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
       RowBox[{
        RowBox[{"p2", "[", "0", "]"}], "\[Equal]", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"n1", ",", "nca", ",", "p2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0.0", ",", "5"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"n1", "[", "t", "]"}], "/.", "s"}], "]"}], ",", 
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"nca", "[", "t", "]"}], "/.", "s"}], "]"}], ",", 
      RowBox[{"Evaluate", "[", 
       RowBox[{
        RowBox[{"p2", "[", "t", "]"}], "/.", "s"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "5"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "5"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Thickness", "[", "0.01", "]"}], ",", 
       RowBox[{"Thickness", "[", "0.02", "]"}], ",", 
       RowBox[{"Thickness", "[", "0.02", "]"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{"Orange", ",", 
       RowBox[{"Darker", "[", "Green", "]"}], ",", "Blue"}], "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"plotofn1Slow500", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"n1", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "5"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "5"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "5"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{"Blue", ",", 
       RowBox[{"Thickness", "[", "linethick", "]"}]}], "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"{", "\"\<N=500\>\"", "}"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"plotofncaSlow500", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"nca", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "5"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "5"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "2"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{"Blue", ",", 
       RowBox[{"Thickness", "[", "linethick", "]"}]}], "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"{", "\"\<N=500\>\"", "}"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"plotofp2Slow500", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"p2", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "5"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "5"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{"Blue", ",", 
       RowBox[{"Thickness", "[", "linethick", "]"}]}], "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"{", "\"\<N=500\>\"", "}"}]}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.815754342443674*^9, 3.815754363897985*^9}, 
   3.8157547936640882`*^9, 
   3.815754854048726*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData["500"], "Output",
 CellChangeTimes->{
  3.8157543303787107`*^9, 3.8157543660284557`*^9, 3.8157548082007933`*^9, 
   3.815754855042717*^9, 3.815761994150304*^9, {3.815825847868977*^9, 
   3.815825861957711*^9}, 3.815825900694335*^9, 3.815826520162107*^9, 
   3.8158471753699102`*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], Thickness[0.01], Opacity[1.], 
      LineBox[CompressedData["
1:eJwV1nc4le8bAHCOfawzqm8kFEVWpIzGuR9ZGSVEJRTZW1mhEhKiKFkl2Svj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       "]]},
     Annotation[#, "Charting`Private`Tag$238053#1"]& ], 
    TagBox[
     {RGBColor[0.880722, 0.611041, 0.142051], Thickness[0.02], Opacity[1.], 
      LineBox[CompressedData["
1:eJwVl3c41e8bxw/HPDgOp0Ffs2QnoqLhfoyQpCgqZO9klZERWSGzhJSMkpWR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       "]]},
     Annotation[#, "Charting`Private`Tag$238053#2"]& ], 
    TagBox[
     {RGBColor[0.560181, 0.691569, 0.194885], Thickness[0.02], Opacity[1.], 
      LineBox[CompressedData["
1:eJwt1Xc8Vf//AHB7j2s0jKxERpR8IuT1LhHSIhWhQmQmpSTKqChEEsquiMjM
lnHda2YTSqWsrOy9fu/zffzuH+c+no/XOef9fr/G44hbXje8SkdDQyOBL8R/
7H1Lpn3W9zRp/v9HaRczOC9mAgEvA3bnqpYe2qwu8xMTs4OEFiGlAT0eTa6w
/Cy2blewXPZ5nKaMNGMrgkUZxe5CH9se3bL8S5ryk9bPNm0fgElPlVsN023N
H1xxG2tdvqB/2HlxrjlAUzKZ9cDK6iN4bR3J56kXpel4yM1pUfQJMK7vj0jw
TtLM7eh7N6cVBO1u/m7ZKdmaKw4GvdO2IWAvoNVfZ1aimUDb+2RR+zm4sYrb
X9OgaB5tfL5roSsMAi5Tk460ftH8G3Wscs4uHPpcO96O/27XDLJeN5tdfQnC
iVw/NQu+ae7dm7s0HRwJFPVTbR8Cf2u2r14LnxJ9BfKpXNGzUUOat2tE9k5m
v4YCa4mLK9HjmoIvOhomtGJA6JWjWsXXac0yi6e2452xsJFhY3Fydl7TUhbR
j9nGQyBr5s+jWSuadKsezXOeCfBntqJbhpMGOvqMd8xpJ4Kg8tuuLaL0kFy9
12GW6w3EbxtMOxTOBO7p7EUzXW/gaYfX1nVXNtAPG2KaSXgLfe1BvDGVXCDs
Xnl22u4dbFxN96Sp4oF/5jFvppSSYCxkxfqSFT9UaN2ZmlxNAm+zp3cHjm6D
MBlDzUlKMsQZPDj/0l4QrLn3BP0Lfg+T/tphV7t2APP3P9IToqmwfT115ket
BHRXfHYb/5sKn/xS2x/PSMKH5KiqsewPsObjzHFNWxo8g27yjHmkwUOPp0d6
yDJw0vXkpVGtdMhwSScJO8qD2AWZjyMcH0Hm14/op0cUYeYQw+rfzo9wOVLZ
PXPnPohgLY4Yts0E7n2H4gNdlOHTHX3Xm9uzYGQxvG23xgGIGVURmPXMgtG3
KiWnxFXBuYXXdkY7G3Tf/O2yVdOA81o0XK4fsiGjef6P2XVNQPkTn6a5cuBY
gJv04iUEvDG1dNNdOdBXRS4Y/HYEVrnyU100ciH+v4dym3uOwoDP29NTCblg
ICf0sylEG/Jt78dN2n0Cjc9CKle8dSH+m4P29aZPIDl1uMyfWx8CTpiM/1PK
g/Ivq2/kMo6D6X5ltX+rebDy6/f+WMFToJUs/tvpcj40xYe7Xbp1GuQFuAMm
KPkwoT4l6md1BjY2RjrHgwuA7LTSbmBqBIn18TfGRIvA989trrK08zAXlSf7
K6gInEbfXPjw7wLo2Db0ty0XQZuivGuKuimM0y8aF7cXg0TU6uMtc2ageuik
2hP/Uuhn3MHK6XIFAtmtZz3nSoEruv6lj5ol/Oy5m+5y5TMU7Fq+uYfNCh7e
ThK5oF4GtI/A6mCRNbRkrtFJT5bDmz1K7U7nrgEvsFpwKlRA3d7PU2P6dqAu
Fa7mb10BVPv723OP2sOzudRZj9YKsLA8RBLRdQTl551XLdMqIUjnDZviMRd4
UC+vv+9SFZgxz5rFsLtBSnaBVNrLKvDeob93MNMN2qKO0O/6UgUW2ZXBVedu
g6TthdLtBynAER95TzX9DtTTP1Sg4aNCtoAeK9nNA7Ye+s7bXF0ND6Rn2T2R
NyBJm0nd9Wqof/XSLzfZG+zYpxvI+2tAyH3vYVEuHyjtYXqUn1ADpVsv+gT1
+YDlbaXFWI9a+HkptfvpCz/IyHzy3VGhHrzUj9RY7/WHUd7RIP0r9TB0RDxl
IcEfpG/ra+4Or4ddNc9m7vIGQIIGe2L/cj043PXKObEUAGF1QTam1AawZhT9
uNj0FG73h0wfM2sEz6Stt4qTn0E8e4Mfj3YL2MXwM5jcfQG20Ppq3LUdwh25
fCJrYoDmzULx98B2aG1ZT6DbEgtRDMK99e/aoTpd5keyZSzU1tmIpH5tB6EL
e2QiN2Jh99m1N1fVOuBxcHjuhmo8/L0mnf6TthMeH+xKD/+eAPZhXmUtoV/B
Gx2tDrJ7C86DMv2fMnrgvK+qFnNmCrCJP5T+pdoH/JJTyX7bc+AZqUE28XI/
1L7lezC2vQCKVHbknXTuh5eeyTMmewpgwOI6rN3rB8ULSt6lhwtA/SPf2fOR
/WB2j7/Y3L4A/uqZeXE29UNlBHLkLikALb+J5rvqA8C5zylKyrQQlua53Qy3
DkKKp/mxwWdFYPn9bDn9lyEwqeqZ0W0tAbbo3043eobgH7kvd++fEsgxdRb+
NTQEo7QzYeyzJUD/zf9uMe0wMKUfSXnNXwrvuov331AZBk4/N3GR86Uw1CmW
8vPNMGhNHVYr7ikF+5bx0KK7f0HP8M/P452f4Qb1oeV16VH4/H2ft25yOYgM
6DAt7B+FjT4nxa255dBAx/rBE43C2XNaO3vKy2EXCp5+YjIK4b5pw5o95dBT
/NL7XeAoSBbtk6YyVsDhrOS4nslRoEljY+JVqQCe6NpvWoVjMK65y6viZQWU
FT29X08Zg8/7GV89iK4Ah24DiTOtY7BoMht9MBHPzZZWO4vRMYiZeXM5Lr0C
7ob2LLkLj8OM3gcZuaoK+P1odGuG9zignp5ho8kKyHbhMNquNwE3/MUF57Qq
4ctrvrsfz02ACVNfgJ9eJQxRBOOPWE/AbZ45U85TlSAoIDPm+GACImbFVUim
lfCwUtuvMm8C7ho6K7Vfr4RzvA9y7SX+gQPXPqMzrythJXea7/PqP3B/ZBp/
bKwS+H8uHTRknYQn91Kvy05VggILzeXhrZNArovexjJfCVZmXOk8SpMQfcl8
PXcD74dB7qjNtUmo21R50sRDhjhj61vcnZPgV9E3xqNChsR7DqN7z0/BoB2v
3rgXGfZWsC75m0/BVwGJH399yFDBkML4y2oKcoY9L/5+RIa+4AGxYJcpuDRs
s7M6mAwiCebnR55MAT/SO3AplgyvKacoiaVToLdwU6CthAxhnMpxvBLTMN6/
zaBlngwShm1pdrun4c2MvvDpZTJkR7gUVShMg4RZkeqXNTK0iH7scFafBufA
K5ZF9FXApSTF3nB2GnaSrzba8lTB03Pb3f38p+GyYsPbbfJV4Bu/dmZufBqO
ZbgrdltUwem9hTfkZqfBbJ/nbNeVKhCpvPnccnkaZPev+3VYV0Hxn9GWFsYZ
SO+x30Kxr4KZXT2nPorMAL/7GR2v21VgmZ53wub0DLSeLQPT4Co4XOSs1507
AzFdr061FuL96MvacRfPgD7Pju/XS6qg99tggE7FDKjK3A1gL6sC9zWz2k9f
ZoAvVcBIraoKsuD4seeDMyDBzTzl1lgFYtXS2vrbZuGnrtYj299VQNPeh0o9
ZmHdT7BYm5kCD0fKEj18ZsF8M36kjJUCrDSxdAcDZoHDyW3bfxwU4N1jQsl7
OQsnWG54bOehwC7/1mOZWbOQqWuZWyJIAX118sk3Q7Ogov8t6vYeCrx4+9Ys
wHAO6nxc6NpPU2B7sc9nHZM5mGxQaJw2pEBMyyURxstzkCX4c47TmALJ60J9
Pk5z0N9tYKNpQoHC8+FW9wLmwEtcQsz7CgV62R/ZO5fNgadjuNmTGxSQumXj
flZ2Hg7bn5mmhlBgj9ovo/i982DjYlpw+zkFlGkuKI4emIfMAKrnrhcUOBKk
N/RAax5KGrI5vCIoYPFO/mya2Twcurv9EX8sBSI6ZhTpQuYh8t1ho6FUCjD+
92A4c3Yeemp9F3eS8XdndZG8sjwP00wmD6OqcD4qXeK0aRbAyCzvFDuVAmIn
LI2/cyzA5OzvlLEaCmhc1a5iklqAAvXy6MhGCtx6yR5vfmEBaD7e3BHXTYGB
+chz7J8X4MwdpV2uExR4c3j/zR9VCxAW/K/lyz8KXApuCsmsX4A9P/Myd01R
4JskY51R9wI0r4xwtc1QoNXIVT1mdgFK9wyHbFmiQFm2gdge2UUwMDe5qUdH
hUgn2tGTkYtQb/Zh1XULFc4WxTCJxy1CPl8la9RWKvAyqu6cfbcIebcKA0u2
UeFZjLNZZM4iBNY2zawLUOFhw/emX42LIGYt5OMiQgUXmfxcF4Yl2Gg6rMYl
TQX9QXuvsBtLwH/lVrmqChV0vHamH3VfgpVRUQM5VSoc2dL7beH+EmTLDz8X
PkgFNe0TqheDloB63ujUqhoVZJMUZ3e+x87xL03VpAL71blreb1LMJL6IrtB
mwpfBrzOdh9bBkG3NXcFIyrUeh7we3pyGTZku/hWsSn8k9kaxsvQZTQcUX2W
CqVHL3MnWi5DkCdcND1HhfR3R+rtvJZh2DOJwc2ECsHWzGg1ZxmeurTRul+i
wsmBUDkRkRWQ0xvJ+2yP15Mb6DCTXIFqqVkjCwcqHL+pcj9adgWU35pLbGDr
0v1s2a6yAm10GmfVnfD5xORu851eAfldN6XTr1PhPzNqBYvvCkxXFltdu0UF
4Y5l49nBFVhPHww/40WF10InNveNr8CQZSr3N2wBq4QUl5kVKFhh7b5ynwpb
Z3RWJzZWoIg0ffb6AyqQSOEJf7etwu/XPlt9fahAb6Aw9kNvFUoN6Fz9H1Fh
tMrSu/bjKijFXVTZFkwF0efd9s8+rcLkRdHP4dhnLU4any1ZhYgE9hCeZ1Qo
Wzoo21e7Cin7DgmxhlAhbA9Px2L/KuyLiJ2cDKWCemS5tLTgGrTNtp2JDadC
kL1w86PHa/By5LKcVzQVKlXCio4Hr8HnwIdzg9gLDCzveMJxnOPHrpMxVLgc
P+sem7gGTCk2FOFYKih31Evkla7Bq9HtzLlxVPhx6O7tgZk18DgzbkhJpIIC
z9cdWpfWIWK/ieGD91QYCh7yfXl1HfQzHdpasGPZFoeHHdZBM3n5j3gKFTgY
tucEua+DnC9NIRl7dMFE5+vzdRg9z6i1mUqFpN4fznaUdUiK9zhrnY7znzJY
HiKzATId//H+yaJCh+SC5B/FDfCwmc+SyqZCYCLTU+UDG0ATEzptj73yWvps
z5EN2G89dWEGuzvY7q+E2Qac+ONXt5ZDhRc3J0j5zzZAR2PwI00eFdhg/krv
7Aawepsm1RRSwf3wbpb8lQ3Q35ssyVSEz6N1MSOEdhPc1KV0jmKTdStXjnBv
QrNa1I1ybA/D4BepsptAV/byTnYxFcau7qLevrIJo1pJHx6W4n4MMt7N07wJ
t23+So6V4/kJCWga7dyE+tXDPSIVVEh5XnKL0rsJXVzVmobYDyPEK++MbkK/
+4JIIbZIy4L8JB0N6sqcOOpdSYWvPWSqsQgNMheRCaCrosKxCdNFCWMaZHyj
r7CVSoU4fr/2BxdoUNpqStIq9px6WmbvRRp0hPmc0a5qKiQ8XbWNsKRBpTdq
Z+5gr0jHdLO60KD8dl4DwRo8b5Y/iqae0qDYInKBUS3u3+5LnmUVNOjCsYrP
0fVUsNn0vyBEoUGF/xVfL8MulcpSdq+hQXKeYhN92HZuNBP7mmgQd+GF47sa
cL54E82TvtMgyXuPY9Owb534oxm0QIMiVs70ZHzB9SFb05rK06JN/h3pz5uo
MHX4m6CXIi2qvFrtmI7NXHlKOUGJFqkp6THXYB8oV7MdUqVFO/0y6lexw0tI
ja7atMiWP+O5VTMVTn0qjQq0oEVF9A8M5FuoUJ3Ev/dzKC3iXrta8baVCj8l
n+r1vaBFWiMqIsXY8283LekjadHzsPWLLdiSb0Zf6sXSov/sOdzXsH3jKlY7
U/F+LNsOGLVRQTPSseYfmRaR01pnV7DzAigWYvO0aFTh/kvlDlxP/Ybt/ku0
aHFcp0MX+zVHW9vEKi0S0r88a4btHfpLp4SODul8Odr+ENsgakXhHIkOnXO7
ItqO/ef93s1AOTq0GfyK176TClw1MfGLV+jQL3WvCN+vVKB98tbE4iodaujf
q/oCe07/Ax/1Gh36blNQ/ha7p6nAP+w6HXJ63OtNwX73te36Hi86lJE428zQ
hftviAVZRdEhGhFuije2DaNbX1MTHeLRt6e37aaCoGhd12orHTLdu1F5E7tJ
dUfz7k46NMtW4uSNfcCR+tn3Ox3KShEMfoXN1L4l+sBfOrT7t8W/euykhHzj
OFp65Gc0aCjbQ4UB9aV6J2V6FBboc6YXO8rYgPxahR4NJyoND2EbXE8oqlGj
R6yrsk7T2J/e6KaIH6ZHyg/09Jm+4XlgffWo8wQ9yuVJPq6ILdl1EB2ypUeh
idb372Nbud7L43hNj+yvpKjyfsf7U/qZJxNLj/RFljsEsdlmUL5OAj1Kt82x
3omddYOpwDuZHj1kfWuhjL3m8rxwLoceeTleLDPGjrj+vqS3gR7p9O/UiMCu
c2yvTF+nR2Ued1K4eqkQI3+AXEfDgBQbXrRtwXYZjyIP0TOgEuZdM8LYWx0t
qsTYGNB+k34eOWxLhxFK+FYGZKKR2KmDvWa3WeOpyIDKPa/d88RWtJVrMrjC
gGz1YuL6sH/aiV7/aM2AdGPu8w9jBznykbiuMaD3rOzeE9gjN1bPNDszoLBM
C9UV7LeeDZ1nPBkQ/dMoRb4fVNgW5vDjXCQDupf3XFsLe7M0bfxyIwMKihe6
F4OdUR4fXNnCgGo5r1clYpuRXyhIdDAghltA/x67qOaeS/83BhRKDrLLxr7Z
dnzu6l8GtMD1oo2KPTw8tmpPz4j4jz8Tn8Bu5pVndzvIiHaHKTEf+Innw8lp
JFqDEQkNeHKpYWfUZNSQgRE1KH/i1sR+5rnvIUmHEUl9YKfRwTYYOrCeZsiI
xur1Xxlj1xcdnvzjwIgEtt7Iu4lNvXy+/XQcI6q7o9aahq1cEpV9J5ERpfoE
SGViv9vyLSTuHSO6eqj2dg72w3ozg/EPjKiITY2lCPuIsiXVv4AR/SjLnaRi
VzA7FZS1MCKdF8rdP7FLMnyj5emZUKPzV03OX7ifDYwFI5mYUMJ2UCdhnxmR
fkXLxoTIj8lKfNjDOxsjvpKYEMVbhU8Am+/VtjBvESZUdy3+tSS2g196QMdB
JiQ1HVanhi104aubpwsT2uFw6ZsVts18ytzQTSZk+JlO1wY7O+zezTN3mBCt
8Jvsa9jHGsVuSN1nQoVRE+5O2DePODi2BDKhTopV923sBnkaK8n3TKh64ERf
APY9WtnTX34wIbqB7/ABe+goe7fUbyak3ZypmI59OmD8ks8AEwrYbiqcgS3J
nXn9wBgTOtFzbDwb+4uwckjCEhMKfK1lW4QtoqrZdIuPGfHIljbWYJOdDQ12
6DGjix1N9/5gy+fs77hjgOOm/7gHsCPm+c3aTjGjKBGPxEHi/J5dDv7nmJHR
x8HSv9j8T80Cp62Y0fY/dzr/EedPsqmn3mdG7z/2ha5gs/V66Dp/YkZ6hSUG
pD48v3dSOUMKmNH+/NoHPNhXeLvbMouZ0beFjSxe7ELd/8ynK5jR7Mg05xZs
m7zJG7camdEJNY0cAezKZ9bRHkPMKMF/IVmij/ien/z3eDsLWslxNNqP/a7X
M/e9EAtiMPlyWhm7+U6ae60IC9ryJcngP2ypDBZ6tl0sSFm0GVSw2wWrtgXv
Y0GOB07wq2MrzKkcfqHPgnZXKrgfwR5MFg+P92RBUce5D57GHn/4e5nemwVF
y8cIncGesUy8dM2PBWl4Z68RphEVl9v3lAWlDXsVG2ELRoqRyZEsyO55t+R5
7NP+olODOSyITcIx3xy71HaHgfwIC7IvF+i1w67S/pEdOs6Cfgr0vrDHrt8Z
u21+kgVlnXXQd8Du+iXc/3mBBa3HLeY6EuufF/Y4xcCKRCaX3a9j79YVSnEV
ZUWhFNUvt7DDdwswFBmzoqN5Dkn3sc0spN73X2BFLYu+ex9gS4bv1+cyY0Xm
LBXFhD9tngi1smRFsVZZX7yxO776CnNdZ0U+uYFDvth8j8aVrQJY0RNQm32M
Hfa7/CpnCStiHCu7+wzbdFsji2oZK6pPWh8jLHHiW5plJSu6mxpgHoKdUzg3
XVDDiqrt/TVDsdtCZO5bdrCiW5NHlp5j82i+iCiYwPEHocdfYoe+tqm5IsaG
eIu970Zj37nte9NzJxvyK7zRSdjCME40UooNTZ/s2BuDLc/29c4XeTY0eGt6
kHDdXe3dKgfZENt6ol4cNp2J5BMOQzZEK/1xMQHbbdsf/QI/NvTuosRcEpGf
2fWF1sdsKKf6JyRjH20WeDv+hA2tPdsVSJjX/8yqeCgb4lg4K/YeO2OhIi0o
hg2FL5zWTsH+2xnPYZnHhnQC73p8IPIRbt7EMcyGnjlkv8zAFs5lE3IYZUNc
7ud7CP9qLbCtm2BDCdKBwpnY1ty8tI/n2FCpVmIiYeen1fs3adnRamdCcha2
r7fiq2lhdgR/7sTkYKc60lp/NWRHQe/61fOxHQMzspTPsSORvR9cCSt8uLge
ZsKO8hr5UwnnDOdFnLrMjs4bd/MXEP1naV9X68SOTPZL/yXccqFdoSSAHYXw
mNwvwl46mrQcX8aOes/3O5Zie5bE+1Eq2dGKy+EIwjRKrzlHKOzo+UmLcsLM
oiHiSg3s6FB1J+kz9tZldz1KFzsSy6ZmEd7/0eDV3yl29KJyeaCMON+WOdV9
OzlQVqi7eCXRz4H/yMZSHKh2+zUtwm50IwYeMhxItU/8KmHPyR+XqxQ5kJ/V
/HvCgXU1AcYaHCigUFKOjJ3iFd1915gD0X8Yk67C7h884k7250A1O2+vU7CP
xDe9kQ3kQKaecUJU7IQLpo1hzzgQy6+wg4QtGm5IWL3kQJOk37cIf8tK+EL/
lgOF6guPEG67tyGmXcaBdt2yq63GJvMU19XMcaCR3IfWtdjiDdpzikscqGu9
zZOw98NWkahVDpSvuRhOWHPx781rdJyokJVCIVzcu02ElcSJnPfckagj6vPe
zVVfjhOtfLjzlfCbQ/uEGq9wohCLxxINxHon2fxWrTlRVX6rMuE/l/pHZa5x
ouNlmzqEd/q+LH7szImE7jM4EH5XvWyC7nGig8p52YSTTpGjcsOxt3Yd/ELk
64rR1tc1nGgk+tiBRuxaV/n7tfWcaPWBmjbhv36MQwuNnMjuzJazhHcnF+QZ
dXCifTp+NwinjgoZc/7mRLoaR9MIf7g58MJ7hRNd9XEXbML++MiNx3YPF4pm
yPpLeFzD3PfRXi7kEp4yR1h+7ujs2/1c6LvkM5pm4nlL/s6+g1xo7ZPYdsIp
kBtlqsOF9jy30SH8bnlK9OQlLpT8Izie8GsnR4X/nnOhbE0F7RaiXpJn443C
udBH/c2ThAV61UmukVxIubTiAuEoffaZjFgupCi9xZHwS+kPebs/cCFab6Yw
wqG/hzWEq7jQ8XMi3wn7G1sdp5/HcZ4ey1aiHqd6za4ucSHf4TAHwqV6xs41
q1xoR8WhW4RnDh17HkjHjU432DwibCYl18VH4kYXX7C8J6y0OGMpKceNPqnE
DhP+GeXroX2FG3W8yrdow14OWw18b82Nfo98vkqYP/hWLOs1brQoW+RIWM/H
pqLRmRuhykAPwp/s9JnOeXIjR8a3Lwk/VeMNs4nkRgq7UuoI/9ebmOrfyI0i
uoJl2rFJCteWMlu40SGGrwqExx8oHOtu50ZmpVuUCb/bWTKw+xs3erV8T5Mw
v0OHaP0QNzrWNmBIeMWT/jgTDQnJn9znQbiH/UClrgAJkaPpqwhXK7/62ytI
QolmRjWEP5mvcd8QJqEjGjENhEMzyRavREnopIdAB2Fdo1NrI7tISKWfPEC4
8PU1lUAlEkqb72boIOolE/2x8TgJdcefRITnZnWS/E6QkLu5yFHCp8pmYg6e
IqHmZ8PHCDMZ6QclGZKQrYvNKcJunsv2XiYklCmzzYKwYfP53XtsSYhT18CD
MIcb/9sgXxIKbtbKIFzF6hi29IiEKlzNPxH2iKvysX6C3+dzpZjwSI3rZY1Q
EtLelKkmXC3YumM8loQkz1N6CT+oCI46XkRCWVUWTJ3Y51ZnQ9+XktB/bLLs
hOUPmD6hryChkY8D3IS706Q8SqpJyGdztwBhpcjyi3IdJPTJaU6W8JDTtAj7
JAktsNYfJ1yacn6b7QwJiRW+O0X4Rf9n7qp5EpIquWlEGJk8pbm3RkIuc2Om
hF8f3flnlJUHieYftSN8Qsg4qV6SB7Xll/kR9kSlJG45HiQ1/OgJ4fSrOz2N
9vEgtwipEMJsWdOGvYd40LbhjVeEa44+o/l3Dsd7eDMIL9jNOyiZ86Bi3doc
wlIhZl23rXiQzIlLBYQf9shmbF7nQZxc+ysIH3auucjzhAeZ1YW0/O9+gTMs
P0J40GBqQQdhDsq3TykRPOgwG7n7f/kR+MeJ3vEgbbGHfYRdqPwVzuU8qIra
/I+whtBuAaZGHpTkaz1PmOWGumvsNx4UdjF2lXC8sKXkl3keVHiTj/kr8Xzr
B1dPOl4UVU3LQRg9nq2Q5+ZFbU2ZJMJ/Jh+aB+/mRb6uZgKEc941ph36jxfZ
PrfYQdjPZOvKxGFedNx5jzhhyar3EScv8qKtauq7CZebZ9xTvMWL9H65KxA2
Xfp0mRTMi4JahJQJz4eVaE8n8aJ1d+WDhEP3kGXbyniRJmfTIcJMvwz5W3p4
kddJgyOE74X2rzfO8SJlDUMdwlOHbw03cPOh81vH9QjbzDK01snyIeODUicI
W7etusuY8yExzeOGhC2zZ8SehPAhh1qPc/9br40jmFLDh9TMDpkSLpuVWt7c
5EOd62rmhP8PrzrhAw==
       "]]},
     Annotation[#, "Charting`Private`Tag$238053#3"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 5}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8157543303787107`*^9, 3.8157543660284557`*^9, 3.8157548082007933`*^9, 
   3.815754855042717*^9, 3.815761994150304*^9, {3.815825847868977*^9, 
   3.815825861957711*^9}, 3.815825900694335*^9, 3.815826520162107*^9, 
   3.81584717541499*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{{{}, {}, 
       TagBox[{
         Directive[
          Opacity[1.], 
          AbsoluteThickness[1.6], 
          RGBColor[0, 0, 1], 
          Thickness[0.01]], 
         LineBox[CompressedData["
1:eJwV1nc4le8bAHCOfawzqm8kFEVWpIzGuR9ZGSVEJRTZW1mhEhKiKFkl2Svj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          "]]}, 
        Annotation[#, "Charting`Private`Tag$238097#1"]& ]}}, {}, {}}, {
    DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
     AxesOrigin -> {0, 0}, FrameTicks -> {{Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}}, 
     GridLines -> {None, None}, DisplayFunction -> Identity, 
     PlotRangePadding -> {{0, 0}, {0, 0}}, PlotRangeClipping -> True, 
     ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
     NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
     AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
     Identity, Frame -> {{False, False}, {False, False}}, 
     FrameLabel -> {{None, None}, {None, None}}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> 15, GridLines -> {None, None}, GridLinesStyle -> 
     Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
       AbsolutePointSize[6], "ScalingFunctions" -> None, 
       "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& ), "CopiedValueFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )}}, PlotRange -> {{0, 5}, {0, 5}}, 
     PlotRangeClipping -> True, 
     PlotRangePadding -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{"\"N=500\""}, "LineLegend", DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 0, 1], 
                    Thickness[0.18]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 0, 1], 
                    Thickness[0.18]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"LineLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Directive", "[", 
               RowBox[{
                 RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                 RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                 InterpretationBox[
                  ButtonBox[
                   TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0, 0, 1], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0., 0.6666666666666666], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0, 0, 1]"], Appearance -> None, BaseStyle -> {},
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                   ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0, 0, 1]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                   Automatic, Method -> "Preemptive"], 
                  RGBColor[0, 0, 1], Editable -> False, Selectable -> False], 
                 ",", 
                 RowBox[{"Thickness", "[", "0.01`", "]"}]}], "]"}], "}"}], 
           ",", 
           RowBox[{"{", #, "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
      Editable -> True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{
  3.8157543303787107`*^9, 3.8157543660284557`*^9, 3.8157548082007933`*^9, 
   3.815754855042717*^9, 3.815761994150304*^9, {3.815825847868977*^9, 
   3.815825861957711*^9}, 3.815825900694335*^9, 3.815826520162107*^9, 
   3.8158471754579477`*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{{{}, {}, 
       TagBox[{
         Directive[
          Opacity[1.], 
          AbsoluteThickness[1.6], 
          RGBColor[0, 0, 1], 
          Thickness[0.01]], 
         LineBox[CompressedData["
1:eJwVl3c41e8bxw/HPDgOp0Ffs2QnoqLhfoyQpCgqZO9klZERWSGzhJSMkpWR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          "]]}, 
        Annotation[#, "Charting`Private`Tag$238164#1"]& ]}}, {}, {}}, {
    DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
     AxesOrigin -> {0, 0}, FrameTicks -> {{Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}}, 
     GridLines -> {None, None}, DisplayFunction -> Identity, 
     PlotRangePadding -> {{0, 0}, {0, 0}}, PlotRangeClipping -> True, 
     ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
     NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
     AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
     Identity, Frame -> {{False, False}, {False, False}}, 
     FrameLabel -> {{None, None}, {None, None}}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> 15, GridLines -> {None, None}, GridLinesStyle -> 
     Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
       AbsolutePointSize[6], "ScalingFunctions" -> None, 
       "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& ), "CopiedValueFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )}}, PlotRange -> {{0, 5}, {0, 2}}, 
     PlotRangeClipping -> True, 
     PlotRangePadding -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{"\"N=500\""}, "LineLegend", DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 0, 1], 
                    Thickness[0.18]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 0, 1], 
                    Thickness[0.18]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"LineLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Directive", "[", 
               RowBox[{
                 RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                 RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                 InterpretationBox[
                  ButtonBox[
                   TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0, 0, 1], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0., 0.6666666666666666], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0, 0, 1]"], Appearance -> None, BaseStyle -> {},
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                   ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0, 0, 1]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                   Automatic, Method -> "Preemptive"], 
                  RGBColor[0, 0, 1], Editable -> False, Selectable -> False], 
                 ",", 
                 RowBox[{"Thickness", "[", "0.01`", "]"}]}], "]"}], "}"}], 
           ",", 
           RowBox[{"{", #, "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
      Editable -> True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{
  3.8157543303787107`*^9, 3.8157543660284557`*^9, 3.8157548082007933`*^9, 
   3.815754855042717*^9, 3.815761994150304*^9, {3.815825847868977*^9, 
   3.815825861957711*^9}, 3.815825900694335*^9, 3.815826520162107*^9, 
   3.8158471755008497`*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{{{}, {}, 
       TagBox[{
         Directive[
          Opacity[1.], 
          AbsoluteThickness[1.6], 
          RGBColor[0, 0, 1], 
          Thickness[0.01]], 
         LineBox[CompressedData["
1:eJwt1Xc8Vf//AHB7j2s0jKxERpR8IuT1LhHSIhWhQmQmpSTKqChEEsquiMjM
lnHda2YTSqWsrOy9fu/zffzuH+c+no/XOef9fr/G44hbXje8SkdDQyOBL8R/
7H1Lpn3W9zRp/v9HaRczOC9mAgEvA3bnqpYe2qwu8xMTs4OEFiGlAT0eTa6w
/Cy2blewXPZ5nKaMNGMrgkUZxe5CH9se3bL8S5ryk9bPNm0fgElPlVsN023N
H1xxG2tdvqB/2HlxrjlAUzKZ9cDK6iN4bR3J56kXpel4yM1pUfQJMK7vj0jw
TtLM7eh7N6cVBO1u/m7ZKdmaKw4GvdO2IWAvoNVfZ1aimUDb+2RR+zm4sYrb
X9OgaB5tfL5roSsMAi5Tk460ftH8G3Wscs4uHPpcO96O/27XDLJeN5tdfQnC
iVw/NQu+ae7dm7s0HRwJFPVTbR8Cf2u2r14LnxJ9BfKpXNGzUUOat2tE9k5m
v4YCa4mLK9HjmoIvOhomtGJA6JWjWsXXac0yi6e2452xsJFhY3Fydl7TUhbR
j9nGQyBr5s+jWSuadKsezXOeCfBntqJbhpMGOvqMd8xpJ4Kg8tuuLaL0kFy9
12GW6w3EbxtMOxTOBO7p7EUzXW/gaYfX1nVXNtAPG2KaSXgLfe1BvDGVXCDs
Xnl22u4dbFxN96Sp4oF/5jFvppSSYCxkxfqSFT9UaN2ZmlxNAm+zp3cHjm6D
MBlDzUlKMsQZPDj/0l4QrLn3BP0Lfg+T/tphV7t2APP3P9IToqmwfT115ket
BHRXfHYb/5sKn/xS2x/PSMKH5KiqsewPsObjzHFNWxo8g27yjHmkwUOPp0d6
yDJw0vXkpVGtdMhwSScJO8qD2AWZjyMcH0Hm14/op0cUYeYQw+rfzo9wOVLZ
PXPnPohgLY4Yts0E7n2H4gNdlOHTHX3Xm9uzYGQxvG23xgGIGVURmPXMgtG3
KiWnxFXBuYXXdkY7G3Tf/O2yVdOA81o0XK4fsiGjef6P2XVNQPkTn6a5cuBY
gJv04iUEvDG1dNNdOdBXRS4Y/HYEVrnyU100ciH+v4dym3uOwoDP29NTCblg
ICf0sylEG/Jt78dN2n0Cjc9CKle8dSH+m4P29aZPIDl1uMyfWx8CTpiM/1PK
g/Ivq2/kMo6D6X5ltX+rebDy6/f+WMFToJUs/tvpcj40xYe7Xbp1GuQFuAMm
KPkwoT4l6md1BjY2RjrHgwuA7LTSbmBqBIn18TfGRIvA989trrK08zAXlSf7
K6gInEbfXPjw7wLo2Db0ty0XQZuivGuKuimM0y8aF7cXg0TU6uMtc2ageuik
2hP/Uuhn3MHK6XIFAtmtZz3nSoEruv6lj5ol/Oy5m+5y5TMU7Fq+uYfNCh7e
ThK5oF4GtI/A6mCRNbRkrtFJT5bDmz1K7U7nrgEvsFpwKlRA3d7PU2P6dqAu
Fa7mb10BVPv723OP2sOzudRZj9YKsLA8RBLRdQTl551XLdMqIUjnDZviMRd4
UC+vv+9SFZgxz5rFsLtBSnaBVNrLKvDeob93MNMN2qKO0O/6UgUW2ZXBVedu
g6TthdLtBynAER95TzX9DtTTP1Sg4aNCtoAeK9nNA7Ye+s7bXF0ND6Rn2T2R
NyBJm0nd9Wqof/XSLzfZG+zYpxvI+2tAyH3vYVEuHyjtYXqUn1ADpVsv+gT1
+YDlbaXFWI9a+HkptfvpCz/IyHzy3VGhHrzUj9RY7/WHUd7RIP0r9TB0RDxl
IcEfpG/ra+4Or4ddNc9m7vIGQIIGe2L/cj043PXKObEUAGF1QTam1AawZhT9
uNj0FG73h0wfM2sEz6Stt4qTn0E8e4Mfj3YL2MXwM5jcfQG20Ppq3LUdwh25
fCJrYoDmzULx98B2aG1ZT6DbEgtRDMK99e/aoTpd5keyZSzU1tmIpH5tB6EL
e2QiN2Jh99m1N1fVOuBxcHjuhmo8/L0mnf6TthMeH+xKD/+eAPZhXmUtoV/B
Gx2tDrJ7C86DMv2fMnrgvK+qFnNmCrCJP5T+pdoH/JJTyX7bc+AZqUE28XI/
1L7lezC2vQCKVHbknXTuh5eeyTMmewpgwOI6rN3rB8ULSt6lhwtA/SPf2fOR
/WB2j7/Y3L4A/uqZeXE29UNlBHLkLikALb+J5rvqA8C5zylKyrQQlua53Qy3
DkKKp/mxwWdFYPn9bDn9lyEwqeqZ0W0tAbbo3043eobgH7kvd++fEsgxdRb+
NTQEo7QzYeyzJUD/zf9uMe0wMKUfSXnNXwrvuov331AZBk4/N3GR86Uw1CmW
8vPNMGhNHVYr7ikF+5bx0KK7f0HP8M/P452f4Qb1oeV16VH4/H2ft25yOYgM
6DAt7B+FjT4nxa255dBAx/rBE43C2XNaO3vKy2EXCp5+YjIK4b5pw5o95dBT
/NL7XeAoSBbtk6YyVsDhrOS4nslRoEljY+JVqQCe6NpvWoVjMK65y6viZQWU
FT29X08Zg8/7GV89iK4Ah24DiTOtY7BoMht9MBHPzZZWO4vRMYiZeXM5Lr0C
7ob2LLkLj8OM3gcZuaoK+P1odGuG9zignp5ho8kKyHbhMNquNwE3/MUF57Qq
4ctrvrsfz02ACVNfgJ9eJQxRBOOPWE/AbZ45U85TlSAoIDPm+GACImbFVUim
lfCwUtuvMm8C7ho6K7Vfr4RzvA9y7SX+gQPXPqMzrythJXea7/PqP3B/ZBp/
bKwS+H8uHTRknYQn91Kvy05VggILzeXhrZNArovexjJfCVZmXOk8SpMQfcl8
PXcD74dB7qjNtUmo21R50sRDhjhj61vcnZPgV9E3xqNChsR7DqN7z0/BoB2v
3rgXGfZWsC75m0/BVwGJH399yFDBkML4y2oKcoY9L/5+RIa+4AGxYJcpuDRs
s7M6mAwiCebnR55MAT/SO3AplgyvKacoiaVToLdwU6CthAxhnMpxvBLTMN6/
zaBlngwShm1pdrun4c2MvvDpZTJkR7gUVShMg4RZkeqXNTK0iH7scFafBufA
K5ZF9FXApSTF3nB2GnaSrzba8lTB03Pb3f38p+GyYsPbbfJV4Bu/dmZufBqO
ZbgrdltUwem9hTfkZqfBbJ/nbNeVKhCpvPnccnkaZPev+3VYV0Hxn9GWFsYZ
SO+x30Kxr4KZXT2nPorMAL/7GR2v21VgmZ53wub0DLSeLQPT4Co4XOSs1507
AzFdr061FuL96MvacRfPgD7Pju/XS6qg99tggE7FDKjK3A1gL6sC9zWz2k9f
ZoAvVcBIraoKsuD4seeDMyDBzTzl1lgFYtXS2vrbZuGnrtYj299VQNPeh0o9
ZmHdT7BYm5kCD0fKEj18ZsF8M36kjJUCrDSxdAcDZoHDyW3bfxwU4N1jQsl7
OQsnWG54bOehwC7/1mOZWbOQqWuZWyJIAX118sk3Q7Ogov8t6vYeCrx4+9Ys
wHAO6nxc6NpPU2B7sc9nHZM5mGxQaJw2pEBMyyURxstzkCX4c47TmALJ60J9
Pk5z0N9tYKNpQoHC8+FW9wLmwEtcQsz7CgV62R/ZO5fNgadjuNmTGxSQumXj
flZ2Hg7bn5mmhlBgj9ovo/i982DjYlpw+zkFlGkuKI4emIfMAKrnrhcUOBKk
N/RAax5KGrI5vCIoYPFO/mya2Twcurv9EX8sBSI6ZhTpQuYh8t1ho6FUCjD+
92A4c3Yeemp9F3eS8XdndZG8sjwP00wmD6OqcD4qXeK0aRbAyCzvFDuVAmIn
LI2/cyzA5OzvlLEaCmhc1a5iklqAAvXy6MhGCtx6yR5vfmEBaD7e3BHXTYGB
+chz7J8X4MwdpV2uExR4c3j/zR9VCxAW/K/lyz8KXApuCsmsX4A9P/Myd01R
4JskY51R9wI0r4xwtc1QoNXIVT1mdgFK9wyHbFmiQFm2gdge2UUwMDe5qUdH
hUgn2tGTkYtQb/Zh1XULFc4WxTCJxy1CPl8la9RWKvAyqu6cfbcIebcKA0u2
UeFZjLNZZM4iBNY2zawLUOFhw/emX42LIGYt5OMiQgUXmfxcF4Yl2Gg6rMYl
TQX9QXuvsBtLwH/lVrmqChV0vHamH3VfgpVRUQM5VSoc2dL7beH+EmTLDz8X
PkgFNe0TqheDloB63ujUqhoVZJMUZ3e+x87xL03VpAL71blreb1LMJL6IrtB
mwpfBrzOdh9bBkG3NXcFIyrUeh7we3pyGTZku/hWsSn8k9kaxsvQZTQcUX2W
CqVHL3MnWi5DkCdcND1HhfR3R+rtvJZh2DOJwc2ECsHWzGg1ZxmeurTRul+i
wsmBUDkRkRWQ0xvJ+2yP15Mb6DCTXIFqqVkjCwcqHL+pcj9adgWU35pLbGDr
0v1s2a6yAm10GmfVnfD5xORu851eAfldN6XTr1PhPzNqBYvvCkxXFltdu0UF
4Y5l49nBFVhPHww/40WF10InNveNr8CQZSr3N2wBq4QUl5kVKFhh7b5ynwpb
Z3RWJzZWoIg0ffb6AyqQSOEJf7etwu/XPlt9fahAb6Aw9kNvFUoN6Fz9H1Fh
tMrSu/bjKijFXVTZFkwF0efd9s8+rcLkRdHP4dhnLU4any1ZhYgE9hCeZ1Qo
Wzoo21e7Cin7DgmxhlAhbA9Px2L/KuyLiJ2cDKWCemS5tLTgGrTNtp2JDadC
kL1w86PHa/By5LKcVzQVKlXCio4Hr8HnwIdzg9gLDCzveMJxnOPHrpMxVLgc
P+sem7gGTCk2FOFYKih31Evkla7Bq9HtzLlxVPhx6O7tgZk18DgzbkhJpIIC
z9cdWpfWIWK/ieGD91QYCh7yfXl1HfQzHdpasGPZFoeHHdZBM3n5j3gKFTgY
tucEua+DnC9NIRl7dMFE5+vzdRg9z6i1mUqFpN4fznaUdUiK9zhrnY7znzJY
HiKzATId//H+yaJCh+SC5B/FDfCwmc+SyqZCYCLTU+UDG0ATEzptj73yWvps
z5EN2G89dWEGuzvY7q+E2Qac+ONXt5ZDhRc3J0j5zzZAR2PwI00eFdhg/krv
7Aawepsm1RRSwf3wbpb8lQ3Q35ssyVSEz6N1MSOEdhPc1KV0jmKTdStXjnBv
QrNa1I1ybA/D4BepsptAV/byTnYxFcau7qLevrIJo1pJHx6W4n4MMt7N07wJ
t23+So6V4/kJCWga7dyE+tXDPSIVVEh5XnKL0rsJXVzVmobYDyPEK++MbkK/
+4JIIbZIy4L8JB0N6sqcOOpdSYWvPWSqsQgNMheRCaCrosKxCdNFCWMaZHyj
r7CVSoU4fr/2BxdoUNpqStIq9px6WmbvRRp0hPmc0a5qKiQ8XbWNsKRBpTdq
Z+5gr0jHdLO60KD8dl4DwRo8b5Y/iqae0qDYInKBUS3u3+5LnmUVNOjCsYrP
0fVUsNn0vyBEoUGF/xVfL8MulcpSdq+hQXKeYhN92HZuNBP7mmgQd+GF47sa
cL54E82TvtMgyXuPY9Owb534oxm0QIMiVs70ZHzB9SFb05rK06JN/h3pz5uo
MHX4m6CXIi2qvFrtmI7NXHlKOUGJFqkp6THXYB8oV7MdUqVFO/0y6lexw0tI
ja7atMiWP+O5VTMVTn0qjQq0oEVF9A8M5FuoUJ3Ev/dzKC3iXrta8baVCj8l
n+r1vaBFWiMqIsXY8283LekjadHzsPWLLdiSb0Zf6sXSov/sOdzXsH3jKlY7
U/F+LNsOGLVRQTPSseYfmRaR01pnV7DzAigWYvO0aFTh/kvlDlxP/Ybt/ku0
aHFcp0MX+zVHW9vEKi0S0r88a4btHfpLp4SODul8Odr+ENsgakXhHIkOnXO7
ItqO/ef93s1AOTq0GfyK176TClw1MfGLV+jQL3WvCN+vVKB98tbE4iodaujf
q/oCe07/Ax/1Gh36blNQ/ha7p6nAP+w6HXJ63OtNwX73te36Hi86lJE428zQ
hftviAVZRdEhGhFuije2DaNbX1MTHeLRt6e37aaCoGhd12orHTLdu1F5E7tJ
dUfz7k46NMtW4uSNfcCR+tn3Ox3KShEMfoXN1L4l+sBfOrT7t8W/euykhHzj
OFp65Gc0aCjbQ4UB9aV6J2V6FBboc6YXO8rYgPxahR4NJyoND2EbXE8oqlGj
R6yrsk7T2J/e6KaIH6ZHyg/09Jm+4XlgffWo8wQ9yuVJPq6ILdl1EB2ypUeh
idb372Nbud7L43hNj+yvpKjyfsf7U/qZJxNLj/RFljsEsdlmUL5OAj1Kt82x
3omddYOpwDuZHj1kfWuhjL3m8rxwLoceeTleLDPGjrj+vqS3gR7p9O/UiMCu
c2yvTF+nR2Ued1K4eqkQI3+AXEfDgBQbXrRtwXYZjyIP0TOgEuZdM8LYWx0t
qsTYGNB+k34eOWxLhxFK+FYGZKKR2KmDvWa3WeOpyIDKPa/d88RWtJVrMrjC
gGz1YuL6sH/aiV7/aM2AdGPu8w9jBznykbiuMaD3rOzeE9gjN1bPNDszoLBM
C9UV7LeeDZ1nPBkQ/dMoRb4fVNgW5vDjXCQDupf3XFsLe7M0bfxyIwMKihe6
F4OdUR4fXNnCgGo5r1clYpuRXyhIdDAghltA/x67qOaeS/83BhRKDrLLxr7Z
dnzu6l8GtMD1oo2KPTw8tmpPz4j4jz8Tn8Bu5pVndzvIiHaHKTEf+Innw8lp
JFqDEQkNeHKpYWfUZNSQgRE1KH/i1sR+5rnvIUmHEUl9YKfRwTYYOrCeZsiI
xur1Xxlj1xcdnvzjwIgEtt7Iu4lNvXy+/XQcI6q7o9aahq1cEpV9J5ERpfoE
SGViv9vyLSTuHSO6eqj2dg72w3ozg/EPjKiITY2lCPuIsiXVv4AR/SjLnaRi
VzA7FZS1MCKdF8rdP7FLMnyj5emZUKPzV03OX7ifDYwFI5mYUMJ2UCdhnxmR
fkXLxoTIj8lKfNjDOxsjvpKYEMVbhU8Am+/VtjBvESZUdy3+tSS2g196QMdB
JiQ1HVanhi104aubpwsT2uFw6ZsVts18ytzQTSZk+JlO1wY7O+zezTN3mBCt
8Jvsa9jHGsVuSN1nQoVRE+5O2DePODi2BDKhTopV923sBnkaK8n3TKh64ERf
APY9WtnTX34wIbqB7/ABe+goe7fUbyak3ZypmI59OmD8ks8AEwrYbiqcgS3J
nXn9wBgTOtFzbDwb+4uwckjCEhMKfK1lW4QtoqrZdIuPGfHIljbWYJOdDQ12
6DGjix1N9/5gy+fs77hjgOOm/7gHsCPm+c3aTjGjKBGPxEHi/J5dDv7nmJHR
x8HSv9j8T80Cp62Y0fY/dzr/EedPsqmn3mdG7z/2ha5gs/V66Dp/YkZ6hSUG
pD48v3dSOUMKmNH+/NoHPNhXeLvbMouZ0beFjSxe7ELd/8ynK5jR7Mg05xZs
m7zJG7camdEJNY0cAezKZ9bRHkPMKMF/IVmij/ien/z3eDsLWslxNNqP/a7X
M/e9EAtiMPlyWhm7+U6ae60IC9ryJcngP2ypDBZ6tl0sSFm0GVSw2wWrtgXv
Y0GOB07wq2MrzKkcfqHPgnZXKrgfwR5MFg+P92RBUce5D57GHn/4e5nemwVF
y8cIncGesUy8dM2PBWl4Z68RphEVl9v3lAWlDXsVG2ELRoqRyZEsyO55t+R5
7NP+olODOSyITcIx3xy71HaHgfwIC7IvF+i1w67S/pEdOs6Cfgr0vrDHrt8Z
u21+kgVlnXXQd8Du+iXc/3mBBa3HLeY6EuufF/Y4xcCKRCaX3a9j79YVSnEV
ZUWhFNUvt7DDdwswFBmzoqN5Dkn3sc0spN73X2BFLYu+ex9gS4bv1+cyY0Xm
LBXFhD9tngi1smRFsVZZX7yxO776CnNdZ0U+uYFDvth8j8aVrQJY0RNQm32M
Hfa7/CpnCStiHCu7+wzbdFsji2oZK6pPWh8jLHHiW5plJSu6mxpgHoKdUzg3
XVDDiqrt/TVDsdtCZO5bdrCiW5NHlp5j82i+iCiYwPEHocdfYoe+tqm5IsaG
eIu970Zj37nte9NzJxvyK7zRSdjCME40UooNTZ/s2BuDLc/29c4XeTY0eGt6
kHDdXe3dKgfZENt6ol4cNp2J5BMOQzZEK/1xMQHbbdsf/QI/NvTuosRcEpGf
2fWF1sdsKKf6JyRjH20WeDv+hA2tPdsVSJjX/8yqeCgb4lg4K/YeO2OhIi0o
hg2FL5zWTsH+2xnPYZnHhnQC73p8IPIRbt7EMcyGnjlkv8zAFs5lE3IYZUNc
7ud7CP9qLbCtm2BDCdKBwpnY1ty8tI/n2FCpVmIiYeen1fs3adnRamdCcha2
r7fiq2lhdgR/7sTkYKc60lp/NWRHQe/61fOxHQMzspTPsSORvR9cCSt8uLge
ZsKO8hr5UwnnDOdFnLrMjs4bd/MXEP1naV9X68SOTPZL/yXccqFdoSSAHYXw
mNwvwl46mrQcX8aOes/3O5Zie5bE+1Eq2dGKy+EIwjRKrzlHKOzo+UmLcsLM
oiHiSg3s6FB1J+kz9tZldz1KFzsSy6ZmEd7/0eDV3yl29KJyeaCMON+WOdV9
OzlQVqi7eCXRz4H/yMZSHKh2+zUtwm50IwYeMhxItU/8KmHPyR+XqxQ5kJ/V
/HvCgXU1AcYaHCigUFKOjJ3iFd1915gD0X8Yk67C7h884k7250A1O2+vU7CP
xDe9kQ3kQKaecUJU7IQLpo1hzzgQy6+wg4QtGm5IWL3kQJOk37cIf8tK+EL/
lgOF6guPEG67tyGmXcaBdt2yq63GJvMU19XMcaCR3IfWtdjiDdpzikscqGu9
zZOw98NWkahVDpSvuRhOWHPx781rdJyokJVCIVzcu02ElcSJnPfckagj6vPe
zVVfjhOtfLjzlfCbQ/uEGq9wohCLxxINxHon2fxWrTlRVX6rMuE/l/pHZa5x
ouNlmzqEd/q+LH7szImE7jM4EH5XvWyC7nGig8p52YSTTpGjcsOxt3Yd/ELk
64rR1tc1nGgk+tiBRuxaV/n7tfWcaPWBmjbhv36MQwuNnMjuzJazhHcnF+QZ
dXCifTp+NwinjgoZc/7mRLoaR9MIf7g58MJ7hRNd9XEXbML++MiNx3YPF4pm
yPpLeFzD3PfRXi7kEp4yR1h+7ujs2/1c6LvkM5pm4nlL/s6+g1xo7ZPYdsIp
kBtlqsOF9jy30SH8bnlK9OQlLpT8Izie8GsnR4X/nnOhbE0F7RaiXpJn443C
udBH/c2ThAV61UmukVxIubTiAuEoffaZjFgupCi9xZHwS+kPebs/cCFab6Yw
wqG/hzWEq7jQ8XMi3wn7G1sdp5/HcZ4ey1aiHqd6za4ucSHf4TAHwqV6xs41
q1xoR8WhW4RnDh17HkjHjU432DwibCYl18VH4kYXX7C8J6y0OGMpKceNPqnE
DhP+GeXroX2FG3W8yrdow14OWw18b82Nfo98vkqYP/hWLOs1brQoW+RIWM/H
pqLRmRuhykAPwp/s9JnOeXIjR8a3Lwk/VeMNs4nkRgq7UuoI/9ebmOrfyI0i
uoJl2rFJCteWMlu40SGGrwqExx8oHOtu50ZmpVuUCb/bWTKw+xs3erV8T5Mw
v0OHaP0QNzrWNmBIeMWT/jgTDQnJn9znQbiH/UClrgAJkaPpqwhXK7/62ytI
QolmRjWEP5mvcd8QJqEjGjENhEMzyRavREnopIdAB2Fdo1NrI7tISKWfPEC4
8PU1lUAlEkqb72boIOolE/2x8TgJdcefRITnZnWS/E6QkLu5yFHCp8pmYg6e
IqHmZ8PHCDMZ6QclGZKQrYvNKcJunsv2XiYklCmzzYKwYfP53XtsSYhT18CD
MIcb/9sgXxIKbtbKIFzF6hi29IiEKlzNPxH2iKvysX6C3+dzpZjwSI3rZY1Q
EtLelKkmXC3YumM8loQkz1N6CT+oCI46XkRCWVUWTJ3Y51ZnQ9+XktB/bLLs
hOUPmD6hryChkY8D3IS706Q8SqpJyGdztwBhpcjyi3IdJPTJaU6W8JDTtAj7
JAktsNYfJ1yacn6b7QwJiRW+O0X4Rf9n7qp5EpIquWlEGJk8pbm3RkIuc2Om
hF8f3flnlJUHieYftSN8Qsg4qV6SB7Xll/kR9kSlJG45HiQ1/OgJ4fSrOz2N
9vEgtwipEMJsWdOGvYd40LbhjVeEa44+o/l3Dsd7eDMIL9jNOyiZ86Bi3doc
wlIhZl23rXiQzIlLBYQf9shmbF7nQZxc+ysIH3auucjzhAeZ1YW0/O9+gTMs
P0J40GBqQQdhDsq3TykRPOgwG7n7f/kR+MeJ3vEgbbGHfYRdqPwVzuU8qIra
/I+whtBuAaZGHpTkaz1PmOWGumvsNx4UdjF2lXC8sKXkl3keVHiTj/kr8Xzr
B1dPOl4UVU3LQRg9nq2Q5+ZFbU2ZJMJ/Jh+aB+/mRb6uZgKEc941ph36jxfZ
PrfYQdjPZOvKxGFedNx5jzhhyar3EScv8qKtauq7CZebZ9xTvMWL9H65KxA2
Xfp0mRTMi4JahJQJz4eVaE8n8aJ1d+WDhEP3kGXbyniRJmfTIcJMvwz5W3p4
kddJgyOE74X2rzfO8SJlDUMdwlOHbw03cPOh81vH9QjbzDK01snyIeODUicI
W7etusuY8yExzeOGhC2zZ8SehPAhh1qPc/9br40jmFLDh9TMDpkSLpuVWt7c
5EOd62rmhP8PrzrhAw==
          "]]}, 
        Annotation[#, "Charting`Private`Tag$238231#1"]& ]}}, {}, {}}, {
    DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
     AxesOrigin -> {0, 0}, FrameTicks -> {{Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}}, 
     GridLines -> {None, None}, DisplayFunction -> Identity, 
     PlotRangePadding -> {{0, 0}, {0, 0}}, PlotRangeClipping -> True, 
     ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
     NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
     AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
     Identity, Frame -> {{False, False}, {False, False}}, 
     FrameLabel -> {{None, None}, {None, None}}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> 15, GridLines -> {None, None}, GridLinesStyle -> 
     Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
       AbsolutePointSize[6], "ScalingFunctions" -> None, 
       "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& ), "CopiedValueFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )}}, PlotRange -> {{0, 5}, {0, 1}}, 
     PlotRangeClipping -> True, 
     PlotRangePadding -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{"\"N=500\""}, "LineLegend", DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 0, 1], 
                    Thickness[0.18]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 0, 1], 
                    Thickness[0.18]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"LineLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Directive", "[", 
               RowBox[{
                 RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                 RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                 InterpretationBox[
                  ButtonBox[
                   TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0, 0, 1], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0., 0.6666666666666666], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0, 0, 1]"], Appearance -> None, BaseStyle -> {},
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                   ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0, 0, 1]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                   Automatic, Method -> "Preemptive"], 
                  RGBColor[0, 0, 1], Editable -> False, Selectable -> False], 
                 ",", 
                 RowBox[{"Thickness", "[", "0.01`", "]"}]}], "]"}], "}"}], 
           ",", 
           RowBox[{"{", #, "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
      Editable -> True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{
  3.8157543303787107`*^9, 3.8157543660284557`*^9, 3.8157548082007933`*^9, 
   3.815754855042717*^9, 3.815761994150304*^9, {3.815825847868977*^9, 
   3.815825861957711*^9}, 3.815825900694335*^9, 3.815826520162107*^9, 
   3.815847175544922*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"n1new500", "[", "y_", "]"}], ":=", 
  RowBox[{
   RowBox[{"n1", "[", "y", "]"}], "/.", "s"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ncanew500", "[", "y_", "]"}], ":=", 
  RowBox[{
   RowBox[{"nca", "[", "y", "]"}], "/.", "s"}]}], "\n", 
 RowBox[{
  RowBox[{"p2new500", "[", "y_", "]"}], ":=", " ", 
  RowBox[{
   RowBox[{"p2", "[", "y", "]"}], "/.", "s"}]}]}], "Input",
 CellChangeTimes->{
  3.8157543166016607`*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"N", "[", 
   RowBox[{"p2new500", "[", "5", "]"}], "]"}], " "}]], "Input",
 CellChangeTimes->{
  3.815826073895664*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 RowBox[{"{", "0.17092399170177086`", "}"}]], "Output",
 CellChangeTimes->{3.8157543911841087`*^9, 3.815761994321363*^9, 
  3.815825908977375*^9, 3.815826003256743*^9, 3.815826074555234*^9, 
  3.815826520418844*^9, 
  3.815847175573164*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Ingdtgralinexpo500", "[", "ti_", "]"}], ":=", 
  RowBox[{
   RowBox[{"-", "\[Lambda]"}], " ", "*", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"n1new500", "[", "tti", "]"}], "*", 
      RowBox[{"ncanew500", "[", "tti", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"tti", ",", "0", ",", "ti"}], "}"}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IngdtgralinexpoInf500", "[", "ti_", "]"}], ":=", 
   RowBox[{"\[Lambda]", " ", "*", 
    RowBox[{"NIntegrate", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"n1new500", "[", "tti", "]"}], "*", 
       RowBox[{"ncanew500", "[", "tti", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"tti", ",", "ti", ",", "5"}], "}"}]}], "]"}]}]}], ";", 
  "            ", 
  StyleBox[
   RowBox[{"(", 
    RowBox[{"Infnty", " ", "is", " ", "5", " ", "here"}], " ", ")"}], "Text"], 
  StyleBox[" ", "Text"], 
  StyleBox[";", "Text"]}], "\[IndentingNewLine]", 
 RowBox[{"DiscretePlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"IngdtgralinexpoInf500", "[", "hh", "]"}], "*", 
    RowBox[{"Exp", "[", 
     RowBox[{"Ingdtgralinexpo500", "[", "hh", "]"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"hh", ",", "0", ",", "3", ",", ".1"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.815754403897533*^9, 
  3.8157544172575502`*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.011000000000000001`], 
    AbsoluteThickness[1.6], {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.011000000000000001`], AbsoluteThickness[1.6], Opacity[0.2], 
      LineBox[{{{3., 0.000020381931076016698`}, {3., 
       0.000020381931076016698`}}},
       VertexColors->None]}, 
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.011000000000000001`], AbsoluteThickness[1.6], Opacity[0.2], 
      LineBox[CompressedData["
1:eJxV0n8o3HEcx/GvYzRKWyu6YTU3NVv5AwstXh9Xy18bjlESduLoWvYXa5TV
Fv5ht7Syaaew0rXVLmb5kbgVrSNpXRFFTnRlzW4jss5c81q93/X949G77+fz
/Nb3qrnBVBOqadqV00d39nBcKRZTUmAOdFZkw8Dtyv2cN6+DM4bYHXe03TUH
Wu6/Iv59laG1chY09+lpwfmGzwWO+uubX0DL91fwsUhvMK5Og+b+X80Ghtsm
EpdsE6Dl+V74MtbGp3Y/gebeUhucbfTPfrh2fMEJWt7vw+LeVPePeAdo7hfm
g7OLZmtIZo1zALTs24MupnMktfQtaHn+T2zFRRdP9r0CLft/4UHFZfv2yxeg
5f2/8eSw3e9ebgMtv+8APXXOmQ7LU9Cy7xD3tPt51uom0LLvCEVDxks3bI9A
y75jGEfhKim0gJZ9f/Aw8V12p6kKtOwLwNFT+vjWZAlo2aepXP2Kx/c8n/+f
kudrKsfTtZ48cwe07A9RVlu9P9eXDVrer1PlhRmp/pZ00PL7QpX72UFv1NFN
0LIvTMUOe++azxtAy74wNb+aYA549KBl3znlbRwqS265CFr2hSvrRn+evTcC
tOyLUN+7lgbDF07+m/u/0Q2SQg==
       "],
       VertexColors->None]}}}, 
   {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.011000000000000001`], 
    AbsoluteThickness[1.6], {}, PointBox[CompressedData["
1:eJxTTMoPSmViYGCQB2IQDQOH9NKDVP8dt581EwR22os/P8037xCMf9JeZk2C
cn38MXsTYxC4bL89YFWmxqPDUPmb9huCJZWdbh+wh5j2wH5z226lixN2Q9U/
tn9pfmfXvjdb7dPTQOCZ/aJja1V+C2yE6n9pf/7DvsnvZVbZnz0DAm/sq7MZ
LVI3Loaa98GeSax3i1H4XKj6j/ZPpPlC9syfCjX/s31inNS8ZxP7ofq/2Ff9
aP90+kYb1L5v9jMyNh7sSG+AmvfD3o8h1D07uRxq3k/74BVOwloTCqDm/bZ3
2mZ/KCwwHWreH/tcpaW2vUEJUPP+2a+aEV5huicMah6Dg6PkzasvW/yh6hkc
7K723dc86Ao1n9Ehe0LmJ8eXtlD9TA4xgeZGn2pMoPYxO5xu/jab+6c21DwW
B/HNj32TOJWh5rE4nLktm/TvqiTUPFaHx2UrojRrBKHmsTlkP1jkPm82O9Q8
doe3fReXsJ39bwcxj8PBkit/sXX8VzsAmpXXMg==
     "]], {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0.000020381931076016698`},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{
   "MessagesHead" -> DiscretePlot, "AxisPadding" -> Scaled[0.02], 
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "DefaultPlotStyle" -> {
      Directive[
       RGBColor[0.368417, 0.506779, 0.709798], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.880722, 0.611041, 0.142051], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.560181, 0.691569, 0.194885], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.922526, 0.385626, 0.209179], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.528488, 0.470624, 0.701351], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.772079, 0.431554, 0.102387], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.363898, 0.618501, 0.782349], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[1, 0.75, 0], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.647624, 0.37816, 0.614037], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.571589, 0.586483, 0.], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.915, 0.3325, 0.2125], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.40082222609352647`, 0.5220066643438841, 0.85], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.9728288904374106, 0.621644452187053, 0.07336199581899142], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.736782672705901, 0.358, 0.5030266573755369], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.28026441037696703`, 0.715, 0.4292089322474965], 
       AbsoluteThickness[1.6]]}, "DomainPadding" -> Scaled[0.02], 
    "PointSizeFunction" -> "SmallPointSize", "RangePadding" -> Scaled[0.05]},
  PlotRange->{{0., 3.}, {0.000020381931076016698`, 0.18744341395937708`}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.02]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.815754433799115*^9, 3.8157620018473663`*^9, 
  3.815826095447472*^9, 3.815826527986084*^9, 
  3.815847183106023*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals500vals", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"IngdtgralinexpoInf500", "[", "hh", "]"}], "*", 
      RowBox[{"Exp", "[", 
       RowBox[{"Ingdtgralinexpo500", "[", "hh", "]"}], "]"}]}], " ", ",", 
     RowBox[{"{", 
      RowBox[{"hh", ",", "0.0", ",", "3", ",", ".02"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.815754473162491*^9, 3.8157544773224277`*^9}, {
  3.815826103719449*^9, 
  3.8158261042467813`*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals500func", " ", "=", " ", 
  RowBox[{"ListInterpolation", "[", 
   RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals500vals", ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0.0", ",", "3"}], "}"}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"tau2for500", "=", 
  RowBox[{
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals500func", "[", "ww", "]"}],
      ",", " ", 
     RowBox[{"{", 
      RowBox[{"ww", ",", "0.0", ",", "3"}], "}"}]}], "]"}], "  ", "/", 
   RowBox[{"N", "[", 
    RowBox[{"p2new500", "[", "5", "]"}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.815754467786021*^9, 3.815754501034259*^9}, {
  3.815826112599503*^9, 
  3.8158261161345243`*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 TagBox[
  TemplateBox[{RowBox[{
      StyleBox[
       TagBox["InterpolatingFunction", "SummaryHead"], 
       "NonInterpretableSummary"], 
      StyleBox["[", "NonInterpretableSummary"], 
      DynamicModuleBox[{Typeset`open$$ = False}, 
       PanelBox[
        PaneSelectorBox[{False -> GridBox[{{
              PaneBox[
               ButtonBox[
                DynamicBox[
                 FEPrivate`FrontEndResource[
                 "FEBitmaps", "SquarePlusIconMedium"]], 
                ButtonFunction :> (Typeset`open$$ = True), Appearance -> None,
                 Evaluator -> Automatic, Method -> "Preemptive"], 
               Alignment -> {Center, Center}, ImageSize -> 
               Dynamic[{
                 Automatic, 3.5 CurrentValue["FontCapHeight"]/
                  AbsoluteCurrentValue[Magnification]}]], 
              GraphicsBox[{{{{}, {}, 
                  TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAA88dx3mtMaz4/AFpSJf7HP6m+gdgd
Cqk/1p+pop34xz8vlAOEtBe6P8izxhUFv8c/j/RD6Atiwz8j7FGFVTbHP8yH
F2FrmMk/gruI4a5fxj+j2m5OyyrQP3YPqtySKsU/ZlmCWdBP0z/iQ60rYNXD
P0YlD0Y7uNY/ZhzvBuk/wj+JpeQbvRDaP6bNxwk8ocA/0o3qXq4v3T+vSEk/
kzu+P5zhtMECSeA/Subx91AJuz9SsIwKZt3hP8hHLsJvMbg/OdkIyNRp4z/R
ygPsJ5O1P6+oQXb2F+U/TgA+WZPysj8orBLbT6nmPyOmeWMFtbA/MFagMFxc
6D/BJWbhKgWtP2pa0vpzB+o/hlwgJrwpqT+mkpx7w5XrP96i5Tor9KU/cXEj
7cVF7T+IV165at6iPz+EQhUA2e4/io2j5yJVoD/OHg+X9kbwPw1sT2qc2Zs/
lijP3XId8T+1vr/spL6XP19M2/+K5fE/szVqQo5plD9ww0WafL7yP0SlbkQr
SJE/glT8DwqJ8z9SXL+ahIWNP60SBUCdT/Q/Vf/BiwU+iT8fJGzoCSf1P6XY
9/yxQIU/k08fbBLw9T/d/hfF0hCCP07OMGj0yfY/WBX+m7g8fj8iepQe3J/3
Pwgpwgl1Vnk/9z9EsF9n+D/SI6tzW3N1PxRZUrq8P/k/7TSp7BLgcT8yjKyf
tQn6PyoHBJDCG24/aexYP7TP+j8mqVUNPWhpP+efY1eMpvs/44hXTdAZZT9n
bbpKAG/8P3dKY7pJuGE/Lo5vtk1I/T/fUcMdUkldP/fIcP02E/4/JGAq7GR6
WD/YMMT+Jdr+P5/LI10JglQ/Aex1eO6x/z9KSILaz+dQP5bguWapPQBAlq25
icIzTD/O9GdNyKoAQGL9x/maJEc/kx8/EeoVAUDYcmP37AlDP1hXvMLZeQFA
A2NVLEa1Pz/BuGgwNuYBQIcHJYBW+Tk/Kye7i2BLAkDW0eeJjYo1PyGsNsSN
rgJAaWPcYpfqMT+7WuG4JxoDQCvZPVKRUC0/VhYym49+A0CKzd8QmUkoP5T7
sTlk6wNAPAebvH/KIz9f91q1O1YEQE+7XaGvLCA/KgCqHuG5BED3TMF1AMga
P5kyKETzJQVAKtC/ZAfOFT8JckxX04oFQBzqWI9q/BE/HdufJiD4BUCCdAIq
wy0NP71aHNNvYwZAt5PS1iy+Bz9e5z5tjccGQIAMznbJkwM/op2Qwxc0B0Bm
QQyE+L7/PudgiAdwmQdAQ10YbMwV+j4I5Sz5//8HQEL9Fuw7X/U+89DA0g==

                    "]]}, 
                   Annotation[#, 
                    "Charting`Private`Tag$303865#1"]& ]}}, {}, {}}, {
               DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
                AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
                GridLines -> {None, None}, DisplayFunction -> Identity, 
                PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                All, DisplayFunction -> Identity, AspectRatio -> 1, 
                Axes -> {False, False}, AxesLabel -> {None, None}, 
                AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                Frame -> {{True, True}, {True, True}}, 
                FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                Directive[
                  Opacity[0.5], 
                  Thickness[Tiny], 
                  RGBColor[0.368417, 0.506779, 0.709798]], 
                FrameTicks -> {{None, None}, {None, None}}, 
                GridLines -> {None, None}, GridLinesStyle -> Directive[
                  GrayLevel[0.5, 0.4]], ImageSize -> 
                Dynamic[{
                  Automatic, 3.5 CurrentValue["FontCapHeight"]/
                   AbsoluteCurrentValue[Magnification]}], 
                Method -> {
                 "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                  AbsolutePointSize[6], "ScalingFunctions" -> None, 
                  "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                PlotRange -> {{0., 3.}, {0., 0.18744341393539973`}}, 
                PlotRangeClipping -> True, PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
              GridBox[{{
                 RowBox[{
                   TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox[
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "3.`"}], "}"}], "}"}], 
                    "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"scalar\"", "SummaryItem"]}]}}, 
               GridBoxAlignment -> {
                "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
               False, GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {
                "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
               BaseStyle -> {
                ShowStringCharacters -> False, NumberMarks -> False, 
                 PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
            GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
            BaselinePosition -> {1, 1}], True -> GridBox[{{
              PaneBox[
               ButtonBox[
                DynamicBox[
                 FEPrivate`FrontEndResource[
                 "FEBitmaps", "SquareMinusIconMedium"]], 
                ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                None, Evaluator -> Automatic, Method -> "Preemptive"], 
               Alignment -> {Center, Center}, ImageSize -> 
               Dynamic[{
                 Automatic, 3.5 CurrentValue["FontCapHeight"]/
                  AbsoluteCurrentValue[Magnification]}]], 
              GraphicsBox[{{{{}, {}, 
                  TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAA88dx3mtMaz4/AFpSJf7HP6m+gdgd
Cqk/1p+pop34xz8vlAOEtBe6P8izxhUFv8c/j/RD6Atiwz8j7FGFVTbHP8yH
F2FrmMk/gruI4a5fxj+j2m5OyyrQP3YPqtySKsU/ZlmCWdBP0z/iQ60rYNXD
P0YlD0Y7uNY/ZhzvBuk/wj+JpeQbvRDaP6bNxwk8ocA/0o3qXq4v3T+vSEk/
kzu+P5zhtMECSeA/Subx91AJuz9SsIwKZt3hP8hHLsJvMbg/OdkIyNRp4z/R
ygPsJ5O1P6+oQXb2F+U/TgA+WZPysj8orBLbT6nmPyOmeWMFtbA/MFagMFxc
6D/BJWbhKgWtP2pa0vpzB+o/hlwgJrwpqT+mkpx7w5XrP96i5Tor9KU/cXEj
7cVF7T+IV165at6iPz+EQhUA2e4/io2j5yJVoD/OHg+X9kbwPw1sT2qc2Zs/
lijP3XId8T+1vr/spL6XP19M2/+K5fE/szVqQo5plD9ww0WafL7yP0SlbkQr
SJE/glT8DwqJ8z9SXL+ahIWNP60SBUCdT/Q/Vf/BiwU+iT8fJGzoCSf1P6XY
9/yxQIU/k08fbBLw9T/d/hfF0hCCP07OMGj0yfY/WBX+m7g8fj8iepQe3J/3
Pwgpwgl1Vnk/9z9EsF9n+D/SI6tzW3N1PxRZUrq8P/k/7TSp7BLgcT8yjKyf
tQn6PyoHBJDCG24/aexYP7TP+j8mqVUNPWhpP+efY1eMpvs/44hXTdAZZT9n
bbpKAG/8P3dKY7pJuGE/Lo5vtk1I/T/fUcMdUkldP/fIcP02E/4/JGAq7GR6
WD/YMMT+Jdr+P5/LI10JglQ/Aex1eO6x/z9KSILaz+dQP5bguWapPQBAlq25
icIzTD/O9GdNyKoAQGL9x/maJEc/kx8/EeoVAUDYcmP37AlDP1hXvMLZeQFA
A2NVLEa1Pz/BuGgwNuYBQIcHJYBW+Tk/Kye7i2BLAkDW0eeJjYo1PyGsNsSN
rgJAaWPcYpfqMT+7WuG4JxoDQCvZPVKRUC0/VhYym49+A0CKzd8QmUkoP5T7
sTlk6wNAPAebvH/KIz9f91q1O1YEQE+7XaGvLCA/KgCqHuG5BED3TMF1AMga
P5kyKETzJQVAKtC/ZAfOFT8JckxX04oFQBzqWI9q/BE/HdufJiD4BUCCdAIq
wy0NP71aHNNvYwZAt5PS1iy+Bz9e5z5tjccGQIAMznbJkwM/op2Qwxc0B0Bm
QQyE+L7/PudgiAdwmQdAQ10YbMwV+j4I5Sz5//8HQEL9Fuw7X/U+89DA0g==

                    "]]}, 
                   Annotation[#, 
                    "Charting`Private`Tag$303865#1"]& ]}}, {}, {}}, {
               DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
                AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
                GridLines -> {None, None}, DisplayFunction -> Identity, 
                PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                All, DisplayFunction -> Identity, AspectRatio -> 1, 
                Axes -> {False, False}, AxesLabel -> {None, None}, 
                AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                Frame -> {{True, True}, {True, True}}, 
                FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                Directive[
                  Opacity[0.5], 
                  Thickness[Tiny], 
                  RGBColor[0.368417, 0.506779, 0.709798]], 
                FrameTicks -> {{None, None}, {None, None}}, 
                GridLines -> {None, None}, GridLinesStyle -> Directive[
                  GrayLevel[0.5, 0.4]], ImageSize -> 
                Dynamic[{
                  Automatic, 3.5 CurrentValue["FontCapHeight"]/
                   AbsoluteCurrentValue[Magnification]}], 
                Method -> {
                 "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                  AbsolutePointSize[6], "ScalingFunctions" -> None, 
                  "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                PlotRange -> {{0., 3.}, {0., 0.18744341393539973`}}, 
                PlotRangeClipping -> True, PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
              GridBox[{{
                 RowBox[{
                   TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox[
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "3.`"}], "}"}], "}"}], 
                    "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"scalar\"", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["3", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["False", "SummaryItem"]}]}}, 
               GridBoxAlignment -> {
                "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
               False, GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {
                "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
               BaseStyle -> {
                ShowStringCharacters -> False, NumberMarks -> False, 
                 PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
            GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
            BaselinePosition -> {1, 1}]}, 
         Dynamic[Typeset`open$$], ImageSize -> Automatic], BaselinePosition -> 
        Baseline], DynamicModuleValues :> {}], 
      StyleBox["]", "NonInterpretableSummary"]}]},
   "CopyTag",
   DisplayFunction->(#& ),
   InterpretationFunction->("InterpolatingFunction[{{0., 3.}}, <>]"& )],
  False,
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{3.815754525924816*^9, 3.815762039950253*^9, 
  3.8158261483625193`*^9, 3.815826566441744*^9, 
  3.8158472217014713`*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 RowBox[{"{", "0.698540826808822`", "}"}]], "Output",
 CellChangeTimes->{3.815754525924816*^9, 3.815762039950253*^9, 
  3.8158261483625193`*^9, 3.815826566441744*^9, 
  3.815847221707397*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.815754609227364*^9, 
  3.8157546102839413`*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Mu]", "=", "38"}], ";", 
  RowBox[{"\[Lambda]", "=", "6"}], ";", 
  RowBox[{"NR", "=", "1"}], ";", 
  RowBox[{"\[Nu]", "=", "nopumpingrate"}], ";", 
  RowBox[{"A", "=", "100"}]}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{"a", "=", "1.53"}], ";", 
   RowBox[{"b", "=", "1.43"}], ";", 
   RowBox[{
    RowBox[{"Jin", "[", "t_", "]"}], ":=", 
    RowBox[{
     RowBox[{"A", "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"1", "/", "2.3"}], "-", 
        RowBox[{"1", "/", "2.31"}]}], ")"}]}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"-", "2.3"}], "*", "t"}], "]"}], "-", 
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"-", "2.31"}], "*", "t"}], "]"}]}], 
      ")"}]}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"s", "=", 
   RowBox[{"NDSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"n1", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Mu]"}], "*", 
          RowBox[{"n1", "[", "t", "]"}]}], "+", " ", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], " ", "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"2", "*", 
             RowBox[{"n1", "[", "t", "]"}]}]}], " ", ")"}]}]}]}], " ", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"nca", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{"Jin", "[", "t", "]"}], "-", 
         RowBox[{"\[Nu]", "*", 
          RowBox[{"nca", "[", "t", "]"}]}], " ", "-", 
         RowBox[{"\[Lambda]", "*", 
          RowBox[{"nca", "[", "t", "]"}], "*", 
          RowBox[{"(", 
           RowBox[{"NR", "-", 
            RowBox[{"n1", "[", "t", "]"}]}], ")"}]}], "+", 
         RowBox[{"\[Mu]", "*", 
          RowBox[{"n1", "[", "t", "]"}]}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"p2", "'"}], "[", "t", "]"}], "\[Equal]", " ", 
        RowBox[{"\[Lambda]", "*", 
         RowBox[{"n1", "[", "t", "]"}], "*", 
         RowBox[{"nca", "[", "t", "]"}], "*", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"p2", "[", "t", "]"}]}], ")"}]}]}], ",", 
       "\[IndentingNewLine]", " ", 
       RowBox[{
        RowBox[{"n1", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
       RowBox[{
        RowBox[{"nca", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
       RowBox[{
        RowBox[{"p2", "[", "0", "]"}], "\[Equal]", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"n1", ",", "nca", ",", "p2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0.0", ",", "5"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"n1", "[", "t", "]"}], "/.", "s"}], "]"}], ",", 
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"nca", "[", "t", "]"}], "/.", "s"}], "]"}], ",", 
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"p2", "[", "t", "]"}], "/.", "s"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "5"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "5"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Thickness", "[", "0.01", "]"}], ",", 
      RowBox[{"Thickness", "[", "0.02", "]"}], ",", 
      RowBox[{"Thickness", "[", "0.02", "]"}]}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{"Orange", ",", 
      RowBox[{"Darker", "[", "Green", "]"}], ",", "Blue"}], "}"}]}], ",", 
   RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"plotofn1Slow100NOPUMPS", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"n1", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "5"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "5"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", ".5"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Darker", "[", "Green", "]"}], ",", 
       RowBox[{"Thickness", "[", "linethick", "]"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"FrameTicksStyle", "\[Rule]", "15"}]}], ",", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"{", "\"\<N=100 No pumps\>\"", "}"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"plotofncaSlow100NOPUMPS", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{"nca", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "5"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "5"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "2"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Darker", "[", "Green", "]"}], ",", 
       RowBox[{"Thickness", "[", "linethick", "]"}]}], "}"}]}], ",", 
    RowBox[{"FrameTicksStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"{", "\"\<N=100 No pumps\>\"", "}"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plotofp2Slow100NOPUMPS", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"p2", "[", "t", "]"}], "/.", "s"}], "]"}], " ", ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0", ",", "5"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "5"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Darker", "[", "Green", "]"}], ",", 
        RowBox[{"Thickness", "[", "linethick", "]"}]}], "}"}]}], ",", 
     RowBox[{"FrameTicksStyle", "\[Rule]", "15"}], ",", 
     RowBox[{"PlotLegends", "\[Rule]", 
      RowBox[{"{", "\"\<N=100 No pumps\>\"", "}"}]}]}], "]"}]}], 
  " "}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.815754918416644*^9, 
  3.815754934958974*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData["100"], "Output",
 CellChangeTimes->{3.815754611869281*^9, 3.8157549397247677`*^9, 
  3.815762039989636*^9, 3.8158261974052258`*^9, 3.815826322055132*^9, 
  3.815826566481101*^9, 
  3.8158472217409277`*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], Thickness[0.01], Opacity[1.], 
      LineBox[CompressedData["
1:eJwVlHc4Fe4bxnE4ONY5jgbJXmUUiqQ8b9kRISUze69KNoWsZH1llZSR1bLX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       "]]},
     Annotation[#, "Charting`Private`Tag$303955#1"]& ], 
    TagBox[
     {RGBColor[0.880722, 0.611041, 0.142051], Thickness[0.02], Opacity[1.], 
      LineBox[CompressedData["
1:eJwVlnc8le8bx3HseTgqVEhWkZKRVK4bGeFbCNl7ZpWMksrMyE5I2ZtEEZFs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       "]]},
     Annotation[#, "Charting`Private`Tag$303955#2"]& ], 
    TagBox[
     {RGBColor[0.560181, 0.691569, 0.194885], Thickness[0.02], Opacity[1.], 
      LineBox[CompressedData["
1:eJwt1nc8Vu/7AHB78zxGQkIRQpKkYVx3pCHRUnZIRkYoo6iEEpKRkLI+KKUk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       "]]},
     Annotation[#, "Charting`Private`Tag$303955#3"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  FrameTicksStyle->15,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 5}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.815754611869281*^9, 3.8157549397247677`*^9, 
  3.815762039989636*^9, 3.8158261974052258`*^9, 3.815826322055132*^9, 
  3.815826566481101*^9, 
  3.815847221785825*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{{{}, {}, 
       TagBox[{
         Directive[
          Opacity[1.], 
          AbsoluteThickness[1.6], 
          RGBColor[0, 
           NCache[
            Rational[2, 3], 0.6666666666666666], 0], 
          Thickness[0.01]], 
         LineBox[CompressedData["
1:eJwVlHc4Fe4bxnE4ONY5jgbJXmUUiqQ8b9kRISUze69KNoWsZH1llZSR1bLX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          "]]}, 
        Annotation[#, "Charting`Private`Tag$303999#1"]& ]}}, {}, {}}, {
    DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
     AxesOrigin -> {0, 0}, FrameTicks -> {{Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}}, 
     GridLines -> {None, None}, DisplayFunction -> Identity, 
     PlotRangePadding -> {{0, 0}, {0, 0}}, PlotRangeClipping -> True, 
     ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
     NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
     AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
     Identity, Frame -> {{False, False}, {False, False}}, 
     FrameLabel -> {{None, None}, {None, None}}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     GridLines -> {None, None}, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
       AbsolutePointSize[6], "ScalingFunctions" -> None, 
       "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& ), "CopiedValueFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )}}, PlotRange -> {{0, 5}, {0, 0.5}}, 
     PlotRangeClipping -> True, 
     PlotRangePadding -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{"\"N=100 No pumps\""}, "LineLegend", 
      DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 
                    NCache[
                    Rational[2, 3], 0.6666666666666666], 0], 
                    Thickness[0.18]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 
                    NCache[
                    Rational[2, 3], 0.6666666666666666], 0], 
                    Thickness[0.18]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"LineLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Directive", "[", 
               RowBox[{
                 RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                 RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                 InterpretationBox[
                  ButtonBox[
                   TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0, 
                    Rational[2, 3], 0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0.4444444444444444, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0, 2/3, 0]"], Appearance -> None, 
                   BaseStyle -> {}, BaselinePosition -> Baseline, 
                   DefaultBaseStyle -> {}, ButtonFunction :> 
                   With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0, 
                    Rational[2, 3], 0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                   Automatic, Method -> "Preemptive"], 
                  RGBColor[0, 
                   Rational[2, 3], 0], Editable -> False, Selectable -> 
                  False], ",", 
                 RowBox[{"Thickness", "[", "0.01`", "]"}]}], "]"}], "}"}], 
           ",", 
           RowBox[{"{", #, "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
      Editable -> True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{3.815754611869281*^9, 3.8157549397247677`*^9, 
  3.815762039989636*^9, 3.8158261974052258`*^9, 3.815826322055132*^9, 
  3.815826566481101*^9, 
  3.815847221835321*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{{{}, {}, 
       TagBox[{
         Directive[
          Opacity[1.], 
          AbsoluteThickness[1.6], 
          RGBColor[0, 
           NCache[
            Rational[2, 3], 0.6666666666666666], 0], 
          Thickness[0.01]], 
         LineBox[CompressedData["
1:eJwVlnc8le8bx3HseTgqVEhWkZKRVK4bGeFbCNl7ZpWMksrMyE5I2ZtEEZFs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          "]]}, 
        Annotation[#, "Charting`Private`Tag$304066#1"]& ]}}, {}, {}}, {
    DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
     AxesOrigin -> {0, 0}, FrameTicks -> {{Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}}, 
     GridLines -> {None, None}, DisplayFunction -> Identity, 
     PlotRangePadding -> {{0, 0}, {0, 0}}, PlotRangeClipping -> True, 
     ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
     NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
     AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
     Identity, Frame -> {{False, False}, {False, False}}, 
     FrameLabel -> {{None, None}, {None, None}}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> 15, GridLines -> {None, None}, GridLinesStyle -> 
     Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
       AbsolutePointSize[6], "ScalingFunctions" -> None, 
       "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& ), "CopiedValueFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )}}, PlotRange -> {{0, 5}, {0, 2}}, 
     PlotRangeClipping -> True, 
     PlotRangePadding -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{"\"N=100 No pumps\""}, "LineLegend", 
      DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 
                    NCache[
                    Rational[2, 3], 0.6666666666666666], 0], 
                    Thickness[0.18]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 
                    NCache[
                    Rational[2, 3], 0.6666666666666666], 0], 
                    Thickness[0.18]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"LineLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Directive", "[", 
               RowBox[{
                 RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                 RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                 InterpretationBox[
                  ButtonBox[
                   TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0, 
                    Rational[2, 3], 0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0.4444444444444444, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0, 2/3, 0]"], Appearance -> None, 
                   BaseStyle -> {}, BaselinePosition -> Baseline, 
                   DefaultBaseStyle -> {}, ButtonFunction :> 
                   With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0, 
                    Rational[2, 3], 0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                   Automatic, Method -> "Preemptive"], 
                  RGBColor[0, 
                   Rational[2, 3], 0], Editable -> False, Selectable -> 
                  False], ",", 
                 RowBox[{"Thickness", "[", "0.01`", "]"}]}], "]"}], "}"}], 
           ",", 
           RowBox[{"{", #, "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
      Editable -> True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{3.815754611869281*^9, 3.8157549397247677`*^9, 
  3.815762039989636*^9, 3.8158261974052258`*^9, 3.815826322055132*^9, 
  3.815826566481101*^9, 
  3.81584722189095*^9},ExpressionUUID->"00000000-0000-0000-0000-000000000000"],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{{{}, {}, 
       TagBox[{
         Directive[
          Opacity[1.], 
          AbsoluteThickness[1.6], 
          RGBColor[0, 
           NCache[
            Rational[2, 3], 0.6666666666666666], 0], 
          Thickness[0.01]], 
         LineBox[CompressedData["
1:eJwt1nc8Vu/7AHB78zxGQkIRQpKkYVx3pCHRUnZIRkYoo6iEEpKRkLI+KKUk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          "]]}, 
        Annotation[#, "Charting`Private`Tag$304133#1"]& ]}}, {}, {}}, {
    DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
     AxesOrigin -> {0, 0}, FrameTicks -> {{Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
        Charting`ScaledFrameTicks[{Identity, Identity}]}}, 
     GridLines -> {None, None}, DisplayFunction -> Identity, 
     PlotRangePadding -> {{0, 0}, {0, 0}}, PlotRangeClipping -> True, 
     ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
     NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
     AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
     Identity, Frame -> {{False, False}, {False, False}}, 
     FrameLabel -> {{None, None}, {None, None}}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> 15, GridLines -> {None, None}, GridLinesStyle -> 
     Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {
      "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
       AbsolutePointSize[6], "ScalingFunctions" -> None, 
       "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& ), "CopiedValueFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )}}, PlotRange -> {{0, 5}, {0, 1}}, 
     PlotRangeClipping -> True, 
     PlotRangePadding -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{"\"N=100 No pumps\""}, "LineLegend", 
      DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 
                    NCache[
                    Rational[2, 3], 0.6666666666666666], 0], 
                    Thickness[0.18]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 
                    NCache[
                    Rational[2, 3], 0.6666666666666666], 0], 
                    Thickness[0.18]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"LineLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Directive", "[", 
               RowBox[{
                 RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                 RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                 InterpretationBox[
                  ButtonBox[
                   TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0, 
                    Rational[2, 3], 0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0.4444444444444444, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0, 2/3, 0]"], Appearance -> None, 
                   BaseStyle -> {}, BaselinePosition -> Baseline, 
                   DefaultBaseStyle -> {}, ButtonFunction :> 
                   With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0, 
                    Rational[2, 3], 0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                   Automatic, Method -> "Preemptive"], 
                  RGBColor[0, 
                   Rational[2, 3], 0], Editable -> False, Selectable -> 
                  False], ",", 
                 RowBox[{"Thickness", "[", "0.01`", "]"}]}], "]"}], "}"}], 
           ",", 
           RowBox[{"{", #, "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
      Editable -> True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{3.815754611869281*^9, 3.8157549397247677`*^9, 
  3.815762039989636*^9, 3.8158261974052258`*^9, 3.815826322055132*^9, 
  3.815826566481101*^9, 
  3.815847221947744*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"n1new100nopumps", "[", "y_", "]"}], ":=", 
  RowBox[{
   RowBox[{"n1", "[", "y", "]"}], "/.", "s"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ncanew100nopumps", "[", "y_", "]"}], ":=", 
  RowBox[{
   RowBox[{"nca", "[", "y", "]"}], "/.", "s"}]}], "\n", 
 RowBox[{
  RowBox[{"p2new100nopumps", "[", "y_", "]"}], ":=", " ", 
  RowBox[{
   RowBox[{"p2", "[", "y", "]"}], "/.", "s"}]}]}], "Input",
 CellChangeTimes->{{3.815754891790193*^9, 
  3.815754898638482*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"N", "[", 
   RowBox[{"p2new100nopumps", "[", "5", "]"}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.81575491027006*^9, 3.81575491142627*^9}, {
  3.8157549548957653`*^9, 
  3.815754960654957*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 RowBox[{"{", "0.4157180580757541`", "}"}]], "Output",
 CellChangeTimes->{{3.8157549493662567`*^9, 3.815754961369128*^9}, 
   3.815762040160346*^9, 3.8158262028828363`*^9, 3.8158263275085*^9, 
   3.8158265667261457`*^9, 
   3.815847221977909*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Ingdtgralinexpo100nopumps", "[", "ti_", "]"}], ":=", 
  RowBox[{
   RowBox[{"-", "\[Lambda]"}], " ", "*", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"n1new100nopumps", "[", "tti", "]"}], "*", 
      RowBox[{"ncanew100nopumps", "[", "tti", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"tti", ",", "0", ",", "ti"}], "}"}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IngdtgralinexpoInf100nopumps", "[", "ti_", "]"}], ":=", 
   RowBox[{"\[Lambda]", " ", "*", 
    RowBox[{"NIntegrate", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"n1new100nopumps", "[", "tti", "]"}], "*", 
       RowBox[{"ncanew100nopumps", "[", "tti", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"tti", ",", "ti", ",", "5"}], "}"}]}], "]"}]}]}], ";", 
  "            ", 
  StyleBox[
   RowBox[{"(", 
    RowBox[{"Infnty", " ", "is", " ", "10", " ", "here"}], " ", ")"}], "Text"], 
  StyleBox[" ", "Text"], 
  StyleBox[";", "Text"]}], "\[IndentingNewLine]", 
 RowBox[{"DiscretePlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"IngdtgralinexpoInf100nopumps", "[", "hh", "]"}], "*", 
    RowBox[{"Exp", "[", 
     RowBox[{"Ingdtgralinexpo100nopumps", "[", "hh", "]"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"hh", ",", "0", ",", "3", ",", ".1"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.815754992976308*^9, 3.8157550064156427`*^9}, {
   3.8157550713927507`*^9, 3.815755081392302*^9}, 
   3.8157551189612503`*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.011000000000000001`], 
    AbsoluteThickness[1.6], {
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.011000000000000001`], AbsoluteThickness[1.6], Opacity[0.2], 
      LineBox[{{{3., 0.00004745455113397962}, {3., 0.00004745455113397962}}},
       VertexColors->None]}, 
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.011000000000000001`], AbsoluteThickness[1.6], Opacity[0.2], 
      LineBox[CompressedData["
1:eJxVz1koRGEUwPFr7mDK1DBTshcZstdghDjfC/JAoQlllyXUhEgSJcRExAuT
J5PyYM2DlEKWEh6kUZbB2Moa2SMxcY/Oqfvw63S/7/95FmhTi3iO4zx+PtHf
J0yd4sJfqTKD4EDe5SXGLAH9gGVmwZCTHNwmMaPpfg2iikyFkrkjtLAPC7XM
Nqhio62zW/bR9P9d0OoPjWX9O2hh/1tzDLpEw/CKaQtNzz8FX2PXda1uHS3s
S4otcwGjeRnG8INlNL3/Evz89wfz1fNoYb+5YZkbuE6fEud4zaBp3z0EZjVO
KsVT/ybnP8BYUqmrjWkETfsf4dnJT7EiHULT+5+gR9RhbyvVo+n7XuC2u0Fb
Ot6Lpn1vkLc3vXpu0KFp3zt8mI0y6WkzmvZ9QNxrvNp5qB5N+z4hze6ulR+v
QtO+L4iQeXKd8jI07ePYunLhIMytAE3P51hzuo+qSpqJpv1WLOguk69hKWh6
v4idLNXLc0cT0PR9PNvW3C6WhzA07ROzCjuFxkWmRtM+MYu8bHfwfg9C0z5r
dnY1MJmd7I2mfTaserbP0b3SFU37bNnEW4BW0yRHC/tvtbN4AQ==
       "],
       VertexColors->None]}}}, 
   {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.011000000000000001`], 
    AbsoluteThickness[1.6], {}, PointBox[CompressedData["
1:eJxTTMoPSmViYGCQB2IQDQMVws+0VI0e2s+aCQI77RfH+em1ccD4J+2tUu8m
c+y5b29iDAKX7Y3srFljW25D5W/a58+6dzVrxjV7iGkP7Ls8Fy89evciVP1j
e/Wrva/Luk7bp6eBwDP7NQkRV03vHIHqf2mvqXV7TqLZfvuzZ0Dgjf3r8I0s
cUrboeZ9sNeJqdugyrIRqv6j/VrfDGm2uyug5n+2/yqhKXyUZxFU/xf7CUyd
Auw8s6D2fbN/21+Tn7FuEtS8H/YJtzYfe7q4C2reT/vfD6/y8zxugpr32971
u5uZ5KIqqHl/7IO537UyryuCmvfP3pxfkaFHKAtqHoPDadUDd0xkkqDqGRya
wtWMingioeYzOui+i2QudQiE6mdyeHS4Sih+jTvUPmaHy6FvD2brO0DNY3HI
4RYOleI3g5rH4mD5skNQ5acu1DxWhyevZm6I9VOBmsfmULxzsphsoTTUPHaH
9T+080PrhaDmcTjoMEt9s33IYQ8AjV/LNw==
     "]], {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0.00004745455113397962},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{
   "MessagesHead" -> DiscretePlot, "AxisPadding" -> Scaled[0.02], 
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "DefaultPlotStyle" -> {
      Directive[
       RGBColor[0.368417, 0.506779, 0.709798], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.880722, 0.611041, 0.142051], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.560181, 0.691569, 0.194885], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.922526, 0.385626, 0.209179], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.528488, 0.470624, 0.701351], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.772079, 0.431554, 0.102387], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.363898, 0.618501, 0.782349], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[1, 0.75, 0], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.647624, 0.37816, 0.614037], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.571589, 0.586483, 0.], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.915, 0.3325, 0.2125], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.40082222609352647`, 0.5220066643438841, 0.85], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.9728288904374106, 0.621644452187053, 0.07336199581899142], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.736782672705901, 0.358, 0.5030266573755369], 
       AbsoluteThickness[1.6]], 
      Directive[
       RGBColor[0.28026441037696703`, 0.715, 0.4292089322474965], 
       AbsoluteThickness[1.6]]}, "DomainPadding" -> Scaled[0.02], 
    "PointSizeFunction" -> "SmallPointSize", "RangePadding" -> Scaled[0.05]},
  PlotRange->{{0., 3.}, {0.00004745455113397962, 0.5373712385049734}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.02]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.8157551114934483`*^9, 3.815755242336421*^9, 
  3.8157620577429533`*^9, 3.815826223558133*^9, 3.815826347703657*^9, 
  3.8158265844648943`*^9, 
  3.815847239669963*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals100nopumpsvals", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"IngdtgralinexpoInf100nopumps", "[", "hh", "]"}], "*", 
      RowBox[{"Exp", "[", 
       RowBox[{"Ingdtgralinexpo100nopumps", "[", "hh", "]"}], "]"}]}], " ", 
     ",", 
     RowBox[{"{", 
      RowBox[{"hh", ",", "0.0", ",", "3", ",", ".03"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.815755107087908*^9, 3.815755129824435*^9}, 
   3.81582623256826*^9, 
   3.815826352713028*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals100nopumpsfunc", " ", "=", " ", 
  RowBox[{"ListInterpolation", "[", 
   RowBox[{"IngdtgralinexpoInfIngdtgralinexpovals100nopumpsvals", ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0.0", ",", "3"}], "}"}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"tau2for100nopumps", "=", 
  RowBox[{
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
     "IngdtgralinexpoInfIngdtgralinexpovals100nopumpsfunc", "[", "ww", "]"}], 
     ",", " ", 
     RowBox[{"{", 
      RowBox[{"ww", ",", "0.0", ",", "3"}], "}"}]}], "]"}], "  ", "/", 
   RowBox[{"N", "[", 
    RowBox[{"p2new100nopumps", "[", "5", "]"}], "]"}], " "}]}]}], "Input",
 CellChangeTimes->{{3.8157551639849653`*^9, 3.8157551903691673`*^9}, 
   3.8158262369526176`*^9, 3.815826271545116*^9, {3.815826626812216*^9, 
   3.815826627195588*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 TagBox[
  TemplateBox[{RowBox[{
      StyleBox[
       TagBox["InterpolatingFunction", "SummaryHead"], 
       "NonInterpretableSummary"], 
      StyleBox["[", "NonInterpretableSummary"], 
      DynamicModuleBox[{Typeset`open$$ = False}, 
       PanelBox[
        PaneSelectorBox[{False -> GridBox[{{
              PaneBox[
               ButtonBox[
                DynamicBox[
                 FEPrivate`FrontEndResource[
                 "FEBitmaps", "SquarePlusIconMedium"]], 
                ButtonFunction :> (Typeset`open$$ = True), Appearance -> None,
                 Evaluator -> Automatic, Method -> "Preemptive"], 
               Alignment -> {Center, Center}, ImageSize -> 
               Dynamic[{
                 Automatic, 3.5 CurrentValue["FontCapHeight"]/
                  AbsoluteCurrentValue[Magnification]}]], 
              GraphicsBox[{{{{}, {}, 
                  TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAA88dx3mtMaz4O7MIqJTLhP6m+gdgd
Cqk/P9V6XIQv4T8vlAOEtBe6P7xgPciZBeE/j/RD6Atiwz9159V9G5XgP8yH
F2FrmMk/qJXgllK83z+j2m5OyyrQP4Zgauv4rN0/ZlmCWdBP0z/LqVXrEG/b
P0YlD0Y7uNY/6KqYMTbU2D+JpeQbvRDaPzAIdGbCPNY/0o3qXq4v3T95kLuP
W+LTP5zhtMECSeA/AczH9NZ40T9SsIwKZt3hP5w/pXVdx84/OdkIyNRp4z/C
RBPbUAzLP6+oQXb2F+U/HkXEfOtnxz8orBLbT6nmP7/2vw1HYcQ/MFagMFxc
6D+qwRvi3HvBP2pa0vpzB+o/UONPv53/vT+mkpx7w5XrP7jXm88N8rk/cXEj
7cVF7T/Id4PgTh62Pz+EQhUA2e4/3NseuZMFsz/OHg+X9kbwP2Y+PyN+H7A/
lijP3XId8T+FOKAqLl2rP19M2/+K5fE/E8CCguZwpz9ww0WafL7yP00DtDJ5
yaM/glT8DwqJ8z+qUezecN2gP60SBUCdT/Q/jIsZPTXMnD8fJGzoCSf1P+he
MFVdOJg/k08fbBLw9T/vMmRqlZOUP07OMGj0yfY/R4cCh083kT8iepQe3J/3
P1BkEJ0+24w/9z9EsF9n+D+uJq8TLHCIPxRZUrq8P/k/JPh4gYJghD8yjKyf
tQn6P06wpj5eLIE/aexYP7TP+j8oJyvhywF9P+efY1eMpvs/clC/5iEdeD9n
bbpKAG/8PwP4biQBRXQ/Lo5vtk1I/T8Mt6sxscRwP/fIcP02E/4/4uPbvSwP
bD/YMMT+Jdr+P9O2cPI0iGc/Aex1eO6x/z8pOelGY2tjP5bguWapPQBA00WQ
yc42YD/O9GdNyKoAQIvJojuEo1o/kx8/EeoVAUDIKzbus+9VP1hXvMLZeQFA
57PKHH1IUj/BuGgwNuYBQC0k8+Yt+00/Kye7i2BLAkBAZHBaieJIPyGsNsSN
rgJAGVHVoZK2RD+7WuG4JxoDQPV41JNp9UA/VhYym49+A0C7OL5kvx48P5T7
sTlk6wNA03XQ1CHuNj9f91q1O1YEQGwYpkiMwDI/KgCqHuG5BEBE0RDsDxEv
P5kyKETzJQVAIj5kpvROKT8JckxX04oFQFstYfbs4iQ/HdufJiD4BUBRyDq1
W/MgP71aHNNvYwZAg7aDsSyZGz9e5z5tjccGQAGOgcT7wxY/op2Qwxc0B0AZ
6LQZKHcSP+dgiAdwmQdAiEaGNzdbDj8I5Sz5//8HQCB7kko+4Qg/aEXFOQ==

                    "]]}, 
                   Annotation[#, 
                    "Charting`Private`Tag$420370#1"]& ]}}, {}, {}}, {
               DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
                AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
                GridLines -> {None, None}, DisplayFunction -> Identity, 
                PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                All, DisplayFunction -> Identity, AspectRatio -> 1, 
                Axes -> {False, False}, AxesLabel -> {None, None}, 
                AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                Frame -> {{True, True}, {True, True}}, 
                FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                Directive[
                  Opacity[0.5], 
                  Thickness[Tiny], 
                  RGBColor[0.368417, 0.506779, 0.709798]], 
                FrameTicks -> {{None, None}, {None, None}}, 
                GridLines -> {None, None}, GridLinesStyle -> Directive[
                  GrayLevel[0.5, 0.4]], ImageSize -> 
                Dynamic[{
                  Automatic, 3.5 CurrentValue["FontCapHeight"]/
                   AbsoluteCurrentValue[Magnification]}], 
                Method -> {
                 "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                  AbsolutePointSize[6], "ScalingFunctions" -> None, 
                  "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                PlotRange -> {{0., 3.}, {0., 0.5373712382491946}}, 
                PlotRangeClipping -> True, PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
              GridBox[{{
                 RowBox[{
                   TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox[
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "3.`"}], "}"}], "}"}], 
                    "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"scalar\"", "SummaryItem"]}]}}, 
               GridBoxAlignment -> {
                "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
               False, GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {
                "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
               BaseStyle -> {
                ShowStringCharacters -> False, NumberMarks -> False, 
                 PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
            GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
            BaselinePosition -> {1, 1}], True -> GridBox[{{
              PaneBox[
               ButtonBox[
                DynamicBox[
                 FEPrivate`FrontEndResource[
                 "FEBitmaps", "SquareMinusIconMedium"]], 
                ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                None, Evaluator -> Automatic, Method -> "Preemptive"], 
               Alignment -> {Center, Center}, ImageSize -> 
               Dynamic[{
                 Automatic, 3.5 CurrentValue["FontCapHeight"]/
                  AbsoluteCurrentValue[Magnification]}]], 
              GraphicsBox[{{{{}, {}, 
                  TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAA88dx3mtMaz4O7MIqJTLhP6m+gdgd
Cqk/P9V6XIQv4T8vlAOEtBe6P7xgPciZBeE/j/RD6Atiwz9159V9G5XgP8yH
F2FrmMk/qJXgllK83z+j2m5OyyrQP4Zgauv4rN0/ZlmCWdBP0z/LqVXrEG/b
P0YlD0Y7uNY/6KqYMTbU2D+JpeQbvRDaPzAIdGbCPNY/0o3qXq4v3T95kLuP
W+LTP5zhtMECSeA/AczH9NZ40T9SsIwKZt3hP5w/pXVdx84/OdkIyNRp4z/C
RBPbUAzLP6+oQXb2F+U/HkXEfOtnxz8orBLbT6nmP7/2vw1HYcQ/MFagMFxc
6D+qwRvi3HvBP2pa0vpzB+o/UONPv53/vT+mkpx7w5XrP7jXm88N8rk/cXEj
7cVF7T/Id4PgTh62Pz+EQhUA2e4/3NseuZMFsz/OHg+X9kbwP2Y+PyN+H7A/
lijP3XId8T+FOKAqLl2rP19M2/+K5fE/E8CCguZwpz9ww0WafL7yP00DtDJ5
yaM/glT8DwqJ8z+qUezecN2gP60SBUCdT/Q/jIsZPTXMnD8fJGzoCSf1P+he
MFVdOJg/k08fbBLw9T/vMmRqlZOUP07OMGj0yfY/R4cCh083kT8iepQe3J/3
P1BkEJ0+24w/9z9EsF9n+D+uJq8TLHCIPxRZUrq8P/k/JPh4gYJghD8yjKyf
tQn6P06wpj5eLIE/aexYP7TP+j8oJyvhywF9P+efY1eMpvs/clC/5iEdeD9n
bbpKAG/8PwP4biQBRXQ/Lo5vtk1I/T8Mt6sxscRwP/fIcP02E/4/4uPbvSwP
bD/YMMT+Jdr+P9O2cPI0iGc/Aex1eO6x/z8pOelGY2tjP5bguWapPQBA00WQ
yc42YD/O9GdNyKoAQIvJojuEo1o/kx8/EeoVAUDIKzbus+9VP1hXvMLZeQFA
57PKHH1IUj/BuGgwNuYBQC0k8+Yt+00/Kye7i2BLAkBAZHBaieJIPyGsNsSN
rgJAGVHVoZK2RD+7WuG4JxoDQPV41JNp9UA/VhYym49+A0C7OL5kvx48P5T7
sTlk6wNA03XQ1CHuNj9f91q1O1YEQGwYpkiMwDI/KgCqHuG5BEBE0RDsDxEv
P5kyKETzJQVAIj5kpvROKT8JckxX04oFQFstYfbs4iQ/HdufJiD4BUBRyDq1
W/MgP71aHNNvYwZAg7aDsSyZGz9e5z5tjccGQAGOgcT7wxY/op2Qwxc0B0AZ
6LQZKHcSP+dgiAdwmQdAiEaGNzdbDj8I5Sz5//8HQCB7kko+4Qg/aEXFOQ==

                    "]]}, 
                   Annotation[#, 
                    "Charting`Private`Tag$420370#1"]& ]}}, {}, {}}, {
               DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
                AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
                GridLines -> {None, None}, DisplayFunction -> Identity, 
                PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                All, DisplayFunction -> Identity, AspectRatio -> 1, 
                Axes -> {False, False}, AxesLabel -> {None, None}, 
                AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                Frame -> {{True, True}, {True, True}}, 
                FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                Directive[
                  Opacity[0.5], 
                  Thickness[Tiny], 
                  RGBColor[0.368417, 0.506779, 0.709798]], 
                FrameTicks -> {{None, None}, {None, None}}, 
                GridLines -> {None, None}, GridLinesStyle -> Directive[
                  GrayLevel[0.5, 0.4]], ImageSize -> 
                Dynamic[{
                  Automatic, 3.5 CurrentValue["FontCapHeight"]/
                   AbsoluteCurrentValue[Magnification]}], 
                Method -> {
                 "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                  AbsolutePointSize[6], "ScalingFunctions" -> None, 
                  "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                PlotRange -> {{0., 3.}, {0., 0.5373712382491946}}, 
                PlotRangeClipping -> True, PlotRangePadding -> {{
                   Scaled[0.1], 
                   Scaled[0.1]}, {
                   Scaled[0.1], 
                   Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
              GridBox[{{
                 RowBox[{
                   TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox[
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "3.`"}], "}"}], "}"}], 
                    "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"scalar\"", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["3", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                 RowBox[{
                   TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                   "\[InvisibleSpace]", 
                   TagBox["False", "SummaryItem"]}]}}, 
               GridBoxAlignment -> {
                "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
               False, GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {
                "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
               BaseStyle -> {
                ShowStringCharacters -> False, NumberMarks -> False, 
                 PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
            GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
            GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
            BaselinePosition -> {1, 1}]}, 
         Dynamic[Typeset`open$$], ImageSize -> Automatic], BaselinePosition -> 
        Baseline], DynamicModuleValues :> {}], 
      StyleBox["]", "NonInterpretableSummary"]}]},
   "CopyTag",
   DisplayFunction->(#& ),
   InterpretationFunction->("InterpolatingFunction[{{0., 3.}}, <>]"& )],
  False,
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{
  3.815755251433545*^9, 3.815762142767376*^9, 3.81582642019167*^9, {
   3.815826642387384*^9, 3.815826650535285*^9}, 
   3.815847297561776*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 RowBox[{"{", "0.7665764861967864`", "}"}]], "Output",
 CellChangeTimes->{
  3.815755251433545*^9, 3.815762142767376*^9, 3.81582642019167*^9, {
   3.815826642387384*^9, 3.815826650535285*^9}, 
   3.815847297567091*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.815846058143876*^9, 
  3.815846058485114*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"timesvector", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"First", "[", "tau2for100", "]"}], ",", " ", 
    RowBox[{"First", "[", "tau2for300", "]"}], ",", " ", 
    RowBox[{"First", "[", "tau2for500", "]"}], ",", 
    RowBox[{"First", "[", "tau2for100nopumps", "]"}]}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"xticks", "=", 
  RowBox[{"{", 
   RowBox[{
   "\"\<N=100\>\"", ",", "\"\<N=300\>\"", ",", "\"\<N=500\>\"", ",", 
    "\"\<N=100nopumps\>\""}], "}"}]}]}], "Input",
 CellChangeTimes->{{3.815827894381819*^9, 3.815827894382124*^9}, {
  3.815827953751704*^9, 3.815827960616466*^9}, {3.815828002968965*^9, 
  3.815828122361771*^9}, {3.8158460664054537`*^9, 
  3.81584607080518*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.6692334403265496`", ",", "0.6803428392539929`", ",", 
   "0.698540826808822`", ",", "0.7665764861967864`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.815847297591489*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"N=100\"\>", ",", "\<\"N=300\"\>", ",", "\<\"N=500\"\>", 
   ",", "\<\"N=100nopumps\"\>"}], "}"}]], "Output",
 CellChangeTimes->{
  3.815847297592718*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"d", "=", 
   RowBox[{"Range", "[", "4", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.8158345963464003`*^9, 3.815834628618585*^9}, 
   3.815834800476544*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"colorList", "=", 
   RowBox[{"{", 
    RowBox[{"Black", ",", "Red", ",", "Blue", ",", "Green"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"bList", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"{", "#", "}"}], "&"}], "/@", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"n", ",", 
        RowBox[{"timesvector", "[", 
         RowBox[{"[", "n", "]"}], "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "d"}], "}"}]}], "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{
  3.8158346735942163`*^9, 3.8158348022688847`*^9, {3.8158348988452587`*^9, 
   3.8158349187207823`*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[CellGroupData[{

Cell[BoxData["bList"], "Input",
 CellChangeTimes->{{3.815834676475243*^9, 
  3.81583467745444*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0.6692334403265496`"}], "}"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"2", ",", "0.6803428392539929`"}], "}"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"3", ",", "0.698540826808822`"}], "}"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"4", ",", "0.7665764861967864`"}], "}"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.815834677921139*^9, {3.8158347652691393`*^9, 3.815834804821867*^9}, 
   3.8158349210922737`*^9, 
   3.815847297635269*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"center", "=", 
   RowBox[{
    RowBox[{"Row", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"#", ",", 
        RowBox[{"Invisible", "[", "#", "]"}]}], "}"}], ",", 
      "\"\<\[NegativeThickSpace]\>\""}], "]"}], "&"}]}], ";"}]], "Input",Expre\
ssionUUID->"00000000-0000-0000-0000-000000000000"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xticks", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"center", "@", 
       RowBox[{"Rotate", "[", 
        RowBox[{"\"\<N=100 \>\"", " ", ",", 
         RowBox[{"45", " ", "Degree"}]}], "]"}]}]}], "}"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"2", ",", 
      RowBox[{"center", "@", 
       RowBox[{"Rotate", "[", 
        RowBox[{"\"\<N=300 \>\"", " ", ",", 
         RowBox[{"45", " ", "Degree"}]}], "]"}]}]}], "}"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"3", ",", 
      RowBox[{"center", "@", 
       RowBox[{"Rotate", "[", 
        RowBox[{"\"\<N=500 \>\"", " ", ",", 
         RowBox[{"45", " ", "Degree"}]}], "]"}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"4", ",", 
      RowBox[{"center", "@", 
       RowBox[{"Rotate", "[", 
        RowBox[{"\"\<N=100 no pumps \>\"", " ", ",", 
         RowBox[{"45", " ", "Degree"}]}], "]"}]}]}], "}"}]}], 
   "}"}]}]], "Input",ExpressionUUID->"00000000-0000-0000-0000-000000000000"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", 
     TemplateBox[{
      "\[NegativeThickSpace]","\"\[NegativeThickSpace]\"",RotationBox[
       "\"N=100 \"", BoxRotation -> 0.7853981633974483],StyleBox[
        RotationBox["\"N=100 \"", BoxRotation -> 0.7853981633974483], 
        ShowContents -> False, StripOnInput -> False]},
      "RowWithSeparators"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     TemplateBox[{
      "\[NegativeThickSpace]","\"\[NegativeThickSpace]\"",RotationBox[
       "\"N=300 \"", BoxRotation -> 0.7853981633974483],StyleBox[
        RotationBox["\"N=300 \"", BoxRotation -> 0.7853981633974483], 
        ShowContents -> False, StripOnInput -> False]},
      "RowWithSeparators"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", 
     TemplateBox[{
      "\[NegativeThickSpace]","\"\[NegativeThickSpace]\"",RotationBox[
       "\"N=500 \"", BoxRotation -> 0.7853981633974483],StyleBox[
        RotationBox["\"N=500 \"", BoxRotation -> 0.7853981633974483], 
        ShowContents -> False, StripOnInput -> False]},
      "RowWithSeparators"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", 
     TemplateBox[{
      "\[NegativeThickSpace]","\"\[NegativeThickSpace]\"",RotationBox[
       "\"N=100 no pumps \"", BoxRotation -> 0.7853981633974483],StyleBox[
        RotationBox["\"N=100 no pumps \"", BoxRotation -> 0.7853981633974483],
         ShowContents -> False, StripOnInput -> False]},
      "RowWithSeparators"]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.815846014351861*^9, {3.81584693746955*^9, 3.8158469608102293`*^9}, 
   3.815847297675349*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"plotofp2Slow", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{"bList", ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"xticks", ",", "None"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", "colorList"}], ",", 
    RowBox[{"PlotMarkers", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Graphics", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Disk", "[", "]"}], "}"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "15"}]}], "]"}], "}"}]}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "4.1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"Black", ",", "20"}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.815837474601446*^9, 3.8158374844696283`*^9}, {
  3.815837667055241*^9, 3.815837752968227*^9}, {3.815846026613381*^9, 
  3.815846047317108*^9}, {3.815846115878439*^9, 3.815846180903454*^9}, {
  3.815846238422658*^9, 
  3.815846243831258*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 GraphicsBox[{{}, {
    {GrayLevel[0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
     GeometricTransformationBox[InsetBox[
       GraphicsBox[
        {GrayLevel[0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
         DiskBox[{0, 0}]},
        ImageSize->15], {0., 0.}], {{{1., 0.6692334403265496}}, {{1., 
      0.6692334403265496}}}]}, 
    {RGBColor[1, 0, 0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
     GeometricTransformationBox[InsetBox[
       GraphicsBox[
        {RGBColor[1, 0, 0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
         DiskBox[{0, 0}]},
        ImageSize->15], {0., 0.}], {{{2., 0.6803428392539929}}, {{2., 
      0.6803428392539929}}}]}, 
    {RGBColor[0, 0, 1], AbsolutePointSize[6], AbsoluteThickness[1.6], 
     GeometricTransformationBox[InsetBox[
       GraphicsBox[
        {RGBColor[0, 0, 1], AbsolutePointSize[6], AbsoluteThickness[1.6], 
         DiskBox[{0, 0}]},
        ImageSize->15], {0., 0.}], {{{3., 0.698540826808822}}, {{3., 
      0.698540826808822}}}]}, 
    {RGBColor[0, 1, 0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
     GeometricTransformationBox[InsetBox[
       GraphicsBox[
        {RGBColor[0, 1, 0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
         DiskBox[{0, 0}]},
        ImageSize->15], {0., 0.}], {{{4., 0.7665764861967864}}, {{4., 
      0.7665764861967864}}}]}, {}}, {}, {}, {{}, {}}, {{}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, None}, {{{1, 
       FormBox[
        TemplateBox[{"\[NegativeThickSpace]", "\"\[NegativeThickSpace]\"", 
          RotationBox["\"N=100 \"", BoxRotation -> 0.7853981633974483], 
          StyleBox[
           RotationBox["\"N=100 \"", BoxRotation -> 0.7853981633974483], 
           ShowContents -> False, StripOnInput -> False]}, 
         "RowWithSeparators"], TraditionalForm]}, {2, 
       FormBox[
        TemplateBox[{"\[NegativeThickSpace]", "\"\[NegativeThickSpace]\"", 
          RotationBox["\"N=300 \"", BoxRotation -> 0.7853981633974483], 
          StyleBox[
           RotationBox["\"N=300 \"", BoxRotation -> 0.7853981633974483], 
           ShowContents -> False, StripOnInput -> False]}, 
         "RowWithSeparators"], TraditionalForm]}, {3, 
       FormBox[
        TemplateBox[{"\[NegativeThickSpace]", "\"\[NegativeThickSpace]\"", 
          RotationBox["\"N=500 \"", BoxRotation -> 0.7853981633974483], 
          StyleBox[
           RotationBox["\"N=500 \"", BoxRotation -> 0.7853981633974483], 
           ShowContents -> False, StripOnInput -> False]}, 
         "RowWithSeparators"], TraditionalForm]}, {4, 
       FormBox[
        TemplateBox[{"\[NegativeThickSpace]", "\"\[NegativeThickSpace]\"", 
          RotationBox[
          "\"N=100 no pumps \"", BoxRotation -> 0.7853981633974483], 
          StyleBox[
           RotationBox[
           "\"N=100 no pumps \"", BoxRotation -> 0.7853981633974483], 
           ShowContents -> False, StripOnInput -> False]}, 
         "RowWithSeparators"], TraditionalForm]}}, None}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  LabelStyle->Directive[
    GrayLevel[0], 20],
  Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 4.1}, {0, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.815846035456442*^9, 3.81584604779907*^9}, {
   3.81584611950458*^9, 3.815846167926982*^9}, {3.815846244361161*^9, 
   3.815846270197864*^9}, 
   3.815847297710744*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"figureslowp2", "=", 
  RowBox[{"Labeled", "[", 
   RowBox[{
    RowBox[{"Show", "[", 
     RowBox[{"plotofp2Slow", ",", 
      RowBox[{"LabelStyle", "\[Rule]", 
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", "20"}], "]"}]}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Conditional opening time (s)\>\"", ",", "\"\<Condition\>\""}], 
     "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"Left", ",", "Bottom", ",", "Top", ",", "Right"}], "}"}], ",", 
    RowBox[{"RotateLabel", "\[Rule]", "True"}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"Black", ",", "20"}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.815846251255488*^9, 3.8158462969030237`*^9}, 
   3.815847097312373*^9, {3.8158473696339893`*^9, 
   3.815847370129941*^9}},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{}, {{{
        Directive[
         PointSize[0.012833333333333334`], 
         AbsoluteThickness[1.6], 
         GrayLevel[0], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          GraphicsBox[{
            Directive[
             PointSize[0.012833333333333334`], 
             AbsoluteThickness[1.6], 
             GrayLevel[0], 
             AbsolutePointSize[6]], 
            DiskBox[{0, 0}]}, ImageSize -> 15], {0., 0.}], {{{1., 
         0.6692334403265496}}, {{1., 0.6692334403265496}}}]}, {
        Directive[
         PointSize[0.012833333333333334`], 
         AbsoluteThickness[1.6], 
         RGBColor[1, 0, 0], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          GraphicsBox[{
            Directive[
             PointSize[0.012833333333333334`], 
             AbsoluteThickness[1.6], 
             RGBColor[1, 0, 0], 
             AbsolutePointSize[6]], 
            DiskBox[{0, 0}]}, ImageSize -> 15], {0., 0.}], {{{2., 
         0.6803428392539929}}, {{2., 0.6803428392539929}}}]}, {
        Directive[
         PointSize[0.012833333333333334`], 
         AbsoluteThickness[1.6], 
         RGBColor[0, 0, 1], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          GraphicsBox[{
            Directive[
             PointSize[0.012833333333333334`], 
             AbsoluteThickness[1.6], 
             RGBColor[0, 0, 1], 
             AbsolutePointSize[6]], 
            DiskBox[{0, 0}]}, ImageSize -> 15], {0., 0.}], {{{3., 
         0.698540826808822}}, {{3., 0.698540826808822}}}]}, {
        Directive[
         PointSize[0.012833333333333334`], 
         AbsoluteThickness[1.6], 
         RGBColor[0, 1, 0], 
         AbsolutePointSize[6]], 
        GeometricTransformationBox[
         InsetBox[
          GraphicsBox[{
            Directive[
             PointSize[0.012833333333333334`], 
             AbsoluteThickness[1.6], 
             RGBColor[0, 1, 0], 
             AbsolutePointSize[6]], 
            DiskBox[{0, 0}]}, ImageSize -> 15], {0., 0.}], {{{4., 
         0.7665764861967864}}, {{4., 
         0.7665764861967864}}}]}, {}}}, {}, {}, {{}, {}}, {{}, {}}}, {
    LabelStyle -> Directive[
       GrayLevel[0], 20], DisplayFunction -> Identity, 
     PlotRangePadding -> {{0, 0}, {0, 0}}, AxesOrigin -> {0, 0}, 
     PlotRange -> {{0, 4.1}, {0, 1}}, PlotRangeClipping -> True, ImagePadding -> 
     All, DisplayFunction -> Identity, AspectRatio -> 
     NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
     AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
     Identity, Frame -> {{True, True}, {True, True}}, 
     FrameLabel -> {{None, None}, {None, None}}, 
     FrameTicks -> {{Automatic, None}, {{{1, 
          FormBox[
           
           TemplateBox[{
            "\[NegativeThickSpace]", "\"\[NegativeThickSpace]\"", 
             RotationBox["\"N=100 \"", BoxRotation -> 0.7853981633974483], 
             StyleBox[
              RotationBox["\"N=100 \"", BoxRotation -> 0.7853981633974483], 
              ShowContents -> False, StripOnInput -> False]}, 
            "RowWithSeparators"], TraditionalForm]}, {2, 
          FormBox[
           
           TemplateBox[{
            "\[NegativeThickSpace]", "\"\[NegativeThickSpace]\"", 
             RotationBox["\"N=300 \"", BoxRotation -> 0.7853981633974483], 
             StyleBox[
              RotationBox["\"N=300 \"", BoxRotation -> 0.7853981633974483], 
              ShowContents -> False, StripOnInput -> False]}, 
            "RowWithSeparators"], TraditionalForm]}, {3, 
          FormBox[
           
           TemplateBox[{
            "\[NegativeThickSpace]", "\"\[NegativeThickSpace]\"", 
             RotationBox["\"N=500 \"", BoxRotation -> 0.7853981633974483], 
             StyleBox[
              RotationBox["\"N=500 \"", BoxRotation -> 0.7853981633974483], 
              ShowContents -> False, StripOnInput -> False]}, 
            "RowWithSeparators"], TraditionalForm]}, {4, 
          FormBox[
           
           TemplateBox[{
            "\[NegativeThickSpace]", "\"\[NegativeThickSpace]\"", 
             RotationBox[
             "\"N=100 no pumps \"", BoxRotation -> 0.7853981633974483], 
             StyleBox[
              RotationBox[
              "\"N=100 no pumps \"", BoxRotation -> 0.7853981633974483], 
              ShowContents -> False, StripOnInput -> False]}, 
            "RowWithSeparators"], TraditionalForm]}}, None}}, 
     GridLines -> {None, None}, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], LabelStyle -> Directive[
       GrayLevel[0], 20], 
     Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& ), "CopiedValueFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )}}, PlotRange -> {{0, 4.1}, {0, 1}}, 
     PlotRangeClipping -> True, PlotRangePadding -> {{0, 0}, {0, 0}}, 
     Ticks -> {Automatic, Automatic}}],"\"Conditional opening time (s)\"",
   "\"Condition\""},
  "Labeled",
  DisplayFunction->(GridBox[{{
      ItemBox[
       RotationBox[#2, BoxRotation -> 1.5707963267948966`], BaseStyle -> 
       Directive[
         GrayLevel[0], 20], DefaultBaseStyle -> "LabeledLabel"], 
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"]}, {"", 
      ItemBox[#3, BaseStyle -> Directive[
         GrayLevel[0], 20], DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, 
    GridBoxItemSize -> {"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
    BaselinePosition -> {1, 2}]& ),
  InterpretationFunction->(RowBox[{"Labeled", "[", 
     RowBox[{#, ",", 
       RowBox[{"{", 
         RowBox[{#2, ",", #3}], "}"}], ",", 
       RowBox[{"{", 
         RowBox[{"Left", ",", "Bottom", ",", "Top", ",", "Right"}], "}"}], 
       ",", 
       RowBox[{"RotateLabel", "\[Rule]", "True"}], ",", 
       RowBox[{"LabelStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
           RowBox[{
             InterpretationBox[
              ButtonBox[
               TooltipBox[
                GraphicsBox[{{
                   GrayLevel[0], 
                   RectangleBox[{0, 0}]}, {
                   GrayLevel[0], 
                   RectangleBox[{1, -1}]}, {
                   GrayLevel[0], 
                   RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                 True, FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                 PlotRangePadding -> None, ImageSize -> 
                 Dynamic[{
                   Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], "GrayLevel[0]"], 
               Appearance -> None, BaseStyle -> {}, BaselinePosition -> 
               Baseline, DefaultBaseStyle -> {}, ButtonFunction :> 
               With[{Typeset`box$ = EvaluationBox[]}, 
                 If[
                  Not[
                   AbsoluteCurrentValue["Deployed"]], 
                  SelectionMove[Typeset`box$, All, Expression]; 
                  FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                  FrontEnd`Private`$ColorSelectorInitialColor = GrayLevel[0]; 
                  FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                  MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
               Automatic, Method -> "Preemptive"], 
              GrayLevel[0], Editable -> False, Selectable -> False], ",", 
             "20"}], "]"}]}]}], "]"}]& )]], "Output",
 CellChangeTimes->{3.815846254798067*^9, 3.8158471000743923`*^9, 
  3.815847297737513*^9, 
  3.8158473708187723`*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\</media/basnayak/Data \
new/basnayak/Dropbox/STIM_ORAI_bionewmetrics/mathematica_scripts/\
slowp2conditions.pdf\>\"", ",", "figureslowp2"}], "]"}]], "Input",ExpressionUU\
ID->"00000000-0000-0000-0000-000000000000"],

Cell[BoxData["\<\"/media/basnayak/Data \
new/basnayak/Dropbox/STIM_ORAI_bionewmetrics/mathematica_scripts/\
slowp2conditions.pdf\"\>"], "Output",
 CellChangeTimes->{3.815847320138359*^9, 
  3.815847373024023*^9},ExpressionUUID->"00000000-0000-0000-0000-\
000000000000"]
}, Open  ]]
},
WindowSize->{1200, 1140},
WindowMargins->{{0, Automatic}, {Automatic, 150}},
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 302, 7, 34, "Input"],
Cell[CellGroupData[{
Cell[885, 31, 6495, 185, 355, "Input"],
Cell[7383, 218, 300, 5, 32, "Output"],
Cell[7686, 225, 41967, 710, 241, "Output"],
Cell[49656, 937, 23034, 415, 243, "Output"],
Cell[72693, 1354, 23189, 418, 232, "Output"],
Cell[95885, 1774, 17029, 317, 221, "Output"]
}, Open  ]],
Cell[112929, 2094, 471, 13, 80, "Input"],
Cell[CellGroupData[{
Cell[113425, 2111, 499, 13, 77, "Input"],
Cell[113927, 2126, 315, 6, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[114279, 2137, 1766, 45, 80, "Input"],
Cell[116048, 2184, 4527, 105, 231, "Output"]
}, Open  ]],
Cell[120590, 2292, 765, 17, 34, "Input"],
Cell[CellGroupData[{
Cell[121380, 2313, 593, 11, 34, "Input"],
Cell[121976, 2326, 12928, 257, 65, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[134941, 2588, 666, 15, 34, "Input"],
Cell[135610, 2605, 345, 6, 32, "Output"]
}, Open  ]],
Cell[135970, 2614, 251, 4, 121, "Input"],
Cell[136224, 2620, 302, 7, 34, "Input"],
Cell[CellGroupData[{
Cell[136551, 2631, 6615, 188, 333, "Input"],
Cell[143169, 2821, 337, 6, 32, "Output"],
Cell[143509, 2829, 29267, 501, 243, "Output"],
Cell[172779, 3332, 16101, 302, 245, "Output"],
Cell[188883, 3636, 16178, 303, 245, "Output"],
Cell[205064, 3941, 18514, 341, 245, "Output"]
}, Open  ]],
Cell[223593, 4285, 516, 15, 80, "Input"],
Cell[CellGroupData[{
Cell[224134, 4304, 547, 13, 77, "Input"],
Cell[224684, 4319, 337, 6, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[225058, 4330, 1814, 46, 80, "Input"],
Cell[226875, 4378, 4575, 105, 235, "Output"]
}, Open  ]],
Cell[231465, 4486, 790, 17, 34, "Input"],
Cell[CellGroupData[{
Cell[232280, 4507, 647, 12, 34, "Input"],
Cell[232930, 4521, 12959, 258, 65, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[245926, 4784, 737, 16, 34, "Input"],
Cell[246666, 4802, 395, 7, 32, "Output"]
}, Open  ]],
Cell[247076, 4812, 232, 5, 99, "Input"],
Cell[CellGroupData[{
Cell[247333, 4821, 6503, 185, 286, "Input"],
Cell[253839, 5008, 352, 6, 32, "Output"],
Cell[254194, 5016, 29438, 504, 243, "Output"],
Cell[283635, 5522, 16189, 303, 250, "Output"],
Cell[299827, 5827, 16189, 303, 245, "Output"],
Cell[316019, 6132, 18615, 343, 245, "Output"]
}, Open  ]],
Cell[334649, 6478, 518, 15, 80, "Input"],
Cell[CellGroupData[{
Cell[335192, 6497, 210, 6, 32, "Input"],
Cell[335405, 6505, 311, 6, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[335753, 6516, 1473, 41, 80, "Input"],
Cell[337229, 6559, 4394, 103, 235, "Output"]
}, Open  ]],
Cell[341638, 6665, 597, 15, 34, "Input"],
Cell[CellGroupData[{
Cell[342260, 6684, 845, 21, 57, "Input"],
Cell[343108, 6707, 12912, 257, 65, "Output"],
Cell[356023, 6966, 262, 5, 32, "Output"]
}, Open  ]],
Cell[356300, 6974, 234, 5, 99, "Input"],
Cell[CellGroupData[{
Cell[356559, 6983, 6791, 193, 286, "Input"],
Cell[363353, 7178, 276, 5, 32, "Output"],
Cell[363632, 7185, 29607, 507, 243, "Output"],
Cell[393242, 7694, 16371, 311, 245, "Output"],
Cell[409616, 8007, 16610, 314, 245, "Output"],
Cell[426229, 8323, 19110, 356, 245, "Output"]
}, Open  ]],
Cell[445354, 8682, 561, 15, 80, "Input"],
Cell[CellGroupData[{
Cell[445940, 8701, 290, 7, 32, "Input"],
Cell[446233, 8710, 317, 6, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[446587, 8721, 1607, 42, 80, "Input"],
Cell[448197, 8765, 4386, 102, 239, "Output"]
}, Open  ]],
Cell[452598, 8870, 619, 16, 56, "Input"],
Cell[CellGroupData[{
Cell[453242, 8890, 941, 22, 79, "Input"],
Cell[454186, 8914, 12932, 258, 65, "Output"],
Cell[467121, 9174, 289, 6, 32, "Output"]
}, Open  ]],
Cell[467425, 9183, 232, 5, 99, "Input"],
Cell[CellGroupData[{
Cell[467682, 9192, 778, 18, 57, "Input"],
Cell[468463, 9212, 273, 7, 34, "Output"],
Cell[468739, 9221, 254, 6, 34, "Output"]
}, Open  ]],
Cell[469008, 9230, 251, 6, 34, "Input"],
Cell[469262, 9238, 731, 22, 57, "Input"],
Cell[CellGroupData[{
Cell[470018, 9264, 156, 3, 32, "Input"],
Cell[470177, 9269, 671, 20, 34, "Output"]
}, Open  ]],
Cell[470863, 9292, 338, 10, 34, "Input"],
Cell[CellGroupData[{
Cell[471226, 9306, 1015, 28, 57, "Input"],
Cell[472244, 9336, 1710, 38, 114, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[473991, 9379, 1364, 35, 57, "Input"],
Cell[475358, 9416, 4065, 91, 290, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[479460, 9512, 892, 22, 57, "Input"],
Cell[480355, 9536, 8459, 193, 406, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[488851, 9734, 270, 6, 56, "Input"],
Cell[489124, 9742, 269, 5, 32, "Output"]
}, Open  ]]
}
]
*)

